#include "ppzz02.header.cxx"
void ppzz02_list_subprocess_born(vector<string> & subprocess, vector<vector<int> > & subgroup_no_member, int contribution_order_alpha_s, int contribution_order_alpha_e, int contribution_order_interference){
  Logger logger("ppzz02_list_subprocess_born");
  logger << LOG_DEBUG << "called" << endl;
  if (contribution_order_alpha_s == 0 && contribution_order_alpha_e == 2 && contribution_order_interference == 0){
    subprocess.resize(3);
    subprocess[1] = "dd~_zz";
    subprocess[2] = "uu~_zz";
    int member_0[] = {1, 2};
    subgroup_no_member[0] = vector<int> (member_0, member_0 + sizeof(member_0) / sizeof(int));
  }
  else if (contribution_order_alpha_s == 2 && contribution_order_alpha_e == 2 && contribution_order_interference == 0){
    subprocess.resize(2);
    subprocess[1] = "gg_zz";
    int member_0[] = {1};
    subgroup_no_member[0] = vector<int> (member_0, member_0 + sizeof(member_0) / sizeof(int));
  }
  logger << LOG_DEBUG << "finished" << endl;
}
void ppzz02_list_subprocess_C_QCD(vector<string> & subprocess, vector<vector<int> > & subgroup_no_member, int contribution_order_alpha_s, int contribution_order_alpha_e, int contribution_order_interference){
  Logger logger("ppzz02_list_subprocess_C_QCD");
  logger << LOG_DEBUG << "called" << endl;
  subprocess.resize(3);
  subprocess[1] = "dd~_zz";
  subprocess[2] = "uu~_zz";
  int member_0[] = {1, 2};
  subgroup_no_member[0] = vector<int> (member_0, member_0 + sizeof(member_0) / sizeof(int));
  logger << LOG_DEBUG << "finished" << endl;
}
void ppzz02_list_subprocess_V_QCD(vector<string> & subprocess, vector<vector<int> > & subgroup_no_member, int contribution_order_alpha_s, int contribution_order_alpha_e, int contribution_order_interference){
  Logger logger("ppzz02_list_subprocess_V_QCD");
  logger << LOG_DEBUG << "called" << endl;
  subprocess.resize(3);
  subprocess[1] = "dd~_zz";
  subprocess[2] = "uu~_zz";
  int member_0[] = {1, 2};
  subgroup_no_member[0] = vector<int> (member_0, member_0 + sizeof(member_0) / sizeof(int));
  logger << LOG_DEBUG << "finished" << endl;
}
void ppzz02_list_subprocess_R_QCD(vector<string> & subprocess, vector<vector<int> > & subgroup_no_member, int contribution_order_alpha_s, int contribution_order_alpha_e, int contribution_order_interference){
  Logger logger("ppzz02_list_subprocess_R_QCD");
  logger << LOG_DEBUG << "called" << endl;
  subprocess.resize(7);
  subprocess[1] = "gd_zzd";
  subprocess[2] = "gu_zzu";
  subprocess[3] = "gd~_zzd~";
  subprocess[4] = "gu~_zzu~";
  subprocess[5] = "dd~_zzg";
  subprocess[6] = "uu~_zzg";
  int member_0[] = {1, 2, 3, 4, 5, 6};
  subgroup_no_member[0] = vector<int> (member_0, member_0 + sizeof(member_0) / sizeof(int));
  logger << LOG_DEBUG << "finished" << endl;
}
void ppzz02_list_subprocess_RC_QCD(vector<string> & subprocess, vector<vector<int> > & subgroup_no_member, int contribution_order_alpha_s, int contribution_order_alpha_e, int contribution_order_interference){
  Logger logger("ppzz02_list_subprocess_RC_QCD");
  logger << LOG_DEBUG << "called" << endl;
  subprocess.resize(7);
  subprocess[1] = "gd_zzd";
  subprocess[2] = "gu_zzu";
  subprocess[3] = "gd~_zzd~";
  subprocess[4] = "gu~_zzu~";
  subprocess[5] = "dd~_zzg";
  subprocess[6] = "uu~_zzg";
  int member_0[] = {1, 2, 3, 4, 5, 6};
  subgroup_no_member[0] = vector<int> (member_0, member_0 + sizeof(member_0) / sizeof(int));
  logger << LOG_DEBUG << "finished" << endl;
}
void ppzz02_list_subprocess_RV_QCD(vector<string> & subprocess, vector<vector<int> > & subgroup_no_member, int contribution_order_alpha_s, int contribution_order_alpha_e, int contribution_order_interference){
  Logger logger("ppzz02_list_subprocess_RV_QCD");
  logger << LOG_DEBUG << "called" << endl;
  subprocess.resize(7);
  subprocess[1] = "gd_zzd";
  subprocess[2] = "gu_zzu";
  subprocess[3] = "gd~_zzd~";
  subprocess[4] = "gu~_zzu~";
  subprocess[5] = "dd~_zzg";
  subprocess[6] = "uu~_zzg";
  int member_0[] = {1, 2, 3, 4, 5, 6};
  subgroup_no_member[0] = vector<int> (member_0, member_0 + sizeof(member_0) / sizeof(int));
  logger << LOG_DEBUG << "finished" << endl;
}
void ppzz02_list_subprocess_RR_QCD(vector<string> & subprocess, vector<vector<int> > & subgroup_no_member, int contribution_order_alpha_s, int contribution_order_alpha_e, int contribution_order_interference){
  Logger logger("ppzz02_list_subprocess_RR_QCD");
  logger << LOG_DEBUG << "called" << endl;
  subprocess.resize(35);
  subprocess[1] = "gg_zzdd~";
  subprocess[2] = "gg_zzuu~";
  subprocess[3] = "gd_zzgd";
  subprocess[4] = "gu_zzgu";
  subprocess[5] = "gd~_zzgd~";
  subprocess[6] = "gu~_zzgu~";
  subprocess[7] = "dd_zzdd";
  subprocess[8] = "du_zzdu";
  subprocess[9] = "ds_zzds";
  subprocess[10] = "dc_zzdc";
  subprocess[11] = "dd~_zzgg";
  subprocess[12] = "dd~_zzdd~";
  subprocess[13] = "dd~_zzuu~";
  subprocess[14] = "dd~_zzss~";
  subprocess[15] = "dd~_zzcc~";
  subprocess[16] = "du~_zzdu~";
  subprocess[17] = "ds~_zzds~";
  subprocess[18] = "dc~_zzdc~";
  subprocess[19] = "uu_zzuu";
  subprocess[20] = "uc_zzuc";
  subprocess[21] = "ud~_zzud~";
  subprocess[22] = "uu~_zzgg";
  subprocess[23] = "uu~_zzdd~";
  subprocess[24] = "uu~_zzuu~";
  subprocess[25] = "uu~_zzss~";
  subprocess[26] = "uu~_zzcc~";
  subprocess[27] = "us~_zzus~";
  subprocess[28] = "uc~_zzuc~";
  subprocess[29] = "d~d~_zzd~d~";
  subprocess[30] = "d~u~_zzd~u~";
  subprocess[31] = "d~s~_zzd~s~";
  subprocess[32] = "d~c~_zzd~c~";
  subprocess[33] = "u~u~_zzu~u~";
  subprocess[34] = "u~c~_zzu~c~";
  int member_0[] = {1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 34};
  subgroup_no_member[0] = vector<int> (member_0, member_0 + sizeof(member_0) / sizeof(int));
  logger << LOG_DEBUG << "finished" << endl;
}
