#include "../include/classes.cxx"
#include "../include/definitions.phasespace.set.cxx"
#include "../ppeeexex04/header/ppeeexex04.phasespace.h"
void ppeeexex04_ax_psp_140_gux_ememepepux(int no_ps, phasespace_set & psi){
  static Logger logger("ppeeexex04_ax_psp_140_gux_ememepepux");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;
  psi_v_smin[no_ps].resize(22);
  psi_needed_v_smin[no_ps].resize(22);
  int needed_v_smin_0[] = {   0,    1,    2,    3,    4,    5,    6,    7,   32,   33,   34,   35,   44,   45,   46,   47,   48,   49,   50,   51,   52,   53,   54,   55,   80,   81,   82,   83,   92,   93,   94,   95,   96,   97,   98,   99,  108,  109,  110,  111}; //  40
  psi_needed_v_smin[no_ps][  0] = get_vector_from_array_int(needed_v_smin_0, 40);
  int needed_v_smin_1[] = {   0,    1,    2,    3,   48,   49,   50,   51}; //   8
  psi_needed_v_smin[no_ps][  1] = get_vector_from_array_int(needed_v_smin_1, 8);
  int needed_v_smin_2[] = {   0,    1,    2,    3,    8,    9,   10,   11,   48,   49,   50,   51,   56,   57,   58,   59}; //  16
  psi_needed_v_smin[no_ps][  2] = get_vector_from_array_int(needed_v_smin_2, 16);
  int needed_v_smin_3[] = {   4,    5,    6,    7,   52,   53,   54,   55}; //   8
  psi_needed_v_smin[no_ps][  3] = get_vector_from_array_int(needed_v_smin_3, 8);
  int needed_v_smin_4[] = {   4,    5,    6,    7,   20,   21,   22,   23,   52,   53,   54,   55,   68,   69,   70,   71}; //  16
  psi_needed_v_smin[no_ps][  4] = get_vector_from_array_int(needed_v_smin_4, 16);
  int needed_v_smin_5[] = {   8,    9,   10,   11,   12,   13,   14,   15,   36,   37,   38,   39,   40,   41,   42,   43,   56,   57,   58,   59,   60,   61,   62,   63,   84,   85,   86,   87,   88,   89,   90,   91,  100,  101,  102,  103,  104,  105,  106,  107}; //  40
  psi_needed_v_smin[no_ps][  5] = get_vector_from_array_int(needed_v_smin_5, 40);
  int needed_v_smin_6[] = {   8,    9,   10,   11,   56,   57,   58,   59}; //   8
  psi_needed_v_smin[no_ps][  6] = get_vector_from_array_int(needed_v_smin_6, 8);
  int needed_v_smin_7[] = {  12,   13,   14,   15,   60,   61,   62,   63}; //   8
  psi_needed_v_smin[no_ps][  7] = get_vector_from_array_int(needed_v_smin_7, 8);
  int needed_v_smin_8[] = {  12,   13,   14,   15,   28,   29,   30,   31,   60,   61,   62,   63,   76,   77,   78,   79}; //  16
  psi_needed_v_smin[no_ps][  8] = get_vector_from_array_int(needed_v_smin_8, 16);
  int needed_v_smin_9[] = {  16,   17,   18,   19,   20,   21,   22,   23,   36,   37,   38,   39,   40,   41,   42,   43,   64,   65,   66,   67,   68,   69,   70,   71,   84,   85,   86,   87,   88,   89,   90,   91,  100,  101,  102,  103,  104,  105,  106,  107}; //  40
  psi_needed_v_smin[no_ps][  9] = get_vector_from_array_int(needed_v_smin_9, 40);
  int needed_v_smin_10[] = {  16,   17,   18,   19,   64,   65,   66,   67}; //   8
  psi_needed_v_smin[no_ps][ 10] = get_vector_from_array_int(needed_v_smin_10, 8);
  int needed_v_smin_11[] = {  16,   17,   18,   19,   24,   25,   26,   27,   64,   65,   66,   67,   72,   73,   74,   75}; //  16
  psi_needed_v_smin[no_ps][ 11] = get_vector_from_array_int(needed_v_smin_11, 16);
  int needed_v_smin_12[] = {  20,   21,   22,   23,   68,   69,   70,   71}; //   8
  psi_needed_v_smin[no_ps][ 12] = get_vector_from_array_int(needed_v_smin_12, 8);
  int needed_v_smin_13[] = {  24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,   44,   45,   46,   47,   72,   73,   74,   75,   76,   77,   78,   79,   80,   81,   82,   83,   92,   93,   94,   95,   96,   97,   98,   99,  108,  109,  110,  111}; //  40
  psi_needed_v_smin[no_ps][ 13] = get_vector_from_array_int(needed_v_smin_13, 40);
  int needed_v_smin_14[] = {  24,   25,   26,   27,   72,   73,   74,   75}; //   8
  psi_needed_v_smin[no_ps][ 14] = get_vector_from_array_int(needed_v_smin_14, 8);
  int needed_v_smin_15[] = {  28,   29,   30,   31,   76,   77,   78,   79}; //   8
  psi_needed_v_smin[no_ps][ 15] = get_vector_from_array_int(needed_v_smin_15, 8);
  int needed_v_smin_16[] = {  32,   33,   34,   35,   92,   93,   94,   95}; //   8
  psi_needed_v_smin[no_ps][ 16] = get_vector_from_array_int(needed_v_smin_16, 8);
  int needed_v_smin_17[] = {  36,   37,   38,   39,   88,   89,   90,   91}; //   8
  psi_needed_v_smin[no_ps][ 17] = get_vector_from_array_int(needed_v_smin_17, 8);
  int needed_v_smin_18[] = {  40,   41,   42,   43,   84,   85,   86,   87}; //   8
  psi_needed_v_smin[no_ps][ 18] = get_vector_from_array_int(needed_v_smin_18, 8);
  int needed_v_smin_19[] = {  44,   45,   46,   47,   80,   81,   82,   83}; //   8
  psi_needed_v_smin[no_ps][ 19] = get_vector_from_array_int(needed_v_smin_19, 8);
  int needed_v_smin_20[] = {  96,   97,   98,   99,  108,  109,  110,  111}; //   8
  psi_needed_v_smin[no_ps][ 20] = get_vector_from_array_int(needed_v_smin_20, 8);
  int needed_v_smin_21[] = { 100,  101,  102,  103,  104,  105,  106,  107}; //   8
  psi_needed_v_smin[no_ps][ 21] = get_vector_from_array_int(needed_v_smin_21, 8);

  psi_v_smax[no_ps].resize(25);
  psi_needed_v_smax[no_ps].resize(25);
  int needed_v_smax_0[] = {   0,    1,    2,    3,    4,    5,    6,    7,   32,   33,   34,   35,   48,   49,   50,   51,   52,   53,   54,   55,   80,   81,   82,   83,   96,   97,   98,   99}; //  28
  psi_needed_v_smax[no_ps][  0] = get_vector_from_array_int(needed_v_smax_0, 28);
  int needed_v_smax_1[] = {   0,    1,    2,    3,    8,    9,   10,   11,   48,   49,   50,   51,   56,   57,   58,   59}; //  16
  psi_needed_v_smax[no_ps][  1] = get_vector_from_array_int(needed_v_smax_1, 16);
  int needed_v_smax_2[] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,   48,   49,   50,   51,   52,   53,   54,   55,   56,   57,   58,   59,   60,   61,   62,   63,   64,   65,   66,   67,   68,   69,   70,   71,   72,   73,   74,   75,   76,   77,   78,   79,   96,   97,   98,   99,  100,  101,  102,  103,  104,  105,  106,  107,  108,  109,  110,  111}; //  80
  psi_needed_v_smax[no_ps][  2] = get_vector_from_array_int(needed_v_smax_2, 80);
  int needed_v_smax_3[] = {   4,    5,    6,    7,   20,   21,   22,   23,   52,   53,   54,   55,   68,   69,   70,   71}; //  16
  psi_needed_v_smax[no_ps][  3] = get_vector_from_array_int(needed_v_smax_3, 16);
  int needed_v_smax_4[] = {   8,    9,   10,   11,   12,   13,   14,   15,   36,   37,   38,   39,   56,   57,   58,   59,   60,   61,   62,   63,   84,   85,   86,   87,  100,  101,  102,  103}; //  28
  psi_needed_v_smax[no_ps][  4] = get_vector_from_array_int(needed_v_smax_4, 28);
  int needed_v_smax_5[] = {  12,   13,   14,   15,   28,   29,   30,   31,   60,   61,   62,   63,   76,   77,   78,   79}; //  16
  psi_needed_v_smax[no_ps][  5] = get_vector_from_array_int(needed_v_smax_5, 16);
  int needed_v_smax_6[] = {  16,   17,   18,   19,   20,   21,   22,   23,   40,   41,   42,   43,   64,   65,   66,   67,   68,   69,   70,   71,   88,   89,   90,   91,  104,  105,  106,  107}; //  28
  psi_needed_v_smax[no_ps][  6] = get_vector_from_array_int(needed_v_smax_6, 28);
  int needed_v_smax_7[] = {  16,   17,   18,   19,   24,   25,   26,   27,   64,   65,   66,   67,   72,   73,   74,   75}; //  16
  psi_needed_v_smax[no_ps][  7] = get_vector_from_array_int(needed_v_smax_7, 16);
  int needed_v_smax_8[] = {  24,   25,   26,   27,   28,   29,   30,   31,   44,   45,   46,   47,   72,   73,   74,   75,   76,   77,   78,   79,   92,   93,   94,   95,  108,  109,  110,  111}; //  28
  psi_needed_v_smax[no_ps][  8] = get_vector_from_array_int(needed_v_smax_8, 28);
  int needed_v_smax_9[] = {  32,   33,   34,   35}; //   4
  psi_needed_v_smax[no_ps][  9] = get_vector_from_array_int(needed_v_smax_9, 4);
  int needed_v_smax_10[] = {  32,   33,   34,   35}; //   4
  psi_needed_v_smax[no_ps][ 10] = get_vector_from_array_int(needed_v_smax_10, 4);
  int needed_v_smax_11[] = {  36,   37,   38,   39}; //   4
  psi_needed_v_smax[no_ps][ 11] = get_vector_from_array_int(needed_v_smax_11, 4);
  int needed_v_smax_12[] = {  36,   37,   38,   39}; //   4
  psi_needed_v_smax[no_ps][ 12] = get_vector_from_array_int(needed_v_smax_12, 4);
  int needed_v_smax_13[] = {  40,   41,   42,   43}; //   4
  psi_needed_v_smax[no_ps][ 13] = get_vector_from_array_int(needed_v_smax_13, 4);
  int needed_v_smax_14[] = {  40,   41,   42,   43}; //   4
  psi_needed_v_smax[no_ps][ 14] = get_vector_from_array_int(needed_v_smax_14, 4);
  int needed_v_smax_15[] = {  44,   45,   46,   47}; //   4
  psi_needed_v_smax[no_ps][ 15] = get_vector_from_array_int(needed_v_smax_15, 4);
  int needed_v_smax_16[] = {  44,   45,   46,   47}; //   4
  psi_needed_v_smax[no_ps][ 16] = get_vector_from_array_int(needed_v_smax_16, 4);
  int needed_v_smax_17[] = {  80,   81,   82,   83,   96,   97,   98,   99}; //   8
  psi_needed_v_smax[no_ps][ 17] = get_vector_from_array_int(needed_v_smax_17, 8);
  int needed_v_smax_18[] = {  80,   81,   82,   83}; //   4
  psi_needed_v_smax[no_ps][ 18] = get_vector_from_array_int(needed_v_smax_18, 4);
  int needed_v_smax_19[] = {  84,   85,   86,   87,  100,  101,  102,  103}; //   8
  psi_needed_v_smax[no_ps][ 19] = get_vector_from_array_int(needed_v_smax_19, 8);
  int needed_v_smax_20[] = {  84,   85,   86,   87}; //   4
  psi_needed_v_smax[no_ps][ 20] = get_vector_from_array_int(needed_v_smax_20, 4);
  int needed_v_smax_21[] = {  88,   89,   90,   91,  104,  105,  106,  107}; //   8
  psi_needed_v_smax[no_ps][ 21] = get_vector_from_array_int(needed_v_smax_21, 8);
  int needed_v_smax_22[] = {  88,   89,   90,   91}; //   4
  psi_needed_v_smax[no_ps][ 22] = get_vector_from_array_int(needed_v_smax_22, 4);
  int needed_v_smax_23[] = {  92,   93,   94,   95,  108,  109,  110,  111}; //   8
  psi_needed_v_smax[no_ps][ 23] = get_vector_from_array_int(needed_v_smax_23, 8);
  int needed_v_smax_24[] = {  92,   93,   94,   95}; //   4
  psi_needed_v_smax[no_ps][ 24] = get_vector_from_array_int(needed_v_smax_24, 4);

  psi_container_IS_startvalue[no_ps][0] = psi_container_IS_name.size();
  psi_g_p[no_ps].resize(48);
  psi_needed_g_p[no_ps].resize(48);
  int needed_g_p_0[] = {   0,    1,    4,    5,   32,   33,   48,   49,   52,   53,   80,   81,   96,   97}; //  14
  psi_needed_g_p[no_ps][0] = get_vector_from_array_int(needed_g_p_0, 14);
  psi_container_IS_name.push_back("propagator_0_smin0_smax0");
  int needed_g_p_1[] = {   0,    1,    2,    3,   48,   49,   50,   51}; //   8
  psi_needed_g_p[no_ps][1] = get_vector_from_array_int(needed_g_p_1, 8);
  psi_container_IS_name.push_back("propagator_0_smin1_smax1");
  int needed_g_p_2[] = {   0,    2,    8,   10,   48,   50,   56,   58}; //   8
  psi_needed_g_p[no_ps][2] = get_vector_from_array_int(needed_g_p_2, 8);
  psi_container_IS_name.push_back("propagator_0_smin2_smax2");
  int needed_g_p_3[] = {   1,    3,    9,   11,   49,   51,   57,   59}; //   8
  psi_needed_g_p[no_ps][3] = get_vector_from_array_int(needed_g_p_3, 8);
  psi_container_IS_name.push_back("propagator_23_smin2_smax2");
  int needed_g_p_4[] = {   2,    3,    6,    7,   34,   35,   50,   51,   54,   55,   82,   83,   98,   99}; //  14
  psi_needed_g_p[no_ps][4] = get_vector_from_array_int(needed_g_p_4, 14);
  psi_container_IS_name.push_back("propagator_23_smin0_smax0");
  int needed_g_p_5[] = {   4,    5,    6,    7,   52,   53,   54,   55}; //   8
  psi_needed_g_p[no_ps][5] = get_vector_from_array_int(needed_g_p_5, 8);
  psi_container_IS_name.push_back("propagator_0_smin3_smax3");
  int needed_g_p_6[] = {   4,    6,   20,   22,   52,   54,   68,   70}; //   8
  psi_needed_g_p[no_ps][6] = get_vector_from_array_int(needed_g_p_6, 8);
  psi_container_IS_name.push_back("propagator_0_smin4_smax2");
  int needed_g_p_7[] = {   5,    7,   21,   23,   53,   55,   69,   71}; //   8
  psi_needed_g_p[no_ps][7] = get_vector_from_array_int(needed_g_p_7, 8);
  psi_container_IS_name.push_back("propagator_23_smin4_smax2");
  int needed_g_p_8[] = {   8,    9,   12,   13,   36,   37,   56,   57,   60,   61,   84,   85,  100,  101}; //  14
  psi_needed_g_p[no_ps][8] = get_vector_from_array_int(needed_g_p_8, 14);
  psi_container_IS_name.push_back("propagator_0_smin5_smax4");
  int needed_g_p_9[] = {   8,    9,   10,   11,   56,   57,   58,   59}; //   8
  psi_needed_g_p[no_ps][9] = get_vector_from_array_int(needed_g_p_9, 8);
  psi_container_IS_name.push_back("propagator_0_smin6_smax1");
  int needed_g_p_10[] = {  10,   11,   14,   15,   38,   39,   58,   59,   62,   63,   86,   87,  102,  103}; //  14
  psi_needed_g_p[no_ps][10] = get_vector_from_array_int(needed_g_p_10, 14);
  psi_container_IS_name.push_back("propagator_23_smin5_smax4");
  int needed_g_p_11[] = {  12,   13,   14,   15,   60,   61,   62,   63}; //   8
  psi_needed_g_p[no_ps][11] = get_vector_from_array_int(needed_g_p_11, 8);
  psi_container_IS_name.push_back("propagator_0_smin7_smax5");
  int needed_g_p_12[] = {  12,   14,   28,   30,   60,   62,   76,   78}; //   8
  psi_needed_g_p[no_ps][12] = get_vector_from_array_int(needed_g_p_12, 8);
  psi_container_IS_name.push_back("propagator_0_smin8_smax2");
  int needed_g_p_13[] = {  13,   15,   29,   31,   61,   63,   77,   79}; //   8
  psi_needed_g_p[no_ps][13] = get_vector_from_array_int(needed_g_p_13, 8);
  psi_container_IS_name.push_back("propagator_23_smin8_smax2");
  int needed_g_p_14[] = {  16,   17,   20,   21,   40,   41,   64,   65,   68,   69,   88,   89,  104,  105}; //  14
  psi_needed_g_p[no_ps][14] = get_vector_from_array_int(needed_g_p_14, 14);
  psi_container_IS_name.push_back("propagator_0_smin9_smax6");
  int needed_g_p_15[] = {  16,   17,   18,   19,   64,   65,   66,   67}; //   8
  psi_needed_g_p[no_ps][15] = get_vector_from_array_int(needed_g_p_15, 8);
  psi_container_IS_name.push_back("propagator_0_smin10_smax7");
  int needed_g_p_16[] = {  16,   18,   24,   26,   64,   66,   72,   74}; //   8
  psi_needed_g_p[no_ps][16] = get_vector_from_array_int(needed_g_p_16, 8);
  psi_container_IS_name.push_back("propagator_0_smin11_smax2");
  int needed_g_p_17[] = {  17,   19,   25,   27,   65,   67,   73,   75}; //   8
  psi_needed_g_p[no_ps][17] = get_vector_from_array_int(needed_g_p_17, 8);
  psi_container_IS_name.push_back("propagator_23_smin11_smax2");
  int needed_g_p_18[] = {  18,   19,   22,   23,   42,   43,   66,   67,   70,   71,   90,   91,  106,  107}; //  14
  psi_needed_g_p[no_ps][18] = get_vector_from_array_int(needed_g_p_18, 14);
  psi_container_IS_name.push_back("propagator_23_smin9_smax6");
  int needed_g_p_19[] = {  20,   21,   22,   23,   68,   69,   70,   71}; //   8
  psi_needed_g_p[no_ps][19] = get_vector_from_array_int(needed_g_p_19, 8);
  psi_container_IS_name.push_back("propagator_0_smin12_smax3");
  int needed_g_p_20[] = {  24,   25,   28,   29,   44,   45,   72,   73,   76,   77,   92,   93,  108,  109}; //  14
  psi_needed_g_p[no_ps][20] = get_vector_from_array_int(needed_g_p_20, 14);
  psi_container_IS_name.push_back("propagator_0_smin13_smax8");
  int needed_g_p_21[] = {  24,   25,   26,   27,   72,   73,   74,   75}; //   8
  psi_needed_g_p[no_ps][21] = get_vector_from_array_int(needed_g_p_21, 8);
  psi_container_IS_name.push_back("propagator_0_smin14_smax7");
  int needed_g_p_22[] = {  26,   27,   30,   31,   46,   47,   74,   75,   78,   79,   94,   95,  110,  111}; //  14
  psi_needed_g_p[no_ps][22] = get_vector_from_array_int(needed_g_p_22, 14);
  psi_container_IS_name.push_back("propagator_23_smin13_smax8");
  int needed_g_p_23[] = {  28,   29,   30,   31,   76,   77,   78,   79}; //   8
  psi_needed_g_p[no_ps][23] = get_vector_from_array_int(needed_g_p_23, 8);
  psi_container_IS_name.push_back("propagator_0_smin15_smax5");
  int needed_g_p_24[] = {  32,   33,   34,   35}; //   4
  psi_needed_g_p[no_ps][24] = get_vector_from_array_int(needed_g_p_24, 4);
  psi_container_IS_name.push_back("propagator_0_smin16_smax9");
  int needed_g_p_25[] = {  32,   34}; //   2
  psi_needed_g_p[no_ps][25] = get_vector_from_array_int(needed_g_p_25, 2);
  psi_container_IS_name.push_back("propagator_0_smin13_smax10");
  int needed_g_p_26[] = {  33,   35}; //   2
  psi_needed_g_p[no_ps][26] = get_vector_from_array_int(needed_g_p_26, 2);
  psi_container_IS_name.push_back("propagator_23_smin13_smax10");
  int needed_g_p_27[] = {  36,   37,   38,   39}; //   4
  psi_needed_g_p[no_ps][27] = get_vector_from_array_int(needed_g_p_27, 4);
  psi_container_IS_name.push_back("propagator_0_smin17_smax11");
  int needed_g_p_28[] = {  36,   38}; //   2
  psi_needed_g_p[no_ps][28] = get_vector_from_array_int(needed_g_p_28, 2);
  psi_container_IS_name.push_back("propagator_0_smin9_smax12");
  int needed_g_p_29[] = {  37,   39}; //   2
  psi_needed_g_p[no_ps][29] = get_vector_from_array_int(needed_g_p_29, 2);
  psi_container_IS_name.push_back("propagator_23_smin9_smax12");
  int needed_g_p_30[] = {  40,   41,   42,   43}; //   4
  psi_needed_g_p[no_ps][30] = get_vector_from_array_int(needed_g_p_30, 4);
  psi_container_IS_name.push_back("propagator_0_smin18_smax13");
  int needed_g_p_31[] = {  40,   42}; //   2
  psi_needed_g_p[no_ps][31] = get_vector_from_array_int(needed_g_p_31, 2);
  psi_container_IS_name.push_back("propagator_0_smin5_smax14");
  int needed_g_p_32[] = {  41,   43}; //   2
  psi_needed_g_p[no_ps][32] = get_vector_from_array_int(needed_g_p_32, 2);
  psi_container_IS_name.push_back("propagator_23_smin5_smax14");
  int needed_g_p_33[] = {  44,   45,   46,   47}; //   4
  psi_needed_g_p[no_ps][33] = get_vector_from_array_int(needed_g_p_33, 4);
  psi_container_IS_name.push_back("propagator_0_smin19_smax15");
  int needed_g_p_34[] = {  44,   46}; //   2
  psi_needed_g_p[no_ps][34] = get_vector_from_array_int(needed_g_p_34, 2);
  psi_container_IS_name.push_back("propagator_0_smin0_smax16");
  int needed_g_p_35[] = {  45,   47}; //   2
  psi_needed_g_p[no_ps][35] = get_vector_from_array_int(needed_g_p_35, 2);
  psi_container_IS_name.push_back("propagator_23_smin0_smax16");
  int needed_g_p_36[] = {  80,   82,   96,   98}; //   4
  psi_needed_g_p[no_ps][36] = get_vector_from_array_int(needed_g_p_36, 4);
  psi_container_IS_name.push_back("propagator_0_smin13_smax17");
  int needed_g_p_37[] = {  80,   81,   82,   83}; //   4
  psi_needed_g_p[no_ps][37] = get_vector_from_array_int(needed_g_p_37, 4);
  psi_container_IS_name.push_back("propagator_0_smin19_smax18");
  int needed_g_p_38[] = {  81,   83,   97,   99}; //   4
  psi_needed_g_p[no_ps][38] = get_vector_from_array_int(needed_g_p_38, 4);
  psi_container_IS_name.push_back("propagator_23_smin13_smax17");
  int needed_g_p_39[] = {  84,   86,  100,  102}; //   4
  psi_needed_g_p[no_ps][39] = get_vector_from_array_int(needed_g_p_39, 4);
  psi_container_IS_name.push_back("propagator_0_smin9_smax19");
  int needed_g_p_40[] = {  84,   85,   86,   87}; //   4
  psi_needed_g_p[no_ps][40] = get_vector_from_array_int(needed_g_p_40, 4);
  psi_container_IS_name.push_back("propagator_0_smin18_smax20");
  int needed_g_p_41[] = {  85,   87,  101,  103}; //   4
  psi_needed_g_p[no_ps][41] = get_vector_from_array_int(needed_g_p_41, 4);
  psi_container_IS_name.push_back("propagator_23_smin9_smax19");
  int needed_g_p_42[] = {  88,   90,  104,  106}; //   4
  psi_needed_g_p[no_ps][42] = get_vector_from_array_int(needed_g_p_42, 4);
  psi_container_IS_name.push_back("propagator_0_smin5_smax21");
  int needed_g_p_43[] = {  88,   89,   90,   91}; //   4
  psi_needed_g_p[no_ps][43] = get_vector_from_array_int(needed_g_p_43, 4);
  psi_container_IS_name.push_back("propagator_0_smin17_smax22");
  int needed_g_p_44[] = {  89,   91,  105,  107}; //   4
  psi_needed_g_p[no_ps][44] = get_vector_from_array_int(needed_g_p_44, 4);
  psi_container_IS_name.push_back("propagator_23_smin5_smax21");
  int needed_g_p_45[] = {  92,   94,  108,  110}; //   4
  psi_needed_g_p[no_ps][45] = get_vector_from_array_int(needed_g_p_45, 4);
  psi_container_IS_name.push_back("propagator_0_smin0_smax23");
  int needed_g_p_46[] = {  92,   93,   94,   95}; //   4
  psi_needed_g_p[no_ps][46] = get_vector_from_array_int(needed_g_p_46, 4);
  psi_container_IS_name.push_back("propagator_0_smin16_smax24");
  int needed_g_p_47[] = {  93,   95,  109,  111}; //   4
  psi_needed_g_p[no_ps][47] = get_vector_from_array_int(needed_g_p_47, 4);
  psi_container_IS_name.push_back("propagator_23_smin0_smax23");

  psi_container_IS_startvalue[no_ps][1] = psi_container_IS_name.size();
  psi_g_f[no_ps].resize(2);
  psi_needed_g_f[no_ps].resize(2);
  int needed_g_f_0[] = {  96,   97,   98,   99,  108,  109,  110,  111}; //   8
  psi_needed_g_f[no_ps][0] = get_vector_from_array_int(needed_g_f_0, 8);
  psi_container_IS_name.push_back("timelikeinvariant_smin20_smax2");
  int needed_g_f_1[] = { 100,  101,  102,  103,  104,  105,  106,  107}; //   8
  psi_needed_g_f[no_ps][1] = get_vector_from_array_int(needed_g_f_1, 8);
  psi_container_IS_name.push_back("timelikeinvariant_smin21_smax2");

  psi_container_IS_startvalue[no_ps][2] = psi_container_IS_name.size();
  psi_g_t[no_ps].resize(9);
  psi_needed_g_t[no_ps].resize(9);
  int needed_g_t_0[] = {  48,   49,   50,   51,   52,   53,   54,   55,   56,   57,   58,   59,   60,   61,   62,   63,   64,   65,   66,   67,   68,   69,   70,   71,   72,   73,   74,   75,   76,   77,   78,   79,   96,   97,   98,   99,  100,  101,  102,  103,  104,  105,  106,  107,  108,  109,  110,  111}; //  48
  psi_needed_g_t[no_ps][0] = get_vector_from_array_int(needed_g_t_0, 48);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_2__64_60");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_2__64_60");
  int needed_g_t_1[] = {  80,   81,   82,   83}; //   4
  psi_needed_g_t[no_ps][1] = get_vector_from_array_int(needed_g_t_1, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_1__24_100");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_1__24_100");
  int needed_g_t_2[] = {  84,   85,   86,   87}; //   4
  psi_needed_g_t[no_ps][2] = get_vector_from_array_int(needed_g_t_2, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_1__40_84");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_1__40_84");
  int needed_g_t_3[] = {  88,   89,   90,   91}; //   4
  psi_needed_g_t[no_ps][3] = get_vector_from_array_int(needed_g_t_3, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_1__20_104");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_1__20_104");
  int needed_g_t_4[] = {  92,   93,   94,   95}; //   4
  psi_needed_g_t[no_ps][4] = get_vector_from_array_int(needed_g_t_4, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_1__36_88");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_1__36_88");
  int needed_g_t_5[] = {  96,   97,   98,   99}; //   4
  psi_needed_g_t[no_ps][5] = get_vector_from_array_int(needed_g_t_5, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_65__24_36");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_65__24_36");
  int needed_g_t_6[] = { 100,  101,  102,  103}; //   4
  psi_needed_g_t[no_ps][6] = get_vector_from_array_int(needed_g_t_6, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_65__40_20");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_65__40_20");
  int needed_g_t_7[] = { 104,  105,  106,  107}; //   4
  psi_needed_g_t[no_ps][7] = get_vector_from_array_int(needed_g_t_7, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_65__20_40");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_65__20_40");
  int needed_g_t_8[] = { 108,  109,  110,  111}; //   4
  psi_needed_g_t[no_ps][8] = get_vector_from_array_int(needed_g_t_8, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_65__36_24");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_65__36_24");

  psi_container_IS_startvalue[no_ps][3] = psi_container_IS_name.size();
  psi_g_d[no_ps].resize(25);
  psi_needed_g_d[no_ps].resize(25);
  int needed_g_d_0[] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31}; //  32
  psi_needed_g_d[no_ps][0] = get_vector_from_array_int(needed_g_d_0, 32);
  psi_container_IS_name.push_back("costheta_of_decay_124__64_60");
  psi_container_IS_name.push_back("phi_of_decay_124__64_60");
  int needed_g_d_1[] = {   0,    1,    2,    3,    8,    9,   10,   11,   48,   49,   50,   51,   56,   57,   58,   59}; //  16
  psi_needed_g_d[no_ps][1] = get_vector_from_array_int(needed_g_d_1, 16);
  psi_container_IS_name.push_back("costheta_of_decay_60__4_56");
  psi_container_IS_name.push_back("phi_of_decay_60__4_56");
  int needed_g_d_2[] = {   0,    1,    2,    3,   48,   49,   50,   51}; //   8
  psi_needed_g_d[no_ps][2] = get_vector_from_array_int(needed_g_d_2, 8);
  psi_container_IS_name.push_back("costheta_of_decay_56__32_24");
  psi_container_IS_name.push_back("phi_of_decay_56__32_24");
  int needed_g_d_3[] = {   0,    1,    2,    3,    4,    5,    6,    7,   32,   33,   34,   35,   44,   45,   46,   47,   48,   49,   50,   51,   52,   53,   54,   55,   80,   81,   82,   83,   92,   93,   94,   95,   96,   97,   98,   99,  108,  109,  110,  111}; //  40
  psi_needed_g_d[no_ps][3] = get_vector_from_array_int(needed_g_d_3, 40);
  psi_container_IS_name.push_back("costheta_of_decay_24__8_16");
  psi_container_IS_name.push_back("phi_of_decay_24__8_16");
  int needed_g_d_4[] = {   4,    5,    6,    7,   20,   21,   22,   23,   52,   53,   54,   55,   68,   69,   70,   71}; //  16
  psi_needed_g_d[no_ps][4] = get_vector_from_array_int(needed_g_d_4, 16);
  psi_container_IS_name.push_back("costheta_of_decay_60__32_28");
  psi_container_IS_name.push_back("phi_of_decay_60__32_28");
  int needed_g_d_5[] = {   4,    5,    6,    7,   52,   53,   54,   55}; //   8
  psi_needed_g_d[no_ps][5] = get_vector_from_array_int(needed_g_d_5, 8);
  psi_container_IS_name.push_back("costheta_of_decay_28__4_24");
  psi_container_IS_name.push_back("phi_of_decay_28__4_24");
  int needed_g_d_6[] = {   8,    9,   10,   11,   56,   57,   58,   59}; //   8
  psi_needed_g_d[no_ps][6] = get_vector_from_array_int(needed_g_d_6, 8);
  psi_container_IS_name.push_back("costheta_of_decay_56__16_40");
  psi_container_IS_name.push_back("phi_of_decay_56__16_40");
  int needed_g_d_7[] = {   8,    9,   10,   11,   12,   13,   14,   15,   36,   37,   38,   39,   40,   41,   42,   43,   56,   57,   58,   59,   60,   61,   62,   63,   84,   85,   86,   87,   88,   89,   90,   91,  100,  101,  102,  103,  104,  105,  106,  107}; //  40
  psi_needed_g_d[no_ps][7] = get_vector_from_array_int(needed_g_d_7, 40);
  psi_container_IS_name.push_back("costheta_of_decay_40__8_32");
  psi_container_IS_name.push_back("phi_of_decay_40__8_32");
  int needed_g_d_8[] = {  12,   13,   14,   15,   28,   29,   30,   31,   60,   61,   62,   63,   76,   77,   78,   79}; //  16
  psi_needed_g_d[no_ps][8] = get_vector_from_array_int(needed_g_d_8, 16);
  psi_container_IS_name.push_back("costheta_of_decay_60__16_44");
  psi_container_IS_name.push_back("phi_of_decay_60__16_44");
  int needed_g_d_9[] = {  12,   13,   14,   15,   60,   61,   62,   63}; //   8
  psi_needed_g_d[no_ps][9] = get_vector_from_array_int(needed_g_d_9, 8);
  psi_container_IS_name.push_back("costheta_of_decay_44__4_40");
  psi_container_IS_name.push_back("phi_of_decay_44__4_40");
  int needed_g_d_10[] = {  16,   17,   18,   19,   24,   25,   26,   27,   64,   65,   66,   67,   72,   73,   74,   75}; //  16
  psi_needed_g_d[no_ps][10] = get_vector_from_array_int(needed_g_d_10, 16);
  psi_container_IS_name.push_back("costheta_of_decay_60__8_52");
  psi_container_IS_name.push_back("phi_of_decay_60__8_52");
  int needed_g_d_11[] = {  16,   17,   18,   19,   64,   65,   66,   67}; //   8
  psi_needed_g_d[no_ps][11] = get_vector_from_array_int(needed_g_d_11, 8);
  psi_container_IS_name.push_back("costheta_of_decay_52__32_20");
  psi_container_IS_name.push_back("phi_of_decay_52__32_20");
  int needed_g_d_12[] = {  16,   17,   18,   19,   20,   21,   22,   23,   36,   37,   38,   39,   40,   41,   42,   43,   64,   65,   66,   67,   68,   69,   70,   71,   84,   85,   86,   87,   88,   89,   90,   91,  100,  101,  102,  103,  104,  105,  106,  107}; //  40
  psi_needed_g_d[no_ps][12] = get_vector_from_array_int(needed_g_d_12, 40);
  psi_container_IS_name.push_back("costheta_of_decay_20__4_16");
  psi_container_IS_name.push_back("phi_of_decay_20__4_16");
  int needed_g_d_13[] = {  20,   21,   22,   23,   68,   69,   70,   71}; //   8
  psi_needed_g_d[no_ps][13] = get_vector_from_array_int(needed_g_d_13, 8);
  psi_container_IS_name.push_back("costheta_of_decay_28__8_20");
  psi_container_IS_name.push_back("phi_of_decay_28__8_20");
  int needed_g_d_14[] = {  24,   25,   26,   27,   72,   73,   74,   75}; //   8
  psi_needed_g_d[no_ps][14] = get_vector_from_array_int(needed_g_d_14, 8);
  psi_container_IS_name.push_back("costheta_of_decay_52__16_36");
  psi_container_IS_name.push_back("phi_of_decay_52__16_36");
  int needed_g_d_15[] = {  24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,   44,   45,   46,   47,   72,   73,   74,   75,   76,   77,   78,   79,   80,   81,   82,   83,   92,   93,   94,   95,   96,   97,   98,   99,  108,  109,  110,  111}; //  40
  psi_needed_g_d[no_ps][15] = get_vector_from_array_int(needed_g_d_15, 40);
  psi_container_IS_name.push_back("costheta_of_decay_36__4_32");
  psi_container_IS_name.push_back("phi_of_decay_36__4_32");
  int needed_g_d_16[] = {  28,   29,   30,   31,   76,   77,   78,   79}; //   8
  psi_needed_g_d[no_ps][16] = get_vector_from_array_int(needed_g_d_16, 8);
  psi_container_IS_name.push_back("costheta_of_decay_44__8_36");
  psi_container_IS_name.push_back("phi_of_decay_44__8_36");
  int needed_g_d_17[] = {  32,   33,   34,   35}; //   4
  psi_needed_g_d[no_ps][17] = get_vector_from_array_int(needed_g_d_17, 4);
  psi_container_IS_name.push_back("costheta_of_decay_124__36_88");
  psi_container_IS_name.push_back("phi_of_decay_124__36_88");
  int needed_g_d_18[] = {  32,   33,   34,   35,   92,   93,   94,   95}; //   8
  psi_needed_g_d[no_ps][18] = get_vector_from_array_int(needed_g_d_18, 8);
  psi_container_IS_name.push_back("costheta_of_decay_88__64_24");
  psi_container_IS_name.push_back("phi_of_decay_88__64_24");
  int needed_g_d_19[] = {  36,   37,   38,   39}; //   4
  psi_needed_g_d[no_ps][19] = get_vector_from_array_int(needed_g_d_19, 4);
  psi_container_IS_name.push_back("costheta_of_decay_124__20_104");
  psi_container_IS_name.push_back("phi_of_decay_124__20_104");
  int needed_g_d_20[] = {  36,   37,   38,   39,   88,   89,   90,   91}; //   8
  psi_needed_g_d[no_ps][20] = get_vector_from_array_int(needed_g_d_20, 8);
  psi_container_IS_name.push_back("costheta_of_decay_104__64_40");
  psi_container_IS_name.push_back("phi_of_decay_104__64_40");
  int needed_g_d_21[] = {  40,   41,   42,   43}; //   4
  psi_needed_g_d[no_ps][21] = get_vector_from_array_int(needed_g_d_21, 4);
  psi_container_IS_name.push_back("costheta_of_decay_124__40_84");
  psi_container_IS_name.push_back("phi_of_decay_124__40_84");
  int needed_g_d_22[] = {  40,   41,   42,   43,   84,   85,   86,   87}; //   8
  psi_needed_g_d[no_ps][22] = get_vector_from_array_int(needed_g_d_22, 8);
  psi_container_IS_name.push_back("costheta_of_decay_84__64_20");
  psi_container_IS_name.push_back("phi_of_decay_84__64_20");
  int needed_g_d_23[] = {  44,   45,   46,   47}; //   4
  psi_needed_g_d[no_ps][23] = get_vector_from_array_int(needed_g_d_23, 4);
  psi_container_IS_name.push_back("costheta_of_decay_124__24_100");
  psi_container_IS_name.push_back("phi_of_decay_124__24_100");
  int needed_g_d_24[] = {  44,   45,   46,   47,   80,   81,   82,   83}; //   8
  psi_needed_g_d[no_ps][24] = get_vector_from_array_int(needed_g_d_24, 8);
  psi_container_IS_name.push_back("costheta_of_decay_100__64_36");
  psi_container_IS_name.push_back("phi_of_decay_100__64_36");

  psi_c_p[no_ps].resize(112);
  psi_c_f[no_ps].resize(112);
  psi_c_t[no_ps].resize(112);
  psi_c_d[no_ps].resize(112);

  int c_p_0[] = {  0,   1,   2}; //   3
  psi_c_p[no_ps][0] = get_vector_from_array_int(c_p_0, 3);
  int c_f_0[] = {}; //   0
  psi_c_f[no_ps][0] = get_vector_from_array_int(c_f_0, 0);
  int c_t_0[] = {}; //   0
  psi_c_t[no_ps][0] = get_vector_from_array_int(c_t_0, 0);
  int c_d_0[] = {  0,   1,   2,   3}; //   4
  psi_c_d[no_ps][0] = get_vector_from_array_int(c_d_0, 4);

  int c_p_1[] = {  0,   1,   3}; //   3
  psi_c_p[no_ps][1] = get_vector_from_array_int(c_p_1, 3);
  int c_f_1[] = {}; //   0
  psi_c_f[no_ps][1] = get_vector_from_array_int(c_f_1, 0);
  int c_t_1[] = {}; //   0
  psi_c_t[no_ps][1] = get_vector_from_array_int(c_t_1, 0);
  int c_d_1[] = {  0,   1,   2,   3}; //   4
  psi_c_d[no_ps][1] = get_vector_from_array_int(c_d_1, 4);

  int c_p_2[] = {  4,   1,   2}; //   3
  psi_c_p[no_ps][2] = get_vector_from_array_int(c_p_2, 3);
  int c_f_2[] = {}; //   0
  psi_c_f[no_ps][2] = get_vector_from_array_int(c_f_2, 0);
  int c_t_2[] = {}; //   0
  psi_c_t[no_ps][2] = get_vector_from_array_int(c_t_2, 0);
  int c_d_2[] = {  0,   1,   2,   3}; //   4
  psi_c_d[no_ps][2] = get_vector_from_array_int(c_d_2, 4);

  int c_p_3[] = {  4,   1,   3}; //   3
  psi_c_p[no_ps][3] = get_vector_from_array_int(c_p_3, 3);
  int c_f_3[] = {}; //   0
  psi_c_f[no_ps][3] = get_vector_from_array_int(c_f_3, 0);
  int c_t_3[] = {}; //   0
  psi_c_t[no_ps][3] = get_vector_from_array_int(c_t_3, 0);
  int c_d_3[] = {  0,   1,   2,   3}; //   4
  psi_c_d[no_ps][3] = get_vector_from_array_int(c_d_3, 4);

  int c_p_4[] = {  0,   5,   6}; //   3
  psi_c_p[no_ps][4] = get_vector_from_array_int(c_p_4, 3);
  int c_f_4[] = {}; //   0
  psi_c_f[no_ps][4] = get_vector_from_array_int(c_f_4, 0);
  int c_t_4[] = {}; //   0
  psi_c_t[no_ps][4] = get_vector_from_array_int(c_t_4, 0);
  int c_d_4[] = {  0,   4,   5,   3}; //   4
  psi_c_d[no_ps][4] = get_vector_from_array_int(c_d_4, 4);

  int c_p_5[] = {  0,   5,   7}; //   3
  psi_c_p[no_ps][5] = get_vector_from_array_int(c_p_5, 3);
  int c_f_5[] = {}; //   0
  psi_c_f[no_ps][5] = get_vector_from_array_int(c_f_5, 0);
  int c_t_5[] = {}; //   0
  psi_c_t[no_ps][5] = get_vector_from_array_int(c_t_5, 0);
  int c_d_5[] = {  0,   4,   5,   3}; //   4
  psi_c_d[no_ps][5] = get_vector_from_array_int(c_d_5, 4);

  int c_p_6[] = {  4,   5,   6}; //   3
  psi_c_p[no_ps][6] = get_vector_from_array_int(c_p_6, 3);
  int c_f_6[] = {}; //   0
  psi_c_f[no_ps][6] = get_vector_from_array_int(c_f_6, 0);
  int c_t_6[] = {}; //   0
  psi_c_t[no_ps][6] = get_vector_from_array_int(c_t_6, 0);
  int c_d_6[] = {  0,   4,   5,   3}; //   4
  psi_c_d[no_ps][6] = get_vector_from_array_int(c_d_6, 4);

  int c_p_7[] = {  4,   5,   7}; //   3
  psi_c_p[no_ps][7] = get_vector_from_array_int(c_p_7, 3);
  int c_f_7[] = {}; //   0
  psi_c_f[no_ps][7] = get_vector_from_array_int(c_f_7, 0);
  int c_t_7[] = {}; //   0
  psi_c_t[no_ps][7] = get_vector_from_array_int(c_t_7, 0);
  int c_d_7[] = {  0,   4,   5,   3}; //   4
  psi_c_d[no_ps][7] = get_vector_from_array_int(c_d_7, 4);

  int c_p_8[] = {  8,   9,   2}; //   3
  psi_c_p[no_ps][8] = get_vector_from_array_int(c_p_8, 3);
  int c_f_8[] = {}; //   0
  psi_c_f[no_ps][8] = get_vector_from_array_int(c_f_8, 0);
  int c_t_8[] = {}; //   0
  psi_c_t[no_ps][8] = get_vector_from_array_int(c_t_8, 0);
  int c_d_8[] = {  0,   1,   6,   7}; //   4
  psi_c_d[no_ps][8] = get_vector_from_array_int(c_d_8, 4);

  int c_p_9[] = {  8,   9,   3}; //   3
  psi_c_p[no_ps][9] = get_vector_from_array_int(c_p_9, 3);
  int c_f_9[] = {}; //   0
  psi_c_f[no_ps][9] = get_vector_from_array_int(c_f_9, 0);
  int c_t_9[] = {}; //   0
  psi_c_t[no_ps][9] = get_vector_from_array_int(c_t_9, 0);
  int c_d_9[] = {  0,   1,   6,   7}; //   4
  psi_c_d[no_ps][9] = get_vector_from_array_int(c_d_9, 4);

  int c_p_10[] = { 10,   9,   2}; //   3
  psi_c_p[no_ps][10] = get_vector_from_array_int(c_p_10, 3);
  int c_f_10[] = {}; //   0
  psi_c_f[no_ps][10] = get_vector_from_array_int(c_f_10, 0);
  int c_t_10[] = {}; //   0
  psi_c_t[no_ps][10] = get_vector_from_array_int(c_t_10, 0);
  int c_d_10[] = {  0,   1,   6,   7}; //   4
  psi_c_d[no_ps][10] = get_vector_from_array_int(c_d_10, 4);

  int c_p_11[] = { 10,   9,   3}; //   3
  psi_c_p[no_ps][11] = get_vector_from_array_int(c_p_11, 3);
  int c_f_11[] = {}; //   0
  psi_c_f[no_ps][11] = get_vector_from_array_int(c_f_11, 0);
  int c_t_11[] = {}; //   0
  psi_c_t[no_ps][11] = get_vector_from_array_int(c_t_11, 0);
  int c_d_11[] = {  0,   1,   6,   7}; //   4
  psi_c_d[no_ps][11] = get_vector_from_array_int(c_d_11, 4);

  int c_p_12[] = {  8,  11,  12}; //   3
  psi_c_p[no_ps][12] = get_vector_from_array_int(c_p_12, 3);
  int c_f_12[] = {}; //   0
  psi_c_f[no_ps][12] = get_vector_from_array_int(c_f_12, 0);
  int c_t_12[] = {}; //   0
  psi_c_t[no_ps][12] = get_vector_from_array_int(c_t_12, 0);
  int c_d_12[] = {  0,   8,   9,   7}; //   4
  psi_c_d[no_ps][12] = get_vector_from_array_int(c_d_12, 4);

  int c_p_13[] = {  8,  11,  13}; //   3
  psi_c_p[no_ps][13] = get_vector_from_array_int(c_p_13, 3);
  int c_f_13[] = {}; //   0
  psi_c_f[no_ps][13] = get_vector_from_array_int(c_f_13, 0);
  int c_t_13[] = {}; //   0
  psi_c_t[no_ps][13] = get_vector_from_array_int(c_t_13, 0);
  int c_d_13[] = {  0,   8,   9,   7}; //   4
  psi_c_d[no_ps][13] = get_vector_from_array_int(c_d_13, 4);

  int c_p_14[] = { 10,  11,  12}; //   3
  psi_c_p[no_ps][14] = get_vector_from_array_int(c_p_14, 3);
  int c_f_14[] = {}; //   0
  psi_c_f[no_ps][14] = get_vector_from_array_int(c_f_14, 0);
  int c_t_14[] = {}; //   0
  psi_c_t[no_ps][14] = get_vector_from_array_int(c_t_14, 0);
  int c_d_14[] = {  0,   8,   9,   7}; //   4
  psi_c_d[no_ps][14] = get_vector_from_array_int(c_d_14, 4);

  int c_p_15[] = { 10,  11,  13}; //   3
  psi_c_p[no_ps][15] = get_vector_from_array_int(c_p_15, 3);
  int c_f_15[] = {}; //   0
  psi_c_f[no_ps][15] = get_vector_from_array_int(c_f_15, 0);
  int c_t_15[] = {}; //   0
  psi_c_t[no_ps][15] = get_vector_from_array_int(c_t_15, 0);
  int c_d_15[] = {  0,   8,   9,   7}; //   4
  psi_c_d[no_ps][15] = get_vector_from_array_int(c_d_15, 4);

  int c_p_16[] = { 14,  15,  16}; //   3
  psi_c_p[no_ps][16] = get_vector_from_array_int(c_p_16, 3);
  int c_f_16[] = {}; //   0
  psi_c_f[no_ps][16] = get_vector_from_array_int(c_f_16, 0);
  int c_t_16[] = {}; //   0
  psi_c_t[no_ps][16] = get_vector_from_array_int(c_t_16, 0);
  int c_d_16[] = {  0,  10,  11,  12}; //   4
  psi_c_d[no_ps][16] = get_vector_from_array_int(c_d_16, 4);

  int c_p_17[] = { 14,  15,  17}; //   3
  psi_c_p[no_ps][17] = get_vector_from_array_int(c_p_17, 3);
  int c_f_17[] = {}; //   0
  psi_c_f[no_ps][17] = get_vector_from_array_int(c_f_17, 0);
  int c_t_17[] = {}; //   0
  psi_c_t[no_ps][17] = get_vector_from_array_int(c_t_17, 0);
  int c_d_17[] = {  0,  10,  11,  12}; //   4
  psi_c_d[no_ps][17] = get_vector_from_array_int(c_d_17, 4);

  int c_p_18[] = { 18,  15,  16}; //   3
  psi_c_p[no_ps][18] = get_vector_from_array_int(c_p_18, 3);
  int c_f_18[] = {}; //   0
  psi_c_f[no_ps][18] = get_vector_from_array_int(c_f_18, 0);
  int c_t_18[] = {}; //   0
  psi_c_t[no_ps][18] = get_vector_from_array_int(c_t_18, 0);
  int c_d_18[] = {  0,  10,  11,  12}; //   4
  psi_c_d[no_ps][18] = get_vector_from_array_int(c_d_18, 4);

  int c_p_19[] = { 18,  15,  17}; //   3
  psi_c_p[no_ps][19] = get_vector_from_array_int(c_p_19, 3);
  int c_f_19[] = {}; //   0
  psi_c_f[no_ps][19] = get_vector_from_array_int(c_f_19, 0);
  int c_t_19[] = {}; //   0
  psi_c_t[no_ps][19] = get_vector_from_array_int(c_t_19, 0);
  int c_d_19[] = {  0,  10,  11,  12}; //   4
  psi_c_d[no_ps][19] = get_vector_from_array_int(c_d_19, 4);

  int c_p_20[] = { 14,  19,   6}; //   3
  psi_c_p[no_ps][20] = get_vector_from_array_int(c_p_20, 3);
  int c_f_20[] = {}; //   0
  psi_c_f[no_ps][20] = get_vector_from_array_int(c_f_20, 0);
  int c_t_20[] = {}; //   0
  psi_c_t[no_ps][20] = get_vector_from_array_int(c_t_20, 0);
  int c_d_20[] = {  0,   4,  13,  12}; //   4
  psi_c_d[no_ps][20] = get_vector_from_array_int(c_d_20, 4);

  int c_p_21[] = { 14,  19,   7}; //   3
  psi_c_p[no_ps][21] = get_vector_from_array_int(c_p_21, 3);
  int c_f_21[] = {}; //   0
  psi_c_f[no_ps][21] = get_vector_from_array_int(c_f_21, 0);
  int c_t_21[] = {}; //   0
  psi_c_t[no_ps][21] = get_vector_from_array_int(c_t_21, 0);
  int c_d_21[] = {  0,   4,  13,  12}; //   4
  psi_c_d[no_ps][21] = get_vector_from_array_int(c_d_21, 4);

  int c_p_22[] = { 18,  19,   6}; //   3
  psi_c_p[no_ps][22] = get_vector_from_array_int(c_p_22, 3);
  int c_f_22[] = {}; //   0
  psi_c_f[no_ps][22] = get_vector_from_array_int(c_f_22, 0);
  int c_t_22[] = {}; //   0
  psi_c_t[no_ps][22] = get_vector_from_array_int(c_t_22, 0);
  int c_d_22[] = {  0,   4,  13,  12}; //   4
  psi_c_d[no_ps][22] = get_vector_from_array_int(c_d_22, 4);

  int c_p_23[] = { 18,  19,   7}; //   3
  psi_c_p[no_ps][23] = get_vector_from_array_int(c_p_23, 3);
  int c_f_23[] = {}; //   0
  psi_c_f[no_ps][23] = get_vector_from_array_int(c_f_23, 0);
  int c_t_23[] = {}; //   0
  psi_c_t[no_ps][23] = get_vector_from_array_int(c_t_23, 0);
  int c_d_23[] = {  0,   4,  13,  12}; //   4
  psi_c_d[no_ps][23] = get_vector_from_array_int(c_d_23, 4);

  int c_p_24[] = { 20,  21,  16}; //   3
  psi_c_p[no_ps][24] = get_vector_from_array_int(c_p_24, 3);
  int c_f_24[] = {}; //   0
  psi_c_f[no_ps][24] = get_vector_from_array_int(c_f_24, 0);
  int c_t_24[] = {}; //   0
  psi_c_t[no_ps][24] = get_vector_from_array_int(c_t_24, 0);
  int c_d_24[] = {  0,  10,  14,  15}; //   4
  psi_c_d[no_ps][24] = get_vector_from_array_int(c_d_24, 4);

  int c_p_25[] = { 20,  21,  17}; //   3
  psi_c_p[no_ps][25] = get_vector_from_array_int(c_p_25, 3);
  int c_f_25[] = {}; //   0
  psi_c_f[no_ps][25] = get_vector_from_array_int(c_f_25, 0);
  int c_t_25[] = {}; //   0
  psi_c_t[no_ps][25] = get_vector_from_array_int(c_t_25, 0);
  int c_d_25[] = {  0,  10,  14,  15}; //   4
  psi_c_d[no_ps][25] = get_vector_from_array_int(c_d_25, 4);

  int c_p_26[] = { 22,  21,  16}; //   3
  psi_c_p[no_ps][26] = get_vector_from_array_int(c_p_26, 3);
  int c_f_26[] = {}; //   0
  psi_c_f[no_ps][26] = get_vector_from_array_int(c_f_26, 0);
  int c_t_26[] = {}; //   0
  psi_c_t[no_ps][26] = get_vector_from_array_int(c_t_26, 0);
  int c_d_26[] = {  0,  10,  14,  15}; //   4
  psi_c_d[no_ps][26] = get_vector_from_array_int(c_d_26, 4);

  int c_p_27[] = { 22,  21,  17}; //   3
  psi_c_p[no_ps][27] = get_vector_from_array_int(c_p_27, 3);
  int c_f_27[] = {}; //   0
  psi_c_f[no_ps][27] = get_vector_from_array_int(c_f_27, 0);
  int c_t_27[] = {}; //   0
  psi_c_t[no_ps][27] = get_vector_from_array_int(c_t_27, 0);
  int c_d_27[] = {  0,  10,  14,  15}; //   4
  psi_c_d[no_ps][27] = get_vector_from_array_int(c_d_27, 4);

  int c_p_28[] = { 20,  23,  12}; //   3
  psi_c_p[no_ps][28] = get_vector_from_array_int(c_p_28, 3);
  int c_f_28[] = {}; //   0
  psi_c_f[no_ps][28] = get_vector_from_array_int(c_f_28, 0);
  int c_t_28[] = {}; //   0
  psi_c_t[no_ps][28] = get_vector_from_array_int(c_t_28, 0);
  int c_d_28[] = {  0,   8,  16,  15}; //   4
  psi_c_d[no_ps][28] = get_vector_from_array_int(c_d_28, 4);

  int c_p_29[] = { 20,  23,  13}; //   3
  psi_c_p[no_ps][29] = get_vector_from_array_int(c_p_29, 3);
  int c_f_29[] = {}; //   0
  psi_c_f[no_ps][29] = get_vector_from_array_int(c_f_29, 0);
  int c_t_29[] = {}; //   0
  psi_c_t[no_ps][29] = get_vector_from_array_int(c_t_29, 0);
  int c_d_29[] = {  0,   8,  16,  15}; //   4
  psi_c_d[no_ps][29] = get_vector_from_array_int(c_d_29, 4);

  int c_p_30[] = { 22,  23,  12}; //   3
  psi_c_p[no_ps][30] = get_vector_from_array_int(c_p_30, 3);
  int c_f_30[] = {}; //   0
  psi_c_f[no_ps][30] = get_vector_from_array_int(c_f_30, 0);
  int c_t_30[] = {}; //   0
  psi_c_t[no_ps][30] = get_vector_from_array_int(c_t_30, 0);
  int c_d_30[] = {  0,   8,  16,  15}; //   4
  psi_c_d[no_ps][30] = get_vector_from_array_int(c_d_30, 4);

  int c_p_31[] = { 22,  23,  13}; //   3
  psi_c_p[no_ps][31] = get_vector_from_array_int(c_p_31, 3);
  int c_f_31[] = {}; //   0
  psi_c_f[no_ps][31] = get_vector_from_array_int(c_f_31, 0);
  int c_t_31[] = {}; //   0
  psi_c_t[no_ps][31] = get_vector_from_array_int(c_t_31, 0);
  int c_d_31[] = {  0,   8,  16,  15}; //   4
  psi_c_d[no_ps][31] = get_vector_from_array_int(c_d_31, 4);

  int c_p_32[] = {  0,  24,  25}; //   3
  psi_c_p[no_ps][32] = get_vector_from_array_int(c_p_32, 3);
  int c_f_32[] = {}; //   0
  psi_c_f[no_ps][32] = get_vector_from_array_int(c_f_32, 0);
  int c_t_32[] = {}; //   0
  psi_c_t[no_ps][32] = get_vector_from_array_int(c_t_32, 0);
  int c_d_32[] = { 17,  15,  18,   3}; //   4
  psi_c_d[no_ps][32] = get_vector_from_array_int(c_d_32, 4);

  int c_p_33[] = {  0,  24,  26}; //   3
  psi_c_p[no_ps][33] = get_vector_from_array_int(c_p_33, 3);
  int c_f_33[] = {}; //   0
  psi_c_f[no_ps][33] = get_vector_from_array_int(c_f_33, 0);
  int c_t_33[] = {}; //   0
  psi_c_t[no_ps][33] = get_vector_from_array_int(c_t_33, 0);
  int c_d_33[] = { 17,  15,  18,   3}; //   4
  psi_c_d[no_ps][33] = get_vector_from_array_int(c_d_33, 4);

  int c_p_34[] = {  4,  24,  25}; //   3
  psi_c_p[no_ps][34] = get_vector_from_array_int(c_p_34, 3);
  int c_f_34[] = {}; //   0
  psi_c_f[no_ps][34] = get_vector_from_array_int(c_f_34, 0);
  int c_t_34[] = {}; //   0
  psi_c_t[no_ps][34] = get_vector_from_array_int(c_t_34, 0);
  int c_d_34[] = { 17,  15,  18,   3}; //   4
  psi_c_d[no_ps][34] = get_vector_from_array_int(c_d_34, 4);

  int c_p_35[] = {  4,  24,  26}; //   3
  psi_c_p[no_ps][35] = get_vector_from_array_int(c_p_35, 3);
  int c_f_35[] = {}; //   0
  psi_c_f[no_ps][35] = get_vector_from_array_int(c_f_35, 0);
  int c_t_35[] = {}; //   0
  psi_c_t[no_ps][35] = get_vector_from_array_int(c_t_35, 0);
  int c_d_35[] = { 17,  15,  18,   3}; //   4
  psi_c_d[no_ps][35] = get_vector_from_array_int(c_d_35, 4);

  int c_p_36[] = {  8,  27,  28}; //   3
  psi_c_p[no_ps][36] = get_vector_from_array_int(c_p_36, 3);
  int c_f_36[] = {}; //   0
  psi_c_f[no_ps][36] = get_vector_from_array_int(c_f_36, 0);
  int c_t_36[] = {}; //   0
  psi_c_t[no_ps][36] = get_vector_from_array_int(c_t_36, 0);
  int c_d_36[] = { 19,  12,  20,   7}; //   4
  psi_c_d[no_ps][36] = get_vector_from_array_int(c_d_36, 4);

  int c_p_37[] = {  8,  27,  29}; //   3
  psi_c_p[no_ps][37] = get_vector_from_array_int(c_p_37, 3);
  int c_f_37[] = {}; //   0
  psi_c_f[no_ps][37] = get_vector_from_array_int(c_f_37, 0);
  int c_t_37[] = {}; //   0
  psi_c_t[no_ps][37] = get_vector_from_array_int(c_t_37, 0);
  int c_d_37[] = { 19,  12,  20,   7}; //   4
  psi_c_d[no_ps][37] = get_vector_from_array_int(c_d_37, 4);

  int c_p_38[] = { 10,  27,  28}; //   3
  psi_c_p[no_ps][38] = get_vector_from_array_int(c_p_38, 3);
  int c_f_38[] = {}; //   0
  psi_c_f[no_ps][38] = get_vector_from_array_int(c_f_38, 0);
  int c_t_38[] = {}; //   0
  psi_c_t[no_ps][38] = get_vector_from_array_int(c_t_38, 0);
  int c_d_38[] = { 19,  12,  20,   7}; //   4
  psi_c_d[no_ps][38] = get_vector_from_array_int(c_d_38, 4);

  int c_p_39[] = { 10,  27,  29}; //   3
  psi_c_p[no_ps][39] = get_vector_from_array_int(c_p_39, 3);
  int c_f_39[] = {}; //   0
  psi_c_f[no_ps][39] = get_vector_from_array_int(c_f_39, 0);
  int c_t_39[] = {}; //   0
  psi_c_t[no_ps][39] = get_vector_from_array_int(c_t_39, 0);
  int c_d_39[] = { 19,  12,  20,   7}; //   4
  psi_c_d[no_ps][39] = get_vector_from_array_int(c_d_39, 4);

  int c_p_40[] = { 14,  30,  31}; //   3
  psi_c_p[no_ps][40] = get_vector_from_array_int(c_p_40, 3);
  int c_f_40[] = {}; //   0
  psi_c_f[no_ps][40] = get_vector_from_array_int(c_f_40, 0);
  int c_t_40[] = {}; //   0
  psi_c_t[no_ps][40] = get_vector_from_array_int(c_t_40, 0);
  int c_d_40[] = { 21,   7,  22,  12}; //   4
  psi_c_d[no_ps][40] = get_vector_from_array_int(c_d_40, 4);

  int c_p_41[] = { 14,  30,  32}; //   3
  psi_c_p[no_ps][41] = get_vector_from_array_int(c_p_41, 3);
  int c_f_41[] = {}; //   0
  psi_c_f[no_ps][41] = get_vector_from_array_int(c_f_41, 0);
  int c_t_41[] = {}; //   0
  psi_c_t[no_ps][41] = get_vector_from_array_int(c_t_41, 0);
  int c_d_41[] = { 21,   7,  22,  12}; //   4
  psi_c_d[no_ps][41] = get_vector_from_array_int(c_d_41, 4);

  int c_p_42[] = { 18,  30,  31}; //   3
  psi_c_p[no_ps][42] = get_vector_from_array_int(c_p_42, 3);
  int c_f_42[] = {}; //   0
  psi_c_f[no_ps][42] = get_vector_from_array_int(c_f_42, 0);
  int c_t_42[] = {}; //   0
  psi_c_t[no_ps][42] = get_vector_from_array_int(c_t_42, 0);
  int c_d_42[] = { 21,   7,  22,  12}; //   4
  psi_c_d[no_ps][42] = get_vector_from_array_int(c_d_42, 4);

  int c_p_43[] = { 18,  30,  32}; //   3
  psi_c_p[no_ps][43] = get_vector_from_array_int(c_p_43, 3);
  int c_f_43[] = {}; //   0
  psi_c_f[no_ps][43] = get_vector_from_array_int(c_f_43, 0);
  int c_t_43[] = {}; //   0
  psi_c_t[no_ps][43] = get_vector_from_array_int(c_t_43, 0);
  int c_d_43[] = { 21,   7,  22,  12}; //   4
  psi_c_d[no_ps][43] = get_vector_from_array_int(c_d_43, 4);

  int c_p_44[] = { 20,  33,  34}; //   3
  psi_c_p[no_ps][44] = get_vector_from_array_int(c_p_44, 3);
  int c_f_44[] = {}; //   0
  psi_c_f[no_ps][44] = get_vector_from_array_int(c_f_44, 0);
  int c_t_44[] = {}; //   0
  psi_c_t[no_ps][44] = get_vector_from_array_int(c_t_44, 0);
  int c_d_44[] = { 23,   3,  24,  15}; //   4
  psi_c_d[no_ps][44] = get_vector_from_array_int(c_d_44, 4);

  int c_p_45[] = { 20,  33,  35}; //   3
  psi_c_p[no_ps][45] = get_vector_from_array_int(c_p_45, 3);
  int c_f_45[] = {}; //   0
  psi_c_f[no_ps][45] = get_vector_from_array_int(c_f_45, 0);
  int c_t_45[] = {}; //   0
  psi_c_t[no_ps][45] = get_vector_from_array_int(c_t_45, 0);
  int c_d_45[] = { 23,   3,  24,  15}; //   4
  psi_c_d[no_ps][45] = get_vector_from_array_int(c_d_45, 4);

  int c_p_46[] = { 22,  33,  34}; //   3
  psi_c_p[no_ps][46] = get_vector_from_array_int(c_p_46, 3);
  int c_f_46[] = {}; //   0
  psi_c_f[no_ps][46] = get_vector_from_array_int(c_f_46, 0);
  int c_t_46[] = {}; //   0
  psi_c_t[no_ps][46] = get_vector_from_array_int(c_t_46, 0);
  int c_d_46[] = { 23,   3,  24,  15}; //   4
  psi_c_d[no_ps][46] = get_vector_from_array_int(c_d_46, 4);

  int c_p_47[] = { 22,  33,  35}; //   3
  psi_c_p[no_ps][47] = get_vector_from_array_int(c_p_47, 3);
  int c_f_47[] = {}; //   0
  psi_c_f[no_ps][47] = get_vector_from_array_int(c_f_47, 0);
  int c_t_47[] = {}; //   0
  psi_c_t[no_ps][47] = get_vector_from_array_int(c_t_47, 0);
  int c_d_47[] = { 23,   3,  24,  15}; //   4
  psi_c_d[no_ps][47] = get_vector_from_array_int(c_d_47, 4);

  int c_p_48[] = {  0,   1,   2}; //   3
  psi_c_p[no_ps][48] = get_vector_from_array_int(c_p_48, 3);
  int c_f_48[] = {}; //   0
  psi_c_f[no_ps][48] = get_vector_from_array_int(c_f_48, 0);
  int c_t_48[] = {  0}; //   1
  psi_c_t[no_ps][48] = get_vector_from_array_int(c_t_48, 1);
  int c_d_48[] = {  1,   2,   3}; //   3
  psi_c_d[no_ps][48] = get_vector_from_array_int(c_d_48, 3);

  int c_p_49[] = {  0,   1,   3}; //   3
  psi_c_p[no_ps][49] = get_vector_from_array_int(c_p_49, 3);
  int c_f_49[] = {}; //   0
  psi_c_f[no_ps][49] = get_vector_from_array_int(c_f_49, 0);
  int c_t_49[] = {  0}; //   1
  psi_c_t[no_ps][49] = get_vector_from_array_int(c_t_49, 1);
  int c_d_49[] = {  1,   2,   3}; //   3
  psi_c_d[no_ps][49] = get_vector_from_array_int(c_d_49, 3);

  int c_p_50[] = {  4,   1,   2}; //   3
  psi_c_p[no_ps][50] = get_vector_from_array_int(c_p_50, 3);
  int c_f_50[] = {}; //   0
  psi_c_f[no_ps][50] = get_vector_from_array_int(c_f_50, 0);
  int c_t_50[] = {  0}; //   1
  psi_c_t[no_ps][50] = get_vector_from_array_int(c_t_50, 1);
  int c_d_50[] = {  1,   2,   3}; //   3
  psi_c_d[no_ps][50] = get_vector_from_array_int(c_d_50, 3);

  int c_p_51[] = {  4,   1,   3}; //   3
  psi_c_p[no_ps][51] = get_vector_from_array_int(c_p_51, 3);
  int c_f_51[] = {}; //   0
  psi_c_f[no_ps][51] = get_vector_from_array_int(c_f_51, 0);
  int c_t_51[] = {  0}; //   1
  psi_c_t[no_ps][51] = get_vector_from_array_int(c_t_51, 1);
  int c_d_51[] = {  1,   2,   3}; //   3
  psi_c_d[no_ps][51] = get_vector_from_array_int(c_d_51, 3);

  int c_p_52[] = {  0,   5,   6}; //   3
  psi_c_p[no_ps][52] = get_vector_from_array_int(c_p_52, 3);
  int c_f_52[] = {}; //   0
  psi_c_f[no_ps][52] = get_vector_from_array_int(c_f_52, 0);
  int c_t_52[] = {  0}; //   1
  psi_c_t[no_ps][52] = get_vector_from_array_int(c_t_52, 1);
  int c_d_52[] = {  4,   5,   3}; //   3
  psi_c_d[no_ps][52] = get_vector_from_array_int(c_d_52, 3);

  int c_p_53[] = {  0,   5,   7}; //   3
  psi_c_p[no_ps][53] = get_vector_from_array_int(c_p_53, 3);
  int c_f_53[] = {}; //   0
  psi_c_f[no_ps][53] = get_vector_from_array_int(c_f_53, 0);
  int c_t_53[] = {  0}; //   1
  psi_c_t[no_ps][53] = get_vector_from_array_int(c_t_53, 1);
  int c_d_53[] = {  4,   5,   3}; //   3
  psi_c_d[no_ps][53] = get_vector_from_array_int(c_d_53, 3);

  int c_p_54[] = {  4,   5,   6}; //   3
  psi_c_p[no_ps][54] = get_vector_from_array_int(c_p_54, 3);
  int c_f_54[] = {}; //   0
  psi_c_f[no_ps][54] = get_vector_from_array_int(c_f_54, 0);
  int c_t_54[] = {  0}; //   1
  psi_c_t[no_ps][54] = get_vector_from_array_int(c_t_54, 1);
  int c_d_54[] = {  4,   5,   3}; //   3
  psi_c_d[no_ps][54] = get_vector_from_array_int(c_d_54, 3);

  int c_p_55[] = {  4,   5,   7}; //   3
  psi_c_p[no_ps][55] = get_vector_from_array_int(c_p_55, 3);
  int c_f_55[] = {}; //   0
  psi_c_f[no_ps][55] = get_vector_from_array_int(c_f_55, 0);
  int c_t_55[] = {  0}; //   1
  psi_c_t[no_ps][55] = get_vector_from_array_int(c_t_55, 1);
  int c_d_55[] = {  4,   5,   3}; //   3
  psi_c_d[no_ps][55] = get_vector_from_array_int(c_d_55, 3);

  int c_p_56[] = {  8,   9,   2}; //   3
  psi_c_p[no_ps][56] = get_vector_from_array_int(c_p_56, 3);
  int c_f_56[] = {}; //   0
  psi_c_f[no_ps][56] = get_vector_from_array_int(c_f_56, 0);
  int c_t_56[] = {  0}; //   1
  psi_c_t[no_ps][56] = get_vector_from_array_int(c_t_56, 1);
  int c_d_56[] = {  1,   6,   7}; //   3
  psi_c_d[no_ps][56] = get_vector_from_array_int(c_d_56, 3);

  int c_p_57[] = {  8,   9,   3}; //   3
  psi_c_p[no_ps][57] = get_vector_from_array_int(c_p_57, 3);
  int c_f_57[] = {}; //   0
  psi_c_f[no_ps][57] = get_vector_from_array_int(c_f_57, 0);
  int c_t_57[] = {  0}; //   1
  psi_c_t[no_ps][57] = get_vector_from_array_int(c_t_57, 1);
  int c_d_57[] = {  1,   6,   7}; //   3
  psi_c_d[no_ps][57] = get_vector_from_array_int(c_d_57, 3);

  int c_p_58[] = { 10,   9,   2}; //   3
  psi_c_p[no_ps][58] = get_vector_from_array_int(c_p_58, 3);
  int c_f_58[] = {}; //   0
  psi_c_f[no_ps][58] = get_vector_from_array_int(c_f_58, 0);
  int c_t_58[] = {  0}; //   1
  psi_c_t[no_ps][58] = get_vector_from_array_int(c_t_58, 1);
  int c_d_58[] = {  1,   6,   7}; //   3
  psi_c_d[no_ps][58] = get_vector_from_array_int(c_d_58, 3);

  int c_p_59[] = { 10,   9,   3}; //   3
  psi_c_p[no_ps][59] = get_vector_from_array_int(c_p_59, 3);
  int c_f_59[] = {}; //   0
  psi_c_f[no_ps][59] = get_vector_from_array_int(c_f_59, 0);
  int c_t_59[] = {  0}; //   1
  psi_c_t[no_ps][59] = get_vector_from_array_int(c_t_59, 1);
  int c_d_59[] = {  1,   6,   7}; //   3
  psi_c_d[no_ps][59] = get_vector_from_array_int(c_d_59, 3);

  int c_p_60[] = {  8,  11,  12}; //   3
  psi_c_p[no_ps][60] = get_vector_from_array_int(c_p_60, 3);
  int c_f_60[] = {}; //   0
  psi_c_f[no_ps][60] = get_vector_from_array_int(c_f_60, 0);
  int c_t_60[] = {  0}; //   1
  psi_c_t[no_ps][60] = get_vector_from_array_int(c_t_60, 1);
  int c_d_60[] = {  8,   9,   7}; //   3
  psi_c_d[no_ps][60] = get_vector_from_array_int(c_d_60, 3);

  int c_p_61[] = {  8,  11,  13}; //   3
  psi_c_p[no_ps][61] = get_vector_from_array_int(c_p_61, 3);
  int c_f_61[] = {}; //   0
  psi_c_f[no_ps][61] = get_vector_from_array_int(c_f_61, 0);
  int c_t_61[] = {  0}; //   1
  psi_c_t[no_ps][61] = get_vector_from_array_int(c_t_61, 1);
  int c_d_61[] = {  8,   9,   7}; //   3
  psi_c_d[no_ps][61] = get_vector_from_array_int(c_d_61, 3);

  int c_p_62[] = { 10,  11,  12}; //   3
  psi_c_p[no_ps][62] = get_vector_from_array_int(c_p_62, 3);
  int c_f_62[] = {}; //   0
  psi_c_f[no_ps][62] = get_vector_from_array_int(c_f_62, 0);
  int c_t_62[] = {  0}; //   1
  psi_c_t[no_ps][62] = get_vector_from_array_int(c_t_62, 1);
  int c_d_62[] = {  8,   9,   7}; //   3
  psi_c_d[no_ps][62] = get_vector_from_array_int(c_d_62, 3);

  int c_p_63[] = { 10,  11,  13}; //   3
  psi_c_p[no_ps][63] = get_vector_from_array_int(c_p_63, 3);
  int c_f_63[] = {}; //   0
  psi_c_f[no_ps][63] = get_vector_from_array_int(c_f_63, 0);
  int c_t_63[] = {  0}; //   1
  psi_c_t[no_ps][63] = get_vector_from_array_int(c_t_63, 1);
  int c_d_63[] = {  8,   9,   7}; //   3
  psi_c_d[no_ps][63] = get_vector_from_array_int(c_d_63, 3);

  int c_p_64[] = { 14,  15,  16}; //   3
  psi_c_p[no_ps][64] = get_vector_from_array_int(c_p_64, 3);
  int c_f_64[] = {}; //   0
  psi_c_f[no_ps][64] = get_vector_from_array_int(c_f_64, 0);
  int c_t_64[] = {  0}; //   1
  psi_c_t[no_ps][64] = get_vector_from_array_int(c_t_64, 1);
  int c_d_64[] = { 10,  11,  12}; //   3
  psi_c_d[no_ps][64] = get_vector_from_array_int(c_d_64, 3);

  int c_p_65[] = { 14,  15,  17}; //   3
  psi_c_p[no_ps][65] = get_vector_from_array_int(c_p_65, 3);
  int c_f_65[] = {}; //   0
  psi_c_f[no_ps][65] = get_vector_from_array_int(c_f_65, 0);
  int c_t_65[] = {  0}; //   1
  psi_c_t[no_ps][65] = get_vector_from_array_int(c_t_65, 1);
  int c_d_65[] = { 10,  11,  12}; //   3
  psi_c_d[no_ps][65] = get_vector_from_array_int(c_d_65, 3);

  int c_p_66[] = { 18,  15,  16}; //   3
  psi_c_p[no_ps][66] = get_vector_from_array_int(c_p_66, 3);
  int c_f_66[] = {}; //   0
  psi_c_f[no_ps][66] = get_vector_from_array_int(c_f_66, 0);
  int c_t_66[] = {  0}; //   1
  psi_c_t[no_ps][66] = get_vector_from_array_int(c_t_66, 1);
  int c_d_66[] = { 10,  11,  12}; //   3
  psi_c_d[no_ps][66] = get_vector_from_array_int(c_d_66, 3);

  int c_p_67[] = { 18,  15,  17}; //   3
  psi_c_p[no_ps][67] = get_vector_from_array_int(c_p_67, 3);
  int c_f_67[] = {}; //   0
  psi_c_f[no_ps][67] = get_vector_from_array_int(c_f_67, 0);
  int c_t_67[] = {  0}; //   1
  psi_c_t[no_ps][67] = get_vector_from_array_int(c_t_67, 1);
  int c_d_67[] = { 10,  11,  12}; //   3
  psi_c_d[no_ps][67] = get_vector_from_array_int(c_d_67, 3);

  int c_p_68[] = { 14,  19,   6}; //   3
  psi_c_p[no_ps][68] = get_vector_from_array_int(c_p_68, 3);
  int c_f_68[] = {}; //   0
  psi_c_f[no_ps][68] = get_vector_from_array_int(c_f_68, 0);
  int c_t_68[] = {  0}; //   1
  psi_c_t[no_ps][68] = get_vector_from_array_int(c_t_68, 1);
  int c_d_68[] = {  4,  13,  12}; //   3
  psi_c_d[no_ps][68] = get_vector_from_array_int(c_d_68, 3);

  int c_p_69[] = { 14,  19,   7}; //   3
  psi_c_p[no_ps][69] = get_vector_from_array_int(c_p_69, 3);
  int c_f_69[] = {}; //   0
  psi_c_f[no_ps][69] = get_vector_from_array_int(c_f_69, 0);
  int c_t_69[] = {  0}; //   1
  psi_c_t[no_ps][69] = get_vector_from_array_int(c_t_69, 1);
  int c_d_69[] = {  4,  13,  12}; //   3
  psi_c_d[no_ps][69] = get_vector_from_array_int(c_d_69, 3);

  int c_p_70[] = { 18,  19,   6}; //   3
  psi_c_p[no_ps][70] = get_vector_from_array_int(c_p_70, 3);
  int c_f_70[] = {}; //   0
  psi_c_f[no_ps][70] = get_vector_from_array_int(c_f_70, 0);
  int c_t_70[] = {  0}; //   1
  psi_c_t[no_ps][70] = get_vector_from_array_int(c_t_70, 1);
  int c_d_70[] = {  4,  13,  12}; //   3
  psi_c_d[no_ps][70] = get_vector_from_array_int(c_d_70, 3);

  int c_p_71[] = { 18,  19,   7}; //   3
  psi_c_p[no_ps][71] = get_vector_from_array_int(c_p_71, 3);
  int c_f_71[] = {}; //   0
  psi_c_f[no_ps][71] = get_vector_from_array_int(c_f_71, 0);
  int c_t_71[] = {  0}; //   1
  psi_c_t[no_ps][71] = get_vector_from_array_int(c_t_71, 1);
  int c_d_71[] = {  4,  13,  12}; //   3
  psi_c_d[no_ps][71] = get_vector_from_array_int(c_d_71, 3);

  int c_p_72[] = { 20,  21,  16}; //   3
  psi_c_p[no_ps][72] = get_vector_from_array_int(c_p_72, 3);
  int c_f_72[] = {}; //   0
  psi_c_f[no_ps][72] = get_vector_from_array_int(c_f_72, 0);
  int c_t_72[] = {  0}; //   1
  psi_c_t[no_ps][72] = get_vector_from_array_int(c_t_72, 1);
  int c_d_72[] = { 10,  14,  15}; //   3
  psi_c_d[no_ps][72] = get_vector_from_array_int(c_d_72, 3);

  int c_p_73[] = { 20,  21,  17}; //   3
  psi_c_p[no_ps][73] = get_vector_from_array_int(c_p_73, 3);
  int c_f_73[] = {}; //   0
  psi_c_f[no_ps][73] = get_vector_from_array_int(c_f_73, 0);
  int c_t_73[] = {  0}; //   1
  psi_c_t[no_ps][73] = get_vector_from_array_int(c_t_73, 1);
  int c_d_73[] = { 10,  14,  15}; //   3
  psi_c_d[no_ps][73] = get_vector_from_array_int(c_d_73, 3);

  int c_p_74[] = { 22,  21,  16}; //   3
  psi_c_p[no_ps][74] = get_vector_from_array_int(c_p_74, 3);
  int c_f_74[] = {}; //   0
  psi_c_f[no_ps][74] = get_vector_from_array_int(c_f_74, 0);
  int c_t_74[] = {  0}; //   1
  psi_c_t[no_ps][74] = get_vector_from_array_int(c_t_74, 1);
  int c_d_74[] = { 10,  14,  15}; //   3
  psi_c_d[no_ps][74] = get_vector_from_array_int(c_d_74, 3);

  int c_p_75[] = { 22,  21,  17}; //   3
  psi_c_p[no_ps][75] = get_vector_from_array_int(c_p_75, 3);
  int c_f_75[] = {}; //   0
  psi_c_f[no_ps][75] = get_vector_from_array_int(c_f_75, 0);
  int c_t_75[] = {  0}; //   1
  psi_c_t[no_ps][75] = get_vector_from_array_int(c_t_75, 1);
  int c_d_75[] = { 10,  14,  15}; //   3
  psi_c_d[no_ps][75] = get_vector_from_array_int(c_d_75, 3);

  int c_p_76[] = { 20,  23,  12}; //   3
  psi_c_p[no_ps][76] = get_vector_from_array_int(c_p_76, 3);
  int c_f_76[] = {}; //   0
  psi_c_f[no_ps][76] = get_vector_from_array_int(c_f_76, 0);
  int c_t_76[] = {  0}; //   1
  psi_c_t[no_ps][76] = get_vector_from_array_int(c_t_76, 1);
  int c_d_76[] = {  8,  16,  15}; //   3
  psi_c_d[no_ps][76] = get_vector_from_array_int(c_d_76, 3);

  int c_p_77[] = { 20,  23,  13}; //   3
  psi_c_p[no_ps][77] = get_vector_from_array_int(c_p_77, 3);
  int c_f_77[] = {}; //   0
  psi_c_f[no_ps][77] = get_vector_from_array_int(c_f_77, 0);
  int c_t_77[] = {  0}; //   1
  psi_c_t[no_ps][77] = get_vector_from_array_int(c_t_77, 1);
  int c_d_77[] = {  8,  16,  15}; //   3
  psi_c_d[no_ps][77] = get_vector_from_array_int(c_d_77, 3);

  int c_p_78[] = { 22,  23,  12}; //   3
  psi_c_p[no_ps][78] = get_vector_from_array_int(c_p_78, 3);
  int c_f_78[] = {}; //   0
  psi_c_f[no_ps][78] = get_vector_from_array_int(c_f_78, 0);
  int c_t_78[] = {  0}; //   1
  psi_c_t[no_ps][78] = get_vector_from_array_int(c_t_78, 1);
  int c_d_78[] = {  8,  16,  15}; //   3
  psi_c_d[no_ps][78] = get_vector_from_array_int(c_d_78, 3);

  int c_p_79[] = { 22,  23,  13}; //   3
  psi_c_p[no_ps][79] = get_vector_from_array_int(c_p_79, 3);
  int c_f_79[] = {}; //   0
  psi_c_f[no_ps][79] = get_vector_from_array_int(c_f_79, 0);
  int c_t_79[] = {  0}; //   1
  psi_c_t[no_ps][79] = get_vector_from_array_int(c_t_79, 1);
  int c_d_79[] = {  8,  16,  15}; //   3
  psi_c_d[no_ps][79] = get_vector_from_array_int(c_d_79, 3);

  int c_p_80[] = {  0,  36,  37}; //   3
  psi_c_p[no_ps][80] = get_vector_from_array_int(c_p_80, 3);
  int c_f_80[] = {}; //   0
  psi_c_f[no_ps][80] = get_vector_from_array_int(c_f_80, 0);
  int c_t_80[] = {  1}; //   1
  psi_c_t[no_ps][80] = get_vector_from_array_int(c_t_80, 1);
  int c_d_80[] = { 24,  15,   3}; //   3
  psi_c_d[no_ps][80] = get_vector_from_array_int(c_d_80, 3);

  int c_p_81[] = {  0,  38,  37}; //   3
  psi_c_p[no_ps][81] = get_vector_from_array_int(c_p_81, 3);
  int c_f_81[] = {}; //   0
  psi_c_f[no_ps][81] = get_vector_from_array_int(c_f_81, 0);
  int c_t_81[] = {  1}; //   1
  psi_c_t[no_ps][81] = get_vector_from_array_int(c_t_81, 1);
  int c_d_81[] = { 24,  15,   3}; //   3
  psi_c_d[no_ps][81] = get_vector_from_array_int(c_d_81, 3);

  int c_p_82[] = {  4,  36,  37}; //   3
  psi_c_p[no_ps][82] = get_vector_from_array_int(c_p_82, 3);
  int c_f_82[] = {}; //   0
  psi_c_f[no_ps][82] = get_vector_from_array_int(c_f_82, 0);
  int c_t_82[] = {  1}; //   1
  psi_c_t[no_ps][82] = get_vector_from_array_int(c_t_82, 1);
  int c_d_82[] = { 24,  15,   3}; //   3
  psi_c_d[no_ps][82] = get_vector_from_array_int(c_d_82, 3);

  int c_p_83[] = {  4,  38,  37}; //   3
  psi_c_p[no_ps][83] = get_vector_from_array_int(c_p_83, 3);
  int c_f_83[] = {}; //   0
  psi_c_f[no_ps][83] = get_vector_from_array_int(c_f_83, 0);
  int c_t_83[] = {  1}; //   1
  psi_c_t[no_ps][83] = get_vector_from_array_int(c_t_83, 1);
  int c_d_83[] = { 24,  15,   3}; //   3
  psi_c_d[no_ps][83] = get_vector_from_array_int(c_d_83, 3);

  int c_p_84[] = {  8,  39,  40}; //   3
  psi_c_p[no_ps][84] = get_vector_from_array_int(c_p_84, 3);
  int c_f_84[] = {}; //   0
  psi_c_f[no_ps][84] = get_vector_from_array_int(c_f_84, 0);
  int c_t_84[] = {  2}; //   1
  psi_c_t[no_ps][84] = get_vector_from_array_int(c_t_84, 1);
  int c_d_84[] = { 22,  12,   7}; //   3
  psi_c_d[no_ps][84] = get_vector_from_array_int(c_d_84, 3);

  int c_p_85[] = {  8,  41,  40}; //   3
  psi_c_p[no_ps][85] = get_vector_from_array_int(c_p_85, 3);
  int c_f_85[] = {}; //   0
  psi_c_f[no_ps][85] = get_vector_from_array_int(c_f_85, 0);
  int c_t_85[] = {  2}; //   1
  psi_c_t[no_ps][85] = get_vector_from_array_int(c_t_85, 1);
  int c_d_85[] = { 22,  12,   7}; //   3
  psi_c_d[no_ps][85] = get_vector_from_array_int(c_d_85, 3);

  int c_p_86[] = { 10,  39,  40}; //   3
  psi_c_p[no_ps][86] = get_vector_from_array_int(c_p_86, 3);
  int c_f_86[] = {}; //   0
  psi_c_f[no_ps][86] = get_vector_from_array_int(c_f_86, 0);
  int c_t_86[] = {  2}; //   1
  psi_c_t[no_ps][86] = get_vector_from_array_int(c_t_86, 1);
  int c_d_86[] = { 22,  12,   7}; //   3
  psi_c_d[no_ps][86] = get_vector_from_array_int(c_d_86, 3);

  int c_p_87[] = { 10,  41,  40}; //   3
  psi_c_p[no_ps][87] = get_vector_from_array_int(c_p_87, 3);
  int c_f_87[] = {}; //   0
  psi_c_f[no_ps][87] = get_vector_from_array_int(c_f_87, 0);
  int c_t_87[] = {  2}; //   1
  psi_c_t[no_ps][87] = get_vector_from_array_int(c_t_87, 1);
  int c_d_87[] = { 22,  12,   7}; //   3
  psi_c_d[no_ps][87] = get_vector_from_array_int(c_d_87, 3);

  int c_p_88[] = { 14,  42,  43}; //   3
  psi_c_p[no_ps][88] = get_vector_from_array_int(c_p_88, 3);
  int c_f_88[] = {}; //   0
  psi_c_f[no_ps][88] = get_vector_from_array_int(c_f_88, 0);
  int c_t_88[] = {  3}; //   1
  psi_c_t[no_ps][88] = get_vector_from_array_int(c_t_88, 1);
  int c_d_88[] = { 20,   7,  12}; //   3
  psi_c_d[no_ps][88] = get_vector_from_array_int(c_d_88, 3);

  int c_p_89[] = { 14,  44,  43}; //   3
  psi_c_p[no_ps][89] = get_vector_from_array_int(c_p_89, 3);
  int c_f_89[] = {}; //   0
  psi_c_f[no_ps][89] = get_vector_from_array_int(c_f_89, 0);
  int c_t_89[] = {  3}; //   1
  psi_c_t[no_ps][89] = get_vector_from_array_int(c_t_89, 1);
  int c_d_89[] = { 20,   7,  12}; //   3
  psi_c_d[no_ps][89] = get_vector_from_array_int(c_d_89, 3);

  int c_p_90[] = { 18,  42,  43}; //   3
  psi_c_p[no_ps][90] = get_vector_from_array_int(c_p_90, 3);
  int c_f_90[] = {}; //   0
  psi_c_f[no_ps][90] = get_vector_from_array_int(c_f_90, 0);
  int c_t_90[] = {  3}; //   1
  psi_c_t[no_ps][90] = get_vector_from_array_int(c_t_90, 1);
  int c_d_90[] = { 20,   7,  12}; //   3
  psi_c_d[no_ps][90] = get_vector_from_array_int(c_d_90, 3);

  int c_p_91[] = { 18,  44,  43}; //   3
  psi_c_p[no_ps][91] = get_vector_from_array_int(c_p_91, 3);
  int c_f_91[] = {}; //   0
  psi_c_f[no_ps][91] = get_vector_from_array_int(c_f_91, 0);
  int c_t_91[] = {  3}; //   1
  psi_c_t[no_ps][91] = get_vector_from_array_int(c_t_91, 1);
  int c_d_91[] = { 20,   7,  12}; //   3
  psi_c_d[no_ps][91] = get_vector_from_array_int(c_d_91, 3);

  int c_p_92[] = { 20,  45,  46}; //   3
  psi_c_p[no_ps][92] = get_vector_from_array_int(c_p_92, 3);
  int c_f_92[] = {}; //   0
  psi_c_f[no_ps][92] = get_vector_from_array_int(c_f_92, 0);
  int c_t_92[] = {  4}; //   1
  psi_c_t[no_ps][92] = get_vector_from_array_int(c_t_92, 1);
  int c_d_92[] = { 18,   3,  15}; //   3
  psi_c_d[no_ps][92] = get_vector_from_array_int(c_d_92, 3);

  int c_p_93[] = { 20,  47,  46}; //   3
  psi_c_p[no_ps][93] = get_vector_from_array_int(c_p_93, 3);
  int c_f_93[] = {}; //   0
  psi_c_f[no_ps][93] = get_vector_from_array_int(c_f_93, 0);
  int c_t_93[] = {  4}; //   1
  psi_c_t[no_ps][93] = get_vector_from_array_int(c_t_93, 1);
  int c_d_93[] = { 18,   3,  15}; //   3
  psi_c_d[no_ps][93] = get_vector_from_array_int(c_d_93, 3);

  int c_p_94[] = { 22,  45,  46}; //   3
  psi_c_p[no_ps][94] = get_vector_from_array_int(c_p_94, 3);
  int c_f_94[] = {}; //   0
  psi_c_f[no_ps][94] = get_vector_from_array_int(c_f_94, 0);
  int c_t_94[] = {  4}; //   1
  psi_c_t[no_ps][94] = get_vector_from_array_int(c_t_94, 1);
  int c_d_94[] = { 18,   3,  15}; //   3
  psi_c_d[no_ps][94] = get_vector_from_array_int(c_d_94, 3);

  int c_p_95[] = { 22,  47,  46}; //   3
  psi_c_p[no_ps][95] = get_vector_from_array_int(c_p_95, 3);
  int c_f_95[] = {}; //   0
  psi_c_f[no_ps][95] = get_vector_from_array_int(c_f_95, 0);
  int c_t_95[] = {  4}; //   1
  psi_c_t[no_ps][95] = get_vector_from_array_int(c_t_95, 1);
  int c_d_95[] = { 18,   3,  15}; //   3
  psi_c_d[no_ps][95] = get_vector_from_array_int(c_d_95, 3);

  int c_p_96[] = {  0,  36}; //   2
  psi_c_p[no_ps][96] = get_vector_from_array_int(c_p_96, 2);
  int c_f_96[] = {  0}; //   1
  psi_c_f[no_ps][96] = get_vector_from_array_int(c_f_96, 1);
  int c_t_96[] = {  0,   5}; //   2
  psi_c_t[no_ps][96] = get_vector_from_array_int(c_t_96, 2);
  int c_d_96[] = { 15,   3}; //   2
  psi_c_d[no_ps][96] = get_vector_from_array_int(c_d_96, 2);

  int c_p_97[] = {  0,  38}; //   2
  psi_c_p[no_ps][97] = get_vector_from_array_int(c_p_97, 2);
  int c_f_97[] = {  0}; //   1
  psi_c_f[no_ps][97] = get_vector_from_array_int(c_f_97, 1);
  int c_t_97[] = {  0,   5}; //   2
  psi_c_t[no_ps][97] = get_vector_from_array_int(c_t_97, 2);
  int c_d_97[] = { 15,   3}; //   2
  psi_c_d[no_ps][97] = get_vector_from_array_int(c_d_97, 2);

  int c_p_98[] = {  4,  36}; //   2
  psi_c_p[no_ps][98] = get_vector_from_array_int(c_p_98, 2);
  int c_f_98[] = {  0}; //   1
  psi_c_f[no_ps][98] = get_vector_from_array_int(c_f_98, 1);
  int c_t_98[] = {  0,   5}; //   2
  psi_c_t[no_ps][98] = get_vector_from_array_int(c_t_98, 2);
  int c_d_98[] = { 15,   3}; //   2
  psi_c_d[no_ps][98] = get_vector_from_array_int(c_d_98, 2);

  int c_p_99[] = {  4,  38}; //   2
  psi_c_p[no_ps][99] = get_vector_from_array_int(c_p_99, 2);
  int c_f_99[] = {  0}; //   1
  psi_c_f[no_ps][99] = get_vector_from_array_int(c_f_99, 1);
  int c_t_99[] = {  0,   5}; //   2
  psi_c_t[no_ps][99] = get_vector_from_array_int(c_t_99, 2);
  int c_d_99[] = { 15,   3}; //   2
  psi_c_d[no_ps][99] = get_vector_from_array_int(c_d_99, 2);

  int c_p_100[] = {  8,  39}; //   2
  psi_c_p[no_ps][100] = get_vector_from_array_int(c_p_100, 2);
  int c_f_100[] = {  1}; //   1
  psi_c_f[no_ps][100] = get_vector_from_array_int(c_f_100, 1);
  int c_t_100[] = {  0,   6}; //   2
  psi_c_t[no_ps][100] = get_vector_from_array_int(c_t_100, 2);
  int c_d_100[] = { 12,   7}; //   2
  psi_c_d[no_ps][100] = get_vector_from_array_int(c_d_100, 2);

  int c_p_101[] = {  8,  41}; //   2
  psi_c_p[no_ps][101] = get_vector_from_array_int(c_p_101, 2);
  int c_f_101[] = {  1}; //   1
  psi_c_f[no_ps][101] = get_vector_from_array_int(c_f_101, 1);
  int c_t_101[] = {  0,   6}; //   2
  psi_c_t[no_ps][101] = get_vector_from_array_int(c_t_101, 2);
  int c_d_101[] = { 12,   7}; //   2
  psi_c_d[no_ps][101] = get_vector_from_array_int(c_d_101, 2);

  int c_p_102[] = { 10,  39}; //   2
  psi_c_p[no_ps][102] = get_vector_from_array_int(c_p_102, 2);
  int c_f_102[] = {  1}; //   1
  psi_c_f[no_ps][102] = get_vector_from_array_int(c_f_102, 1);
  int c_t_102[] = {  0,   6}; //   2
  psi_c_t[no_ps][102] = get_vector_from_array_int(c_t_102, 2);
  int c_d_102[] = { 12,   7}; //   2
  psi_c_d[no_ps][102] = get_vector_from_array_int(c_d_102, 2);

  int c_p_103[] = { 10,  41}; //   2
  psi_c_p[no_ps][103] = get_vector_from_array_int(c_p_103, 2);
  int c_f_103[] = {  1}; //   1
  psi_c_f[no_ps][103] = get_vector_from_array_int(c_f_103, 1);
  int c_t_103[] = {  0,   6}; //   2
  psi_c_t[no_ps][103] = get_vector_from_array_int(c_t_103, 2);
  int c_d_103[] = { 12,   7}; //   2
  psi_c_d[no_ps][103] = get_vector_from_array_int(c_d_103, 2);

  int c_p_104[] = { 14,  42}; //   2
  psi_c_p[no_ps][104] = get_vector_from_array_int(c_p_104, 2);
  int c_f_104[] = {  1}; //   1
  psi_c_f[no_ps][104] = get_vector_from_array_int(c_f_104, 1);
  int c_t_104[] = {  0,   7}; //   2
  psi_c_t[no_ps][104] = get_vector_from_array_int(c_t_104, 2);
  int c_d_104[] = {  7,  12}; //   2
  psi_c_d[no_ps][104] = get_vector_from_array_int(c_d_104, 2);

  int c_p_105[] = { 14,  44}; //   2
  psi_c_p[no_ps][105] = get_vector_from_array_int(c_p_105, 2);
  int c_f_105[] = {  1}; //   1
  psi_c_f[no_ps][105] = get_vector_from_array_int(c_f_105, 1);
  int c_t_105[] = {  0,   7}; //   2
  psi_c_t[no_ps][105] = get_vector_from_array_int(c_t_105, 2);
  int c_d_105[] = {  7,  12}; //   2
  psi_c_d[no_ps][105] = get_vector_from_array_int(c_d_105, 2);

  int c_p_106[] = { 18,  42}; //   2
  psi_c_p[no_ps][106] = get_vector_from_array_int(c_p_106, 2);
  int c_f_106[] = {  1}; //   1
  psi_c_f[no_ps][106] = get_vector_from_array_int(c_f_106, 1);
  int c_t_106[] = {  0,   7}; //   2
  psi_c_t[no_ps][106] = get_vector_from_array_int(c_t_106, 2);
  int c_d_106[] = {  7,  12}; //   2
  psi_c_d[no_ps][106] = get_vector_from_array_int(c_d_106, 2);

  int c_p_107[] = { 18,  44}; //   2
  psi_c_p[no_ps][107] = get_vector_from_array_int(c_p_107, 2);
  int c_f_107[] = {  1}; //   1
  psi_c_f[no_ps][107] = get_vector_from_array_int(c_f_107, 1);
  int c_t_107[] = {  0,   7}; //   2
  psi_c_t[no_ps][107] = get_vector_from_array_int(c_t_107, 2);
  int c_d_107[] = {  7,  12}; //   2
  psi_c_d[no_ps][107] = get_vector_from_array_int(c_d_107, 2);

  int c_p_108[] = { 20,  45}; //   2
  psi_c_p[no_ps][108] = get_vector_from_array_int(c_p_108, 2);
  int c_f_108[] = {  0}; //   1
  psi_c_f[no_ps][108] = get_vector_from_array_int(c_f_108, 1);
  int c_t_108[] = {  0,   8}; //   2
  psi_c_t[no_ps][108] = get_vector_from_array_int(c_t_108, 2);
  int c_d_108[] = {  3,  15}; //   2
  psi_c_d[no_ps][108] = get_vector_from_array_int(c_d_108, 2);

  int c_p_109[] = { 20,  47}; //   2
  psi_c_p[no_ps][109] = get_vector_from_array_int(c_p_109, 2);
  int c_f_109[] = {  0}; //   1
  psi_c_f[no_ps][109] = get_vector_from_array_int(c_f_109, 1);
  int c_t_109[] = {  0,   8}; //   2
  psi_c_t[no_ps][109] = get_vector_from_array_int(c_t_109, 2);
  int c_d_109[] = {  3,  15}; //   2
  psi_c_d[no_ps][109] = get_vector_from_array_int(c_d_109, 2);

  int c_p_110[] = { 22,  45}; //   2
  psi_c_p[no_ps][110] = get_vector_from_array_int(c_p_110, 2);
  int c_f_110[] = {  0}; //   1
  psi_c_f[no_ps][110] = get_vector_from_array_int(c_f_110, 1);
  int c_t_110[] = {  0,   8}; //   2
  psi_c_t[no_ps][110] = get_vector_from_array_int(c_t_110, 2);
  int c_d_110[] = {  3,  15}; //   2
  psi_c_d[no_ps][110] = get_vector_from_array_int(c_d_110, 2);

  int c_p_111[] = { 22,  47}; //   2
  psi_c_p[no_ps][111] = get_vector_from_array_int(c_p_111, 2);
  int c_f_111[] = {  0}; //   1
  psi_c_f[no_ps][111] = get_vector_from_array_int(c_f_111, 1);
  int c_t_111[] = {  0,   8}; //   2
  psi_c_t[no_ps][111] = get_vector_from_array_int(c_t_111, 2);
  int c_d_111[] = {  3,  15}; //   2
  psi_c_d[no_ps][111] = get_vector_from_array_int(c_d_111, 2);

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
