#include "../include/classes.cxx"
#include "../include/definitions.phasespace.set.cxx"
#include "../ppeeexnex04/header/ppeeexnex04.phasespace.h"
void ppeeexnex04_optimize_minv_doublereal(phasespace_set & psi){
  static Logger logger("ppeeexnex04_optimize_minv_doublereal");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

#include "user/specify.optimize.phasespace.minv.doublereal.cxx"

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

int ppeeexnex04_determination_MCchannels_doublereal(int no_ps, phasespace_set & psi){
  static Logger logger("ppeeexnex04_determination_MCchannels_doublereal");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  int n_channel = 0;
  if      (psi_no_map[no_ps] ==  0){n_channel = 524;}
  else if (psi_no_map[no_ps] ==  1){n_channel = 216;}
  else if (psi_no_map[no_ps] ==  2){n_channel = 216;}
  else if (psi_no_map[no_ps] ==  3){n_channel = 216;}
  else if (psi_no_map[no_ps] ==  4){n_channel = 128;}
  else if (psi_no_map[no_ps] ==  5){n_channel = 128;}
  else if (psi_no_map[no_ps] ==  6){n_channel = 64;}
  else if (psi_no_map[no_ps] ==  7){n_channel = 64;}
  else if (psi_no_map[no_ps] ==  8){n_channel = 128;}
  else if (psi_no_map[no_ps] ==  9){n_channel = 64;}
  else if (psi_no_map[no_ps] == 10){n_channel = 216;}
  else if (psi_no_map[no_ps] == 11){n_channel = 128;}
  else if (psi_no_map[no_ps] == 12){n_channel = 128;}
  else if (psi_no_map[no_ps] == 13){n_channel = 64;}
  else if (psi_no_map[no_ps] == 14){n_channel = 64;}
  else if (psi_no_map[no_ps] == 15){n_channel = 64;}
  else if (psi_no_map[no_ps] == 16){n_channel = 64;}
  else if (psi_no_map[no_ps] == 17){n_channel = 64;}
  else if (psi_no_map[no_ps] == 18){n_channel = 128;}
  else if (psi_no_map[no_ps] == 19){n_channel = 64;}
  else if (psi_no_map[no_ps] == 20){n_channel = 64;}
  else if (psi_no_map[no_ps] == 21){n_channel = 128;}
  else if (psi_no_map[no_ps] == 22){n_channel = 64;}
  else if (psi_no_map[no_ps] == 23){n_channel = 128;}
  else if (psi_no_map[no_ps] == 24){n_channel = 64;}
  return n_channel;

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

void ppeeexnex04_ac_tau_psp_doublereal(int no_ps, vector<int> & tau_MC_map, phasespace_set & psi){
  static Logger logger("ppeeexnex04_ac_tau_psp_doublereal");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  if      (psi.no_map[no_ps] == 0){}
  else if (psi.no_map[no_ps] ==  1){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  2){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  3){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  4){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  5){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  6){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  7){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  8){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  9){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 10){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 11){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 12){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 13){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 14){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 15){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 16){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 17){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 18){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 19){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 20){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 21){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 22){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 23){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 24){
    tau_MC_map.push_back(0);
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

void ppeeexnex04_ax_psp_doublereal(int no_ps, phasespace_set & psi){
  static Logger logger("ppeeexnex04_ax_psp_doublereal");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;
  if (psi_no_map[no_ps] == 0){}
  else if (psi_no_map[no_ps] ==  1){ppeeexnex04_ax_psp_240_gg_ememepvexudx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  2){ppeeexnex04_ax_psp_240_gd_ememepvexgu(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  3){ppeeexnex04_ax_psp_240_gux_ememepvexgdx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  4){ppeeexnex04_ax_psp_240_dd_ememepvexdu(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  5){ppeeexnex04_ax_psp_240_du_ememepvexuu(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  6){ppeeexnex04_ax_psp_240_ds_ememepvexdc(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  7){ppeeexnex04_ax_psp_240_dc_ememepvexuc(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  8){ppeeexnex04_ax_psp_240_ddx_ememepvexudx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  9){ppeeexnex04_ax_psp_240_ddx_ememepvexcsx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 10){ppeeexnex04_ax_psp_240_dux_ememepvexgg(no_ps, psi);}
  else if (psi_no_map[no_ps] == 11){ppeeexnex04_ax_psp_240_dux_ememepvexddx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 12){ppeeexnex04_ax_psp_240_dux_ememepvexuux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 13){ppeeexnex04_ax_psp_240_dux_ememepvexssx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 14){ppeeexnex04_ax_psp_240_dux_ememepvexccx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 15){ppeeexnex04_ax_psp_240_dsx_ememepvexusx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 16){ppeeexnex04_ax_psp_240_dcx_ememepvexdsx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 17){ppeeexnex04_ax_psp_240_dcx_ememepvexucx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 18){ppeeexnex04_ax_psp_240_uux_ememepvexudx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 19){ppeeexnex04_ax_psp_240_uux_ememepvexcsx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 20){ppeeexnex04_ax_psp_240_ucx_ememepvexusx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 21){ppeeexnex04_ax_psp_240_dxux_ememepvexdxdx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 22){ppeeexnex04_ax_psp_240_dxcx_ememepvexdxsx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 23){ppeeexnex04_ax_psp_240_uxux_ememepvexdxux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 24){ppeeexnex04_ax_psp_240_uxcx_ememepvexdxcx(no_ps, psi);}

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
