#include "../include/classes.cxx"
#include "../include/definitions.phasespace.set.cxx"
#include "../ppeexa03/header/ppeexa03.phasespace.h"
void ppeexa03_ax_psp_230_ddx_emepaddx(int no_ps, phasespace_set & psi){
  static Logger logger("ppeexa03_ax_psp_230_ddx_emepaddx");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;
  psi_v_smin[no_ps].resize(23);
  psi_needed_v_smin[no_ps].resize(23);
  int needed_v_smin_0[] = {   0,    1,    2,    3,    6,    7,   12,   13,   14,   15,   16,   17,   20,   21,   26,   27,   28,   29,   34,   35,   36,   37,   38,   39,   40,   41,   42,   43,   44,   45,   46,   47,   50,   51,   52,   53,   54,   55,   58,   59,   60,   61,   64,   65,   68,   69,   70,   71,   72,   73,   74,   75,   76,   77,   78,   79,   80,   81,   84,   85,   88,   89,   90,   91,   92,   93,   94,   95,   98,   99,  100,  101,  102,  103,  106,  107,  108,  109,  110,  111}; //  80
  psi_needed_v_smin[no_ps][  0] = get_vector_from_array_int(needed_v_smin_0, 80);
  int needed_v_smin_1[] = {   4,    5,   10,   11,   22,   23,   24,   25,   48,   49,   62,   63,   82,   83,   96,   97}; //  16
  psi_needed_v_smin[no_ps][  1] = get_vector_from_array_int(needed_v_smin_1, 16);
  int needed_v_smin_2[] = {   4,    5,   10,   11,   22,   23,   24,   25,   48,   49,   62,   63,   82,   83,   96,   97}; //  16
  psi_needed_v_smin[no_ps][  2] = get_vector_from_array_int(needed_v_smin_2, 16);
  int needed_v_smin_3[] = {   6,    7,   14,   15,   16,   17,   26,   27,   40,   41,   46,   47,   52,   53,   98,   99,   42,   43}; //  18
  psi_needed_v_smin[no_ps][  3] = get_vector_from_array_int(needed_v_smin_3, 18);
  int needed_v_smin_4[] = {   8,    9,   18,   19,   30,   31,   32,   33,   56,   57,   66,   67,   86,   87,  104,  105}; //  16
  psi_needed_v_smin[no_ps][  4] = get_vector_from_array_int(needed_v_smin_4, 16);
  int needed_v_smin_5[] = {   8,    9,   18,   19,   30,   31,   32,   33,   56,   57,   66,   67,   86,   87,  104,  105}; //  16
  psi_needed_v_smin[no_ps][  5] = get_vector_from_array_int(needed_v_smin_5, 16);
  int needed_v_smin_6[] = {  10,   11,   18,   19,   24,   25,   32,   33,    4,    5,    8,    9}; //  12
  psi_needed_v_smin[no_ps][  6] = get_vector_from_array_int(needed_v_smin_6, 12);
  int needed_v_smin_7[] = {  12,   13,   28,   29,   38,   39,   44,   45,   50,   51,   54,   55,   64,   65,   84,   85,   60,   61,   92,   93}; //  20
  psi_needed_v_smin[no_ps][  7] = get_vector_from_array_int(needed_v_smin_7, 20);
  int needed_v_smin_8[] = {  12,   13,   50,   51,   64,   65}; //   6
  psi_needed_v_smin[no_ps][  8] = get_vector_from_array_int(needed_v_smin_8, 6);
  int needed_v_smin_9[] = {  14,   15,   52,   53,    6,    7,   42,   43,   46,   47}; //  10
  psi_needed_v_smin[no_ps][  9] = get_vector_from_array_int(needed_v_smin_9, 10);
  int needed_v_smin_10[] = {  16,   17,   26,   27}; //   4
  psi_needed_v_smin[no_ps][ 10] = get_vector_from_array_int(needed_v_smin_10, 4);
  int needed_v_smin_11[] = {  20,   21,   34,   35,   38,   39,   72,   73,   78,   79,   84,   85,   92,   93,  100,  101,    0,    1}; //  18
  psi_needed_v_smin[no_ps][ 11] = get_vector_from_array_int(needed_v_smin_11, 18);
  int needed_v_smin_12[] = {  20,   21,   34,   35,    0,    1,   72,   73}; //   8
  psi_needed_v_smin[no_ps][ 12] = get_vector_from_array_int(needed_v_smin_12, 8);
  int needed_v_smin_13[] = {  22,   23,   30,   31,   48,   49,   56,   57,   62,   63,   66,   67}; //  12
  psi_needed_v_smin[no_ps][ 13] = get_vector_from_array_int(needed_v_smin_13, 12);
  int needed_v_smin_14[] = {  28,   29,   54,   55,   44,   45,   60,   61}; //   8
  psi_needed_v_smin[no_ps][ 14] = get_vector_from_array_int(needed_v_smin_14, 8);
  int needed_v_smin_15[] = {  36,   37,   40,   41,   58,   59,   80,   81,   90,   91,   98,   99,  102,  103,  110,  111,   70,   71}; //  18
  psi_needed_v_smin[no_ps][ 15] = get_vector_from_array_int(needed_v_smin_15, 18);
  int needed_v_smin_16[] = {  36,   37,   58,   59,   70,   71,  110,  111}; //   8
  psi_needed_v_smin[no_ps][ 16] = get_vector_from_array_int(needed_v_smin_16, 8);
  int needed_v_smin_17[] = {  74,   75,   76,   77,   82,   83,   86,   87,   88,   89,   94,   95,   96,   97,  104,  105,  106,  107,  108,  109,    2,    3,   68,   69}; //  24
  psi_needed_v_smin[no_ps][ 17] = get_vector_from_array_int(needed_v_smin_17, 24);
  int needed_v_smin_18[] = {  78,   79,  100,  101}; //   4
  psi_needed_v_smin[no_ps][ 18] = get_vector_from_array_int(needed_v_smin_18, 4);
  int needed_v_smin_19[] = {  80,   81,  102,  103,   90,   91}; //   6
  psi_needed_v_smin[no_ps][ 19] = get_vector_from_array_int(needed_v_smin_19, 6);
  int needed_v_smin_20[] = {   2,    3,   68,   69,   74,   75,   76,   77,  106,  107,  108,  109}; //  12
  psi_needed_v_smin[no_ps][ 20] = get_vector_from_array_int(needed_v_smin_20, 12);
  int needed_v_smin_21[] = {  88,   89}; //   2
  psi_needed_v_smin[no_ps][ 21] = get_vector_from_array_int(needed_v_smin_21, 2);
  int needed_v_smin_22[] = {  94,   95}; //   2
  psi_needed_v_smin[no_ps][ 22] = get_vector_from_array_int(needed_v_smin_22, 2);

  psi_v_smax[no_ps].resize(29);
  psi_needed_v_smax[no_ps].resize(29);
  int needed_v_smax_0[] = {   0,    1,    2,    3,    6,    7,   12,   13,   14,   15,   16,   17,   26,   27,   28,   29,   38,   39,   40,   41,   42,   43,   44,   45,   46,   47,   50,   51,   52,   53,   54,   55,   60,   61,   64,   65,   68,   69,   70,   71,   76,   77,   84,   85,   92,   93,   94,   95,  100,  101,  102,  103,  108,  109,  110,  111}; //  56
  psi_needed_v_smax[no_ps][  0] = get_vector_from_array_int(needed_v_smax_0, 56);
  int needed_v_smax_1[] = {   4,    5,   10,   11,   22,   23,   24,   25,   48,   49,   62,   63,   82,   83}; //  14
  psi_needed_v_smax[no_ps][  1] = get_vector_from_array_int(needed_v_smax_1, 14);
  int needed_v_smax_2[] = {   4,    5,    8,    9,   10,   11,   18,   19,   22,   23,   24,   25,   30,   31,   32,   33,   48,   49,   56,   57,   62,   63,   66,   67,   82,   83,   86,   87}; //  28
  psi_needed_v_smax[no_ps][  2] = get_vector_from_array_int(needed_v_smax_2, 28);
  int needed_v_smax_3[] = {   6,    7,   14,   15,   16,   17,   26,   27,   40,   41,   46,   47,   52,   53,   42,   43}; //  16
  psi_needed_v_smax[no_ps][  3] = get_vector_from_array_int(needed_v_smax_3, 16);
  int needed_v_smax_4[] = {   8,    9,   18,   19,   30,   31,   32,   33,   56,   57,   66,   67,   86,   87}; //  14
  psi_needed_v_smax[no_ps][  4] = get_vector_from_array_int(needed_v_smax_4, 14);
  int needed_v_smax_5[] = {  10,   11,   16,   17,   18,   19,   20,   21,   24,   25,   26,   27,   32,   33,   34,   35,    0,    1,    4,    5,    8,    9,   72,   73}; //  24
  psi_needed_v_smax[no_ps][  5] = get_vector_from_array_int(needed_v_smax_5, 24);
  int needed_v_smax_6[] = {  12,   13,   28,   29,   38,   39,   44,   45,   50,   51,   54,   55,   64,   65,   84,   85,   60,   61}; //  18
  psi_needed_v_smax[no_ps][  6] = get_vector_from_array_int(needed_v_smax_6, 18);
  int needed_v_smax_7[] = {  12,   13,   14,   15,   50,   51,   52,   53,    2,    3,    6,    7,   42,   43,   46,   47,   64,   65,   68,   69,   74,   75,   76,   77,  106,  107,  108,  109}; //  28
  psi_needed_v_smax[no_ps][  7] = get_vector_from_array_int(needed_v_smax_7, 28);
  int needed_v_smax_8[] = {  20,   21,   34,   35,   72,   73,   78,   79}; //   8
  psi_needed_v_smax[no_ps][  8] = get_vector_from_array_int(needed_v_smax_8, 8);
  int needed_v_smax_9[] = {  20,   21,   34,   35,   72,   73}; //   6
  psi_needed_v_smax[no_ps][  9] = get_vector_from_array_int(needed_v_smax_9, 6);
  int needed_v_smax_10[] = {  22,   23,   28,   29,   30,   31,   36,   37,   48,   49,   54,   55,   56,   57,   58,   59,   44,   45,   60,   61,   62,   63,   66,   67,   70,   71,  110,  111}; //  28
  psi_needed_v_smax[no_ps][ 10] = get_vector_from_array_int(needed_v_smax_10, 28);
  int needed_v_smax_11[] = {  36,   37,   58,   59,   80,   81,   90,   91,   98,   99}; //  10
  psi_needed_v_smax[no_ps][ 11] = get_vector_from_array_int(needed_v_smax_11, 10);
  int needed_v_smax_12[] = {  36,   37,   58,   59,   90,   91,   98,   99}; //   8
  psi_needed_v_smax[no_ps][ 12] = get_vector_from_array_int(needed_v_smax_12, 8);
  int needed_v_smax_13[] = {  38,   39,   84,   85}; //   4
  psi_needed_v_smax[no_ps][ 13] = get_vector_from_array_int(needed_v_smax_13, 4);
  int needed_v_smax_14[] = {  40,   41}; //   2
  psi_needed_v_smax[no_ps][ 14] = get_vector_from_array_int(needed_v_smax_14, 2);
  int needed_v_smax_15[] = {  74,   75,   88,   89,   96,   97,  104,  105,  106,  107}; //  10
  psi_needed_v_smax[no_ps][ 15] = get_vector_from_array_int(needed_v_smax_15, 10);
  int needed_v_smax_16[] = {  74,   75,   88,   89,  106,  107}; //   6
  psi_needed_v_smax[no_ps][ 16] = get_vector_from_array_int(needed_v_smax_16, 6);
  int needed_v_smax_17[] = {  76,   77,   94,   95,  108,  109,    2,    3,   68,   69}; //  10
  psi_needed_v_smax[no_ps][ 17] = get_vector_from_array_int(needed_v_smax_17, 10);
  int needed_v_smax_18[] = {  78,   79,   80,   81}; //   4
  psi_needed_v_smax[no_ps][ 18] = get_vector_from_array_int(needed_v_smax_18, 4);
  int needed_v_smax_19[] = {  78,   79,   80,   81}; //   4
  psi_needed_v_smax[no_ps][ 19] = get_vector_from_array_int(needed_v_smax_19, 4);
  int needed_v_smax_20[] = {  82,   83,   86,   87}; //   4
  psi_needed_v_smax[no_ps][ 20] = get_vector_from_array_int(needed_v_smax_20, 4);
  int needed_v_smax_21[] = {  92,   93,  100,  101,    0,    1}; //   6
  psi_needed_v_smax[no_ps][ 21] = get_vector_from_array_int(needed_v_smax_21, 6);
  int needed_v_smax_22[] = {  96,   97}; //   2
  psi_needed_v_smax[no_ps][ 22] = get_vector_from_array_int(needed_v_smax_22, 2);
  int needed_v_smax_23[] = {  96,   97,  104,  105,   94,   95}; //   6
  psi_needed_v_smax[no_ps][ 23] = get_vector_from_array_int(needed_v_smax_23, 6);
  int needed_v_smax_24[] = {  98,   99}; //   2
  psi_needed_v_smax[no_ps][ 24] = get_vector_from_array_int(needed_v_smax_24, 2);
  int needed_v_smax_25[] = { 100,  101,  102,  103,   88,   89,   90,   91}; //   8
  psi_needed_v_smax[no_ps][ 25] = get_vector_from_array_int(needed_v_smax_25, 8);
  int needed_v_smax_26[] = { 102,  103,  110,  111,   70,   71}; //   6
  psi_needed_v_smax[no_ps][ 26] = get_vector_from_array_int(needed_v_smax_26, 6);
  int needed_v_smax_27[] = { 104,  105}; //   2
  psi_needed_v_smax[no_ps][ 27] = get_vector_from_array_int(needed_v_smax_27, 2);
  int needed_v_smax_28[] = {  92,   93}; //   2
  psi_needed_v_smax[no_ps][ 28] = get_vector_from_array_int(needed_v_smax_28, 2);

  psi_container_IS_startvalue[no_ps][0] = psi_container_IS_name.size();
  psi_g_p[no_ps].resize(46);
  psi_needed_g_p[no_ps].resize(46);
  int needed_g_p_0[] = {   0,    2,    6,   12,   14,   16,   26,   28,   38,   40,   42,   44,   46,   50,   52,   54,   60,   64,   68,   70,   76,   84,   92,   94,  100,  102,  108,  110}; //  28
  psi_needed_g_p[no_ps][0] = get_vector_from_array_int(needed_g_p_0, 28);
  psi_container_IS_name.push_back("propagator_0_smin0_smax0");
  int needed_g_p_1[] = {   1,    3,    7,   13,   15,   17,   27,   29,   39,   41,   43,   45,   47,   51,   53,   55,   61,   65,   69,   71,   77,   85,   93,   95,  101,  103,  109,  111}; //  28
  psi_needed_g_p[no_ps][1] = get_vector_from_array_int(needed_g_p_1, 28);
  psi_container_IS_name.push_back("propagator_23_smin0_smax0");
  int needed_g_p_2[] = {   4,    5,   10,   11,   22,   23,   24,   25,   48,   49,   62,   63,   82,   83}; //  14
  psi_needed_g_p[no_ps][2] = get_vector_from_array_int(needed_g_p_2, 14);
  psi_container_IS_name.push_back("propagator_0_smin1_smax1");
  int needed_g_p_3[] = {   4,   10,   22,   24,   48,   62,   82}; //   7
  psi_needed_g_p[no_ps][3] = get_vector_from_array_int(needed_g_p_3, 7);
  psi_container_IS_name.push_back("propagator_0_smin2_smax2");
  int needed_g_p_4[] = {   5,   11,   23,   25,   49,   63,   83}; //   7
  psi_needed_g_p[no_ps][4] = get_vector_from_array_int(needed_g_p_4, 7);
  psi_container_IS_name.push_back("propagator_23_smin2_smax2");
  int needed_g_p_5[] = {   6,    7,   14,   15,   16,   17,   26,   27,   40,   41,   46,   47,   52,   53}; //  14
  psi_needed_g_p[no_ps][5] = get_vector_from_array_int(needed_g_p_5, 14);
  psi_container_IS_name.push_back("propagator_0_smin3_smax3");
  int needed_g_p_6[] = {   8,    9,   18,   19,   30,   31,   32,   33,   56,   57,   66,   67,   86,   87}; //  14
  psi_needed_g_p[no_ps][6] = get_vector_from_array_int(needed_g_p_6, 14);
  psi_container_IS_name.push_back("propagator_0_smin4_smax4");
  int needed_g_p_7[] = {   8,   18,   30,   32,   56,   66,   86}; //   7
  psi_needed_g_p[no_ps][7] = get_vector_from_array_int(needed_g_p_7, 7);
  psi_container_IS_name.push_back("propagator_0_smin5_smax2");
  int needed_g_p_8[] = {   9,   19,   31,   33,   57,   67,   87}; //   7
  psi_needed_g_p[no_ps][8] = get_vector_from_array_int(needed_g_p_8, 7);
  psi_container_IS_name.push_back("propagator_23_smin5_smax2");
  int needed_g_p_9[] = {  10,   11,   18,   19,   24,   25,   32,   33}; //   8
  psi_needed_g_p[no_ps][9] = get_vector_from_array_int(needed_g_p_9, 8);
  psi_container_IS_name.push_back("propagator_0_smin6_smax5");
  int needed_g_p_10[] = {  12,   13,   28,   29,   38,   39,   44,   45,   50,   51,   54,   55,   64,   65,   84,   85}; //  16
  psi_needed_g_p[no_ps][10] = get_vector_from_array_int(needed_g_p_10, 16);
  psi_container_IS_name.push_back("propagator_0_smin7_smax6");
  int needed_g_p_11[] = {  12,   13,   50,   51}; //   4
  psi_needed_g_p[no_ps][11] = get_vector_from_array_int(needed_g_p_11, 4);
  psi_container_IS_name.push_back("propagator_0_smin8_smax7");
  int needed_g_p_12[] = {  14,   15,   52,   53}; //   4
  psi_needed_g_p[no_ps][12] = get_vector_from_array_int(needed_g_p_12, 4);
  psi_container_IS_name.push_back("propagator_0_smin9_smax7");
  int needed_g_p_13[] = {  16,   17,   26,   27}; //   4
  psi_needed_g_p[no_ps][13] = get_vector_from_array_int(needed_g_p_13, 4);
  psi_container_IS_name.push_back("propagator_0_smin10_smax5");
  int needed_g_p_14[] = {  20,   21,   34,   35,   72,   73,   78,   79}; //   8
  psi_needed_g_p[no_ps][14] = get_vector_from_array_int(needed_g_p_14, 8);
  psi_container_IS_name.push_back("propagator_0_smin11_smax8");
  int needed_g_p_15[] = {  20,   34,   72}; //   3
  psi_needed_g_p[no_ps][15] = get_vector_from_array_int(needed_g_p_15, 3);
  psi_container_IS_name.push_back("propagator_0_smin0_smax9");
  int needed_g_p_16[] = {  20,   21,   34,   35}; //   4
  psi_needed_g_p[no_ps][16] = get_vector_from_array_int(needed_g_p_16, 4);
  psi_container_IS_name.push_back("propagator_0_smin12_smax5");
  int needed_g_p_17[] = {  21,   35,   73}; //   3
  psi_needed_g_p[no_ps][17] = get_vector_from_array_int(needed_g_p_17, 3);
  psi_container_IS_name.push_back("propagator_23_smin0_smax9");
  int needed_g_p_18[] = {  22,   23,   30,   31,   48,   49,   56,   57}; //   8
  psi_needed_g_p[no_ps][18] = get_vector_from_array_int(needed_g_p_18, 8);
  psi_container_IS_name.push_back("propagator_0_smin13_smax10");
  int needed_g_p_19[] = {  28,   29,   54,   55}; //   4
  psi_needed_g_p[no_ps][19] = get_vector_from_array_int(needed_g_p_19, 4);
  psi_container_IS_name.push_back("propagator_0_smin14_smax10");
  int needed_g_p_20[] = {  36,   37,   58,   59,   80,   81,   90,   91,   98,   99}; //  10
  psi_needed_g_p[no_ps][20] = get_vector_from_array_int(needed_g_p_20, 10);
  psi_container_IS_name.push_back("propagator_0_smin15_smax11");
  int needed_g_p_21[] = {  36,   58,   90,   98}; //   4
  psi_needed_g_p[no_ps][21] = get_vector_from_array_int(needed_g_p_21, 4);
  psi_container_IS_name.push_back("propagator_0_smin0_smax12");
  int needed_g_p_22[] = {  36,   37,   58,   59}; //   4
  psi_needed_g_p[no_ps][22] = get_vector_from_array_int(needed_g_p_22, 4);
  psi_container_IS_name.push_back("propagator_0_smin16_smax10");
  int needed_g_p_23[] = {  37,   59,   91,   99}; //   4
  psi_needed_g_p[no_ps][23] = get_vector_from_array_int(needed_g_p_23, 4);
  psi_container_IS_name.push_back("propagator_23_smin0_smax12");
  int needed_g_p_24[] = {  38,   39,   84,   85}; //   4
  psi_needed_g_p[no_ps][24] = get_vector_from_array_int(needed_g_p_24, 4);
  psi_container_IS_name.push_back("propagator_0_smin11_smax13");
  int needed_g_p_25[] = {  40,   41}; //   2
  psi_needed_g_p[no_ps][25] = get_vector_from_array_int(needed_g_p_25, 2);
  psi_container_IS_name.push_back("propagator_0_smin15_smax14");
  int needed_g_p_26[] = {  74,   75,   88,   89,   96,   97,  104,  105,  106,  107}; //  10
  psi_needed_g_p[no_ps][26] = get_vector_from_array_int(needed_g_p_26, 10);
  psi_container_IS_name.push_back("propagator_0_smin17_smax15");
  int needed_g_p_27[] = {  74,   88,  106}; //   3
  psi_needed_g_p[no_ps][27] = get_vector_from_array_int(needed_g_p_27, 3);
  psi_container_IS_name.push_back("propagator_0_smin0_smax16");
  int needed_g_p_28[] = {  75,   89,  107}; //   3
  psi_needed_g_p[no_ps][28] = get_vector_from_array_int(needed_g_p_28, 3);
  psi_container_IS_name.push_back("propagator_23_smin0_smax16");
  int needed_g_p_29[] = {  76,   77,   94,   95,  108,  109}; //   6
  psi_needed_g_p[no_ps][29] = get_vector_from_array_int(needed_g_p_29, 6);
  psi_container_IS_name.push_back("propagator_0_smin17_smax17");
  int needed_g_p_30[] = {  78,   79}; //   2
  psi_needed_g_p[no_ps][30] = get_vector_from_array_int(needed_g_p_30, 2);
  psi_container_IS_name.push_back("propagator_0_smin18_smax18");
  int needed_g_p_31[] = {  78,   80}; //   2
  psi_needed_g_p[no_ps][31] = get_vector_from_array_int(needed_g_p_31, 2);
  psi_container_IS_name.push_back("propagator_0_smin0_smax19");
  int needed_g_p_32[] = {  79,   81}; //   2
  psi_needed_g_p[no_ps][32] = get_vector_from_array_int(needed_g_p_32, 2);
  psi_container_IS_name.push_back("propagator_23_smin0_smax19");
  int needed_g_p_33[] = {  80,   81}; //   2
  psi_needed_g_p[no_ps][33] = get_vector_from_array_int(needed_g_p_33, 2);
  psi_container_IS_name.push_back("propagator_0_smin19_smax18");
  int needed_g_p_34[] = {  82,   83,   86,   87}; //   4
  psi_needed_g_p[no_ps][34] = get_vector_from_array_int(needed_g_p_34, 4);
  psi_container_IS_name.push_back("propagator_0_smin17_smax20");
  int needed_g_p_35[] = {  92,   93,  100,  101}; //   4
  psi_needed_g_p[no_ps][35] = get_vector_from_array_int(needed_g_p_35, 4);
  psi_container_IS_name.push_back("propagator_0_smin11_smax21");
  int needed_g_p_36[] = {  96,   97}; //   2
  psi_needed_g_p[no_ps][36] = get_vector_from_array_int(needed_g_p_36, 2);
  psi_container_IS_name.push_back("propagator_0_smin1_smax22");
  int needed_g_p_37[] = {  96}; //   1
  psi_needed_g_p[no_ps][37] = get_vector_from_array_int(needed_g_p_37, 1);
  psi_container_IS_name.push_back("propagator_0_smin2_smax23");
  int needed_g_p_38[] = {  97}; //   1
  psi_needed_g_p[no_ps][38] = get_vector_from_array_int(needed_g_p_38, 1);
  psi_container_IS_name.push_back("propagator_23_smin2_smax23");
  int needed_g_p_39[] = {  98,   99}; //   2
  psi_needed_g_p[no_ps][39] = get_vector_from_array_int(needed_g_p_39, 2);
  psi_container_IS_name.push_back("propagator_0_smin3_smax24");
  int needed_g_p_40[] = { 100,  101}; //   2
  psi_needed_g_p[no_ps][40] = get_vector_from_array_int(needed_g_p_40, 2);
  psi_container_IS_name.push_back("propagator_0_smin18_smax25");
  int needed_g_p_41[] = { 102,  103,  110,  111}; //   4
  psi_needed_g_p[no_ps][41] = get_vector_from_array_int(needed_g_p_41, 4);
  psi_container_IS_name.push_back("propagator_0_smin15_smax26");
  int needed_g_p_42[] = { 102,  103}; //   2
  psi_needed_g_p[no_ps][42] = get_vector_from_array_int(needed_g_p_42, 2);
  psi_container_IS_name.push_back("propagator_0_smin19_smax25");
  int needed_g_p_43[] = { 104,  105}; //   2
  psi_needed_g_p[no_ps][43] = get_vector_from_array_int(needed_g_p_43, 2);
  psi_container_IS_name.push_back("propagator_0_smin4_smax27");
  int needed_g_p_44[] = { 104}; //   1
  psi_needed_g_p[no_ps][44] = get_vector_from_array_int(needed_g_p_44, 1);
  psi_container_IS_name.push_back("propagator_0_smin5_smax23");
  int needed_g_p_45[] = { 105}; //   1
  psi_needed_g_p[no_ps][45] = get_vector_from_array_int(needed_g_p_45, 1);
  psi_container_IS_name.push_back("propagator_23_smin5_smax23");

  psi_container_IS_startvalue[no_ps][1] = psi_container_IS_name.size();
  psi_g_f[no_ps].resize(17);
  psi_needed_g_f[no_ps].resize(17);
  int needed_g_f_0[] = {   0,    1}; //   2
  psi_needed_g_f[no_ps][0] = get_vector_from_array_int(needed_g_f_0, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin11_smax21");
  int needed_g_f_1[] = {   0,    1,   72,   73}; //   4
  psi_needed_g_f[no_ps][1] = get_vector_from_array_int(needed_g_f_1, 4);
  psi_container_IS_name.push_back("timelikeinvariant_smin12_smax5");
  int needed_g_f_2[] = {   2,    3,   68,   69}; //   4
  psi_needed_g_f[no_ps][2] = get_vector_from_array_int(needed_g_f_2, 4);
  psi_container_IS_name.push_back("timelikeinvariant_smin17_smax17");
  int needed_g_f_3[] = {   2,    3,   68,   69,   74,   75,   76,   77,  106,  107,  108,  109}; //  12
  psi_needed_g_f[no_ps][3] = get_vector_from_array_int(needed_g_f_3, 12);
  psi_container_IS_name.push_back("timelikeinvariant_smin20_smax7");
  int needed_g_f_4[] = {   4,    5,    8,    9}; //   4
  psi_needed_g_f[no_ps][4] = get_vector_from_array_int(needed_g_f_4, 4);
  psi_container_IS_name.push_back("timelikeinvariant_smin6_smax5");
  int needed_g_f_5[] = {   6,    7,   42,   43,   46,   47}; //   6
  psi_needed_g_f[no_ps][5] = get_vector_from_array_int(needed_g_f_5, 6);
  psi_container_IS_name.push_back("timelikeinvariant_smin9_smax7");
  int needed_g_f_6[] = {  42,   43}; //   2
  psi_needed_g_f[no_ps][6] = get_vector_from_array_int(needed_g_f_6, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin3_smax3");
  int needed_g_f_7[] = {  44,   45,   60,   61}; //   4
  psi_needed_g_f[no_ps][7] = get_vector_from_array_int(needed_g_f_7, 4);
  psi_container_IS_name.push_back("timelikeinvariant_smin14_smax10");
  int needed_g_f_8[] = {  60,   61}; //   2
  psi_needed_g_f[no_ps][8] = get_vector_from_array_int(needed_g_f_8, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin7_smax6");
  int needed_g_f_9[] = {  62,   63,   66,   67}; //   4
  psi_needed_g_f[no_ps][9] = get_vector_from_array_int(needed_g_f_9, 4);
  psi_container_IS_name.push_back("timelikeinvariant_smin13_smax10");
  int needed_g_f_10[] = {  64,   65}; //   2
  psi_needed_g_f[no_ps][10] = get_vector_from_array_int(needed_g_f_10, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin8_smax7");
  int needed_g_f_11[] = {  70,   71}; //   2
  psi_needed_g_f[no_ps][11] = get_vector_from_array_int(needed_g_f_11, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin15_smax26");
  int needed_g_f_12[] = {  70,   71,  110,  111}; //   4
  psi_needed_g_f[no_ps][12] = get_vector_from_array_int(needed_g_f_12, 4);
  psi_container_IS_name.push_back("timelikeinvariant_smin16_smax10");
  int needed_g_f_13[] = {  88,   89}; //   2
  psi_needed_g_f[no_ps][13] = get_vector_from_array_int(needed_g_f_13, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin21_smax25");
  int needed_g_f_14[] = {  90,   91}; //   2
  psi_needed_g_f[no_ps][14] = get_vector_from_array_int(needed_g_f_14, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin19_smax25");
  int needed_g_f_15[] = {  92,   93}; //   2
  psi_needed_g_f[no_ps][15] = get_vector_from_array_int(needed_g_f_15, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin7_smax28");
  int needed_g_f_16[] = {  94,   95}; //   2
  psi_needed_g_f[no_ps][16] = get_vector_from_array_int(needed_g_f_16, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin22_smax23");

  psi_container_IS_startvalue[no_ps][2] = psi_container_IS_name.size();
  psi_g_t[no_ps].resize(32);
  psi_needed_g_t[no_ps].resize(32);
  int needed_g_t_0[] = {   0,    1,    4,    5,    8,    9,   10,   11,   16,   17,   18,   19,   20,   21,   72,   73}; //  16
  psi_needed_g_t[no_ps][0] = get_vector_from_array_int(needed_g_t_0, 16);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_1__64_60");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_1__64_60");
  int needed_g_t_1[] = {   0,    1,   72,   73}; //   4
  psi_needed_g_t[no_ps][1] = get_vector_from_array_int(needed_g_t_1, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_66__12_48");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_66__12_48");
  int needed_g_t_2[] = {   0,    1}; //   2
  psi_needed_g_t[no_ps][2] = get_vector_from_array_int(needed_g_t_2, 2);
  psi_container_IS_name.push_back("t_of_tchannel_0__66_13__32_16");
  psi_container_IS_name.push_back("phi_of_tchannel_0__66_13__32_16");
  int needed_g_t_3[] = {   2,    3,    6,    7,   12,   13,   14,   15,   74,   75,   76,   77}; //  12
  psi_needed_g_t[no_ps][3] = get_vector_from_array_int(needed_g_t_3, 12);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_1__16_108");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_1__16_108");
  int needed_g_t_4[] = {   2,    3,   74,   75}; //   4
  psi_needed_g_t[no_ps][4] = get_vector_from_array_int(needed_g_t_4, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_18__12_96");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_18__12_96");
  int needed_g_t_5[] = {   2,    3}; //   2
  psi_needed_g_t[no_ps][5] = get_vector_from_array_int(needed_g_t_5, 2);
  psi_container_IS_name.push_back("t_of_tchannel_0__18_13__64_32");
  psi_container_IS_name.push_back("phi_of_tchannel_0__18_13__64_32");
  int needed_g_t_6[] = {   4,    5,    8,    9}; //   4
  psi_needed_g_t[no_ps][6] = get_vector_from_array_int(needed_g_t_6, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__66_1__32_28");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__66_1__32_28");
  int needed_g_t_7[] = {   6,    7}; //   2
  psi_needed_g_t[no_ps][7] = get_vector_from_array_int(needed_g_t_7, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__18_1__64_44");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__18_1__64_44");
  int needed_g_t_8[] = {  42,   43,   46,   47,   50,   51,   52,   53,   64,   65,   68,   69,  106,  107,  108,  109}; //  16
  psi_needed_g_t[no_ps][8] = get_vector_from_array_int(needed_g_t_8, 16);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_2__16_108");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_2__16_108");
  int needed_g_t_9[] = {  42,   43,   46,   47}; //   4
  psi_needed_g_t[no_ps][9] = get_vector_from_array_int(needed_g_t_9, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_17__64_44");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_17__64_44");
  int needed_g_t_10[] = {  42,   43}; //   2
  psi_needed_g_t[no_ps][10] = get_vector_from_array_int(needed_g_t_10, 2);
  psi_container_IS_name.push_back("t_of_tchannel_0__66_17__32_12");
  psi_container_IS_name.push_back("phi_of_tchannel_0__66_17__32_12");
  int needed_g_t_11[] = {  44,   45,   48,   49,   54,   55,   56,   57,   58,   59,   60,   61,   62,   63,   66,   67,   70,   71,  110,  111}; //  20
  psi_needed_g_t[no_ps][11] = get_vector_from_array_int(needed_g_t_11, 20);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_2__32_92");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_2__32_92");
  int needed_g_t_12[] = {  44,   45,   60,   61}; //   4
  psi_needed_g_t[no_ps][12] = get_vector_from_array_int(needed_g_t_12, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_33__16_76");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_33__16_76");
  int needed_g_t_13[] = {  60,   61}; //   2
  psi_needed_g_t[no_ps][13] = get_vector_from_array_int(needed_g_t_13, 2);
  psi_container_IS_name.push_back("t_of_tchannel_0__33_18__64_12");
  psi_container_IS_name.push_back("phi_of_tchannel_0__33_18__64_12");
  int needed_g_t_14[] = {  62,   63,   66,   67}; //   4
  psi_needed_g_t[no_ps][14] = get_vector_from_array_int(needed_g_t_14, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__33_2__64_28");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__33_2__64_28");
  int needed_g_t_15[] = {  64,   65}; //   2
  psi_needed_g_t[no_ps][15] = get_vector_from_array_int(needed_g_t_15, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__17_2__32_76");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__17_2__32_76");
  int needed_g_t_16[] = {  68,   69,  108,  109}; //   4
  psi_needed_g_t[no_ps][16] = get_vector_from_array_int(needed_g_t_16, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_17__12_96");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_17__12_96");
  int needed_g_t_17[] = {  68,   69}; //   2
  psi_needed_g_t[no_ps][17] = get_vector_from_array_int(needed_g_t_17, 2);
  psi_container_IS_name.push_back("t_of_tchannel_0__17_14__32_64");
  psi_container_IS_name.push_back("phi_of_tchannel_0__17_14__32_64");
  int needed_g_t_18[] = {  70,   71,  110,  111}; //   4
  psi_needed_g_t[no_ps][18] = get_vector_from_array_int(needed_g_t_18, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_33__12_80");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_33__12_80");
  int needed_g_t_19[] = {  70,   71}; //   2
  psi_needed_g_t[no_ps][19] = get_vector_from_array_int(needed_g_t_19, 2);
  psi_container_IS_name.push_back("t_of_tchannel_0__33_14__64_16");
  psi_container_IS_name.push_back("phi_of_tchannel_0__33_14__64_16");
  int needed_g_t_20[] = {  76,   77}; //   2
  psi_needed_g_t[no_ps][20] = get_vector_from_array_int(needed_g_t_20, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_18__96_12");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_18__96_12");
  int needed_g_t_21[] = {  78,   79,   80,   81,   88,   89,   90,   91}; //   8
  psi_needed_g_t[no_ps][21] = get_vector_from_array_int(needed_g_t_21, 8);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_2__12_112");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_2__12_112");
  int needed_g_t_22[] = {  82,   83,   86,   87,   94,   95}; //   6
  psi_needed_g_t[no_ps][22] = get_vector_from_array_int(needed_g_t_22, 6);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_2__96_28");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_2__96_28");
  int needed_g_t_23[] = {  84,   85,   92,   93}; //   4
  psi_needed_g_t[no_ps][23] = get_vector_from_array_int(needed_g_t_23, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_2__48_76");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_2__48_76");
  int needed_g_t_24[] = {  88,   89}; //   2
  psi_needed_g_t[no_ps][24] = get_vector_from_array_int(needed_g_t_24, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_13__96_16");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_13__96_16");
  int needed_g_t_25[] = {  90,   91}; //   2
  psi_needed_g_t[no_ps][25] = get_vector_from_array_int(needed_g_t_25, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_13__80_32");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_13__80_32");
  int needed_g_t_26[] = {  92,   93}; //   2
  psi_needed_g_t[no_ps][26] = get_vector_from_array_int(needed_g_t_26, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_49__12_64");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_49__12_64");
  int needed_g_t_27[] = {  94,   95}; //   2
  psi_needed_g_t[no_ps][27] = get_vector_from_array_int(needed_g_t_27, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_97__12_16");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_97__12_16");
  int needed_g_t_28[] = {  96,   97,  104,  105}; //   4
  psi_needed_g_t[no_ps][28] = get_vector_from_array_int(needed_g_t_28, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_1__96_28");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_1__96_28");
  int needed_g_t_29[] = {  98,   99}; //   2
  psi_needed_g_t[no_ps][29] = get_vector_from_array_int(needed_g_t_29, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_1__80_44");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_1__80_44");
  int needed_g_t_30[] = { 100,  101,  102,  103}; //   4
  psi_needed_g_t[no_ps][30] = get_vector_from_array_int(needed_g_t_30, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_1__12_112");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_1__12_112");
  int needed_g_t_31[] = { 106,  107}; //   2
  psi_needed_g_t[no_ps][31] = get_vector_from_array_int(needed_g_t_31, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_17__96_12");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_17__96_12");

  psi_container_IS_startvalue[no_ps][3] = psi_container_IS_name.size();
  psi_g_d[no_ps].resize(24);
  psi_needed_g_d[no_ps].resize(24);
  int needed_g_d_0[] = {   0,    1,    2,    3,    6,    7,   12,   13,   14,   15,   16,   17,   20,   21,   26,   27,   28,   29,   34,   35,   36,   37,   38,   39,   40,   41,   42,   43,   44,   45,   46,   47,   50,   51,   52,   53,   54,   55,   58,   59,   60,   61,   64,   65,   68,   69,   70,   71,   72,   73,   74,   75,   76,   77,   78,   79,   80,   81,   84,   85,   88,   89,   90,   91,   92,   93,   94,   95,   98,   99,  100,  101,  102,  103,  106,  107,  108,  109,  110,  111}; //  80
  psi_needed_g_d[no_ps][0] = get_vector_from_array_int(needed_g_d_0, 80);
  psi_container_IS_name.push_back("costheta_of_decay_12__4_8");
  psi_container_IS_name.push_back("phi_of_decay_12__4_8");
  int needed_g_d_1[] = {   4,    5,   10,   11,   22,   23,   24,   25,   48,   49,   62,   63,   82,   83,   96,   97}; //  16
  psi_needed_g_d[no_ps][1] = get_vector_from_array_int(needed_g_d_1, 16);
  psi_container_IS_name.push_back("costheta_of_decay_28__4_24");
  psi_container_IS_name.push_back("phi_of_decay_28__4_24");
  int needed_g_d_2[] = {   4,    5,   10,   11,   22,   23,   24,   25,   48,   49,   62,   63,   82,   83,   96,   97}; //  16
  psi_needed_g_d[no_ps][2] = get_vector_from_array_int(needed_g_d_2, 16);
  psi_container_IS_name.push_back("costheta_of_decay_24__8_16");
  psi_container_IS_name.push_back("phi_of_decay_24__8_16");
  int needed_g_d_3[] = {   6,    7,   14,   15,   16,   17,   26,   27,   40,   41,   46,   47,   52,   53,   98,   99}; //  16
  psi_needed_g_d[no_ps][3] = get_vector_from_array_int(needed_g_d_3, 16);
  psi_container_IS_name.push_back("costheta_of_decay_44__32_12");
  psi_container_IS_name.push_back("phi_of_decay_44__32_12");
  int needed_g_d_4[] = {   8,    9,   18,   19,   30,   31,   32,   33,   56,   57,   66,   67,   86,   87,  104,  105}; //  16
  psi_needed_g_d[no_ps][4] = get_vector_from_array_int(needed_g_d_4, 16);
  psi_container_IS_name.push_back("costheta_of_decay_28__8_20");
  psi_container_IS_name.push_back("phi_of_decay_28__8_20");
  int needed_g_d_5[] = {   8,    9,   18,   19,   30,   31,   32,   33,   56,   57,   66,   67,   86,   87,  104,  105}; //  16
  psi_needed_g_d[no_ps][5] = get_vector_from_array_int(needed_g_d_5, 16);
  psi_container_IS_name.push_back("costheta_of_decay_20__4_16");
  psi_container_IS_name.push_back("phi_of_decay_20__4_16");
  int needed_g_d_6[] = {  10,   11,   18,   19,   24,   25,   32,   33}; //   8
  psi_needed_g_d[no_ps][6] = get_vector_from_array_int(needed_g_d_6, 8);
  psi_container_IS_name.push_back("costheta_of_decay_60__32_28");
  psi_container_IS_name.push_back("phi_of_decay_60__32_28");
  int needed_g_d_7[] = {  12,   13,   50,   51}; //   4
  psi_needed_g_d[no_ps][7] = get_vector_from_array_int(needed_g_d_7, 4);
  psi_container_IS_name.push_back("costheta_of_decay_108__32_76");
  psi_container_IS_name.push_back("phi_of_decay_108__32_76");
  int needed_g_d_8[] = {  12,   13,   28,   29,   38,   39,   44,   45,   50,   51,   54,   55,   64,   65,   84,   85}; //  16
  psi_needed_g_d[no_ps][8] = get_vector_from_array_int(needed_g_d_8, 16);
  psi_container_IS_name.push_back("costheta_of_decay_76__64_12");
  psi_container_IS_name.push_back("phi_of_decay_76__64_12");
  int needed_g_d_9[] = {  14,   15,   52,   53}; //   4
  psi_needed_g_d[no_ps][9] = get_vector_from_array_int(needed_g_d_9, 4);
  psi_container_IS_name.push_back("costheta_of_decay_108__64_44");
  psi_container_IS_name.push_back("phi_of_decay_108__64_44");
  int needed_g_d_10[] = {  16,   17,   26,   27}; //   4
  psi_needed_g_d[no_ps][10] = get_vector_from_array_int(needed_g_d_10, 4);
  psi_container_IS_name.push_back("costheta_of_decay_60__16_44");
  psi_container_IS_name.push_back("phi_of_decay_60__16_44");
  int needed_g_d_11[] = {  20,   21,   34,   35}; //   4
  psi_needed_g_d[no_ps][11] = get_vector_from_array_int(needed_g_d_11, 4);
  psi_container_IS_name.push_back("costheta_of_decay_60__12_48");
  psi_container_IS_name.push_back("phi_of_decay_60__12_48");
  int needed_g_d_12[] = {  20,   21,   34,   35,   38,   39,   72,   73,   78,   79,   84,   85,   92,   93,  100,  101}; //  16
  psi_needed_g_d[no_ps][12] = get_vector_from_array_int(needed_g_d_12, 16);
  psi_container_IS_name.push_back("costheta_of_decay_48__16_32");
  psi_container_IS_name.push_back("phi_of_decay_48__16_32");
  int needed_g_d_13[] = {  22,   23,   28,   29,   30,   31,   36,   37}; //   8
  psi_needed_g_d[no_ps][13] = get_vector_from_array_int(needed_g_d_13, 8);
  psi_container_IS_name.push_back("costheta_of_decay_124__32_92");
  psi_container_IS_name.push_back("phi_of_decay_124__32_92");
  int needed_g_d_14[] = {  22,   23,   30,   31,   48,   49,   56,   57}; //   8
  psi_needed_g_d[no_ps][14] = get_vector_from_array_int(needed_g_d_14, 8);
  psi_container_IS_name.push_back("costheta_of_decay_92__64_28");
  psi_container_IS_name.push_back("phi_of_decay_92__64_28");
  int needed_g_d_15[] = {  24,   25,   26,   27,   32,   33,   34,   35}; //   8
  psi_needed_g_d[no_ps][15] = get_vector_from_array_int(needed_g_d_15, 8);
  psi_container_IS_name.push_back("costheta_of_decay_124__64_60");
  psi_container_IS_name.push_back("phi_of_decay_124__64_60");
  int needed_g_d_16[] = {  28,   29,   54,   55}; //   4
  psi_needed_g_d[no_ps][16] = get_vector_from_array_int(needed_g_d_16, 4);
  psi_container_IS_name.push_back("costheta_of_decay_92__16_76");
  psi_container_IS_name.push_back("phi_of_decay_92__16_76");
  int needed_g_d_17[] = {  36,   37,   58,   59}; //   4
  psi_needed_g_d[no_ps][17] = get_vector_from_array_int(needed_g_d_17, 4);
  psi_container_IS_name.push_back("costheta_of_decay_92__12_80");
  psi_container_IS_name.push_back("phi_of_decay_92__12_80");
  int needed_g_d_18[] = {  36,   37,   40,   41,   58,   59,   80,   81,   90,   91,   98,   99,  102,  103,  110,  111}; //  16
  psi_needed_g_d[no_ps][18] = get_vector_from_array_int(needed_g_d_18, 16);
  psi_container_IS_name.push_back("costheta_of_decay_80__16_64");
  psi_container_IS_name.push_back("phi_of_decay_80__16_64");
  int needed_g_d_19[] = {  38,   39}; //   2
  psi_needed_g_d[no_ps][19] = get_vector_from_array_int(needed_g_d_19, 2);
  psi_container_IS_name.push_back("costheta_of_decay_124__48_76");
  psi_container_IS_name.push_back("phi_of_decay_124__48_76");
  int needed_g_d_20[] = {  40,   41}; //   2
  psi_needed_g_d[no_ps][20] = get_vector_from_array_int(needed_g_d_20, 2);
  psi_container_IS_name.push_back("costheta_of_decay_124__80_44");
  psi_container_IS_name.push_back("phi_of_decay_124__80_44");
  int needed_g_d_21[] = {  74,   75,   76,   77,   82,   83,   86,   87,   88,   89,   94,   95,   96,   97,  104,  105,  106,  107,  108,  109}; //  20
  psi_needed_g_d[no_ps][21] = get_vector_from_array_int(needed_g_d_21, 20);
  psi_container_IS_name.push_back("costheta_of_decay_96__32_64");
  psi_container_IS_name.push_back("phi_of_decay_96__32_64");
  int needed_g_d_22[] = {  78,   79,  100,  101}; //   4
  psi_needed_g_d[no_ps][22] = get_vector_from_array_int(needed_g_d_22, 4);
  psi_container_IS_name.push_back("costheta_of_decay_112__64_48");
  psi_container_IS_name.push_back("phi_of_decay_112__64_48");
  int needed_g_d_23[] = {  80,   81,  102,  103}; //   4
  psi_needed_g_d[no_ps][23] = get_vector_from_array_int(needed_g_d_23, 4);
  psi_container_IS_name.push_back("costheta_of_decay_112__32_80");
  psi_container_IS_name.push_back("phi_of_decay_112__32_80");

  psi_c_p[no_ps].resize(112);
  psi_c_f[no_ps].resize(112);
  psi_c_t[no_ps].resize(112);
  psi_c_d[no_ps].resize(112);

  int c_p_0[] = {  0}; //   1
  psi_c_p[no_ps][0] = get_vector_from_array_int(c_p_0, 1);
  int c_f_0[] = {  0,   1}; //   2
  psi_c_f[no_ps][0] = get_vector_from_array_int(c_f_0, 2);
  int c_t_0[] = {  0,   1,   2}; //   3
  psi_c_t[no_ps][0] = get_vector_from_array_int(c_t_0, 3);
  int c_d_0[] = {  0}; //   1
  psi_c_d[no_ps][0] = get_vector_from_array_int(c_d_0, 1);

  int c_p_1[] = {  1}; //   1
  psi_c_p[no_ps][1] = get_vector_from_array_int(c_p_1, 1);
  int c_f_1[] = {  0,   1}; //   2
  psi_c_f[no_ps][1] = get_vector_from_array_int(c_f_1, 2);
  int c_t_1[] = {  0,   1,   2}; //   3
  psi_c_t[no_ps][1] = get_vector_from_array_int(c_t_1, 3);
  int c_d_1[] = {  0}; //   1
  psi_c_d[no_ps][1] = get_vector_from_array_int(c_d_1, 1);

  int c_p_2[] = {  0}; //   1
  psi_c_p[no_ps][2] = get_vector_from_array_int(c_p_2, 1);
  int c_f_2[] = {  2,   3}; //   2
  psi_c_f[no_ps][2] = get_vector_from_array_int(c_f_2, 2);
  int c_t_2[] = {  3,   4,   5}; //   3
  psi_c_t[no_ps][2] = get_vector_from_array_int(c_t_2, 3);
  int c_d_2[] = {  0}; //   1
  psi_c_d[no_ps][2] = get_vector_from_array_int(c_d_2, 1);

  int c_p_3[] = {  1}; //   1
  psi_c_p[no_ps][3] = get_vector_from_array_int(c_p_3, 1);
  int c_f_3[] = {  2,   3}; //   2
  psi_c_f[no_ps][3] = get_vector_from_array_int(c_f_3, 2);
  int c_t_3[] = {  3,   4,   5}; //   3
  psi_c_t[no_ps][3] = get_vector_from_array_int(c_t_3, 3);
  int c_d_3[] = {  0}; //   1
  psi_c_d[no_ps][3] = get_vector_from_array_int(c_d_3, 1);

  int c_p_4[] = {  2,   3}; //   2
  psi_c_p[no_ps][4] = get_vector_from_array_int(c_p_4, 2);
  int c_f_4[] = {  4}; //   1
  psi_c_f[no_ps][4] = get_vector_from_array_int(c_f_4, 1);
  int c_t_4[] = {  0,   6}; //   2
  psi_c_t[no_ps][4] = get_vector_from_array_int(c_t_4, 2);
  int c_d_4[] = {  1,   2}; //   2
  psi_c_d[no_ps][4] = get_vector_from_array_int(c_d_4, 2);

  int c_p_5[] = {  2,   4}; //   2
  psi_c_p[no_ps][5] = get_vector_from_array_int(c_p_5, 2);
  int c_f_5[] = {  4}; //   1
  psi_c_f[no_ps][5] = get_vector_from_array_int(c_f_5, 1);
  int c_t_5[] = {  0,   6}; //   2
  psi_c_t[no_ps][5] = get_vector_from_array_int(c_t_5, 2);
  int c_d_5[] = {  1,   2}; //   2
  psi_c_d[no_ps][5] = get_vector_from_array_int(c_d_5, 2);

  int c_p_6[] = {  0,   5}; //   2
  psi_c_p[no_ps][6] = get_vector_from_array_int(c_p_6, 2);
  int c_f_6[] = {  5}; //   1
  psi_c_f[no_ps][6] = get_vector_from_array_int(c_f_6, 1);
  int c_t_6[] = {  3,   7}; //   2
  psi_c_t[no_ps][6] = get_vector_from_array_int(c_t_6, 2);
  int c_d_6[] = {  3,   0}; //   2
  psi_c_d[no_ps][6] = get_vector_from_array_int(c_d_6, 2);

  int c_p_7[] = {  1,   5}; //   2
  psi_c_p[no_ps][7] = get_vector_from_array_int(c_p_7, 2);
  int c_f_7[] = {  5}; //   1
  psi_c_f[no_ps][7] = get_vector_from_array_int(c_f_7, 1);
  int c_t_7[] = {  3,   7}; //   2
  psi_c_t[no_ps][7] = get_vector_from_array_int(c_t_7, 2);
  int c_d_7[] = {  3,   0}; //   2
  psi_c_d[no_ps][7] = get_vector_from_array_int(c_d_7, 2);

  int c_p_8[] = {  6,   7}; //   2
  psi_c_p[no_ps][8] = get_vector_from_array_int(c_p_8, 2);
  int c_f_8[] = {  4}; //   1
  psi_c_f[no_ps][8] = get_vector_from_array_int(c_f_8, 1);
  int c_t_8[] = {  0,   6}; //   2
  psi_c_t[no_ps][8] = get_vector_from_array_int(c_t_8, 2);
  int c_d_8[] = {  4,   5}; //   2
  psi_c_d[no_ps][8] = get_vector_from_array_int(c_d_8, 2);

  int c_p_9[] = {  6,   8}; //   2
  psi_c_p[no_ps][9] = get_vector_from_array_int(c_p_9, 2);
  int c_f_9[] = {  4}; //   1
  psi_c_f[no_ps][9] = get_vector_from_array_int(c_f_9, 1);
  int c_t_9[] = {  0,   6}; //   2
  psi_c_t[no_ps][9] = get_vector_from_array_int(c_t_9, 2);
  int c_d_9[] = {  4,   5}; //   2
  psi_c_d[no_ps][9] = get_vector_from_array_int(c_d_9, 2);

  int c_p_10[] = {  2,   3,   9}; //   3
  psi_c_p[no_ps][10] = get_vector_from_array_int(c_p_10, 3);
  int c_f_10[] = {}; //   0
  psi_c_f[no_ps][10] = get_vector_from_array_int(c_f_10, 0);
  int c_t_10[] = {  0}; //   1
  psi_c_t[no_ps][10] = get_vector_from_array_int(c_t_10, 1);
  int c_d_10[] = {  6,   1,   2}; //   3
  psi_c_d[no_ps][10] = get_vector_from_array_int(c_d_10, 3);

  int c_p_11[] = {  2,   4,   9}; //   3
  psi_c_p[no_ps][11] = get_vector_from_array_int(c_p_11, 3);
  int c_f_11[] = {}; //   0
  psi_c_f[no_ps][11] = get_vector_from_array_int(c_f_11, 0);
  int c_t_11[] = {  0}; //   1
  psi_c_t[no_ps][11] = get_vector_from_array_int(c_t_11, 1);
  int c_d_11[] = {  6,   1,   2}; //   3
  psi_c_d[no_ps][11] = get_vector_from_array_int(c_d_11, 3);

  int c_p_12[] = {  0,  10,  11}; //   3
  psi_c_p[no_ps][12] = get_vector_from_array_int(c_p_12, 3);
  int c_f_12[] = {}; //   0
  psi_c_f[no_ps][12] = get_vector_from_array_int(c_f_12, 0);
  int c_t_12[] = {  3}; //   1
  psi_c_t[no_ps][12] = get_vector_from_array_int(c_t_12, 1);
  int c_d_12[] = {  7,   8,   0}; //   3
  psi_c_d[no_ps][12] = get_vector_from_array_int(c_d_12, 3);

  int c_p_13[] = {  1,  10,  11}; //   3
  psi_c_p[no_ps][13] = get_vector_from_array_int(c_p_13, 3);
  int c_f_13[] = {}; //   0
  psi_c_f[no_ps][13] = get_vector_from_array_int(c_f_13, 0);
  int c_t_13[] = {  3}; //   1
  psi_c_t[no_ps][13] = get_vector_from_array_int(c_t_13, 1);
  int c_d_13[] = {  7,   8,   0}; //   3
  psi_c_d[no_ps][13] = get_vector_from_array_int(c_d_13, 3);

  int c_p_14[] = {  0,   5,  12}; //   3
  psi_c_p[no_ps][14] = get_vector_from_array_int(c_p_14, 3);
  int c_f_14[] = {}; //   0
  psi_c_f[no_ps][14] = get_vector_from_array_int(c_f_14, 0);
  int c_t_14[] = {  3}; //   1
  psi_c_t[no_ps][14] = get_vector_from_array_int(c_t_14, 1);
  int c_d_14[] = {  9,   3,   0}; //   3
  psi_c_d[no_ps][14] = get_vector_from_array_int(c_d_14, 3);

  int c_p_15[] = {  1,   5,  12}; //   3
  psi_c_p[no_ps][15] = get_vector_from_array_int(c_p_15, 3);
  int c_f_15[] = {}; //   0
  psi_c_f[no_ps][15] = get_vector_from_array_int(c_f_15, 0);
  int c_t_15[] = {  3}; //   1
  psi_c_t[no_ps][15] = get_vector_from_array_int(c_t_15, 1);
  int c_d_15[] = {  9,   3,   0}; //   3
  psi_c_d[no_ps][15] = get_vector_from_array_int(c_d_15, 3);

  int c_p_16[] = {  0,   5,  13}; //   3
  psi_c_p[no_ps][16] = get_vector_from_array_int(c_p_16, 3);
  int c_f_16[] = {}; //   0
  psi_c_f[no_ps][16] = get_vector_from_array_int(c_f_16, 0);
  int c_t_16[] = {  0}; //   1
  psi_c_t[no_ps][16] = get_vector_from_array_int(c_t_16, 1);
  int c_d_16[] = { 10,   3,   0}; //   3
  psi_c_d[no_ps][16] = get_vector_from_array_int(c_d_16, 3);

  int c_p_17[] = {  1,   5,  13}; //   3
  psi_c_p[no_ps][17] = get_vector_from_array_int(c_p_17, 3);
  int c_f_17[] = {}; //   0
  psi_c_f[no_ps][17] = get_vector_from_array_int(c_f_17, 0);
  int c_t_17[] = {  0}; //   1
  psi_c_t[no_ps][17] = get_vector_from_array_int(c_t_17, 1);
  int c_d_17[] = { 10,   3,   0}; //   3
  psi_c_d[no_ps][17] = get_vector_from_array_int(c_d_17, 3);

  int c_p_18[] = {  6,   7,   9}; //   3
  psi_c_p[no_ps][18] = get_vector_from_array_int(c_p_18, 3);
  int c_f_18[] = {}; //   0
  psi_c_f[no_ps][18] = get_vector_from_array_int(c_f_18, 0);
  int c_t_18[] = {  0}; //   1
  psi_c_t[no_ps][18] = get_vector_from_array_int(c_t_18, 1);
  int c_d_18[] = {  6,   4,   5}; //   3
  psi_c_d[no_ps][18] = get_vector_from_array_int(c_d_18, 3);

  int c_p_19[] = {  6,   8,   9}; //   3
  psi_c_p[no_ps][19] = get_vector_from_array_int(c_p_19, 3);
  int c_f_19[] = {}; //   0
  psi_c_f[no_ps][19] = get_vector_from_array_int(c_f_19, 0);
  int c_t_19[] = {  0}; //   1
  psi_c_t[no_ps][19] = get_vector_from_array_int(c_t_19, 1);
  int c_d_19[] = {  6,   4,   5}; //   3
  psi_c_d[no_ps][19] = get_vector_from_array_int(c_d_19, 3);

  int c_p_20[] = { 14,  15,  16}; //   3
  psi_c_p[no_ps][20] = get_vector_from_array_int(c_p_20, 3);
  int c_f_20[] = {}; //   0
  psi_c_f[no_ps][20] = get_vector_from_array_int(c_f_20, 0);
  int c_t_20[] = {  0}; //   1
  psi_c_t[no_ps][20] = get_vector_from_array_int(c_t_20, 1);
  int c_d_20[] = { 11,   0,  12}; //   3
  psi_c_d[no_ps][20] = get_vector_from_array_int(c_d_20, 3);

  int c_p_21[] = { 14,  17,  16}; //   3
  psi_c_p[no_ps][21] = get_vector_from_array_int(c_p_21, 3);
  int c_f_21[] = {}; //   0
  psi_c_f[no_ps][21] = get_vector_from_array_int(c_f_21, 0);
  int c_t_21[] = {  0}; //   1
  psi_c_t[no_ps][21] = get_vector_from_array_int(c_t_21, 1);
  int c_d_21[] = { 11,   0,  12}; //   3
  psi_c_d[no_ps][21] = get_vector_from_array_int(c_d_21, 3);

  int c_p_22[] = {  2,   3,  18}; //   3
  psi_c_p[no_ps][22] = get_vector_from_array_int(c_p_22, 3);
  int c_f_22[] = {}; //   0
  psi_c_f[no_ps][22] = get_vector_from_array_int(c_f_22, 0);
  int c_t_22[] = {}; //   0
  psi_c_t[no_ps][22] = get_vector_from_array_int(c_t_22, 0);
  int c_d_22[] = { 13,  14,   1,   2}; //   4
  psi_c_d[no_ps][22] = get_vector_from_array_int(c_d_22, 4);

  int c_p_23[] = {  2,   4,  18}; //   3
  psi_c_p[no_ps][23] = get_vector_from_array_int(c_p_23, 3);
  int c_f_23[] = {}; //   0
  psi_c_f[no_ps][23] = get_vector_from_array_int(c_f_23, 0);
  int c_t_23[] = {}; //   0
  psi_c_t[no_ps][23] = get_vector_from_array_int(c_t_23, 0);
  int c_d_23[] = { 13,  14,   1,   2}; //   4
  psi_c_d[no_ps][23] = get_vector_from_array_int(c_d_23, 4);

  int c_p_24[] = {  2,   3,   9}; //   3
  psi_c_p[no_ps][24] = get_vector_from_array_int(c_p_24, 3);
  int c_f_24[] = {}; //   0
  psi_c_f[no_ps][24] = get_vector_from_array_int(c_f_24, 0);
  int c_t_24[] = {}; //   0
  psi_c_t[no_ps][24] = get_vector_from_array_int(c_t_24, 0);
  int c_d_24[] = { 15,   6,   1,   2}; //   4
  psi_c_d[no_ps][24] = get_vector_from_array_int(c_d_24, 4);

  int c_p_25[] = {  2,   4,   9}; //   3
  psi_c_p[no_ps][25] = get_vector_from_array_int(c_p_25, 3);
  int c_f_25[] = {}; //   0
  psi_c_f[no_ps][25] = get_vector_from_array_int(c_f_25, 0);
  int c_t_25[] = {}; //   0
  psi_c_t[no_ps][25] = get_vector_from_array_int(c_t_25, 0);
  int c_d_25[] = { 15,   6,   1,   2}; //   4
  psi_c_d[no_ps][25] = get_vector_from_array_int(c_d_25, 4);

  int c_p_26[] = {  0,   5,  13}; //   3
  psi_c_p[no_ps][26] = get_vector_from_array_int(c_p_26, 3);
  int c_f_26[] = {}; //   0
  psi_c_f[no_ps][26] = get_vector_from_array_int(c_f_26, 0);
  int c_t_26[] = {}; //   0
  psi_c_t[no_ps][26] = get_vector_from_array_int(c_t_26, 0);
  int c_d_26[] = { 15,  10,   3,   0}; //   4
  psi_c_d[no_ps][26] = get_vector_from_array_int(c_d_26, 4);

  int c_p_27[] = {  1,   5,  13}; //   3
  psi_c_p[no_ps][27] = get_vector_from_array_int(c_p_27, 3);
  int c_f_27[] = {}; //   0
  psi_c_f[no_ps][27] = get_vector_from_array_int(c_f_27, 0);
  int c_t_27[] = {}; //   0
  psi_c_t[no_ps][27] = get_vector_from_array_int(c_t_27, 0);
  int c_d_27[] = { 15,  10,   3,   0}; //   4
  psi_c_d[no_ps][27] = get_vector_from_array_int(c_d_27, 4);

  int c_p_28[] = {  0,  10,  19}; //   3
  psi_c_p[no_ps][28] = get_vector_from_array_int(c_p_28, 3);
  int c_f_28[] = {}; //   0
  psi_c_f[no_ps][28] = get_vector_from_array_int(c_f_28, 0);
  int c_t_28[] = {}; //   0
  psi_c_t[no_ps][28] = get_vector_from_array_int(c_t_28, 0);
  int c_d_28[] = { 13,  16,   8,   0}; //   4
  psi_c_d[no_ps][28] = get_vector_from_array_int(c_d_28, 4);

  int c_p_29[] = {  1,  10,  19}; //   3
  psi_c_p[no_ps][29] = get_vector_from_array_int(c_p_29, 3);
  int c_f_29[] = {}; //   0
  psi_c_f[no_ps][29] = get_vector_from_array_int(c_f_29, 0);
  int c_t_29[] = {}; //   0
  psi_c_t[no_ps][29] = get_vector_from_array_int(c_t_29, 0);
  int c_d_29[] = { 13,  16,   8,   0}; //   4
  psi_c_d[no_ps][29] = get_vector_from_array_int(c_d_29, 4);

  int c_p_30[] = {  6,   7,  18}; //   3
  psi_c_p[no_ps][30] = get_vector_from_array_int(c_p_30, 3);
  int c_f_30[] = {}; //   0
  psi_c_f[no_ps][30] = get_vector_from_array_int(c_f_30, 0);
  int c_t_30[] = {}; //   0
  psi_c_t[no_ps][30] = get_vector_from_array_int(c_t_30, 0);
  int c_d_30[] = { 13,  14,   4,   5}; //   4
  psi_c_d[no_ps][30] = get_vector_from_array_int(c_d_30, 4);

  int c_p_31[] = {  6,   8,  18}; //   3
  psi_c_p[no_ps][31] = get_vector_from_array_int(c_p_31, 3);
  int c_f_31[] = {}; //   0
  psi_c_f[no_ps][31] = get_vector_from_array_int(c_f_31, 0);
  int c_t_31[] = {}; //   0
  psi_c_t[no_ps][31] = get_vector_from_array_int(c_t_31, 0);
  int c_d_31[] = { 13,  14,   4,   5}; //   4
  psi_c_d[no_ps][31] = get_vector_from_array_int(c_d_31, 4);

  int c_p_32[] = {  6,   7,   9}; //   3
  psi_c_p[no_ps][32] = get_vector_from_array_int(c_p_32, 3);
  int c_f_32[] = {}; //   0
  psi_c_f[no_ps][32] = get_vector_from_array_int(c_f_32, 0);
  int c_t_32[] = {}; //   0
  psi_c_t[no_ps][32] = get_vector_from_array_int(c_t_32, 0);
  int c_d_32[] = { 15,   6,   4,   5}; //   4
  psi_c_d[no_ps][32] = get_vector_from_array_int(c_d_32, 4);

  int c_p_33[] = {  6,   8,   9}; //   3
  psi_c_p[no_ps][33] = get_vector_from_array_int(c_p_33, 3);
  int c_f_33[] = {}; //   0
  psi_c_f[no_ps][33] = get_vector_from_array_int(c_f_33, 0);
  int c_t_33[] = {}; //   0
  psi_c_t[no_ps][33] = get_vector_from_array_int(c_t_33, 0);
  int c_d_33[] = { 15,   6,   4,   5}; //   4
  psi_c_d[no_ps][33] = get_vector_from_array_int(c_d_33, 4);

  int c_p_34[] = { 14,  15,  16}; //   3
  psi_c_p[no_ps][34] = get_vector_from_array_int(c_p_34, 3);
  int c_f_34[] = {}; //   0
  psi_c_f[no_ps][34] = get_vector_from_array_int(c_f_34, 0);
  int c_t_34[] = {}; //   0
  psi_c_t[no_ps][34] = get_vector_from_array_int(c_t_34, 0);
  int c_d_34[] = { 15,  11,   0,  12}; //   4
  psi_c_d[no_ps][34] = get_vector_from_array_int(c_d_34, 4);

  int c_p_35[] = { 14,  17,  16}; //   3
  psi_c_p[no_ps][35] = get_vector_from_array_int(c_p_35, 3);
  int c_f_35[] = {}; //   0
  psi_c_f[no_ps][35] = get_vector_from_array_int(c_f_35, 0);
  int c_t_35[] = {}; //   0
  psi_c_t[no_ps][35] = get_vector_from_array_int(c_t_35, 0);
  int c_d_35[] = { 15,  11,   0,  12}; //   4
  psi_c_d[no_ps][35] = get_vector_from_array_int(c_d_35, 4);

  int c_p_36[] = { 20,  21,  22}; //   3
  psi_c_p[no_ps][36] = get_vector_from_array_int(c_p_36, 3);
  int c_f_36[] = {}; //   0
  psi_c_f[no_ps][36] = get_vector_from_array_int(c_f_36, 0);
  int c_t_36[] = {}; //   0
  psi_c_t[no_ps][36] = get_vector_from_array_int(c_t_36, 0);
  int c_d_36[] = { 13,  17,   0,  18}; //   4
  psi_c_d[no_ps][36] = get_vector_from_array_int(c_d_36, 4);

  int c_p_37[] = { 20,  23,  22}; //   3
  psi_c_p[no_ps][37] = get_vector_from_array_int(c_p_37, 3);
  int c_f_37[] = {}; //   0
  psi_c_f[no_ps][37] = get_vector_from_array_int(c_f_37, 0);
  int c_t_37[] = {}; //   0
  psi_c_t[no_ps][37] = get_vector_from_array_int(c_t_37, 0);
  int c_d_37[] = { 13,  17,   0,  18}; //   4
  psi_c_d[no_ps][37] = get_vector_from_array_int(c_d_37, 4);

  int c_p_38[] = {  0,  10,  24}; //   3
  psi_c_p[no_ps][38] = get_vector_from_array_int(c_p_38, 3);
  int c_f_38[] = {}; //   0
  psi_c_f[no_ps][38] = get_vector_from_array_int(c_f_38, 0);
  int c_t_38[] = {}; //   0
  psi_c_t[no_ps][38] = get_vector_from_array_int(c_t_38, 0);
  int c_d_38[] = { 19,  12,   8,   0}; //   4
  psi_c_d[no_ps][38] = get_vector_from_array_int(c_d_38, 4);

  int c_p_39[] = {  1,  10,  24}; //   3
  psi_c_p[no_ps][39] = get_vector_from_array_int(c_p_39, 3);
  int c_f_39[] = {}; //   0
  psi_c_f[no_ps][39] = get_vector_from_array_int(c_f_39, 0);
  int c_t_39[] = {}; //   0
  psi_c_t[no_ps][39] = get_vector_from_array_int(c_t_39, 0);
  int c_d_39[] = { 19,  12,   8,   0}; //   4
  psi_c_d[no_ps][39] = get_vector_from_array_int(c_d_39, 4);

  int c_p_40[] = {  0,   5,  25}; //   3
  psi_c_p[no_ps][40] = get_vector_from_array_int(c_p_40, 3);
  int c_f_40[] = {}; //   0
  psi_c_f[no_ps][40] = get_vector_from_array_int(c_f_40, 0);
  int c_t_40[] = {}; //   0
  psi_c_t[no_ps][40] = get_vector_from_array_int(c_t_40, 0);
  int c_d_40[] = { 20,  18,   3,   0}; //   4
  psi_c_d[no_ps][40] = get_vector_from_array_int(c_d_40, 4);

  int c_p_41[] = {  1,   5,  25}; //   3
  psi_c_p[no_ps][41] = get_vector_from_array_int(c_p_41, 3);
  int c_f_41[] = {}; //   0
  psi_c_f[no_ps][41] = get_vector_from_array_int(c_f_41, 0);
  int c_t_41[] = {}; //   0
  psi_c_t[no_ps][41] = get_vector_from_array_int(c_t_41, 0);
  int c_d_41[] = { 20,  18,   3,   0}; //   4
  psi_c_d[no_ps][41] = get_vector_from_array_int(c_d_41, 4);

  int c_p_42[] = {  0}; //   1
  psi_c_p[no_ps][42] = get_vector_from_array_int(c_p_42, 1);
  int c_f_42[] = {  6,   5}; //   2
  psi_c_f[no_ps][42] = get_vector_from_array_int(c_f_42, 2);
  int c_t_42[] = {  8,   9,  10}; //   3
  psi_c_t[no_ps][42] = get_vector_from_array_int(c_t_42, 3);
  int c_d_42[] = {  0}; //   1
  psi_c_d[no_ps][42] = get_vector_from_array_int(c_d_42, 1);

  int c_p_43[] = {  1}; //   1
  psi_c_p[no_ps][43] = get_vector_from_array_int(c_p_43, 1);
  int c_f_43[] = {  6,   5}; //   2
  psi_c_f[no_ps][43] = get_vector_from_array_int(c_f_43, 2);
  int c_t_43[] = {  8,   9,  10}; //   3
  psi_c_t[no_ps][43] = get_vector_from_array_int(c_t_43, 3);
  int c_d_43[] = {  0}; //   1
  psi_c_d[no_ps][43] = get_vector_from_array_int(c_d_43, 1);

  int c_p_44[] = {  0,  10}; //   2
  psi_c_p[no_ps][44] = get_vector_from_array_int(c_p_44, 2);
  int c_f_44[] = {  7}; //   1
  psi_c_f[no_ps][44] = get_vector_from_array_int(c_f_44, 1);
  int c_t_44[] = { 11,  12}; //   2
  psi_c_t[no_ps][44] = get_vector_from_array_int(c_t_44, 2);
  int c_d_44[] = {  8,   0}; //   2
  psi_c_d[no_ps][44] = get_vector_from_array_int(c_d_44, 2);

  int c_p_45[] = {  1,  10}; //   2
  psi_c_p[no_ps][45] = get_vector_from_array_int(c_p_45, 2);
  int c_f_45[] = {  7}; //   1
  psi_c_f[no_ps][45] = get_vector_from_array_int(c_f_45, 1);
  int c_t_45[] = { 11,  12}; //   2
  psi_c_t[no_ps][45] = get_vector_from_array_int(c_t_45, 2);
  int c_d_45[] = {  8,   0}; //   2
  psi_c_d[no_ps][45] = get_vector_from_array_int(c_d_45, 2);

  int c_p_46[] = {  0,   5}; //   2
  psi_c_p[no_ps][46] = get_vector_from_array_int(c_p_46, 2);
  int c_f_46[] = {  5}; //   1
  psi_c_f[no_ps][46] = get_vector_from_array_int(c_f_46, 1);
  int c_t_46[] = {  8,   9}; //   2
  psi_c_t[no_ps][46] = get_vector_from_array_int(c_t_46, 2);
  int c_d_46[] = {  3,   0}; //   2
  psi_c_d[no_ps][46] = get_vector_from_array_int(c_d_46, 2);

  int c_p_47[] = {  1,   5}; //   2
  psi_c_p[no_ps][47] = get_vector_from_array_int(c_p_47, 2);
  int c_f_47[] = {  5}; //   1
  psi_c_f[no_ps][47] = get_vector_from_array_int(c_f_47, 1);
  int c_t_47[] = {  8,   9}; //   2
  psi_c_t[no_ps][47] = get_vector_from_array_int(c_t_47, 2);
  int c_d_47[] = {  3,   0}; //   2
  psi_c_d[no_ps][47] = get_vector_from_array_int(c_d_47, 2);

  int c_p_48[] = {  2,   3,  18}; //   3
  psi_c_p[no_ps][48] = get_vector_from_array_int(c_p_48, 3);
  int c_f_48[] = {}; //   0
  psi_c_f[no_ps][48] = get_vector_from_array_int(c_f_48, 0);
  int c_t_48[] = { 11}; //   1
  psi_c_t[no_ps][48] = get_vector_from_array_int(c_t_48, 1);
  int c_d_48[] = { 14,   1,   2}; //   3
  psi_c_d[no_ps][48] = get_vector_from_array_int(c_d_48, 3);

  int c_p_49[] = {  2,   4,  18}; //   3
  psi_c_p[no_ps][49] = get_vector_from_array_int(c_p_49, 3);
  int c_f_49[] = {}; //   0
  psi_c_f[no_ps][49] = get_vector_from_array_int(c_f_49, 0);
  int c_t_49[] = { 11}; //   1
  psi_c_t[no_ps][49] = get_vector_from_array_int(c_t_49, 1);
  int c_d_49[] = { 14,   1,   2}; //   3
  psi_c_d[no_ps][49] = get_vector_from_array_int(c_d_49, 3);

  int c_p_50[] = {  0,  10,  11}; //   3
  psi_c_p[no_ps][50] = get_vector_from_array_int(c_p_50, 3);
  int c_f_50[] = {}; //   0
  psi_c_f[no_ps][50] = get_vector_from_array_int(c_f_50, 0);
  int c_t_50[] = {  8}; //   1
  psi_c_t[no_ps][50] = get_vector_from_array_int(c_t_50, 1);
  int c_d_50[] = {  7,   8,   0}; //   3
  psi_c_d[no_ps][50] = get_vector_from_array_int(c_d_50, 3);

  int c_p_51[] = {  1,  10,  11}; //   3
  psi_c_p[no_ps][51] = get_vector_from_array_int(c_p_51, 3);
  int c_f_51[] = {}; //   0
  psi_c_f[no_ps][51] = get_vector_from_array_int(c_f_51, 0);
  int c_t_51[] = {  8}; //   1
  psi_c_t[no_ps][51] = get_vector_from_array_int(c_t_51, 1);
  int c_d_51[] = {  7,   8,   0}; //   3
  psi_c_d[no_ps][51] = get_vector_from_array_int(c_d_51, 3);

  int c_p_52[] = {  0,   5,  12}; //   3
  psi_c_p[no_ps][52] = get_vector_from_array_int(c_p_52, 3);
  int c_f_52[] = {}; //   0
  psi_c_f[no_ps][52] = get_vector_from_array_int(c_f_52, 0);
  int c_t_52[] = {  8}; //   1
  psi_c_t[no_ps][52] = get_vector_from_array_int(c_t_52, 1);
  int c_d_52[] = {  9,   3,   0}; //   3
  psi_c_d[no_ps][52] = get_vector_from_array_int(c_d_52, 3);

  int c_p_53[] = {  1,   5,  12}; //   3
  psi_c_p[no_ps][53] = get_vector_from_array_int(c_p_53, 3);
  int c_f_53[] = {}; //   0
  psi_c_f[no_ps][53] = get_vector_from_array_int(c_f_53, 0);
  int c_t_53[] = {  8}; //   1
  psi_c_t[no_ps][53] = get_vector_from_array_int(c_t_53, 1);
  int c_d_53[] = {  9,   3,   0}; //   3
  psi_c_d[no_ps][53] = get_vector_from_array_int(c_d_53, 3);

  int c_p_54[] = {  0,  10,  19}; //   3
  psi_c_p[no_ps][54] = get_vector_from_array_int(c_p_54, 3);
  int c_f_54[] = {}; //   0
  psi_c_f[no_ps][54] = get_vector_from_array_int(c_f_54, 0);
  int c_t_54[] = { 11}; //   1
  psi_c_t[no_ps][54] = get_vector_from_array_int(c_t_54, 1);
  int c_d_54[] = { 16,   8,   0}; //   3
  psi_c_d[no_ps][54] = get_vector_from_array_int(c_d_54, 3);

  int c_p_55[] = {  1,  10,  19}; //   3
  psi_c_p[no_ps][55] = get_vector_from_array_int(c_p_55, 3);
  int c_f_55[] = {}; //   0
  psi_c_f[no_ps][55] = get_vector_from_array_int(c_f_55, 0);
  int c_t_55[] = { 11}; //   1
  psi_c_t[no_ps][55] = get_vector_from_array_int(c_t_55, 1);
  int c_d_55[] = { 16,   8,   0}; //   3
  psi_c_d[no_ps][55] = get_vector_from_array_int(c_d_55, 3);

  int c_p_56[] = {  6,   7,  18}; //   3
  psi_c_p[no_ps][56] = get_vector_from_array_int(c_p_56, 3);
  int c_f_56[] = {}; //   0
  psi_c_f[no_ps][56] = get_vector_from_array_int(c_f_56, 0);
  int c_t_56[] = { 11}; //   1
  psi_c_t[no_ps][56] = get_vector_from_array_int(c_t_56, 1);
  int c_d_56[] = { 14,   4,   5}; //   3
  psi_c_d[no_ps][56] = get_vector_from_array_int(c_d_56, 3);

  int c_p_57[] = {  6,   8,  18}; //   3
  psi_c_p[no_ps][57] = get_vector_from_array_int(c_p_57, 3);
  int c_f_57[] = {}; //   0
  psi_c_f[no_ps][57] = get_vector_from_array_int(c_f_57, 0);
  int c_t_57[] = { 11}; //   1
  psi_c_t[no_ps][57] = get_vector_from_array_int(c_t_57, 1);
  int c_d_57[] = { 14,   4,   5}; //   3
  psi_c_d[no_ps][57] = get_vector_from_array_int(c_d_57, 3);

  int c_p_58[] = { 20,  21,  22}; //   3
  psi_c_p[no_ps][58] = get_vector_from_array_int(c_p_58, 3);
  int c_f_58[] = {}; //   0
  psi_c_f[no_ps][58] = get_vector_from_array_int(c_f_58, 0);
  int c_t_58[] = { 11}; //   1
  psi_c_t[no_ps][58] = get_vector_from_array_int(c_t_58, 1);
  int c_d_58[] = { 17,   0,  18}; //   3
  psi_c_d[no_ps][58] = get_vector_from_array_int(c_d_58, 3);

  int c_p_59[] = { 20,  23,  22}; //   3
  psi_c_p[no_ps][59] = get_vector_from_array_int(c_p_59, 3);
  int c_f_59[] = {}; //   0
  psi_c_f[no_ps][59] = get_vector_from_array_int(c_f_59, 0);
  int c_t_59[] = { 11}; //   1
  psi_c_t[no_ps][59] = get_vector_from_array_int(c_t_59, 1);
  int c_d_59[] = { 17,   0,  18}; //   3
  psi_c_d[no_ps][59] = get_vector_from_array_int(c_d_59, 3);

  int c_p_60[] = {  0}; //   1
  psi_c_p[no_ps][60] = get_vector_from_array_int(c_p_60, 1);
  int c_f_60[] = {  8,   7}; //   2
  psi_c_f[no_ps][60] = get_vector_from_array_int(c_f_60, 2);
  int c_t_60[] = { 11,  12,  13}; //   3
  psi_c_t[no_ps][60] = get_vector_from_array_int(c_t_60, 3);
  int c_d_60[] = {  0}; //   1
  psi_c_d[no_ps][60] = get_vector_from_array_int(c_d_60, 1);

  int c_p_61[] = {  1}; //   1
  psi_c_p[no_ps][61] = get_vector_from_array_int(c_p_61, 1);
  int c_f_61[] = {  8,   7}; //   2
  psi_c_f[no_ps][61] = get_vector_from_array_int(c_f_61, 2);
  int c_t_61[] = { 11,  12,  13}; //   3
  psi_c_t[no_ps][61] = get_vector_from_array_int(c_t_61, 3);
  int c_d_61[] = {  0}; //   1
  psi_c_d[no_ps][61] = get_vector_from_array_int(c_d_61, 1);

  int c_p_62[] = {  2,   3}; //   2
  psi_c_p[no_ps][62] = get_vector_from_array_int(c_p_62, 2);
  int c_f_62[] = {  9}; //   1
  psi_c_f[no_ps][62] = get_vector_from_array_int(c_f_62, 1);
  int c_t_62[] = { 11,  14}; //   2
  psi_c_t[no_ps][62] = get_vector_from_array_int(c_t_62, 2);
  int c_d_62[] = {  1,   2}; //   2
  psi_c_d[no_ps][62] = get_vector_from_array_int(c_d_62, 2);

  int c_p_63[] = {  2,   4}; //   2
  psi_c_p[no_ps][63] = get_vector_from_array_int(c_p_63, 2);
  int c_f_63[] = {  9}; //   1
  psi_c_f[no_ps][63] = get_vector_from_array_int(c_f_63, 1);
  int c_t_63[] = { 11,  14}; //   2
  psi_c_t[no_ps][63] = get_vector_from_array_int(c_t_63, 2);
  int c_d_63[] = {  1,   2}; //   2
  psi_c_d[no_ps][63] = get_vector_from_array_int(c_d_63, 2);

  int c_p_64[] = {  0,  10}; //   2
  psi_c_p[no_ps][64] = get_vector_from_array_int(c_p_64, 2);
  int c_f_64[] = { 10}; //   1
  psi_c_f[no_ps][64] = get_vector_from_array_int(c_f_64, 1);
  int c_t_64[] = {  8,  15}; //   2
  psi_c_t[no_ps][64] = get_vector_from_array_int(c_t_64, 2);
  int c_d_64[] = {  8,   0}; //   2
  psi_c_d[no_ps][64] = get_vector_from_array_int(c_d_64, 2);

  int c_p_65[] = {  1,  10}; //   2
  psi_c_p[no_ps][65] = get_vector_from_array_int(c_p_65, 2);
  int c_f_65[] = { 10}; //   1
  psi_c_f[no_ps][65] = get_vector_from_array_int(c_f_65, 1);
  int c_t_65[] = {  8,  15}; //   2
  psi_c_t[no_ps][65] = get_vector_from_array_int(c_t_65, 2);
  int c_d_65[] = {  8,   0}; //   2
  psi_c_d[no_ps][65] = get_vector_from_array_int(c_d_65, 2);

  int c_p_66[] = {  6,   7}; //   2
  psi_c_p[no_ps][66] = get_vector_from_array_int(c_p_66, 2);
  int c_f_66[] = {  9}; //   1
  psi_c_f[no_ps][66] = get_vector_from_array_int(c_f_66, 1);
  int c_t_66[] = { 11,  14}; //   2
  psi_c_t[no_ps][66] = get_vector_from_array_int(c_t_66, 2);
  int c_d_66[] = {  4,   5}; //   2
  psi_c_d[no_ps][66] = get_vector_from_array_int(c_d_66, 2);

  int c_p_67[] = {  6,   8}; //   2
  psi_c_p[no_ps][67] = get_vector_from_array_int(c_p_67, 2);
  int c_f_67[] = {  9}; //   1
  psi_c_f[no_ps][67] = get_vector_from_array_int(c_f_67, 1);
  int c_t_67[] = { 11,  14}; //   2
  psi_c_t[no_ps][67] = get_vector_from_array_int(c_t_67, 2);
  int c_d_67[] = {  4,   5}; //   2
  psi_c_d[no_ps][67] = get_vector_from_array_int(c_d_67, 2);

  int c_p_68[] = {  0}; //   1
  psi_c_p[no_ps][68] = get_vector_from_array_int(c_p_68, 1);
  int c_f_68[] = {  2,   3}; //   2
  psi_c_f[no_ps][68] = get_vector_from_array_int(c_f_68, 2);
  int c_t_68[] = {  8,  16,  17}; //   3
  psi_c_t[no_ps][68] = get_vector_from_array_int(c_t_68, 3);
  int c_d_68[] = {  0}; //   1
  psi_c_d[no_ps][68] = get_vector_from_array_int(c_d_68, 1);

  int c_p_69[] = {  1}; //   1
  psi_c_p[no_ps][69] = get_vector_from_array_int(c_p_69, 1);
  int c_f_69[] = {  2,   3}; //   2
  psi_c_f[no_ps][69] = get_vector_from_array_int(c_f_69, 2);
  int c_t_69[] = {  8,  16,  17}; //   3
  psi_c_t[no_ps][69] = get_vector_from_array_int(c_t_69, 3);
  int c_d_69[] = {  0}; //   1
  psi_c_d[no_ps][69] = get_vector_from_array_int(c_d_69, 1);

  int c_p_70[] = {  0}; //   1
  psi_c_p[no_ps][70] = get_vector_from_array_int(c_p_70, 1);
  int c_f_70[] = { 11,  12}; //   2
  psi_c_f[no_ps][70] = get_vector_from_array_int(c_f_70, 2);
  int c_t_70[] = { 11,  18,  19}; //   3
  psi_c_t[no_ps][70] = get_vector_from_array_int(c_t_70, 3);
  int c_d_70[] = {  0}; //   1
  psi_c_d[no_ps][70] = get_vector_from_array_int(c_d_70, 1);

  int c_p_71[] = {  1}; //   1
  psi_c_p[no_ps][71] = get_vector_from_array_int(c_p_71, 1);
  int c_f_71[] = { 11,  12}; //   2
  psi_c_f[no_ps][71] = get_vector_from_array_int(c_f_71, 2);
  int c_t_71[] = { 11,  18,  19}; //   3
  psi_c_t[no_ps][71] = get_vector_from_array_int(c_t_71, 3);
  int c_d_71[] = {  0}; //   1
  psi_c_d[no_ps][71] = get_vector_from_array_int(c_d_71, 1);

  int c_p_72[] = { 14,  15}; //   2
  psi_c_p[no_ps][72] = get_vector_from_array_int(c_p_72, 2);
  int c_f_72[] = {  1}; //   1
  psi_c_f[no_ps][72] = get_vector_from_array_int(c_f_72, 1);
  int c_t_72[] = {  0,   1}; //   2
  psi_c_t[no_ps][72] = get_vector_from_array_int(c_t_72, 2);
  int c_d_72[] = {  0,  12}; //   2
  psi_c_d[no_ps][72] = get_vector_from_array_int(c_d_72, 2);

  int c_p_73[] = { 14,  17}; //   2
  psi_c_p[no_ps][73] = get_vector_from_array_int(c_p_73, 2);
  int c_f_73[] = {  1}; //   1
  psi_c_f[no_ps][73] = get_vector_from_array_int(c_f_73, 1);
  int c_t_73[] = {  0,   1}; //   2
  psi_c_t[no_ps][73] = get_vector_from_array_int(c_t_73, 2);
  int c_d_73[] = {  0,  12}; //   2
  psi_c_d[no_ps][73] = get_vector_from_array_int(c_d_73, 2);

  int c_p_74[] = { 26,  27}; //   2
  psi_c_p[no_ps][74] = get_vector_from_array_int(c_p_74, 2);
  int c_f_74[] = {  3}; //   1
  psi_c_f[no_ps][74] = get_vector_from_array_int(c_f_74, 1);
  int c_t_74[] = {  3,   4}; //   2
  psi_c_t[no_ps][74] = get_vector_from_array_int(c_t_74, 2);
  int c_d_74[] = {  0,  21}; //   2
  psi_c_d[no_ps][74] = get_vector_from_array_int(c_d_74, 2);

  int c_p_75[] = { 26,  28}; //   2
  psi_c_p[no_ps][75] = get_vector_from_array_int(c_p_75, 2);
  int c_f_75[] = {  3}; //   1
  psi_c_f[no_ps][75] = get_vector_from_array_int(c_f_75, 1);
  int c_t_75[] = {  3,   4}; //   2
  psi_c_t[no_ps][75] = get_vector_from_array_int(c_t_75, 2);
  int c_d_75[] = {  0,  21}; //   2
  psi_c_d[no_ps][75] = get_vector_from_array_int(c_d_75, 2);

  int c_p_76[] = {  0,  29}; //   2
  psi_c_p[no_ps][76] = get_vector_from_array_int(c_p_76, 2);
  int c_f_76[] = {  3}; //   1
  psi_c_f[no_ps][76] = get_vector_from_array_int(c_f_76, 1);
  int c_t_76[] = {  3,  20}; //   2
  psi_c_t[no_ps][76] = get_vector_from_array_int(c_t_76, 2);
  int c_d_76[] = { 21,   0}; //   2
  psi_c_d[no_ps][76] = get_vector_from_array_int(c_d_76, 2);

  int c_p_77[] = {  1,  29}; //   2
  psi_c_p[no_ps][77] = get_vector_from_array_int(c_p_77, 2);
  int c_f_77[] = {  3}; //   1
  psi_c_f[no_ps][77] = get_vector_from_array_int(c_f_77, 1);
  int c_t_77[] = {  3,  20}; //   2
  psi_c_t[no_ps][77] = get_vector_from_array_int(c_t_77, 2);
  int c_d_77[] = { 21,   0}; //   2
  psi_c_d[no_ps][77] = get_vector_from_array_int(c_d_77, 2);

  int c_p_78[] = { 14,  30,  31}; //   3
  psi_c_p[no_ps][78] = get_vector_from_array_int(c_p_78, 3);
  int c_f_78[] = {}; //   0
  psi_c_f[no_ps][78] = get_vector_from_array_int(c_f_78, 0);
  int c_t_78[] = { 21}; //   1
  psi_c_t[no_ps][78] = get_vector_from_array_int(c_t_78, 1);
  int c_d_78[] = {  0,  22,  12}; //   3
  psi_c_d[no_ps][78] = get_vector_from_array_int(c_d_78, 3);

  int c_p_79[] = { 14,  30,  32}; //   3
  psi_c_p[no_ps][79] = get_vector_from_array_int(c_p_79, 3);
  int c_f_79[] = {}; //   0
  psi_c_f[no_ps][79] = get_vector_from_array_int(c_f_79, 0);
  int c_t_79[] = { 21}; //   1
  psi_c_t[no_ps][79] = get_vector_from_array_int(c_t_79, 1);
  int c_d_79[] = {  0,  22,  12}; //   3
  psi_c_d[no_ps][79] = get_vector_from_array_int(c_d_79, 3);

  int c_p_80[] = { 20,  33,  31}; //   3
  psi_c_p[no_ps][80] = get_vector_from_array_int(c_p_80, 3);
  int c_f_80[] = {}; //   0
  psi_c_f[no_ps][80] = get_vector_from_array_int(c_f_80, 0);
  int c_t_80[] = { 21}; //   1
  psi_c_t[no_ps][80] = get_vector_from_array_int(c_t_80, 1);
  int c_d_80[] = {  0,  23,  18}; //   3
  psi_c_d[no_ps][80] = get_vector_from_array_int(c_d_80, 3);

  int c_p_81[] = { 20,  33,  32}; //   3
  psi_c_p[no_ps][81] = get_vector_from_array_int(c_p_81, 3);
  int c_f_81[] = {}; //   0
  psi_c_f[no_ps][81] = get_vector_from_array_int(c_f_81, 0);
  int c_t_81[] = { 21}; //   1
  psi_c_t[no_ps][81] = get_vector_from_array_int(c_t_81, 1);
  int c_d_81[] = {  0,  23,  18}; //   3
  psi_c_d[no_ps][81] = get_vector_from_array_int(c_d_81, 3);

  int c_p_82[] = {  2,   3,  34}; //   3
  psi_c_p[no_ps][82] = get_vector_from_array_int(c_p_82, 3);
  int c_f_82[] = {}; //   0
  psi_c_f[no_ps][82] = get_vector_from_array_int(c_f_82, 0);
  int c_t_82[] = { 22}; //   1
  psi_c_t[no_ps][82] = get_vector_from_array_int(c_t_82, 1);
  int c_d_82[] = { 21,   1,   2}; //   3
  psi_c_d[no_ps][82] = get_vector_from_array_int(c_d_82, 3);

  int c_p_83[] = {  2,   4,  34}; //   3
  psi_c_p[no_ps][83] = get_vector_from_array_int(c_p_83, 3);
  int c_f_83[] = {}; //   0
  psi_c_f[no_ps][83] = get_vector_from_array_int(c_f_83, 0);
  int c_t_83[] = { 22}; //   1
  psi_c_t[no_ps][83] = get_vector_from_array_int(c_t_83, 1);
  int c_d_83[] = { 21,   1,   2}; //   3
  psi_c_d[no_ps][83] = get_vector_from_array_int(c_d_83, 3);

  int c_p_84[] = {  0,  10,  24}; //   3
  psi_c_p[no_ps][84] = get_vector_from_array_int(c_p_84, 3);
  int c_f_84[] = {}; //   0
  psi_c_f[no_ps][84] = get_vector_from_array_int(c_f_84, 0);
  int c_t_84[] = { 23}; //   1
  psi_c_t[no_ps][84] = get_vector_from_array_int(c_t_84, 1);
  int c_d_84[] = { 12,   8,   0}; //   3
  psi_c_d[no_ps][84] = get_vector_from_array_int(c_d_84, 3);

  int c_p_85[] = {  1,  10,  24}; //   3
  psi_c_p[no_ps][85] = get_vector_from_array_int(c_p_85, 3);
  int c_f_85[] = {}; //   0
  psi_c_f[no_ps][85] = get_vector_from_array_int(c_f_85, 0);
  int c_t_85[] = { 23}; //   1
  psi_c_t[no_ps][85] = get_vector_from_array_int(c_t_85, 1);
  int c_d_85[] = { 12,   8,   0}; //   3
  psi_c_d[no_ps][85] = get_vector_from_array_int(c_d_85, 3);

  int c_p_86[] = {  6,   7,  34}; //   3
  psi_c_p[no_ps][86] = get_vector_from_array_int(c_p_86, 3);
  int c_f_86[] = {}; //   0
  psi_c_f[no_ps][86] = get_vector_from_array_int(c_f_86, 0);
  int c_t_86[] = { 22}; //   1
  psi_c_t[no_ps][86] = get_vector_from_array_int(c_t_86, 1);
  int c_d_86[] = { 21,   4,   5}; //   3
  psi_c_d[no_ps][86] = get_vector_from_array_int(c_d_86, 3);

  int c_p_87[] = {  6,   8,  34}; //   3
  psi_c_p[no_ps][87] = get_vector_from_array_int(c_p_87, 3);
  int c_f_87[] = {}; //   0
  psi_c_f[no_ps][87] = get_vector_from_array_int(c_f_87, 0);
  int c_t_87[] = { 22}; //   1
  psi_c_t[no_ps][87] = get_vector_from_array_int(c_t_87, 1);
  int c_d_87[] = { 21,   4,   5}; //   3
  psi_c_d[no_ps][87] = get_vector_from_array_int(c_d_87, 3);

  int c_p_88[] = { 26,  27}; //   2
  psi_c_p[no_ps][88] = get_vector_from_array_int(c_p_88, 2);
  int c_f_88[] = { 13}; //   1
  psi_c_f[no_ps][88] = get_vector_from_array_int(c_f_88, 1);
  int c_t_88[] = { 21,  24}; //   2
  psi_c_t[no_ps][88] = get_vector_from_array_int(c_t_88, 2);
  int c_d_88[] = {  0,  21}; //   2
  psi_c_d[no_ps][88] = get_vector_from_array_int(c_d_88, 2);

  int c_p_89[] = { 26,  28}; //   2
  psi_c_p[no_ps][89] = get_vector_from_array_int(c_p_89, 2);
  int c_f_89[] = { 13}; //   1
  psi_c_f[no_ps][89] = get_vector_from_array_int(c_f_89, 1);
  int c_t_89[] = { 21,  24}; //   2
  psi_c_t[no_ps][89] = get_vector_from_array_int(c_t_89, 2);
  int c_d_89[] = {  0,  21}; //   2
  psi_c_d[no_ps][89] = get_vector_from_array_int(c_d_89, 2);

  int c_p_90[] = { 20,  21}; //   2
  psi_c_p[no_ps][90] = get_vector_from_array_int(c_p_90, 2);
  int c_f_90[] = { 14}; //   1
  psi_c_f[no_ps][90] = get_vector_from_array_int(c_f_90, 1);
  int c_t_90[] = { 21,  25}; //   2
  psi_c_t[no_ps][90] = get_vector_from_array_int(c_t_90, 2);
  int c_d_90[] = {  0,  18}; //   2
  psi_c_d[no_ps][90] = get_vector_from_array_int(c_d_90, 2);

  int c_p_91[] = { 20,  23}; //   2
  psi_c_p[no_ps][91] = get_vector_from_array_int(c_p_91, 2);
  int c_f_91[] = { 14}; //   1
  psi_c_f[no_ps][91] = get_vector_from_array_int(c_f_91, 1);
  int c_t_91[] = { 21,  25}; //   2
  psi_c_t[no_ps][91] = get_vector_from_array_int(c_t_91, 2);
  int c_d_91[] = {  0,  18}; //   2
  psi_c_d[no_ps][91] = get_vector_from_array_int(c_d_91, 2);

  int c_p_92[] = {  0,  35}; //   2
  psi_c_p[no_ps][92] = get_vector_from_array_int(c_p_92, 2);
  int c_f_92[] = { 15}; //   1
  psi_c_f[no_ps][92] = get_vector_from_array_int(c_f_92, 1);
  int c_t_92[] = { 23,  26}; //   2
  psi_c_t[no_ps][92] = get_vector_from_array_int(c_t_92, 2);
  int c_d_92[] = { 12,   0}; //   2
  psi_c_d[no_ps][92] = get_vector_from_array_int(c_d_92, 2);

  int c_p_93[] = {  1,  35}; //   2
  psi_c_p[no_ps][93] = get_vector_from_array_int(c_p_93, 2);
  int c_f_93[] = { 15}; //   1
  psi_c_f[no_ps][93] = get_vector_from_array_int(c_f_93, 1);
  int c_t_93[] = { 23,  26}; //   2
  psi_c_t[no_ps][93] = get_vector_from_array_int(c_t_93, 2);
  int c_d_93[] = { 12,   0}; //   2
  psi_c_d[no_ps][93] = get_vector_from_array_int(c_d_93, 2);

  int c_p_94[] = {  0,  29}; //   2
  psi_c_p[no_ps][94] = get_vector_from_array_int(c_p_94, 2);
  int c_f_94[] = { 16}; //   1
  psi_c_f[no_ps][94] = get_vector_from_array_int(c_f_94, 1);
  int c_t_94[] = { 22,  27}; //   2
  psi_c_t[no_ps][94] = get_vector_from_array_int(c_t_94, 2);
  int c_d_94[] = { 21,   0}; //   2
  psi_c_d[no_ps][94] = get_vector_from_array_int(c_d_94, 2);

  int c_p_95[] = {  1,  29}; //   2
  psi_c_p[no_ps][95] = get_vector_from_array_int(c_p_95, 2);
  int c_f_95[] = { 16}; //   1
  psi_c_f[no_ps][95] = get_vector_from_array_int(c_f_95, 1);
  int c_t_95[] = { 22,  27}; //   2
  psi_c_t[no_ps][95] = get_vector_from_array_int(c_t_95, 2);
  int c_d_95[] = { 21,   0}; //   2
  psi_c_d[no_ps][95] = get_vector_from_array_int(c_d_95, 2);

  int c_p_96[] = { 26,  36,  37}; //   3
  psi_c_p[no_ps][96] = get_vector_from_array_int(c_p_96, 3);
  int c_f_96[] = {}; //   0
  psi_c_f[no_ps][96] = get_vector_from_array_int(c_f_96, 0);
  int c_t_96[] = { 28}; //   1
  psi_c_t[no_ps][96] = get_vector_from_array_int(c_t_96, 1);
  int c_d_96[] = {  1,   2,  21}; //   3
  psi_c_d[no_ps][96] = get_vector_from_array_int(c_d_96, 3);

  int c_p_97[] = { 26,  36,  38}; //   3
  psi_c_p[no_ps][97] = get_vector_from_array_int(c_p_97, 3);
  int c_f_97[] = {}; //   0
  psi_c_f[no_ps][97] = get_vector_from_array_int(c_f_97, 0);
  int c_t_97[] = { 28}; //   1
  psi_c_t[no_ps][97] = get_vector_from_array_int(c_t_97, 1);
  int c_d_97[] = {  1,   2,  21}; //   3
  psi_c_d[no_ps][97] = get_vector_from_array_int(c_d_97, 3);

  int c_p_98[] = { 20,  21,  39}; //   3
  psi_c_p[no_ps][98] = get_vector_from_array_int(c_p_98, 3);
  int c_f_98[] = {}; //   0
  psi_c_f[no_ps][98] = get_vector_from_array_int(c_f_98, 0);
  int c_t_98[] = { 29}; //   1
  psi_c_t[no_ps][98] = get_vector_from_array_int(c_t_98, 1);
  int c_d_98[] = {  3,   0,  18}; //   3
  psi_c_d[no_ps][98] = get_vector_from_array_int(c_d_98, 3);

  int c_p_99[] = { 20,  23,  39}; //   3
  psi_c_p[no_ps][99] = get_vector_from_array_int(c_p_99, 3);
  int c_f_99[] = {}; //   0
  psi_c_f[no_ps][99] = get_vector_from_array_int(c_f_99, 0);
  int c_t_99[] = { 29}; //   1
  psi_c_t[no_ps][99] = get_vector_from_array_int(c_t_99, 1);
  int c_d_99[] = {  3,   0,  18}; //   3
  psi_c_d[no_ps][99] = get_vector_from_array_int(c_d_99, 3);

  int c_p_100[] = {  0,  35,  40}; //   3
  psi_c_p[no_ps][100] = get_vector_from_array_int(c_p_100, 3);
  int c_f_100[] = {}; //   0
  psi_c_f[no_ps][100] = get_vector_from_array_int(c_f_100, 0);
  int c_t_100[] = { 30}; //   1
  psi_c_t[no_ps][100] = get_vector_from_array_int(c_t_100, 1);
  int c_d_100[] = { 22,  12,   0}; //   3
  psi_c_d[no_ps][100] = get_vector_from_array_int(c_d_100, 3);

  int c_p_101[] = {  1,  35,  40}; //   3
  psi_c_p[no_ps][101] = get_vector_from_array_int(c_p_101, 3);
  int c_f_101[] = {}; //   0
  psi_c_f[no_ps][101] = get_vector_from_array_int(c_f_101, 0);
  int c_t_101[] = { 30}; //   1
  psi_c_t[no_ps][101] = get_vector_from_array_int(c_t_101, 1);
  int c_d_101[] = { 22,  12,   0}; //   3
  psi_c_d[no_ps][101] = get_vector_from_array_int(c_d_101, 3);

  int c_p_102[] = {  0,  41,  42}; //   3
  psi_c_p[no_ps][102] = get_vector_from_array_int(c_p_102, 3);
  int c_f_102[] = {}; //   0
  psi_c_f[no_ps][102] = get_vector_from_array_int(c_f_102, 0);
  int c_t_102[] = { 30}; //   1
  psi_c_t[no_ps][102] = get_vector_from_array_int(c_t_102, 1);
  int c_d_102[] = { 23,  18,   0}; //   3
  psi_c_d[no_ps][102] = get_vector_from_array_int(c_d_102, 3);

  int c_p_103[] = {  1,  41,  42}; //   3
  psi_c_p[no_ps][103] = get_vector_from_array_int(c_p_103, 3);
  int c_f_103[] = {}; //   0
  psi_c_f[no_ps][103] = get_vector_from_array_int(c_f_103, 0);
  int c_t_103[] = { 30}; //   1
  psi_c_t[no_ps][103] = get_vector_from_array_int(c_t_103, 1);
  int c_d_103[] = { 23,  18,   0}; //   3
  psi_c_d[no_ps][103] = get_vector_from_array_int(c_d_103, 3);

  int c_p_104[] = { 26,  43,  44}; //   3
  psi_c_p[no_ps][104] = get_vector_from_array_int(c_p_104, 3);
  int c_f_104[] = {}; //   0
  psi_c_f[no_ps][104] = get_vector_from_array_int(c_f_104, 0);
  int c_t_104[] = { 28}; //   1
  psi_c_t[no_ps][104] = get_vector_from_array_int(c_t_104, 1);
  int c_d_104[] = {  4,   5,  21}; //   3
  psi_c_d[no_ps][104] = get_vector_from_array_int(c_d_104, 3);

  int c_p_105[] = { 26,  43,  45}; //   3
  psi_c_p[no_ps][105] = get_vector_from_array_int(c_p_105, 3);
  int c_f_105[] = {}; //   0
  psi_c_f[no_ps][105] = get_vector_from_array_int(c_f_105, 0);
  int c_t_105[] = { 28}; //   1
  psi_c_t[no_ps][105] = get_vector_from_array_int(c_t_105, 1);
  int c_d_105[] = {  4,   5,  21}; //   3
  psi_c_d[no_ps][105] = get_vector_from_array_int(c_d_105, 3);

  int c_p_106[] = { 26,  27}; //   2
  psi_c_p[no_ps][106] = get_vector_from_array_int(c_p_106, 2);
  int c_f_106[] = {  3}; //   1
  psi_c_f[no_ps][106] = get_vector_from_array_int(c_f_106, 1);
  int c_t_106[] = {  8,  31}; //   2
  psi_c_t[no_ps][106] = get_vector_from_array_int(c_t_106, 2);
  int c_d_106[] = {  0,  21}; //   2
  psi_c_d[no_ps][106] = get_vector_from_array_int(c_d_106, 2);

  int c_p_107[] = { 26,  28}; //   2
  psi_c_p[no_ps][107] = get_vector_from_array_int(c_p_107, 2);
  int c_f_107[] = {  3}; //   1
  psi_c_f[no_ps][107] = get_vector_from_array_int(c_f_107, 1);
  int c_t_107[] = {  8,  31}; //   2
  psi_c_t[no_ps][107] = get_vector_from_array_int(c_t_107, 2);
  int c_d_107[] = {  0,  21}; //   2
  psi_c_d[no_ps][107] = get_vector_from_array_int(c_d_107, 2);

  int c_p_108[] = {  0,  29}; //   2
  psi_c_p[no_ps][108] = get_vector_from_array_int(c_p_108, 2);
  int c_f_108[] = {  3}; //   1
  psi_c_f[no_ps][108] = get_vector_from_array_int(c_f_108, 1);
  int c_t_108[] = {  8,  16}; //   2
  psi_c_t[no_ps][108] = get_vector_from_array_int(c_t_108, 2);
  int c_d_108[] = { 21,   0}; //   2
  psi_c_d[no_ps][108] = get_vector_from_array_int(c_d_108, 2);

  int c_p_109[] = {  1,  29}; //   2
  psi_c_p[no_ps][109] = get_vector_from_array_int(c_p_109, 2);
  int c_f_109[] = {  3}; //   1
  psi_c_f[no_ps][109] = get_vector_from_array_int(c_f_109, 1);
  int c_t_109[] = {  8,  16}; //   2
  psi_c_t[no_ps][109] = get_vector_from_array_int(c_t_109, 2);
  int c_d_109[] = { 21,   0}; //   2
  psi_c_d[no_ps][109] = get_vector_from_array_int(c_d_109, 2);

  int c_p_110[] = {  0,  41}; //   2
  psi_c_p[no_ps][110] = get_vector_from_array_int(c_p_110, 2);
  int c_f_110[] = { 12}; //   1
  psi_c_f[no_ps][110] = get_vector_from_array_int(c_f_110, 1);
  int c_t_110[] = { 11,  18}; //   2
  psi_c_t[no_ps][110] = get_vector_from_array_int(c_t_110, 2);
  int c_d_110[] = { 18,   0}; //   2
  psi_c_d[no_ps][110] = get_vector_from_array_int(c_d_110, 2);

  int c_p_111[] = {  1,  41}; //   2
  psi_c_p[no_ps][111] = get_vector_from_array_int(c_p_111, 2);
  int c_f_111[] = { 12}; //   1
  psi_c_f[no_ps][111] = get_vector_from_array_int(c_f_111, 1);
  int c_t_111[] = { 11,  18}; //   2
  psi_c_t[no_ps][111] = get_vector_from_array_int(c_t_111, 2);
  int c_d_111[] = { 18,   0}; //   2
  psi_c_d[no_ps][111] = get_vector_from_array_int(c_d_111, 2);

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
