#include "../include/classes.cxx"
#include "../include/definitions.phasespace.set.cxx"
#include "../ppeexa03/header/ppeexa03.phasespace.h"
void ppeexa03_ax_psp_230_ds_emepads(int no_ps, phasespace_set & psi){
  static Logger logger("ppeexa03_ax_psp_230_ds_emepads");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;
  psi_v_smin[no_ps].resize(20);
  psi_needed_v_smin[no_ps].resize(20);
  int needed_v_smin_0[] = {   0,    1,    2,    3,    6,    7,   12,   13,   16,   17,   18,   19,   20,   21,   22,   23,   26,   27,   30,   31,   32,   33,   36,   37,   40,   41,   42,   43,   44,   45,   46,   47,   48,   49,   50,   51,   52,   53,   54,   55}; //  40
  psi_needed_v_smin[no_ps][  0] = get_vector_from_array_int(needed_v_smin_0, 40);
  int needed_v_smin_1[] = {   4,    5,   10,   11,   24,   25,   34,   35}; //   8
  psi_needed_v_smin[no_ps][  1] = get_vector_from_array_int(needed_v_smin_1, 8);
  int needed_v_smin_2[] = {   4,    5,   10,   11,   24,   25,   34,   35}; //   8
  psi_needed_v_smin[no_ps][  2] = get_vector_from_array_int(needed_v_smin_2, 8);
  int needed_v_smin_3[] = {   6,    7,   12,   13,   22,   23,   52,   53,   18,   19}; //  10
  psi_needed_v_smin[no_ps][  3] = get_vector_from_array_int(needed_v_smin_3, 10);
  int needed_v_smin_4[] = {   8,    9,   14,   15,   28,   29,   38,   39}; //   8
  psi_needed_v_smin[no_ps][  4] = get_vector_from_array_int(needed_v_smin_4, 8);
  int needed_v_smin_5[] = {   8,    9,   14,   15,   28,   29,   38,   39}; //   8
  psi_needed_v_smin[no_ps][  5] = get_vector_from_array_int(needed_v_smin_5, 8);
  int needed_v_smin_6[] = {  10,   11,   14,   15,    4,    5,    8,    9}; //   8
  psi_needed_v_smin[no_ps][  6] = get_vector_from_array_int(needed_v_smin_6, 8);
  int needed_v_smin_7[] = {  12,   13}; //   2
  psi_needed_v_smin[no_ps][  7] = get_vector_from_array_int(needed_v_smin_7, 2);
  int needed_v_smin_8[] = {  16,   17,   44,   45,   46,   47,   50,   51,    0,    1}; //  10
  psi_needed_v_smin[no_ps][  8] = get_vector_from_array_int(needed_v_smin_8, 10);
  int needed_v_smin_9[] = {  16,   17,    0,    1,   44,   45}; //   6
  psi_needed_v_smin[no_ps][  9] = get_vector_from_array_int(needed_v_smin_9, 6);
  int needed_v_smin_10[] = {  20,   21,   26,   27,   36,   37,   46,   47,   32,   33,   50,   51}; //  12
  psi_needed_v_smin[no_ps][ 10] = get_vector_from_array_int(needed_v_smin_10, 12);
  int needed_v_smin_11[] = {  24,   25,   28,   29,   34,   35,   38,   39}; //   8
  psi_needed_v_smin[no_ps][ 11] = get_vector_from_array_int(needed_v_smin_11, 8);
  int needed_v_smin_12[] = {  26,   27,   20,   21,   32,   33}; //   6
  psi_needed_v_smin[no_ps][ 12] = get_vector_from_array_int(needed_v_smin_12, 6);
  int needed_v_smin_13[] = {  30,   31,   48,   49,   52,   53,   54,   55,   42,   43}; //  10
  psi_needed_v_smin[no_ps][ 13] = get_vector_from_array_int(needed_v_smin_13, 10);
  int needed_v_smin_14[] = {  30,   31,   42,   43,   54,   55}; //   6
  psi_needed_v_smin[no_ps][ 14] = get_vector_from_array_int(needed_v_smin_14, 6);
  int needed_v_smin_15[] = {   2,    3,   40,   41}; //   4
  psi_needed_v_smin[no_ps][ 15] = get_vector_from_array_int(needed_v_smin_15, 4);
  int needed_v_smin_16[] = {   2,    3,   40,   41}; //   4
  psi_needed_v_smin[no_ps][ 16] = get_vector_from_array_int(needed_v_smin_16, 4);
  int needed_v_smin_17[] = {   6,    7,   18,   19,   22,   23}; //   6
  psi_needed_v_smin[no_ps][ 17] = get_vector_from_array_int(needed_v_smin_17, 6);
  int needed_v_smin_18[] = {  36,   37}; //   2
  psi_needed_v_smin[no_ps][ 18] = get_vector_from_array_int(needed_v_smin_18, 2);
  int needed_v_smin_19[] = {  48,   49}; //   2
  psi_needed_v_smin[no_ps][ 19] = get_vector_from_array_int(needed_v_smin_19, 2);

  psi_v_smax[no_ps].resize(20);
  psi_needed_v_smax[no_ps].resize(20);
  int needed_v_smax_0[] = {   0,    1,    2,    3,    6,    7,   12,   13,   18,   19,   20,   21,   22,   23,   26,   27,   32,   33,   36,   37,   40,   41,   42,   43,   46,   47,   50,   51,   54,   55}; //  30
  psi_needed_v_smax[no_ps][  0] = get_vector_from_array_int(needed_v_smax_0, 30);
  int needed_v_smax_1[] = {   4,    5,   10,   11,   24,   25,   34,   35}; //   8
  psi_needed_v_smax[no_ps][  1] = get_vector_from_array_int(needed_v_smax_1, 8);
  int needed_v_smax_2[] = {   4,    5,    8,    9,   10,   11,   14,   15,   24,   25,   28,   29,   34,   35,   38,   39}; //  16
  psi_needed_v_smax[no_ps][  2] = get_vector_from_array_int(needed_v_smax_2, 16);
  int needed_v_smax_3[] = {   6,    7,   12,   13,   22,   23,   18,   19}; //   8
  psi_needed_v_smax[no_ps][  3] = get_vector_from_array_int(needed_v_smax_3, 8);
  int needed_v_smax_4[] = {   8,    9,   14,   15,   28,   29,   38,   39}; //   8
  psi_needed_v_smax[no_ps][  4] = get_vector_from_array_int(needed_v_smax_4, 8);
  int needed_v_smax_5[] = {  10,   11,   12,   13,   14,   15,   16,   17,    0,    1,    4,    5,    8,    9,   44,   45}; //  16
  psi_needed_v_smax[no_ps][  5] = get_vector_from_array_int(needed_v_smax_5, 16);
  int needed_v_smax_6[] = {  16,   17,   44,   45}; //   4
  psi_needed_v_smax[no_ps][  6] = get_vector_from_array_int(needed_v_smax_6, 4);
  int needed_v_smax_7[] = {  16,   17,   44,   45}; //   4
  psi_needed_v_smax[no_ps][  7] = get_vector_from_array_int(needed_v_smax_7, 4);
  int needed_v_smax_8[] = {  20,   21,   26,   27,   36,   37,   46,   47,   32,   33}; //  10
  psi_needed_v_smax[no_ps][  8] = get_vector_from_array_int(needed_v_smax_8, 10);
  int needed_v_smax_9[] = {  24,   25,   26,   27,   28,   29,   30,   31,   20,   21,   32,   33,   34,   35,   38,   39,   42,   43,   54,   55}; //  20
  psi_needed_v_smax[no_ps][  9] = get_vector_from_array_int(needed_v_smax_9, 20);
  int needed_v_smax_10[] = {  30,   31,   48,   49,   52,   53}; //   6
  psi_needed_v_smax[no_ps][ 10] = get_vector_from_array_int(needed_v_smax_10, 6);
  int needed_v_smax_11[] = {  30,   31,   48,   49,   52,   53}; //   6
  psi_needed_v_smax[no_ps][ 11] = get_vector_from_array_int(needed_v_smax_11, 6);
  int needed_v_smax_12[] = {  46,   47}; //   2
  psi_needed_v_smax[no_ps][ 12] = get_vector_from_array_int(needed_v_smax_12, 2);
  int needed_v_smax_13[] = {  50,   51,    0,    1}; //   4
  psi_needed_v_smax[no_ps][ 13] = get_vector_from_array_int(needed_v_smax_13, 4);
  int needed_v_smax_14[] = {  52,   53}; //   2
  psi_needed_v_smax[no_ps][ 14] = get_vector_from_array_int(needed_v_smax_14, 2);
  int needed_v_smax_15[] = {  54,   55,   42,   43}; //   4
  psi_needed_v_smax[no_ps][ 15] = get_vector_from_array_int(needed_v_smax_15, 4);
  int needed_v_smax_16[] = {   2,    3,   40,   41}; //   4
  psi_needed_v_smax[no_ps][ 16] = get_vector_from_array_int(needed_v_smax_16, 4);
  int needed_v_smax_17[] = {   2,    3,    6,    7,   18,   19,   22,   23,   36,   37,   40,   41}; //  12
  psi_needed_v_smax[no_ps][ 17] = get_vector_from_array_int(needed_v_smax_17, 12);
  int needed_v_smax_18[] = {  48,   49}; //   2
  psi_needed_v_smax[no_ps][ 18] = get_vector_from_array_int(needed_v_smax_18, 2);
  int needed_v_smax_19[] = {  50,   51}; //   2
  psi_needed_v_smax[no_ps][ 19] = get_vector_from_array_int(needed_v_smax_19, 2);

  psi_container_IS_startvalue[no_ps][0] = psi_container_IS_name.size();
  psi_g_p[no_ps].resize(26);
  psi_needed_g_p[no_ps].resize(26);
  int needed_g_p_0[] = {   0,    2,    6,   12,   18,   20,   22,   26,   32,   36,   40,   42,   46,   50,   54}; //  15
  psi_needed_g_p[no_ps][0] = get_vector_from_array_int(needed_g_p_0, 15);
  psi_container_IS_name.push_back("propagator_0_smin0_smax0");
  int needed_g_p_1[] = {   1,    3,    7,   13,   19,   21,   23,   27,   33,   37,   41,   43,   47,   51,   55}; //  15
  psi_needed_g_p[no_ps][1] = get_vector_from_array_int(needed_g_p_1, 15);
  psi_container_IS_name.push_back("propagator_23_smin0_smax0");
  int needed_g_p_2[] = {   4,    5,   10,   11,   24,   25,   34,   35}; //   8
  psi_needed_g_p[no_ps][2] = get_vector_from_array_int(needed_g_p_2, 8);
  psi_container_IS_name.push_back("propagator_0_smin1_smax1");
  int needed_g_p_3[] = {   4,   10,   24,   34}; //   4
  psi_needed_g_p[no_ps][3] = get_vector_from_array_int(needed_g_p_3, 4);
  psi_container_IS_name.push_back("propagator_0_smin2_smax2");
  int needed_g_p_4[] = {   5,   11,   25,   35}; //   4
  psi_needed_g_p[no_ps][4] = get_vector_from_array_int(needed_g_p_4, 4);
  psi_container_IS_name.push_back("propagator_23_smin2_smax2");
  int needed_g_p_5[] = {   6,    7,   12,   13,   22,   23}; //   6
  psi_needed_g_p[no_ps][5] = get_vector_from_array_int(needed_g_p_5, 6);
  psi_container_IS_name.push_back("propagator_0_smin3_smax3");
  int needed_g_p_6[] = {   8,    9,   14,   15,   28,   29,   38,   39}; //   8
  psi_needed_g_p[no_ps][6] = get_vector_from_array_int(needed_g_p_6, 8);
  psi_container_IS_name.push_back("propagator_0_smin4_smax4");
  int needed_g_p_7[] = {   8,   14,   28,   38}; //   4
  psi_needed_g_p[no_ps][7] = get_vector_from_array_int(needed_g_p_7, 4);
  psi_container_IS_name.push_back("propagator_0_smin5_smax2");
  int needed_g_p_8[] = {   9,   15,   29,   39}; //   4
  psi_needed_g_p[no_ps][8] = get_vector_from_array_int(needed_g_p_8, 4);
  psi_container_IS_name.push_back("propagator_23_smin5_smax2");
  int needed_g_p_9[] = {  10,   11,   14,   15}; //   4
  psi_needed_g_p[no_ps][9] = get_vector_from_array_int(needed_g_p_9, 4);
  psi_container_IS_name.push_back("propagator_0_smin6_smax5");
  int needed_g_p_10[] = {  12,   13}; //   2
  psi_needed_g_p[no_ps][10] = get_vector_from_array_int(needed_g_p_10, 2);
  psi_container_IS_name.push_back("propagator_0_smin7_smax5");
  int needed_g_p_11[] = {  16,   17,   44,   45}; //   4
  psi_needed_g_p[no_ps][11] = get_vector_from_array_int(needed_g_p_11, 4);
  psi_container_IS_name.push_back("propagator_0_smin8_smax6");
  int needed_g_p_12[] = {  16,   44}; //   2
  psi_needed_g_p[no_ps][12] = get_vector_from_array_int(needed_g_p_12, 2);
  psi_container_IS_name.push_back("propagator_0_smin0_smax7");
  int needed_g_p_13[] = {  16,   17}; //   2
  psi_needed_g_p[no_ps][13] = get_vector_from_array_int(needed_g_p_13, 2);
  psi_container_IS_name.push_back("propagator_0_smin9_smax5");
  int needed_g_p_14[] = {  17,   45}; //   2
  psi_needed_g_p[no_ps][14] = get_vector_from_array_int(needed_g_p_14, 2);
  psi_container_IS_name.push_back("propagator_23_smin0_smax7");
  int needed_g_p_15[] = {  20,   21,   26,   27,   36,   37,   46,   47}; //   8
  psi_needed_g_p[no_ps][15] = get_vector_from_array_int(needed_g_p_15, 8);
  psi_container_IS_name.push_back("propagator_0_smin10_smax8");
  int needed_g_p_16[] = {  24,   25,   28,   29}; //   4
  psi_needed_g_p[no_ps][16] = get_vector_from_array_int(needed_g_p_16, 4);
  psi_container_IS_name.push_back("propagator_0_smin11_smax9");
  int needed_g_p_17[] = {  26,   27}; //   2
  psi_needed_g_p[no_ps][17] = get_vector_from_array_int(needed_g_p_17, 2);
  psi_container_IS_name.push_back("propagator_0_smin12_smax9");
  int needed_g_p_18[] = {  30,   31,   48,   49,   52,   53}; //   6
  psi_needed_g_p[no_ps][18] = get_vector_from_array_int(needed_g_p_18, 6);
  psi_container_IS_name.push_back("propagator_0_smin13_smax10");
  int needed_g_p_19[] = {  30,   48,   52}; //   3
  psi_needed_g_p[no_ps][19] = get_vector_from_array_int(needed_g_p_19, 3);
  psi_container_IS_name.push_back("propagator_0_smin0_smax11");
  int needed_g_p_20[] = {  30,   31}; //   2
  psi_needed_g_p[no_ps][20] = get_vector_from_array_int(needed_g_p_20, 2);
  psi_container_IS_name.push_back("propagator_0_smin14_smax9");
  int needed_g_p_21[] = {  31,   49,   53}; //   3
  psi_needed_g_p[no_ps][21] = get_vector_from_array_int(needed_g_p_21, 3);
  psi_container_IS_name.push_back("propagator_23_smin0_smax11");
  int needed_g_p_22[] = {  46,   47}; //   2
  psi_needed_g_p[no_ps][22] = get_vector_from_array_int(needed_g_p_22, 2);
  psi_container_IS_name.push_back("propagator_0_smin8_smax12");
  int needed_g_p_23[] = {  50,   51}; //   2
  psi_needed_g_p[no_ps][23] = get_vector_from_array_int(needed_g_p_23, 2);
  psi_container_IS_name.push_back("propagator_0_smin8_smax13");
  int needed_g_p_24[] = {  52,   53}; //   2
  psi_needed_g_p[no_ps][24] = get_vector_from_array_int(needed_g_p_24, 2);
  psi_container_IS_name.push_back("propagator_0_smin3_smax14");
  int needed_g_p_25[] = {  54,   55}; //   2
  psi_needed_g_p[no_ps][25] = get_vector_from_array_int(needed_g_p_25, 2);
  psi_container_IS_name.push_back("propagator_0_smin13_smax15");

  psi_container_IS_startvalue[no_ps][1] = psi_container_IS_name.size();
  psi_g_f[no_ps].resize(15);
  psi_needed_g_f[no_ps].resize(15);
  int needed_g_f_0[] = {   0,    1}; //   2
  psi_needed_g_f[no_ps][0] = get_vector_from_array_int(needed_g_f_0, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin8_smax13");
  int needed_g_f_1[] = {   0,    1,   44,   45}; //   4
  psi_needed_g_f[no_ps][1] = get_vector_from_array_int(needed_g_f_1, 4);
  psi_container_IS_name.push_back("timelikeinvariant_smin9_smax5");
  int needed_g_f_2[] = {   2,    3,   40,   41}; //   4
  psi_needed_g_f[no_ps][2] = get_vector_from_array_int(needed_g_f_2, 4);
  psi_container_IS_name.push_back("timelikeinvariant_smin15_smax16");
  int needed_g_f_3[] = {   2,    3,   40,   41}; //   4
  psi_needed_g_f[no_ps][3] = get_vector_from_array_int(needed_g_f_3, 4);
  psi_container_IS_name.push_back("timelikeinvariant_smin16_smax17");
  int needed_g_f_4[] = {   4,    5,    8,    9}; //   4
  psi_needed_g_f[no_ps][4] = get_vector_from_array_int(needed_g_f_4, 4);
  psi_container_IS_name.push_back("timelikeinvariant_smin6_smax5");
  int needed_g_f_5[] = {   6,    7,   18,   19,   22,   23}; //   6
  psi_needed_g_f[no_ps][5] = get_vector_from_array_int(needed_g_f_5, 6);
  psi_container_IS_name.push_back("timelikeinvariant_smin17_smax17");
  int needed_g_f_6[] = {  18,   19}; //   2
  psi_needed_g_f[no_ps][6] = get_vector_from_array_int(needed_g_f_6, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin3_smax3");
  int needed_g_f_7[] = {  20,   21,   32,   33}; //   4
  psi_needed_g_f[no_ps][7] = get_vector_from_array_int(needed_g_f_7, 4);
  psi_container_IS_name.push_back("timelikeinvariant_smin12_smax9");
  int needed_g_f_8[] = {  32,   33}; //   2
  psi_needed_g_f[no_ps][8] = get_vector_from_array_int(needed_g_f_8, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin10_smax8");
  int needed_g_f_9[] = {  34,   35,   38,   39}; //   4
  psi_needed_g_f[no_ps][9] = get_vector_from_array_int(needed_g_f_9, 4);
  psi_container_IS_name.push_back("timelikeinvariant_smin11_smax9");
  int needed_g_f_10[] = {  36,   37}; //   2
  psi_needed_g_f[no_ps][10] = get_vector_from_array_int(needed_g_f_10, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin18_smax17");
  int needed_g_f_11[] = {  42,   43}; //   2
  psi_needed_g_f[no_ps][11] = get_vector_from_array_int(needed_g_f_11, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin13_smax15");
  int needed_g_f_12[] = {  42,   43,   54,   55}; //   4
  psi_needed_g_f[no_ps][12] = get_vector_from_array_int(needed_g_f_12, 4);
  psi_container_IS_name.push_back("timelikeinvariant_smin14_smax9");
  int needed_g_f_13[] = {  48,   49}; //   2
  psi_needed_g_f[no_ps][13] = get_vector_from_array_int(needed_g_f_13, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin19_smax18");
  int needed_g_f_14[] = {  50,   51}; //   2
  psi_needed_g_f[no_ps][14] = get_vector_from_array_int(needed_g_f_14, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin10_smax19");

  psi_container_IS_startvalue[no_ps][2] = psi_container_IS_name.size();
  psi_g_t[no_ps].resize(25);
  psi_needed_g_t[no_ps].resize(25);
  int needed_g_t_0[] = {   0,    1,    4,    5,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   44,   45}; //  16
  psi_needed_g_t[no_ps][0] = get_vector_from_array_int(needed_g_t_0, 16);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_1__64_60");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_1__64_60");
  int needed_g_t_1[] = {   0,    1,   44,   45}; //   4
  psi_needed_g_t[no_ps][1] = get_vector_from_array_int(needed_g_t_1, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_66__12_48");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_66__12_48");
  int needed_g_t_2[] = {   0,    1}; //   2
  psi_needed_g_t[no_ps][2] = get_vector_from_array_int(needed_g_t_2, 2);
  psi_container_IS_name.push_back("t_of_tchannel_0__66_13__32_16");
  psi_container_IS_name.push_back("phi_of_tchannel_0__66_13__32_16");
  int needed_g_t_3[] = {   2,    3,    6,    7}; //   4
  psi_needed_g_t[no_ps][3] = get_vector_from_array_int(needed_g_t_3, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_1__16_108");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_1__16_108");
  int needed_g_t_4[] = {   2,    3}; //   2
  psi_needed_g_t[no_ps][4] = get_vector_from_array_int(needed_g_t_4, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_18__12_96");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_18__12_96");
  int needed_g_t_5[] = {   2,    3}; //   2
  psi_needed_g_t[no_ps][5] = get_vector_from_array_int(needed_g_t_5, 2);
  psi_container_IS_name.push_back("t_of_tchannel_0__18_13__64_32");
  psi_container_IS_name.push_back("phi_of_tchannel_0__18_13__64_32");
  int needed_g_t_6[] = {   4,    5,    8,    9}; //   4
  psi_needed_g_t[no_ps][6] = get_vector_from_array_int(needed_g_t_6, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__66_1__32_28");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__66_1__32_28");
  int needed_g_t_7[] = {   6,    7}; //   2
  psi_needed_g_t[no_ps][7] = get_vector_from_array_int(needed_g_t_7, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__18_1__64_44");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__18_1__64_44");
  int needed_g_t_8[] = {  18,   19,   22,   23,   36,   37,   40,   41}; //   8
  psi_needed_g_t[no_ps][8] = get_vector_from_array_int(needed_g_t_8, 8);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_2__16_108");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_2__16_108");
  int needed_g_t_9[] = {  18,   19,   22,   23}; //   4
  psi_needed_g_t[no_ps][9] = get_vector_from_array_int(needed_g_t_9, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_17__64_44");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_17__64_44");
  int needed_g_t_10[] = {  18,   19}; //   2
  psi_needed_g_t[no_ps][10] = get_vector_from_array_int(needed_g_t_10, 2);
  psi_container_IS_name.push_back("t_of_tchannel_0__66_17__32_12");
  psi_container_IS_name.push_back("phi_of_tchannel_0__66_17__32_12");
  int needed_g_t_11[] = {  20,   21,   24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,   38,   39,   42,   43,   54,   55}; //  20
  psi_needed_g_t[no_ps][11] = get_vector_from_array_int(needed_g_t_11, 20);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_2__32_92");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_2__32_92");
  int needed_g_t_12[] = {  20,   21,   32,   33}; //   4
  psi_needed_g_t[no_ps][12] = get_vector_from_array_int(needed_g_t_12, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_33__16_76");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_33__16_76");
  int needed_g_t_13[] = {  32,   33}; //   2
  psi_needed_g_t[no_ps][13] = get_vector_from_array_int(needed_g_t_13, 2);
  psi_container_IS_name.push_back("t_of_tchannel_0__33_18__64_12");
  psi_container_IS_name.push_back("phi_of_tchannel_0__33_18__64_12");
  int needed_g_t_14[] = {  34,   35,   38,   39}; //   4
  psi_needed_g_t[no_ps][14] = get_vector_from_array_int(needed_g_t_14, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__33_2__64_28");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__33_2__64_28");
  int needed_g_t_15[] = {  36,   37}; //   2
  psi_needed_g_t[no_ps][15] = get_vector_from_array_int(needed_g_t_15, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__17_2__32_76");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__17_2__32_76");
  int needed_g_t_16[] = {  40,   41}; //   2
  psi_needed_g_t[no_ps][16] = get_vector_from_array_int(needed_g_t_16, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_17__12_96");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_17__12_96");
  int needed_g_t_17[] = {  40,   41}; //   2
  psi_needed_g_t[no_ps][17] = get_vector_from_array_int(needed_g_t_17, 2);
  psi_container_IS_name.push_back("t_of_tchannel_0__17_14__32_64");
  psi_container_IS_name.push_back("phi_of_tchannel_0__17_14__32_64");
  int needed_g_t_18[] = {  42,   43,   54,   55}; //   4
  psi_needed_g_t[no_ps][18] = get_vector_from_array_int(needed_g_t_18, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_33__12_80");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_33__12_80");
  int needed_g_t_19[] = {  42,   43}; //   2
  psi_needed_g_t[no_ps][19] = get_vector_from_array_int(needed_g_t_19, 2);
  psi_container_IS_name.push_back("t_of_tchannel_0__33_14__64_16");
  psi_container_IS_name.push_back("phi_of_tchannel_0__33_14__64_16");
  int needed_g_t_20[] = {  46,   47,   50,   51}; //   4
  psi_needed_g_t[no_ps][20] = get_vector_from_array_int(needed_g_t_20, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_2__48_76");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_2__48_76");
  int needed_g_t_21[] = {  48,   49}; //   2
  psi_needed_g_t[no_ps][21] = get_vector_from_array_int(needed_g_t_21, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_2__12_112");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_2__12_112");
  int needed_g_t_22[] = {  48,   49}; //   2
  psi_needed_g_t[no_ps][22] = get_vector_from_array_int(needed_g_t_22, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_13__80_32");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_13__80_32");
  int needed_g_t_23[] = {  50,   51}; //   2
  psi_needed_g_t[no_ps][23] = get_vector_from_array_int(needed_g_t_23, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_49__12_64");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_49__12_64");
  int needed_g_t_24[] = {  52,   53}; //   2
  psi_needed_g_t[no_ps][24] = get_vector_from_array_int(needed_g_t_24, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_1__80_44");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_1__80_44");

  psi_container_IS_startvalue[no_ps][3] = psi_container_IS_name.size();
  psi_g_d[no_ps].resize(15);
  psi_needed_g_d[no_ps].resize(15);
  int needed_g_d_0[] = {   0,    1,    2,    3,    6,    7,   12,   13,   16,   17,   18,   19,   20,   21,   22,   23,   26,   27,   30,   31,   32,   33,   36,   37,   40,   41,   42,   43,   44,   45,   46,   47,   48,   49,   50,   51,   52,   53,   54,   55}; //  40
  psi_needed_g_d[no_ps][0] = get_vector_from_array_int(needed_g_d_0, 40);
  psi_container_IS_name.push_back("costheta_of_decay_12__4_8");
  psi_container_IS_name.push_back("phi_of_decay_12__4_8");
  int needed_g_d_1[] = {   4,    5,   10,   11,   24,   25,   34,   35}; //   8
  psi_needed_g_d[no_ps][1] = get_vector_from_array_int(needed_g_d_1, 8);
  psi_container_IS_name.push_back("costheta_of_decay_28__4_24");
  psi_container_IS_name.push_back("phi_of_decay_28__4_24");
  int needed_g_d_2[] = {   4,    5,   10,   11,   24,   25,   34,   35}; //   8
  psi_needed_g_d[no_ps][2] = get_vector_from_array_int(needed_g_d_2, 8);
  psi_container_IS_name.push_back("costheta_of_decay_24__8_16");
  psi_container_IS_name.push_back("phi_of_decay_24__8_16");
  int needed_g_d_3[] = {   6,    7,   12,   13,   22,   23,   52,   53}; //   8
  psi_needed_g_d[no_ps][3] = get_vector_from_array_int(needed_g_d_3, 8);
  psi_container_IS_name.push_back("costheta_of_decay_44__32_12");
  psi_container_IS_name.push_back("phi_of_decay_44__32_12");
  int needed_g_d_4[] = {   8,    9,   14,   15,   28,   29,   38,   39}; //   8
  psi_needed_g_d[no_ps][4] = get_vector_from_array_int(needed_g_d_4, 8);
  psi_container_IS_name.push_back("costheta_of_decay_28__8_20");
  psi_container_IS_name.push_back("phi_of_decay_28__8_20");
  int needed_g_d_5[] = {   8,    9,   14,   15,   28,   29,   38,   39}; //   8
  psi_needed_g_d[no_ps][5] = get_vector_from_array_int(needed_g_d_5, 8);
  psi_container_IS_name.push_back("costheta_of_decay_20__4_16");
  psi_container_IS_name.push_back("phi_of_decay_20__4_16");
  int needed_g_d_6[] = {  10,   11,   14,   15}; //   4
  psi_needed_g_d[no_ps][6] = get_vector_from_array_int(needed_g_d_6, 4);
  psi_container_IS_name.push_back("costheta_of_decay_60__32_28");
  psi_container_IS_name.push_back("phi_of_decay_60__32_28");
  int needed_g_d_7[] = {  12,   13}; //   2
  psi_needed_g_d[no_ps][7] = get_vector_from_array_int(needed_g_d_7, 2);
  psi_container_IS_name.push_back("costheta_of_decay_60__16_44");
  psi_container_IS_name.push_back("phi_of_decay_60__16_44");
  int needed_g_d_8[] = {  16,   17}; //   2
  psi_needed_g_d[no_ps][8] = get_vector_from_array_int(needed_g_d_8, 2);
  psi_container_IS_name.push_back("costheta_of_decay_60__12_48");
  psi_container_IS_name.push_back("phi_of_decay_60__12_48");
  int needed_g_d_9[] = {  16,   17,   44,   45,   46,   47,   50,   51}; //   8
  psi_needed_g_d[no_ps][9] = get_vector_from_array_int(needed_g_d_9, 8);
  psi_container_IS_name.push_back("costheta_of_decay_48__16_32");
  psi_container_IS_name.push_back("phi_of_decay_48__16_32");
  int needed_g_d_10[] = {  20,   21,   26,   27,   36,   37,   46,   47}; //   8
  psi_needed_g_d[no_ps][10] = get_vector_from_array_int(needed_g_d_10, 8);
  psi_container_IS_name.push_back("costheta_of_decay_76__64_12");
  psi_container_IS_name.push_back("phi_of_decay_76__64_12");
  int needed_g_d_11[] = {  24,   25,   28,   29}; //   4
  psi_needed_g_d[no_ps][11] = get_vector_from_array_int(needed_g_d_11, 4);
  psi_container_IS_name.push_back("costheta_of_decay_92__64_28");
  psi_container_IS_name.push_back("phi_of_decay_92__64_28");
  int needed_g_d_12[] = {  26,   27}; //   2
  psi_needed_g_d[no_ps][12] = get_vector_from_array_int(needed_g_d_12, 2);
  psi_container_IS_name.push_back("costheta_of_decay_92__16_76");
  psi_container_IS_name.push_back("phi_of_decay_92__16_76");
  int needed_g_d_13[] = {  30,   31}; //   2
  psi_needed_g_d[no_ps][13] = get_vector_from_array_int(needed_g_d_13, 2);
  psi_container_IS_name.push_back("costheta_of_decay_92__12_80");
  psi_container_IS_name.push_back("phi_of_decay_92__12_80");
  int needed_g_d_14[] = {  30,   31,   48,   49,   52,   53,   54,   55}; //   8
  psi_needed_g_d[no_ps][14] = get_vector_from_array_int(needed_g_d_14, 8);
  psi_container_IS_name.push_back("costheta_of_decay_80__16_64");
  psi_container_IS_name.push_back("phi_of_decay_80__16_64");

  psi_c_p[no_ps].resize(56);
  psi_c_f[no_ps].resize(56);
  psi_c_t[no_ps].resize(56);
  psi_c_d[no_ps].resize(56);

  int c_p_0[] = {  0}; //   1
  psi_c_p[no_ps][0] = get_vector_from_array_int(c_p_0, 1);
  int c_f_0[] = {  0,   1}; //   2
  psi_c_f[no_ps][0] = get_vector_from_array_int(c_f_0, 2);
  int c_t_0[] = {  0,   1,   2}; //   3
  psi_c_t[no_ps][0] = get_vector_from_array_int(c_t_0, 3);
  int c_d_0[] = {  0}; //   1
  psi_c_d[no_ps][0] = get_vector_from_array_int(c_d_0, 1);

  int c_p_1[] = {  1}; //   1
  psi_c_p[no_ps][1] = get_vector_from_array_int(c_p_1, 1);
  int c_f_1[] = {  0,   1}; //   2
  psi_c_f[no_ps][1] = get_vector_from_array_int(c_f_1, 2);
  int c_t_1[] = {  0,   1,   2}; //   3
  psi_c_t[no_ps][1] = get_vector_from_array_int(c_t_1, 3);
  int c_d_1[] = {  0}; //   1
  psi_c_d[no_ps][1] = get_vector_from_array_int(c_d_1, 1);

  int c_p_2[] = {  0}; //   1
  psi_c_p[no_ps][2] = get_vector_from_array_int(c_p_2, 1);
  int c_f_2[] = {  2,   3}; //   2
  psi_c_f[no_ps][2] = get_vector_from_array_int(c_f_2, 2);
  int c_t_2[] = {  3,   4,   5}; //   3
  psi_c_t[no_ps][2] = get_vector_from_array_int(c_t_2, 3);
  int c_d_2[] = {  0}; //   1
  psi_c_d[no_ps][2] = get_vector_from_array_int(c_d_2, 1);

  int c_p_3[] = {  1}; //   1
  psi_c_p[no_ps][3] = get_vector_from_array_int(c_p_3, 1);
  int c_f_3[] = {  2,   3}; //   2
  psi_c_f[no_ps][3] = get_vector_from_array_int(c_f_3, 2);
  int c_t_3[] = {  3,   4,   5}; //   3
  psi_c_t[no_ps][3] = get_vector_from_array_int(c_t_3, 3);
  int c_d_3[] = {  0}; //   1
  psi_c_d[no_ps][3] = get_vector_from_array_int(c_d_3, 1);

  int c_p_4[] = {  2,   3}; //   2
  psi_c_p[no_ps][4] = get_vector_from_array_int(c_p_4, 2);
  int c_f_4[] = {  4}; //   1
  psi_c_f[no_ps][4] = get_vector_from_array_int(c_f_4, 1);
  int c_t_4[] = {  0,   6}; //   2
  psi_c_t[no_ps][4] = get_vector_from_array_int(c_t_4, 2);
  int c_d_4[] = {  1,   2}; //   2
  psi_c_d[no_ps][4] = get_vector_from_array_int(c_d_4, 2);

  int c_p_5[] = {  2,   4}; //   2
  psi_c_p[no_ps][5] = get_vector_from_array_int(c_p_5, 2);
  int c_f_5[] = {  4}; //   1
  psi_c_f[no_ps][5] = get_vector_from_array_int(c_f_5, 1);
  int c_t_5[] = {  0,   6}; //   2
  psi_c_t[no_ps][5] = get_vector_from_array_int(c_t_5, 2);
  int c_d_5[] = {  1,   2}; //   2
  psi_c_d[no_ps][5] = get_vector_from_array_int(c_d_5, 2);

  int c_p_6[] = {  0,   5}; //   2
  psi_c_p[no_ps][6] = get_vector_from_array_int(c_p_6, 2);
  int c_f_6[] = {  5}; //   1
  psi_c_f[no_ps][6] = get_vector_from_array_int(c_f_6, 1);
  int c_t_6[] = {  3,   7}; //   2
  psi_c_t[no_ps][6] = get_vector_from_array_int(c_t_6, 2);
  int c_d_6[] = {  3,   0}; //   2
  psi_c_d[no_ps][6] = get_vector_from_array_int(c_d_6, 2);

  int c_p_7[] = {  1,   5}; //   2
  psi_c_p[no_ps][7] = get_vector_from_array_int(c_p_7, 2);
  int c_f_7[] = {  5}; //   1
  psi_c_f[no_ps][7] = get_vector_from_array_int(c_f_7, 1);
  int c_t_7[] = {  3,   7}; //   2
  psi_c_t[no_ps][7] = get_vector_from_array_int(c_t_7, 2);
  int c_d_7[] = {  3,   0}; //   2
  psi_c_d[no_ps][7] = get_vector_from_array_int(c_d_7, 2);

  int c_p_8[] = {  6,   7}; //   2
  psi_c_p[no_ps][8] = get_vector_from_array_int(c_p_8, 2);
  int c_f_8[] = {  4}; //   1
  psi_c_f[no_ps][8] = get_vector_from_array_int(c_f_8, 1);
  int c_t_8[] = {  0,   6}; //   2
  psi_c_t[no_ps][8] = get_vector_from_array_int(c_t_8, 2);
  int c_d_8[] = {  4,   5}; //   2
  psi_c_d[no_ps][8] = get_vector_from_array_int(c_d_8, 2);

  int c_p_9[] = {  6,   8}; //   2
  psi_c_p[no_ps][9] = get_vector_from_array_int(c_p_9, 2);
  int c_f_9[] = {  4}; //   1
  psi_c_f[no_ps][9] = get_vector_from_array_int(c_f_9, 1);
  int c_t_9[] = {  0,   6}; //   2
  psi_c_t[no_ps][9] = get_vector_from_array_int(c_t_9, 2);
  int c_d_9[] = {  4,   5}; //   2
  psi_c_d[no_ps][9] = get_vector_from_array_int(c_d_9, 2);

  int c_p_10[] = {  2,   3,   9}; //   3
  psi_c_p[no_ps][10] = get_vector_from_array_int(c_p_10, 3);
  int c_f_10[] = {}; //   0
  psi_c_f[no_ps][10] = get_vector_from_array_int(c_f_10, 0);
  int c_t_10[] = {  0}; //   1
  psi_c_t[no_ps][10] = get_vector_from_array_int(c_t_10, 1);
  int c_d_10[] = {  6,   1,   2}; //   3
  psi_c_d[no_ps][10] = get_vector_from_array_int(c_d_10, 3);

  int c_p_11[] = {  2,   4,   9}; //   3
  psi_c_p[no_ps][11] = get_vector_from_array_int(c_p_11, 3);
  int c_f_11[] = {}; //   0
  psi_c_f[no_ps][11] = get_vector_from_array_int(c_f_11, 0);
  int c_t_11[] = {  0}; //   1
  psi_c_t[no_ps][11] = get_vector_from_array_int(c_t_11, 1);
  int c_d_11[] = {  6,   1,   2}; //   3
  psi_c_d[no_ps][11] = get_vector_from_array_int(c_d_11, 3);

  int c_p_12[] = {  0,   5,  10}; //   3
  psi_c_p[no_ps][12] = get_vector_from_array_int(c_p_12, 3);
  int c_f_12[] = {}; //   0
  psi_c_f[no_ps][12] = get_vector_from_array_int(c_f_12, 0);
  int c_t_12[] = {  0}; //   1
  psi_c_t[no_ps][12] = get_vector_from_array_int(c_t_12, 1);
  int c_d_12[] = {  7,   3,   0}; //   3
  psi_c_d[no_ps][12] = get_vector_from_array_int(c_d_12, 3);

  int c_p_13[] = {  1,   5,  10}; //   3
  psi_c_p[no_ps][13] = get_vector_from_array_int(c_p_13, 3);
  int c_f_13[] = {}; //   0
  psi_c_f[no_ps][13] = get_vector_from_array_int(c_f_13, 0);
  int c_t_13[] = {  0}; //   1
  psi_c_t[no_ps][13] = get_vector_from_array_int(c_t_13, 1);
  int c_d_13[] = {  7,   3,   0}; //   3
  psi_c_d[no_ps][13] = get_vector_from_array_int(c_d_13, 3);

  int c_p_14[] = {  6,   7,   9}; //   3
  psi_c_p[no_ps][14] = get_vector_from_array_int(c_p_14, 3);
  int c_f_14[] = {}; //   0
  psi_c_f[no_ps][14] = get_vector_from_array_int(c_f_14, 0);
  int c_t_14[] = {  0}; //   1
  psi_c_t[no_ps][14] = get_vector_from_array_int(c_t_14, 1);
  int c_d_14[] = {  6,   4,   5}; //   3
  psi_c_d[no_ps][14] = get_vector_from_array_int(c_d_14, 3);

  int c_p_15[] = {  6,   8,   9}; //   3
  psi_c_p[no_ps][15] = get_vector_from_array_int(c_p_15, 3);
  int c_f_15[] = {}; //   0
  psi_c_f[no_ps][15] = get_vector_from_array_int(c_f_15, 0);
  int c_t_15[] = {  0}; //   1
  psi_c_t[no_ps][15] = get_vector_from_array_int(c_t_15, 1);
  int c_d_15[] = {  6,   4,   5}; //   3
  psi_c_d[no_ps][15] = get_vector_from_array_int(c_d_15, 3);

  int c_p_16[] = { 11,  12,  13}; //   3
  psi_c_p[no_ps][16] = get_vector_from_array_int(c_p_16, 3);
  int c_f_16[] = {}; //   0
  psi_c_f[no_ps][16] = get_vector_from_array_int(c_f_16, 0);
  int c_t_16[] = {  0}; //   1
  psi_c_t[no_ps][16] = get_vector_from_array_int(c_t_16, 1);
  int c_d_16[] = {  8,   0,   9}; //   3
  psi_c_d[no_ps][16] = get_vector_from_array_int(c_d_16, 3);

  int c_p_17[] = { 11,  14,  13}; //   3
  psi_c_p[no_ps][17] = get_vector_from_array_int(c_p_17, 3);
  int c_f_17[] = {}; //   0
  psi_c_f[no_ps][17] = get_vector_from_array_int(c_f_17, 0);
  int c_t_17[] = {  0}; //   1
  psi_c_t[no_ps][17] = get_vector_from_array_int(c_t_17, 1);
  int c_d_17[] = {  8,   0,   9}; //   3
  psi_c_d[no_ps][17] = get_vector_from_array_int(c_d_17, 3);

  int c_p_18[] = {  0}; //   1
  psi_c_p[no_ps][18] = get_vector_from_array_int(c_p_18, 1);
  int c_f_18[] = {  6,   5}; //   2
  psi_c_f[no_ps][18] = get_vector_from_array_int(c_f_18, 2);
  int c_t_18[] = {  8,   9,  10}; //   3
  psi_c_t[no_ps][18] = get_vector_from_array_int(c_t_18, 3);
  int c_d_18[] = {  0}; //   1
  psi_c_d[no_ps][18] = get_vector_from_array_int(c_d_18, 1);

  int c_p_19[] = {  1}; //   1
  psi_c_p[no_ps][19] = get_vector_from_array_int(c_p_19, 1);
  int c_f_19[] = {  6,   5}; //   2
  psi_c_f[no_ps][19] = get_vector_from_array_int(c_f_19, 2);
  int c_t_19[] = {  8,   9,  10}; //   3
  psi_c_t[no_ps][19] = get_vector_from_array_int(c_t_19, 3);
  int c_d_19[] = {  0}; //   1
  psi_c_d[no_ps][19] = get_vector_from_array_int(c_d_19, 1);

  int c_p_20[] = {  0,  15}; //   2
  psi_c_p[no_ps][20] = get_vector_from_array_int(c_p_20, 2);
  int c_f_20[] = {  7}; //   1
  psi_c_f[no_ps][20] = get_vector_from_array_int(c_f_20, 1);
  int c_t_20[] = { 11,  12}; //   2
  psi_c_t[no_ps][20] = get_vector_from_array_int(c_t_20, 2);
  int c_d_20[] = { 10,   0}; //   2
  psi_c_d[no_ps][20] = get_vector_from_array_int(c_d_20, 2);

  int c_p_21[] = {  1,  15}; //   2
  psi_c_p[no_ps][21] = get_vector_from_array_int(c_p_21, 2);
  int c_f_21[] = {  7}; //   1
  psi_c_f[no_ps][21] = get_vector_from_array_int(c_f_21, 1);
  int c_t_21[] = { 11,  12}; //   2
  psi_c_t[no_ps][21] = get_vector_from_array_int(c_t_21, 2);
  int c_d_21[] = { 10,   0}; //   2
  psi_c_d[no_ps][21] = get_vector_from_array_int(c_d_21, 2);

  int c_p_22[] = {  0,   5}; //   2
  psi_c_p[no_ps][22] = get_vector_from_array_int(c_p_22, 2);
  int c_f_22[] = {  5}; //   1
  psi_c_f[no_ps][22] = get_vector_from_array_int(c_f_22, 1);
  int c_t_22[] = {  8,   9}; //   2
  psi_c_t[no_ps][22] = get_vector_from_array_int(c_t_22, 2);
  int c_d_22[] = {  3,   0}; //   2
  psi_c_d[no_ps][22] = get_vector_from_array_int(c_d_22, 2);

  int c_p_23[] = {  1,   5}; //   2
  psi_c_p[no_ps][23] = get_vector_from_array_int(c_p_23, 2);
  int c_f_23[] = {  5}; //   1
  psi_c_f[no_ps][23] = get_vector_from_array_int(c_f_23, 1);
  int c_t_23[] = {  8,   9}; //   2
  psi_c_t[no_ps][23] = get_vector_from_array_int(c_t_23, 2);
  int c_d_23[] = {  3,   0}; //   2
  psi_c_d[no_ps][23] = get_vector_from_array_int(c_d_23, 2);

  int c_p_24[] = {  2,   3,  16}; //   3
  psi_c_p[no_ps][24] = get_vector_from_array_int(c_p_24, 3);
  int c_f_24[] = {}; //   0
  psi_c_f[no_ps][24] = get_vector_from_array_int(c_f_24, 0);
  int c_t_24[] = { 11}; //   1
  psi_c_t[no_ps][24] = get_vector_from_array_int(c_t_24, 1);
  int c_d_24[] = { 11,   1,   2}; //   3
  psi_c_d[no_ps][24] = get_vector_from_array_int(c_d_24, 3);

  int c_p_25[] = {  2,   4,  16}; //   3
  psi_c_p[no_ps][25] = get_vector_from_array_int(c_p_25, 3);
  int c_f_25[] = {}; //   0
  psi_c_f[no_ps][25] = get_vector_from_array_int(c_f_25, 0);
  int c_t_25[] = { 11}; //   1
  psi_c_t[no_ps][25] = get_vector_from_array_int(c_t_25, 1);
  int c_d_25[] = { 11,   1,   2}; //   3
  psi_c_d[no_ps][25] = get_vector_from_array_int(c_d_25, 3);

  int c_p_26[] = {  0,  15,  17}; //   3
  psi_c_p[no_ps][26] = get_vector_from_array_int(c_p_26, 3);
  int c_f_26[] = {}; //   0
  psi_c_f[no_ps][26] = get_vector_from_array_int(c_f_26, 0);
  int c_t_26[] = { 11}; //   1
  psi_c_t[no_ps][26] = get_vector_from_array_int(c_t_26, 1);
  int c_d_26[] = { 12,  10,   0}; //   3
  psi_c_d[no_ps][26] = get_vector_from_array_int(c_d_26, 3);

  int c_p_27[] = {  1,  15,  17}; //   3
  psi_c_p[no_ps][27] = get_vector_from_array_int(c_p_27, 3);
  int c_f_27[] = {}; //   0
  psi_c_f[no_ps][27] = get_vector_from_array_int(c_f_27, 0);
  int c_t_27[] = { 11}; //   1
  psi_c_t[no_ps][27] = get_vector_from_array_int(c_t_27, 1);
  int c_d_27[] = { 12,  10,   0}; //   3
  psi_c_d[no_ps][27] = get_vector_from_array_int(c_d_27, 3);

  int c_p_28[] = {  6,   7,  16}; //   3
  psi_c_p[no_ps][28] = get_vector_from_array_int(c_p_28, 3);
  int c_f_28[] = {}; //   0
  psi_c_f[no_ps][28] = get_vector_from_array_int(c_f_28, 0);
  int c_t_28[] = { 11}; //   1
  psi_c_t[no_ps][28] = get_vector_from_array_int(c_t_28, 1);
  int c_d_28[] = { 11,   4,   5}; //   3
  psi_c_d[no_ps][28] = get_vector_from_array_int(c_d_28, 3);

  int c_p_29[] = {  6,   8,  16}; //   3
  psi_c_p[no_ps][29] = get_vector_from_array_int(c_p_29, 3);
  int c_f_29[] = {}; //   0
  psi_c_f[no_ps][29] = get_vector_from_array_int(c_f_29, 0);
  int c_t_29[] = { 11}; //   1
  psi_c_t[no_ps][29] = get_vector_from_array_int(c_t_29, 1);
  int c_d_29[] = { 11,   4,   5}; //   3
  psi_c_d[no_ps][29] = get_vector_from_array_int(c_d_29, 3);

  int c_p_30[] = { 18,  19,  20}; //   3
  psi_c_p[no_ps][30] = get_vector_from_array_int(c_p_30, 3);
  int c_f_30[] = {}; //   0
  psi_c_f[no_ps][30] = get_vector_from_array_int(c_f_30, 0);
  int c_t_30[] = { 11}; //   1
  psi_c_t[no_ps][30] = get_vector_from_array_int(c_t_30, 1);
  int c_d_30[] = { 13,   0,  14}; //   3
  psi_c_d[no_ps][30] = get_vector_from_array_int(c_d_30, 3);

  int c_p_31[] = { 18,  21,  20}; //   3
  psi_c_p[no_ps][31] = get_vector_from_array_int(c_p_31, 3);
  int c_f_31[] = {}; //   0
  psi_c_f[no_ps][31] = get_vector_from_array_int(c_f_31, 0);
  int c_t_31[] = { 11}; //   1
  psi_c_t[no_ps][31] = get_vector_from_array_int(c_t_31, 1);
  int c_d_31[] = { 13,   0,  14}; //   3
  psi_c_d[no_ps][31] = get_vector_from_array_int(c_d_31, 3);

  int c_p_32[] = {  0}; //   1
  psi_c_p[no_ps][32] = get_vector_from_array_int(c_p_32, 1);
  int c_f_32[] = {  8,   7}; //   2
  psi_c_f[no_ps][32] = get_vector_from_array_int(c_f_32, 2);
  int c_t_32[] = { 11,  12,  13}; //   3
  psi_c_t[no_ps][32] = get_vector_from_array_int(c_t_32, 3);
  int c_d_32[] = {  0}; //   1
  psi_c_d[no_ps][32] = get_vector_from_array_int(c_d_32, 1);

  int c_p_33[] = {  1}; //   1
  psi_c_p[no_ps][33] = get_vector_from_array_int(c_p_33, 1);
  int c_f_33[] = {  8,   7}; //   2
  psi_c_f[no_ps][33] = get_vector_from_array_int(c_f_33, 2);
  int c_t_33[] = { 11,  12,  13}; //   3
  psi_c_t[no_ps][33] = get_vector_from_array_int(c_t_33, 3);
  int c_d_33[] = {  0}; //   1
  psi_c_d[no_ps][33] = get_vector_from_array_int(c_d_33, 1);

  int c_p_34[] = {  2,   3}; //   2
  psi_c_p[no_ps][34] = get_vector_from_array_int(c_p_34, 2);
  int c_f_34[] = {  9}; //   1
  psi_c_f[no_ps][34] = get_vector_from_array_int(c_f_34, 1);
  int c_t_34[] = { 11,  14}; //   2
  psi_c_t[no_ps][34] = get_vector_from_array_int(c_t_34, 2);
  int c_d_34[] = {  1,   2}; //   2
  psi_c_d[no_ps][34] = get_vector_from_array_int(c_d_34, 2);

  int c_p_35[] = {  2,   4}; //   2
  psi_c_p[no_ps][35] = get_vector_from_array_int(c_p_35, 2);
  int c_f_35[] = {  9}; //   1
  psi_c_f[no_ps][35] = get_vector_from_array_int(c_f_35, 1);
  int c_t_35[] = { 11,  14}; //   2
  psi_c_t[no_ps][35] = get_vector_from_array_int(c_t_35, 2);
  int c_d_35[] = {  1,   2}; //   2
  psi_c_d[no_ps][35] = get_vector_from_array_int(c_d_35, 2);

  int c_p_36[] = {  0,  15}; //   2
  psi_c_p[no_ps][36] = get_vector_from_array_int(c_p_36, 2);
  int c_f_36[] = { 10}; //   1
  psi_c_f[no_ps][36] = get_vector_from_array_int(c_f_36, 1);
  int c_t_36[] = {  8,  15}; //   2
  psi_c_t[no_ps][36] = get_vector_from_array_int(c_t_36, 2);
  int c_d_36[] = { 10,   0}; //   2
  psi_c_d[no_ps][36] = get_vector_from_array_int(c_d_36, 2);

  int c_p_37[] = {  1,  15}; //   2
  psi_c_p[no_ps][37] = get_vector_from_array_int(c_p_37, 2);
  int c_f_37[] = { 10}; //   1
  psi_c_f[no_ps][37] = get_vector_from_array_int(c_f_37, 1);
  int c_t_37[] = {  8,  15}; //   2
  psi_c_t[no_ps][37] = get_vector_from_array_int(c_t_37, 2);
  int c_d_37[] = { 10,   0}; //   2
  psi_c_d[no_ps][37] = get_vector_from_array_int(c_d_37, 2);

  int c_p_38[] = {  6,   7}; //   2
  psi_c_p[no_ps][38] = get_vector_from_array_int(c_p_38, 2);
  int c_f_38[] = {  9}; //   1
  psi_c_f[no_ps][38] = get_vector_from_array_int(c_f_38, 1);
  int c_t_38[] = { 11,  14}; //   2
  psi_c_t[no_ps][38] = get_vector_from_array_int(c_t_38, 2);
  int c_d_38[] = {  4,   5}; //   2
  psi_c_d[no_ps][38] = get_vector_from_array_int(c_d_38, 2);

  int c_p_39[] = {  6,   8}; //   2
  psi_c_p[no_ps][39] = get_vector_from_array_int(c_p_39, 2);
  int c_f_39[] = {  9}; //   1
  psi_c_f[no_ps][39] = get_vector_from_array_int(c_f_39, 1);
  int c_t_39[] = { 11,  14}; //   2
  psi_c_t[no_ps][39] = get_vector_from_array_int(c_t_39, 2);
  int c_d_39[] = {  4,   5}; //   2
  psi_c_d[no_ps][39] = get_vector_from_array_int(c_d_39, 2);

  int c_p_40[] = {  0}; //   1
  psi_c_p[no_ps][40] = get_vector_from_array_int(c_p_40, 1);
  int c_f_40[] = {  2,   3}; //   2
  psi_c_f[no_ps][40] = get_vector_from_array_int(c_f_40, 2);
  int c_t_40[] = {  8,  16,  17}; //   3
  psi_c_t[no_ps][40] = get_vector_from_array_int(c_t_40, 3);
  int c_d_40[] = {  0}; //   1
  psi_c_d[no_ps][40] = get_vector_from_array_int(c_d_40, 1);

  int c_p_41[] = {  1}; //   1
  psi_c_p[no_ps][41] = get_vector_from_array_int(c_p_41, 1);
  int c_f_41[] = {  2,   3}; //   2
  psi_c_f[no_ps][41] = get_vector_from_array_int(c_f_41, 2);
  int c_t_41[] = {  8,  16,  17}; //   3
  psi_c_t[no_ps][41] = get_vector_from_array_int(c_t_41, 3);
  int c_d_41[] = {  0}; //   1
  psi_c_d[no_ps][41] = get_vector_from_array_int(c_d_41, 1);

  int c_p_42[] = {  0}; //   1
  psi_c_p[no_ps][42] = get_vector_from_array_int(c_p_42, 1);
  int c_f_42[] = { 11,  12}; //   2
  psi_c_f[no_ps][42] = get_vector_from_array_int(c_f_42, 2);
  int c_t_42[] = { 11,  18,  19}; //   3
  psi_c_t[no_ps][42] = get_vector_from_array_int(c_t_42, 3);
  int c_d_42[] = {  0}; //   1
  psi_c_d[no_ps][42] = get_vector_from_array_int(c_d_42, 1);

  int c_p_43[] = {  1}; //   1
  psi_c_p[no_ps][43] = get_vector_from_array_int(c_p_43, 1);
  int c_f_43[] = { 11,  12}; //   2
  psi_c_f[no_ps][43] = get_vector_from_array_int(c_f_43, 2);
  int c_t_43[] = { 11,  18,  19}; //   3
  psi_c_t[no_ps][43] = get_vector_from_array_int(c_t_43, 3);
  int c_d_43[] = {  0}; //   1
  psi_c_d[no_ps][43] = get_vector_from_array_int(c_d_43, 1);

  int c_p_44[] = { 11,  12}; //   2
  psi_c_p[no_ps][44] = get_vector_from_array_int(c_p_44, 2);
  int c_f_44[] = {  1}; //   1
  psi_c_f[no_ps][44] = get_vector_from_array_int(c_f_44, 1);
  int c_t_44[] = {  0,   1}; //   2
  psi_c_t[no_ps][44] = get_vector_from_array_int(c_t_44, 2);
  int c_d_44[] = {  0,   9}; //   2
  psi_c_d[no_ps][44] = get_vector_from_array_int(c_d_44, 2);

  int c_p_45[] = { 11,  14}; //   2
  psi_c_p[no_ps][45] = get_vector_from_array_int(c_p_45, 2);
  int c_f_45[] = {  1}; //   1
  psi_c_f[no_ps][45] = get_vector_from_array_int(c_f_45, 1);
  int c_t_45[] = {  0,   1}; //   2
  psi_c_t[no_ps][45] = get_vector_from_array_int(c_t_45, 2);
  int c_d_45[] = {  0,   9}; //   2
  psi_c_d[no_ps][45] = get_vector_from_array_int(c_d_45, 2);

  int c_p_46[] = {  0,  15,  22}; //   3
  psi_c_p[no_ps][46] = get_vector_from_array_int(c_p_46, 3);
  int c_f_46[] = {}; //   0
  psi_c_f[no_ps][46] = get_vector_from_array_int(c_f_46, 0);
  int c_t_46[] = { 20}; //   1
  psi_c_t[no_ps][46] = get_vector_from_array_int(c_t_46, 1);
  int c_d_46[] = {  9,  10,   0}; //   3
  psi_c_d[no_ps][46] = get_vector_from_array_int(c_d_46, 3);

  int c_p_47[] = {  1,  15,  22}; //   3
  psi_c_p[no_ps][47] = get_vector_from_array_int(c_p_47, 3);
  int c_f_47[] = {}; //   0
  psi_c_f[no_ps][47] = get_vector_from_array_int(c_f_47, 0);
  int c_t_47[] = { 20}; //   1
  psi_c_t[no_ps][47] = get_vector_from_array_int(c_t_47, 1);
  int c_d_47[] = {  9,  10,   0}; //   3
  psi_c_d[no_ps][47] = get_vector_from_array_int(c_d_47, 3);

  int c_p_48[] = { 18,  19}; //   2
  psi_c_p[no_ps][48] = get_vector_from_array_int(c_p_48, 2);
  int c_f_48[] = { 13}; //   1
  psi_c_f[no_ps][48] = get_vector_from_array_int(c_f_48, 1);
  int c_t_48[] = { 21,  22}; //   2
  psi_c_t[no_ps][48] = get_vector_from_array_int(c_t_48, 2);
  int c_d_48[] = {  0,  14}; //   2
  psi_c_d[no_ps][48] = get_vector_from_array_int(c_d_48, 2);

  int c_p_49[] = { 18,  21}; //   2
  psi_c_p[no_ps][49] = get_vector_from_array_int(c_p_49, 2);
  int c_f_49[] = { 13}; //   1
  psi_c_f[no_ps][49] = get_vector_from_array_int(c_f_49, 1);
  int c_t_49[] = { 21,  22}; //   2
  psi_c_t[no_ps][49] = get_vector_from_array_int(c_t_49, 2);
  int c_d_49[] = {  0,  14}; //   2
  psi_c_d[no_ps][49] = get_vector_from_array_int(c_d_49, 2);

  int c_p_50[] = {  0,  23}; //   2
  psi_c_p[no_ps][50] = get_vector_from_array_int(c_p_50, 2);
  int c_f_50[] = { 14}; //   1
  psi_c_f[no_ps][50] = get_vector_from_array_int(c_f_50, 1);
  int c_t_50[] = { 20,  23}; //   2
  psi_c_t[no_ps][50] = get_vector_from_array_int(c_t_50, 2);
  int c_d_50[] = {  9,   0}; //   2
  psi_c_d[no_ps][50] = get_vector_from_array_int(c_d_50, 2);

  int c_p_51[] = {  1,  23}; //   2
  psi_c_p[no_ps][51] = get_vector_from_array_int(c_p_51, 2);
  int c_f_51[] = { 14}; //   1
  psi_c_f[no_ps][51] = get_vector_from_array_int(c_f_51, 1);
  int c_t_51[] = { 20,  23}; //   2
  psi_c_t[no_ps][51] = get_vector_from_array_int(c_t_51, 2);
  int c_d_51[] = {  9,   0}; //   2
  psi_c_d[no_ps][51] = get_vector_from_array_int(c_d_51, 2);

  int c_p_52[] = { 18,  19,  24}; //   3
  psi_c_p[no_ps][52] = get_vector_from_array_int(c_p_52, 3);
  int c_f_52[] = {}; //   0
  psi_c_f[no_ps][52] = get_vector_from_array_int(c_f_52, 0);
  int c_t_52[] = { 24}; //   1
  psi_c_t[no_ps][52] = get_vector_from_array_int(c_t_52, 1);
  int c_d_52[] = {  3,   0,  14}; //   3
  psi_c_d[no_ps][52] = get_vector_from_array_int(c_d_52, 3);

  int c_p_53[] = { 18,  21,  24}; //   3
  psi_c_p[no_ps][53] = get_vector_from_array_int(c_p_53, 3);
  int c_f_53[] = {}; //   0
  psi_c_f[no_ps][53] = get_vector_from_array_int(c_f_53, 0);
  int c_t_53[] = { 24}; //   1
  psi_c_t[no_ps][53] = get_vector_from_array_int(c_t_53, 1);
  int c_d_53[] = {  3,   0,  14}; //   3
  psi_c_d[no_ps][53] = get_vector_from_array_int(c_d_53, 3);

  int c_p_54[] = {  0,  25}; //   2
  psi_c_p[no_ps][54] = get_vector_from_array_int(c_p_54, 2);
  int c_f_54[] = { 12}; //   1
  psi_c_f[no_ps][54] = get_vector_from_array_int(c_f_54, 1);
  int c_t_54[] = { 11,  18}; //   2
  psi_c_t[no_ps][54] = get_vector_from_array_int(c_t_54, 2);
  int c_d_54[] = { 14,   0}; //   2
  psi_c_d[no_ps][54] = get_vector_from_array_int(c_d_54, 2);

  int c_p_55[] = {  1,  25}; //   2
  psi_c_p[no_ps][55] = get_vector_from_array_int(c_p_55, 2);
  int c_f_55[] = { 12}; //   1
  psi_c_f[no_ps][55] = get_vector_from_array_int(c_f_55, 1);
  int c_t_55[] = { 11,  18}; //   2
  psi_c_t[no_ps][55] = get_vector_from_array_int(c_t_55, 2);
  int c_d_55[] = { 14,   0}; //   2
  psi_c_d[no_ps][55] = get_vector_from_array_int(c_d_55, 2);

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
