#include "../include/classes.cxx"
#include "../include/definitions.phasespace.set.cxx"
#include "../ppeexmxnm04/header/ppeexmxnm04.phasespace.h"
void ppeexmxnm04_optimize_minv_doublereal(phasespace_set & psi){
  static Logger logger("ppeexmxnm04_optimize_minv_doublereal");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

#include "user/specify.optimize.phasespace.minv.doublereal.cxx"

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

int ppeexmxnm04_determination_MCchannels_doublereal(int no_ps, phasespace_set & psi){
  static Logger logger("ppeexmxnm04_determination_MCchannels_doublereal");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  int n_channel = 0;
  if      (psi_no_map[no_ps] ==  0){n_channel = 262;}
  else if (psi_no_map[no_ps] ==  1){n_channel = 108;}
  else if (psi_no_map[no_ps] ==  2){n_channel = 108;}
  else if (psi_no_map[no_ps] ==  3){n_channel = 108;}
  else if (psi_no_map[no_ps] ==  4){n_channel = 64;}
  else if (psi_no_map[no_ps] ==  5){n_channel = 32;}
  else if (psi_no_map[no_ps] ==  6){n_channel = 64;}
  else if (psi_no_map[no_ps] ==  7){n_channel = 32;}
  else if (psi_no_map[no_ps] ==  8){n_channel = 32;}
  else if (psi_no_map[no_ps] ==  9){n_channel = 64;}
  else if (psi_no_map[no_ps] == 10){n_channel = 32;}
  else if (psi_no_map[no_ps] == 11){n_channel = 108;}
  else if (psi_no_map[no_ps] == 12){n_channel = 64;}
  else if (psi_no_map[no_ps] == 13){n_channel = 64;}
  else if (psi_no_map[no_ps] == 14){n_channel = 32;}
  else if (psi_no_map[no_ps] == 15){n_channel = 32;}
  else if (psi_no_map[no_ps] == 16){n_channel = 64;}
  else if (psi_no_map[no_ps] == 17){n_channel = 32;}
  else if (psi_no_map[no_ps] == 18){n_channel = 32;}
  else if (psi_no_map[no_ps] == 19){n_channel = 32;}
  else if (psi_no_map[no_ps] == 20){n_channel = 32;}
  else if (psi_no_map[no_ps] == 21){n_channel = 64;}
  else if (psi_no_map[no_ps] == 22){n_channel = 64;}
  else if (psi_no_map[no_ps] == 23){n_channel = 32;}
  else if (psi_no_map[no_ps] == 24){n_channel = 32;}
  return n_channel;

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

void ppeexmxnm04_ac_tau_psp_doublereal(int no_ps, vector<int> & tau_MC_map, phasespace_set & psi){
  static Logger logger("ppeexmxnm04_ac_tau_psp_doublereal");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  if      (psi.no_map[no_ps] == 0){}
  else if (psi.no_map[no_ps] ==  1){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  2){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  3){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  4){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  5){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  6){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  7){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  8){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  9){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 10){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 11){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 12){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 13){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 14){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 15){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 16){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 17){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 18){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 19){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 20){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 21){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 22){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 23){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 24){
    tau_MC_map.push_back(0);
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

void ppeexmxnm04_ax_psp_doublereal(int no_ps, phasespace_set & psi){
  static Logger logger("ppeexmxnm04_ax_psp_doublereal");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;
  if (psi_no_map[no_ps] == 0){}
  else if (psi_no_map[no_ps] ==  1){ppeexmxnm04_ax_psp_240_gg_emepmupvmdux(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  2){ppeexmxnm04_ax_psp_240_gu_emepmupvmgd(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  3){ppeexmxnm04_ax_psp_240_gdx_emepmupvmgux(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  4){ppeexmxnm04_ax_psp_240_du_emepmupvmdd(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  5){ppeexmxnm04_ax_psp_240_dc_emepmupvmds(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  6){ppeexmxnm04_ax_psp_240_ddx_emepmupvmdux(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  7){ppeexmxnm04_ax_psp_240_ddx_emepmupvmscx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  8){ppeexmxnm04_ax_psp_240_dsx_emepmupvmdcx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  9){ppeexmxnm04_ax_psp_240_uu_emepmupvmdu(no_ps, psi);}
  else if (psi_no_map[no_ps] == 10){ppeexmxnm04_ax_psp_240_uc_emepmupvmdc(no_ps, psi);}
  else if (psi_no_map[no_ps] == 11){ppeexmxnm04_ax_psp_240_udx_emepmupvmgg(no_ps, psi);}
  else if (psi_no_map[no_ps] == 12){ppeexmxnm04_ax_psp_240_udx_emepmupvmddx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 13){ppeexmxnm04_ax_psp_240_udx_emepmupvmuux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 14){ppeexmxnm04_ax_psp_240_udx_emepmupvmssx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 15){ppeexmxnm04_ax_psp_240_udx_emepmupvmccx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 16){ppeexmxnm04_ax_psp_240_uux_emepmupvmdux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 17){ppeexmxnm04_ax_psp_240_uux_emepmupvmscx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 18){ppeexmxnm04_ax_psp_240_usx_emepmupvmdsx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 19){ppeexmxnm04_ax_psp_240_usx_emepmupvmucx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 20){ppeexmxnm04_ax_psp_240_ucx_emepmupvmdcx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 21){ppeexmxnm04_ax_psp_240_dxdx_emepmupvmdxux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 22){ppeexmxnm04_ax_psp_240_dxux_emepmupvmuxux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 23){ppeexmxnm04_ax_psp_240_dxsx_emepmupvmdxcx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 24){ppeexmxnm04_ax_psp_240_dxcx_emepmupvmuxcx(no_ps, psi);}

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
