#include "../include/classes.cxx"
#include "../include/definitions.phasespace.set.cxx"
#include "../ppeexmxnm04/header/ppeexmxnm04.phasespace.h"
void ppeexmxnm04_ax_psp_240_uux_emepmupvmscx(int no_ps, phasespace_set & psi){
  static Logger logger("ppeexmxnm04_ax_psp_240_uux_emepmupvmscx");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;
  psi_v_smin[no_ps].resize(21);
  psi_needed_v_smin[no_ps].resize(21);
  int needed_v_smin_0[] = {   0,    1,    2,    3,    4,    5,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31}; //  30
  psi_needed_v_smin[no_ps][  0] = get_vector_from_array_int(needed_v_smin_0, 30);
  int needed_v_smin_1[] = {   0,    1}; //   2
  psi_needed_v_smin[no_ps][  1] = get_vector_from_array_int(needed_v_smin_1, 2);
  int needed_v_smin_2[] = {   0,    1}; //   2
  psi_needed_v_smin[no_ps][  2] = get_vector_from_array_int(needed_v_smin_2, 2);
  int needed_v_smin_3[] = {   0,    2,    3,    6,    8,    9}; //   6
  psi_needed_v_smin[no_ps][  3] = get_vector_from_array_int(needed_v_smin_3, 6);
  int needed_v_smin_4[] = {   1,    4,    5,    7,   10,   11}; //   6
  psi_needed_v_smin[no_ps][  4] = get_vector_from_array_int(needed_v_smin_4, 6);
  int needed_v_smin_5[] = {   2,    3,    4,    5}; //   4
  psi_needed_v_smin[no_ps][  5] = get_vector_from_array_int(needed_v_smin_5, 4);
  int needed_v_smin_6[] = {   2,    3,    4,    5}; //   4
  psi_needed_v_smin[no_ps][  6] = get_vector_from_array_int(needed_v_smin_6, 4);
  int needed_v_smin_7[] = {   6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31}; //  26
  psi_needed_v_smin[no_ps][  7] = get_vector_from_array_int(needed_v_smin_7, 26);
  int needed_v_smin_8[] = {   6,    7}; //   2
  psi_needed_v_smin[no_ps][  8] = get_vector_from_array_int(needed_v_smin_8, 2);
  int needed_v_smin_9[] = {   6,    7}; //   2
  psi_needed_v_smin[no_ps][  9] = get_vector_from_array_int(needed_v_smin_9, 2);
  int needed_v_smin_10[] = {   8,    9,   10,   11}; //   4
  psi_needed_v_smin[no_ps][ 10] = get_vector_from_array_int(needed_v_smin_10, 4);
  int needed_v_smin_11[] = {  12,   13,   22,   23,   26,   27,   30,   31}; //   8
  psi_needed_v_smin[no_ps][ 11] = get_vector_from_array_int(needed_v_smin_11, 8);
  int needed_v_smin_12[] = {  12,   13}; //   2
  psi_needed_v_smin[no_ps][ 12] = get_vector_from_array_int(needed_v_smin_12, 2);
  int needed_v_smin_13[] = {  14,   15,   20,   21,   24,   25,   28,   29}; //   8
  psi_needed_v_smin[no_ps][ 13] = get_vector_from_array_int(needed_v_smin_13, 8);
  int needed_v_smin_14[] = {  14,   15}; //   2
  psi_needed_v_smin[no_ps][ 14] = get_vector_from_array_int(needed_v_smin_14, 2);
  int needed_v_smin_15[] = {  16,   17,   20,   21}; //   4
  psi_needed_v_smin[no_ps][ 15] = get_vector_from_array_int(needed_v_smin_15, 4);
  int needed_v_smin_16[] = {  16,   17}; //   2
  psi_needed_v_smin[no_ps][ 16] = get_vector_from_array_int(needed_v_smin_16, 2);
  int needed_v_smin_17[] = {  18,   19,   22,   23}; //   4
  psi_needed_v_smin[no_ps][ 17] = get_vector_from_array_int(needed_v_smin_17, 4);
  int needed_v_smin_18[] = {  18,   19}; //   2
  psi_needed_v_smin[no_ps][ 18] = get_vector_from_array_int(needed_v_smin_18, 2);
  int needed_v_smin_19[] = {  24,   25,   28,   29}; //   4
  psi_needed_v_smin[no_ps][ 19] = get_vector_from_array_int(needed_v_smin_19, 4);
  int needed_v_smin_20[] = {  26,   27,   30,   31}; //   4
  psi_needed_v_smin[no_ps][ 20] = get_vector_from_array_int(needed_v_smin_20, 4);

  psi_v_smax[no_ps].resize(26);
  psi_needed_v_smax[no_ps].resize(26);
  int needed_v_smax_0[] = {   0,    1,    2,    3,    4,    5,   16,   17,   18,   19,   22,   23,   28,   29,   30,   31}; //  16
  psi_needed_v_smax[no_ps][  0] = get_vector_from_array_int(needed_v_smax_0, 16);
  int needed_v_smax_1[] = {   0,    1}; //   2
  psi_needed_v_smax[no_ps][  1] = get_vector_from_array_int(needed_v_smax_1, 2);
  int needed_v_smax_2[] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11}; //  12
  psi_needed_v_smax[no_ps][  2] = get_vector_from_array_int(needed_v_smax_2, 12);
  int needed_v_smax_3[] = {   0,    2,    3,    6,    8,    9,   14,   15,   18,   19}; //  10
  psi_needed_v_smax[no_ps][  3] = get_vector_from_array_int(needed_v_smax_3, 10);
  int needed_v_smax_4[] = {   1,    4,    5,    7,   10,   11,   12,   13,   16,   17}; //  10
  psi_needed_v_smax[no_ps][  4] = get_vector_from_array_int(needed_v_smax_4, 10);
  int needed_v_smax_5[] = {   2,    3,    4,    5}; //   4
  psi_needed_v_smax[no_ps][  5] = get_vector_from_array_int(needed_v_smax_5, 4);
  int needed_v_smax_6[] = {   6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   20,   21,   24,   25,   26,   27}; //  16
  psi_needed_v_smax[no_ps][  6] = get_vector_from_array_int(needed_v_smax_6, 16);
  int needed_v_smax_7[] = {   6,    7}; //   2
  psi_needed_v_smax[no_ps][  7] = get_vector_from_array_int(needed_v_smax_7, 2);
  int needed_v_smax_8[] = {   8,    9,   10,   11,   20,   21}; //   6
  psi_needed_v_smax[no_ps][  8] = get_vector_from_array_int(needed_v_smax_8, 6);
  int needed_v_smax_9[] = {  12,   13,   26,   27}; //   4
  psi_needed_v_smax[no_ps][  9] = get_vector_from_array_int(needed_v_smax_9, 4);
  int needed_v_smax_10[] = {  12,   13}; //   2
  psi_needed_v_smax[no_ps][ 10] = get_vector_from_array_int(needed_v_smax_10, 2);
  int needed_v_smax_11[] = {  14,   15,   24,   25}; //   4
  psi_needed_v_smax[no_ps][ 11] = get_vector_from_array_int(needed_v_smax_11, 4);
  int needed_v_smax_12[] = {  14,   15}; //   2
  psi_needed_v_smax[no_ps][ 12] = get_vector_from_array_int(needed_v_smax_12, 2);
  int needed_v_smax_13[] = {  16,   17}; //   2
  psi_needed_v_smax[no_ps][ 13] = get_vector_from_array_int(needed_v_smax_13, 2);
  int needed_v_smax_14[] = {  16,   17}; //   2
  psi_needed_v_smax[no_ps][ 14] = get_vector_from_array_int(needed_v_smax_14, 2);
  int needed_v_smax_15[] = {  18,   19}; //   2
  psi_needed_v_smax[no_ps][ 15] = get_vector_from_array_int(needed_v_smax_15, 2);
  int needed_v_smax_16[] = {  18,   19}; //   2
  psi_needed_v_smax[no_ps][ 16] = get_vector_from_array_int(needed_v_smax_16, 2);
  int needed_v_smax_17[] = {  20,   21,   28,   29}; //   4
  psi_needed_v_smax[no_ps][ 17] = get_vector_from_array_int(needed_v_smax_17, 4);
  int needed_v_smax_18[] = {  20,   21}; //   2
  psi_needed_v_smax[no_ps][ 18] = get_vector_from_array_int(needed_v_smax_18, 2);
  int needed_v_smax_19[] = {  22,   23,   28,   29,   30,   31}; //   6
  psi_needed_v_smax[no_ps][ 19] = get_vector_from_array_int(needed_v_smax_19, 6);
  int needed_v_smax_20[] = {  22,   23}; //   2
  psi_needed_v_smax[no_ps][ 20] = get_vector_from_array_int(needed_v_smax_20, 2);
  int needed_v_smax_21[] = {  22,   23}; //   2
  psi_needed_v_smax[no_ps][ 21] = get_vector_from_array_int(needed_v_smax_21, 2);
  int needed_v_smax_22[] = {  24,   25,   26,   27}; //   4
  psi_needed_v_smax[no_ps][ 22] = get_vector_from_array_int(needed_v_smax_22, 4);
  int needed_v_smax_23[] = {  24,   25,   26,   27}; //   4
  psi_needed_v_smax[no_ps][ 23] = get_vector_from_array_int(needed_v_smax_23, 4);
  int needed_v_smax_24[] = {  28,   29,   30,   31}; //   4
  psi_needed_v_smax[no_ps][ 24] = get_vector_from_array_int(needed_v_smax_24, 4);
  int needed_v_smax_25[] = {  30,   31}; //   2
  psi_needed_v_smax[no_ps][ 25] = get_vector_from_array_int(needed_v_smax_25, 2);

  psi_container_IS_startvalue[no_ps][0] = psi_container_IS_name.size();
  psi_g_p[no_ps].resize(40);
  psi_needed_g_p[no_ps].resize(40);
  int needed_g_p_0[] = {   0,    1,    3,    5,   17,   19,   23,   29,   31}; //   9
  psi_needed_g_p[no_ps][0] = get_vector_from_array_int(needed_g_p_0, 9);
  psi_container_IS_name.push_back("propagator_23_smin0_smax0");
  int needed_g_p_1[] = {   0,    1}; //   2
  psi_needed_g_p[no_ps][1] = get_vector_from_array_int(needed_g_p_1, 2);
  psi_container_IS_name.push_back("propagator_0_smin1_smax1");
  int needed_g_p_2[] = {   0,    1}; //   2
  psi_needed_g_p[no_ps][2] = get_vector_from_array_int(needed_g_p_2, 2);
  psi_container_IS_name.push_back("propagator_24_smin2_smax2");
  int needed_g_p_3[] = {   0,    2,    3,    6,    8,    9}; //   6
  psi_needed_g_p[no_ps][3] = get_vector_from_array_int(needed_g_p_3, 6);
  psi_container_IS_name.push_back("propagator_0_smin3_smax3");
  int needed_g_p_4[] = {   1,    4,    5,    7,   10,   11}; //   6
  psi_needed_g_p[no_ps][4] = get_vector_from_array_int(needed_g_p_4, 6);
  psi_container_IS_name.push_back("propagator_0_smin4_smax4");
  int needed_g_p_5[] = {   2,    4,   16,   18,   22,   28,   30}; //   7
  psi_needed_g_p[no_ps][5] = get_vector_from_array_int(needed_g_p_5, 7);
  psi_container_IS_name.push_back("propagator_0_smin0_smax0");
  int needed_g_p_6[] = {   2,    3,    4,    5}; //   4
  psi_needed_g_p[no_ps][6] = get_vector_from_array_int(needed_g_p_6, 4);
  psi_container_IS_name.push_back("propagator_0_smin5_smax5");
  int needed_g_p_7[] = {   2,    3,    4,    5}; //   4
  psi_needed_g_p[no_ps][7] = get_vector_from_array_int(needed_g_p_7, 4);
  psi_container_IS_name.push_back("propagator_24_smin6_smax2");
  int needed_g_p_8[] = {   6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   20,   21,   24,   25,   26,   27}; //  16
  psi_needed_g_p[no_ps][8] = get_vector_from_array_int(needed_g_p_8, 16);
  psi_container_IS_name.push_back("propagator_24_smin7_smax6");
  int needed_g_p_9[] = {   6,    7}; //   2
  psi_needed_g_p[no_ps][9] = get_vector_from_array_int(needed_g_p_9, 2);
  psi_container_IS_name.push_back("propagator_0_smin8_smax7");
  int needed_g_p_10[] = {   6,    7}; //   2
  psi_needed_g_p[no_ps][10] = get_vector_from_array_int(needed_g_p_10, 2);
  psi_container_IS_name.push_back("propagator_24_smin9_smax2");
  int needed_g_p_11[] = {   8,   10,   20}; //   3
  psi_needed_g_p[no_ps][11] = get_vector_from_array_int(needed_g_p_11, 3);
  psi_container_IS_name.push_back("propagator_0_smin0_smax8");
  int needed_g_p_12[] = {   8,    9,   10,   11}; //   4
  psi_needed_g_p[no_ps][12] = get_vector_from_array_int(needed_g_p_12, 4);
  psi_container_IS_name.push_back("propagator_24_smin10_smax2");
  int needed_g_p_13[] = {   9,   11,   21}; //   3
  psi_needed_g_p[no_ps][13] = get_vector_from_array_int(needed_g_p_13, 3);
  psi_container_IS_name.push_back("propagator_23_smin0_smax8");
  int needed_g_p_14[] = {  12,   13,   26,   27}; //   4
  psi_needed_g_p[no_ps][14] = get_vector_from_array_int(needed_g_p_14, 4);
  psi_container_IS_name.push_back("propagator_0_smin11_smax9");
  int needed_g_p_15[] = {  12}; //   1
  psi_needed_g_p[no_ps][15] = get_vector_from_array_int(needed_g_p_15, 1);
  psi_container_IS_name.push_back("propagator_0_smin0_smax10");
  int needed_g_p_16[] = {  12,   13}; //   2
  psi_needed_g_p[no_ps][16] = get_vector_from_array_int(needed_g_p_16, 2);
  psi_container_IS_name.push_back("propagator_0_smin12_smax4");
  int needed_g_p_17[] = {  13}; //   1
  psi_needed_g_p[no_ps][17] = get_vector_from_array_int(needed_g_p_17, 1);
  psi_container_IS_name.push_back("propagator_23_smin0_smax10");
  int needed_g_p_18[] = {  14,   15,   24,   25}; //   4
  psi_needed_g_p[no_ps][18] = get_vector_from_array_int(needed_g_p_18, 4);
  psi_container_IS_name.push_back("propagator_0_smin13_smax11");
  int needed_g_p_19[] = {  14}; //   1
  psi_needed_g_p[no_ps][19] = get_vector_from_array_int(needed_g_p_19, 1);
  psi_container_IS_name.push_back("propagator_0_smin0_smax12");
  int needed_g_p_20[] = {  14,   15}; //   2
  psi_needed_g_p[no_ps][20] = get_vector_from_array_int(needed_g_p_20, 2);
  psi_container_IS_name.push_back("propagator_0_smin14_smax3");
  int needed_g_p_21[] = {  15}; //   1
  psi_needed_g_p[no_ps][21] = get_vector_from_array_int(needed_g_p_21, 1);
  psi_container_IS_name.push_back("propagator_23_smin0_smax12");
  int needed_g_p_22[] = {  16,   17}; //   2
  psi_needed_g_p[no_ps][22] = get_vector_from_array_int(needed_g_p_22, 2);
  psi_container_IS_name.push_back("propagator_0_smin15_smax13");
  int needed_g_p_23[] = {  16,   17}; //   2
  psi_needed_g_p[no_ps][23] = get_vector_from_array_int(needed_g_p_23, 2);
  psi_container_IS_name.push_back("propagator_24_smin7_smax14");
  int needed_g_p_24[] = {  16,   17}; //   2
  psi_needed_g_p[no_ps][24] = get_vector_from_array_int(needed_g_p_24, 2);
  psi_container_IS_name.push_back("propagator_0_smin16_smax4");
  int needed_g_p_25[] = {  18,   19}; //   2
  psi_needed_g_p[no_ps][25] = get_vector_from_array_int(needed_g_p_25, 2);
  psi_container_IS_name.push_back("propagator_0_smin17_smax15");
  int needed_g_p_26[] = {  18,   19}; //   2
  psi_needed_g_p[no_ps][26] = get_vector_from_array_int(needed_g_p_26, 2);
  psi_container_IS_name.push_back("propagator_24_smin7_smax16");
  int needed_g_p_27[] = {  18,   19}; //   2
  psi_needed_g_p[no_ps][27] = get_vector_from_array_int(needed_g_p_27, 2);
  psi_container_IS_name.push_back("propagator_0_smin18_smax3");
  int needed_g_p_28[] = {  20,   21,   28,   29}; //   4
  psi_needed_g_p[no_ps][28] = get_vector_from_array_int(needed_g_p_28, 4);
  psi_container_IS_name.push_back("propagator_0_smin13_smax17");
  int needed_g_p_29[] = {  20,   21}; //   2
  psi_needed_g_p[no_ps][29] = get_vector_from_array_int(needed_g_p_29, 2);
  psi_container_IS_name.push_back("propagator_0_smin15_smax18");
  int needed_g_p_30[] = {  22,   23,   28,   29,   30,   31}; //   6
  psi_needed_g_p[no_ps][30] = get_vector_from_array_int(needed_g_p_30, 6);
  psi_container_IS_name.push_back("propagator_24_smin7_smax19");
  int needed_g_p_31[] = {  22,   23}; //   2
  psi_needed_g_p[no_ps][31] = get_vector_from_array_int(needed_g_p_31, 2);
  psi_container_IS_name.push_back("propagator_0_smin17_smax20");
  int needed_g_p_32[] = {  22,   23}; //   2
  psi_needed_g_p[no_ps][32] = get_vector_from_array_int(needed_g_p_32, 2);
  psi_container_IS_name.push_back("propagator_0_smin11_smax21");
  int needed_g_p_33[] = {  24,   25}; //   2
  psi_needed_g_p[no_ps][33] = get_vector_from_array_int(needed_g_p_33, 2);
  psi_container_IS_name.push_back("propagator_0_smin19_smax22");
  int needed_g_p_34[] = {  24,   26}; //   2
  psi_needed_g_p[no_ps][34] = get_vector_from_array_int(needed_g_p_34, 2);
  psi_container_IS_name.push_back("propagator_0_smin0_smax23");
  int needed_g_p_35[] = {  25,   27}; //   2
  psi_needed_g_p[no_ps][35] = get_vector_from_array_int(needed_g_p_35, 2);
  psi_container_IS_name.push_back("propagator_23_smin0_smax23");
  int needed_g_p_36[] = {  26,   27}; //   2
  psi_needed_g_p[no_ps][36] = get_vector_from_array_int(needed_g_p_36, 2);
  psi_container_IS_name.push_back("propagator_0_smin20_smax22");
  int needed_g_p_37[] = {  28,   29}; //   2
  psi_needed_g_p[no_ps][37] = get_vector_from_array_int(needed_g_p_37, 2);
  psi_container_IS_name.push_back("propagator_0_smin19_smax24");
  int needed_g_p_38[] = {  30,   31}; //   2
  psi_needed_g_p[no_ps][38] = get_vector_from_array_int(needed_g_p_38, 2);
  psi_container_IS_name.push_back("propagator_0_smin11_smax25");
  int needed_g_p_39[] = {  30,   31}; //   2
  psi_needed_g_p[no_ps][39] = get_vector_from_array_int(needed_g_p_39, 2);
  psi_container_IS_name.push_back("propagator_0_smin20_smax24");

  psi_container_IS_startvalue[no_ps][1] = psi_container_IS_name.size();
  psi_g_f[no_ps].resize(0);
  psi_needed_g_f[no_ps].resize(0);

  psi_container_IS_startvalue[no_ps][2] = psi_container_IS_name.size();
  psi_g_t[no_ps].resize(2);
  psi_needed_g_t[no_ps].resize(2);
  int needed_g_t_0[] = {  24,   25,   26,   27}; //   4
  psi_needed_g_t[no_ps][0] = get_vector_from_array_int(needed_g_t_0, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_2__12_240");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_2__12_240");
  int needed_g_t_1[] = {  28,   29,   30,   31}; //   4
  psi_needed_g_t[no_ps][1] = get_vector_from_array_int(needed_g_t_1, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_1__12_240");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_1__12_240");

  psi_container_IS_startvalue[no_ps][3] = psi_container_IS_name.size();
  psi_g_d[no_ps].resize(25);
  psi_needed_g_d[no_ps].resize(25);
  int needed_g_d_0[] = {   0,    2,    3,    6,    8,    9,   14,   15,   18,   19}; //  10
  psi_needed_g_d[no_ps][0] = get_vector_from_array_int(needed_g_d_0, 10);
  psi_container_IS_name.push_back("costheta_of_decay_252__64_188");
  psi_container_IS_name.push_back("phi_of_decay_252__64_188");
  int needed_g_d_1[] = {   0,    2,    3,    6,    8,    9}; //   6
  psi_needed_g_d[no_ps][1] = get_vector_from_array_int(needed_g_d_1, 6);
  psi_container_IS_name.push_back("costheta_of_decay_188__128_60");
  psi_container_IS_name.push_back("phi_of_decay_188__128_60");
  int needed_g_d_2[] = {   0,    1}; //   2
  psi_needed_g_d[no_ps][2] = get_vector_from_array_int(needed_g_d_2, 2);
  psi_container_IS_name.push_back("costheta_of_decay_60__16_44");
  psi_container_IS_name.push_back("phi_of_decay_60__16_44");
  int needed_g_d_3[] = {   0,    1}; //   2
  psi_needed_g_d[no_ps][3] = get_vector_from_array_int(needed_g_d_3, 2);
  psi_container_IS_name.push_back("costheta_of_decay_44__32_12");
  psi_container_IS_name.push_back("phi_of_decay_44__32_12");
  int needed_g_d_4[] = {   0,    1,    2,    3,    4,    5,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31}; //  30
  psi_needed_g_d[no_ps][4] = get_vector_from_array_int(needed_g_d_4, 30);
  psi_container_IS_name.push_back("costheta_of_decay_12__4_8");
  psi_container_IS_name.push_back("phi_of_decay_12__4_8");
  int needed_g_d_5[] = {   1,    4,    5,    7,   10,   11,   12,   13,   16,   17}; //  10
  psi_needed_g_d[no_ps][5] = get_vector_from_array_int(needed_g_d_5, 10);
  psi_container_IS_name.push_back("costheta_of_decay_252__128_124");
  psi_container_IS_name.push_back("phi_of_decay_252__128_124");
  int needed_g_d_6[] = {   1,    4,    5,    7,   10,   11}; //   6
  psi_needed_g_d[no_ps][6] = get_vector_from_array_int(needed_g_d_6, 6);
  psi_container_IS_name.push_back("costheta_of_decay_124__64_60");
  psi_container_IS_name.push_back("phi_of_decay_124__64_60");
  int needed_g_d_7[] = {   2,    3,    4,    5}; //   4
  psi_needed_g_d[no_ps][7] = get_vector_from_array_int(needed_g_d_7, 4);
  psi_container_IS_name.push_back("costheta_of_decay_60__32_28");
  psi_container_IS_name.push_back("phi_of_decay_60__32_28");
  int needed_g_d_8[] = {   2,    3,    4,    5}; //   4
  psi_needed_g_d[no_ps][8] = get_vector_from_array_int(needed_g_d_8, 4);
  psi_container_IS_name.push_back("costheta_of_decay_28__16_12");
  psi_container_IS_name.push_back("phi_of_decay_28__16_12");
  int needed_g_d_9[] = {   6,    7}; //   2
  psi_needed_g_d[no_ps][9] = get_vector_from_array_int(needed_g_d_9, 2);
  psi_container_IS_name.push_back("costheta_of_decay_60__8_52");
  psi_container_IS_name.push_back("phi_of_decay_60__8_52");
  int needed_g_d_10[] = {   6,    7}; //   2
  psi_needed_g_d[no_ps][10] = get_vector_from_array_int(needed_g_d_10, 2);
  psi_container_IS_name.push_back("costheta_of_decay_52__4_48");
  psi_container_IS_name.push_back("phi_of_decay_52__4_48");
  int needed_g_d_11[] = {   6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31}; //  26
  psi_needed_g_d[no_ps][11] = get_vector_from_array_int(needed_g_d_11, 26);
  psi_container_IS_name.push_back("costheta_of_decay_48__16_32");
  psi_container_IS_name.push_back("phi_of_decay_48__16_32");
  int needed_g_d_12[] = {   8,    9,   10,   11}; //   4
  psi_needed_g_d[no_ps][12] = get_vector_from_array_int(needed_g_d_12, 4);
  psi_container_IS_name.push_back("costheta_of_decay_60__12_48");
  psi_container_IS_name.push_back("phi_of_decay_60__12_48");
  int needed_g_d_13[] = {  12,   13}; //   2
  psi_needed_g_d[no_ps][13] = get_vector_from_array_int(needed_g_d_13, 2);
  psi_container_IS_name.push_back("costheta_of_decay_124__12_112");
  psi_container_IS_name.push_back("phi_of_decay_124__12_112");
  int needed_g_d_14[] = {  12,   13,   22,   23,   26,   27,   30,   31}; //   8
  psi_needed_g_d[no_ps][14] = get_vector_from_array_int(needed_g_d_14, 8);
  psi_container_IS_name.push_back("costheta_of_decay_112__64_48");
  psi_container_IS_name.push_back("phi_of_decay_112__64_48");
  int needed_g_d_15[] = {  14,   15}; //   2
  psi_needed_g_d[no_ps][15] = get_vector_from_array_int(needed_g_d_15, 2);
  psi_container_IS_name.push_back("costheta_of_decay_188__12_176");
  psi_container_IS_name.push_back("phi_of_decay_188__12_176");
  int needed_g_d_16[] = {  14,   15,   20,   21,   24,   25,   28,   29}; //   8
  psi_needed_g_d[no_ps][16] = get_vector_from_array_int(needed_g_d_16, 8);
  psi_container_IS_name.push_back("costheta_of_decay_176__128_48");
  psi_container_IS_name.push_back("phi_of_decay_176__128_48");
  int needed_g_d_17[] = {  16,   17}; //   2
  psi_needed_g_d[no_ps][17] = get_vector_from_array_int(needed_g_d_17, 2);
  psi_container_IS_name.push_back("costheta_of_decay_124__48_76");
  psi_container_IS_name.push_back("phi_of_decay_124__48_76");
  int needed_g_d_18[] = {  16,   17,   20,   21}; //   4
  psi_needed_g_d[no_ps][18] = get_vector_from_array_int(needed_g_d_18, 4);
  psi_container_IS_name.push_back("costheta_of_decay_76__64_12");
  psi_container_IS_name.push_back("phi_of_decay_76__64_12");
  int needed_g_d_19[] = {  18,   19}; //   2
  psi_needed_g_d[no_ps][19] = get_vector_from_array_int(needed_g_d_19, 2);
  psi_container_IS_name.push_back("costheta_of_decay_188__48_140");
  psi_container_IS_name.push_back("phi_of_decay_188__48_140");
  int needed_g_d_20[] = {  18,   19,   22,   23}; //   4
  psi_needed_g_d[no_ps][20] = get_vector_from_array_int(needed_g_d_20, 4);
  psi_container_IS_name.push_back("costheta_of_decay_140__128_12");
  psi_container_IS_name.push_back("phi_of_decay_140__128_12");
  int needed_g_d_21[] = {  20,   21}; //   2
  psi_needed_g_d[no_ps][21] = get_vector_from_array_int(needed_g_d_21, 2);
  psi_container_IS_name.push_back("costheta_of_decay_252__76_176");
  psi_container_IS_name.push_back("phi_of_decay_252__76_176");
  int needed_g_d_22[] = {  22,   23}; //   2
  psi_needed_g_d[no_ps][22] = get_vector_from_array_int(needed_g_d_22, 2);
  psi_container_IS_name.push_back("costheta_of_decay_252__112_140");
  psi_container_IS_name.push_back("phi_of_decay_252__112_140");
  int needed_g_d_23[] = {  24,   25,   28,   29}; //   4
  psi_needed_g_d[no_ps][23] = get_vector_from_array_int(needed_g_d_23, 4);
  psi_container_IS_name.push_back("costheta_of_decay_240__64_176");
  psi_container_IS_name.push_back("phi_of_decay_240__64_176");
  int needed_g_d_24[] = {  26,   27,   30,   31}; //   4
  psi_needed_g_d[no_ps][24] = get_vector_from_array_int(needed_g_d_24, 4);
  psi_container_IS_name.push_back("costheta_of_decay_240__128_112");
  psi_container_IS_name.push_back("phi_of_decay_240__128_112");

  psi_c_p[no_ps].resize(32);
  psi_c_f[no_ps].resize(32);
  psi_c_t[no_ps].resize(32);
  psi_c_d[no_ps].resize(32);

  int c_p_0[] = {  0,   1,   2,   3}; //   4
  psi_c_p[no_ps][0] = get_vector_from_array_int(c_p_0, 4);
  int c_f_0[] = {}; //   0
  psi_c_f[no_ps][0] = get_vector_from_array_int(c_f_0, 0);
  int c_t_0[] = {}; //   0
  psi_c_t[no_ps][0] = get_vector_from_array_int(c_t_0, 0);
  int c_d_0[] = {  0,   1,   2,   3,   4}; //   5
  psi_c_d[no_ps][0] = get_vector_from_array_int(c_d_0, 5);

  int c_p_1[] = {  0,   1,   2,   4}; //   4
  psi_c_p[no_ps][1] = get_vector_from_array_int(c_p_1, 4);
  int c_f_1[] = {}; //   0
  psi_c_f[no_ps][1] = get_vector_from_array_int(c_f_1, 0);
  int c_t_1[] = {}; //   0
  psi_c_t[no_ps][1] = get_vector_from_array_int(c_t_1, 0);
  int c_d_1[] = {  5,   6,   2,   3,   4}; //   5
  psi_c_d[no_ps][1] = get_vector_from_array_int(c_d_1, 5);

  int c_p_2[] = {  5,   6,   7,   3}; //   4
  psi_c_p[no_ps][2] = get_vector_from_array_int(c_p_2, 4);
  int c_f_2[] = {}; //   0
  psi_c_f[no_ps][2] = get_vector_from_array_int(c_f_2, 0);
  int c_t_2[] = {}; //   0
  psi_c_t[no_ps][2] = get_vector_from_array_int(c_t_2, 0);
  int c_d_2[] = {  0,   1,   7,   8,   4}; //   5
  psi_c_d[no_ps][2] = get_vector_from_array_int(c_d_2, 5);

  int c_p_3[] = {  0,   6,   7,   3}; //   4
  psi_c_p[no_ps][3] = get_vector_from_array_int(c_p_3, 4);
  int c_f_3[] = {}; //   0
  psi_c_f[no_ps][3] = get_vector_from_array_int(c_f_3, 0);
  int c_t_3[] = {}; //   0
  psi_c_t[no_ps][3] = get_vector_from_array_int(c_t_3, 0);
  int c_d_3[] = {  0,   1,   7,   8,   4}; //   5
  psi_c_d[no_ps][3] = get_vector_from_array_int(c_d_3, 5);

  int c_p_4[] = {  5,   6,   7,   4}; //   4
  psi_c_p[no_ps][4] = get_vector_from_array_int(c_p_4, 4);
  int c_f_4[] = {}; //   0
  psi_c_f[no_ps][4] = get_vector_from_array_int(c_f_4, 0);
  int c_t_4[] = {}; //   0
  psi_c_t[no_ps][4] = get_vector_from_array_int(c_t_4, 0);
  int c_d_4[] = {  5,   6,   7,   8,   4}; //   5
  psi_c_d[no_ps][4] = get_vector_from_array_int(c_d_4, 5);

  int c_p_5[] = {  0,   6,   7,   4}; //   4
  psi_c_p[no_ps][5] = get_vector_from_array_int(c_p_5, 4);
  int c_f_5[] = {}; //   0
  psi_c_f[no_ps][5] = get_vector_from_array_int(c_f_5, 0);
  int c_t_5[] = {}; //   0
  psi_c_t[no_ps][5] = get_vector_from_array_int(c_t_5, 0);
  int c_d_5[] = {  5,   6,   7,   8,   4}; //   5
  psi_c_d[no_ps][5] = get_vector_from_array_int(c_d_5, 5);

  int c_p_6[] = {  8,   9,  10,   3}; //   4
  psi_c_p[no_ps][6] = get_vector_from_array_int(c_p_6, 4);
  int c_f_6[] = {}; //   0
  psi_c_f[no_ps][6] = get_vector_from_array_int(c_f_6, 0);
  int c_t_6[] = {}; //   0
  psi_c_t[no_ps][6] = get_vector_from_array_int(c_t_6, 0);
  int c_d_6[] = {  0,   1,   9,  10,  11}; //   5
  psi_c_d[no_ps][6] = get_vector_from_array_int(c_d_6, 5);

  int c_p_7[] = {  8,   9,  10,   4}; //   4
  psi_c_p[no_ps][7] = get_vector_from_array_int(c_p_7, 4);
  int c_f_7[] = {}; //   0
  psi_c_f[no_ps][7] = get_vector_from_array_int(c_f_7, 0);
  int c_t_7[] = {}; //   0
  psi_c_t[no_ps][7] = get_vector_from_array_int(c_t_7, 0);
  int c_d_7[] = {  5,   6,   9,  10,  11}; //   5
  psi_c_d[no_ps][7] = get_vector_from_array_int(c_d_7, 5);

  int c_p_8[] = {  8,  11,  12,   3}; //   4
  psi_c_p[no_ps][8] = get_vector_from_array_int(c_p_8, 4);
  int c_f_8[] = {}; //   0
  psi_c_f[no_ps][8] = get_vector_from_array_int(c_f_8, 0);
  int c_t_8[] = {}; //   0
  psi_c_t[no_ps][8] = get_vector_from_array_int(c_t_8, 0);
  int c_d_8[] = {  0,   1,  12,   4,  11}; //   5
  psi_c_d[no_ps][8] = get_vector_from_array_int(c_d_8, 5);

  int c_p_9[] = {  8,  13,  12,   3}; //   4
  psi_c_p[no_ps][9] = get_vector_from_array_int(c_p_9, 4);
  int c_f_9[] = {}; //   0
  psi_c_f[no_ps][9] = get_vector_from_array_int(c_f_9, 0);
  int c_t_9[] = {}; //   0
  psi_c_t[no_ps][9] = get_vector_from_array_int(c_t_9, 0);
  int c_d_9[] = {  0,   1,  12,   4,  11}; //   5
  psi_c_d[no_ps][9] = get_vector_from_array_int(c_d_9, 5);

  int c_p_10[] = {  8,  11,  12,   4}; //   4
  psi_c_p[no_ps][10] = get_vector_from_array_int(c_p_10, 4);
  int c_f_10[] = {}; //   0
  psi_c_f[no_ps][10] = get_vector_from_array_int(c_f_10, 0);
  int c_t_10[] = {}; //   0
  psi_c_t[no_ps][10] = get_vector_from_array_int(c_t_10, 0);
  int c_d_10[] = {  5,   6,  12,   4,  11}; //   5
  psi_c_d[no_ps][10] = get_vector_from_array_int(c_d_10, 5);

  int c_p_11[] = {  8,  13,  12,   4}; //   4
  psi_c_p[no_ps][11] = get_vector_from_array_int(c_p_11, 4);
  int c_f_11[] = {}; //   0
  psi_c_f[no_ps][11] = get_vector_from_array_int(c_f_11, 0);
  int c_t_11[] = {}; //   0
  psi_c_t[no_ps][11] = get_vector_from_array_int(c_t_11, 0);
  int c_d_11[] = {  5,   6,  12,   4,  11}; //   5
  psi_c_d[no_ps][11] = get_vector_from_array_int(c_d_11, 5);

  int c_p_12[] = {  8,  14,  15,  16}; //   4
  psi_c_p[no_ps][12] = get_vector_from_array_int(c_p_12, 4);
  int c_f_12[] = {}; //   0
  psi_c_f[no_ps][12] = get_vector_from_array_int(c_f_12, 0);
  int c_t_12[] = {}; //   0
  psi_c_t[no_ps][12] = get_vector_from_array_int(c_t_12, 0);
  int c_d_12[] = {  5,  13,   4,  14,  11}; //   5
  psi_c_d[no_ps][12] = get_vector_from_array_int(c_d_12, 5);

  int c_p_13[] = {  8,  14,  17,  16}; //   4
  psi_c_p[no_ps][13] = get_vector_from_array_int(c_p_13, 4);
  int c_f_13[] = {}; //   0
  psi_c_f[no_ps][13] = get_vector_from_array_int(c_f_13, 0);
  int c_t_13[] = {}; //   0
  psi_c_t[no_ps][13] = get_vector_from_array_int(c_t_13, 0);
  int c_d_13[] = {  5,  13,   4,  14,  11}; //   5
  psi_c_d[no_ps][13] = get_vector_from_array_int(c_d_13, 5);

  int c_p_14[] = {  8,  18,  19,  20}; //   4
  psi_c_p[no_ps][14] = get_vector_from_array_int(c_p_14, 4);
  int c_f_14[] = {}; //   0
  psi_c_f[no_ps][14] = get_vector_from_array_int(c_f_14, 0);
  int c_t_14[] = {}; //   0
  psi_c_t[no_ps][14] = get_vector_from_array_int(c_t_14, 0);
  int c_d_14[] = {  0,  15,   4,  16,  11}; //   5
  psi_c_d[no_ps][14] = get_vector_from_array_int(c_d_14, 5);

  int c_p_15[] = {  8,  18,  21,  20}; //   4
  psi_c_p[no_ps][15] = get_vector_from_array_int(c_p_15, 4);
  int c_f_15[] = {}; //   0
  psi_c_f[no_ps][15] = get_vector_from_array_int(c_f_15, 0);
  int c_t_15[] = {}; //   0
  psi_c_t[no_ps][15] = get_vector_from_array_int(c_t_15, 0);
  int c_d_15[] = {  0,  15,   4,  16,  11}; //   5
  psi_c_d[no_ps][15] = get_vector_from_array_int(c_d_15, 5);

  int c_p_16[] = {  5,  22,  23,  24}; //   4
  psi_c_p[no_ps][16] = get_vector_from_array_int(c_p_16, 4);
  int c_f_16[] = {}; //   0
  psi_c_f[no_ps][16] = get_vector_from_array_int(c_f_16, 0);
  int c_t_16[] = {}; //   0
  psi_c_t[no_ps][16] = get_vector_from_array_int(c_t_16, 0);
  int c_d_16[] = {  5,  17,  11,  18,   4}; //   5
  psi_c_d[no_ps][16] = get_vector_from_array_int(c_d_16, 5);

  int c_p_17[] = {  0,  22,  23,  24}; //   4
  psi_c_p[no_ps][17] = get_vector_from_array_int(c_p_17, 4);
  int c_f_17[] = {}; //   0
  psi_c_f[no_ps][17] = get_vector_from_array_int(c_f_17, 0);
  int c_t_17[] = {}; //   0
  psi_c_t[no_ps][17] = get_vector_from_array_int(c_t_17, 0);
  int c_d_17[] = {  5,  17,  11,  18,   4}; //   5
  psi_c_d[no_ps][17] = get_vector_from_array_int(c_d_17, 5);

  int c_p_18[] = {  5,  25,  26,  27}; //   4
  psi_c_p[no_ps][18] = get_vector_from_array_int(c_p_18, 4);
  int c_f_18[] = {}; //   0
  psi_c_f[no_ps][18] = get_vector_from_array_int(c_f_18, 0);
  int c_t_18[] = {}; //   0
  psi_c_t[no_ps][18] = get_vector_from_array_int(c_t_18, 0);
  int c_d_18[] = {  0,  19,  11,  20,   4}; //   5
  psi_c_d[no_ps][18] = get_vector_from_array_int(c_d_18, 5);

  int c_p_19[] = {  0,  25,  26,  27}; //   4
  psi_c_p[no_ps][19] = get_vector_from_array_int(c_p_19, 4);
  int c_f_19[] = {}; //   0
  psi_c_f[no_ps][19] = get_vector_from_array_int(c_f_19, 0);
  int c_t_19[] = {}; //   0
  psi_c_t[no_ps][19] = get_vector_from_array_int(c_t_19, 0);
  int c_d_19[] = {  0,  19,  11,  20,   4}; //   5
  psi_c_d[no_ps][19] = get_vector_from_array_int(c_d_19, 5);

  int c_p_20[] = {  8,  11,  28,  29}; //   4
  psi_c_p[no_ps][20] = get_vector_from_array_int(c_p_20, 4);
  int c_f_20[] = {}; //   0
  psi_c_f[no_ps][20] = get_vector_from_array_int(c_f_20, 0);
  int c_t_20[] = {}; //   0
  psi_c_t[no_ps][20] = get_vector_from_array_int(c_t_20, 0);
  int c_d_20[] = { 21,  18,  16,   4,  11}; //   5
  psi_c_d[no_ps][20] = get_vector_from_array_int(c_d_20, 5);

  int c_p_21[] = {  8,  13,  28,  29}; //   4
  psi_c_p[no_ps][21] = get_vector_from_array_int(c_p_21, 4);
  int c_f_21[] = {}; //   0
  psi_c_f[no_ps][21] = get_vector_from_array_int(c_f_21, 0);
  int c_t_21[] = {}; //   0
  psi_c_t[no_ps][21] = get_vector_from_array_int(c_t_21, 0);
  int c_d_21[] = { 21,  18,  16,   4,  11}; //   5
  psi_c_d[no_ps][21] = get_vector_from_array_int(c_d_21, 5);

  int c_p_22[] = {  5,  30,  31,  32}; //   4
  psi_c_p[no_ps][22] = get_vector_from_array_int(c_p_22, 4);
  int c_f_22[] = {}; //   0
  psi_c_f[no_ps][22] = get_vector_from_array_int(c_f_22, 0);
  int c_t_22[] = {}; //   0
  psi_c_t[no_ps][22] = get_vector_from_array_int(c_t_22, 0);
  int c_d_22[] = { 22,  14,  20,  11,   4}; //   5
  psi_c_d[no_ps][22] = get_vector_from_array_int(c_d_22, 5);

  int c_p_23[] = {  0,  30,  31,  32}; //   4
  psi_c_p[no_ps][23] = get_vector_from_array_int(c_p_23, 4);
  int c_f_23[] = {}; //   0
  psi_c_f[no_ps][23] = get_vector_from_array_int(c_f_23, 0);
  int c_t_23[] = {}; //   0
  psi_c_t[no_ps][23] = get_vector_from_array_int(c_t_23, 0);
  int c_d_23[] = { 22,  14,  20,  11,   4}; //   5
  psi_c_d[no_ps][23] = get_vector_from_array_int(c_d_23, 5);

  int c_p_24[] = {  8,  18,  33,  34}; //   4
  psi_c_p[no_ps][24] = get_vector_from_array_int(c_p_24, 4);
  int c_f_24[] = {}; //   0
  psi_c_f[no_ps][24] = get_vector_from_array_int(c_f_24, 0);
  int c_t_24[] = {  0}; //   1
  psi_c_t[no_ps][24] = get_vector_from_array_int(c_t_24, 1);
  int c_d_24[] = {  4,  23,  16,  11}; //   4
  psi_c_d[no_ps][24] = get_vector_from_array_int(c_d_24, 4);

  int c_p_25[] = {  8,  18,  33,  35}; //   4
  psi_c_p[no_ps][25] = get_vector_from_array_int(c_p_25, 4);
  int c_f_25[] = {}; //   0
  psi_c_f[no_ps][25] = get_vector_from_array_int(c_f_25, 0);
  int c_t_25[] = {  0}; //   1
  psi_c_t[no_ps][25] = get_vector_from_array_int(c_t_25, 1);
  int c_d_25[] = {  4,  23,  16,  11}; //   4
  psi_c_d[no_ps][25] = get_vector_from_array_int(c_d_25, 4);

  int c_p_26[] = {  8,  14,  36,  34}; //   4
  psi_c_p[no_ps][26] = get_vector_from_array_int(c_p_26, 4);
  int c_f_26[] = {}; //   0
  psi_c_f[no_ps][26] = get_vector_from_array_int(c_f_26, 0);
  int c_t_26[] = {  0}; //   1
  psi_c_t[no_ps][26] = get_vector_from_array_int(c_t_26, 1);
  int c_d_26[] = {  4,  24,  14,  11}; //   4
  psi_c_d[no_ps][26] = get_vector_from_array_int(c_d_26, 4);

  int c_p_27[] = {  8,  14,  36,  35}; //   4
  psi_c_p[no_ps][27] = get_vector_from_array_int(c_p_27, 4);
  int c_f_27[] = {}; //   0
  psi_c_f[no_ps][27] = get_vector_from_array_int(c_f_27, 0);
  int c_t_27[] = {  0}; //   1
  psi_c_t[no_ps][27] = get_vector_from_array_int(c_t_27, 1);
  int c_d_27[] = {  4,  24,  14,  11}; //   4
  psi_c_d[no_ps][27] = get_vector_from_array_int(c_d_27, 4);

  int c_p_28[] = {  5,  30,  28,  37}; //   4
  psi_c_p[no_ps][28] = get_vector_from_array_int(c_p_28, 4);
  int c_f_28[] = {}; //   0
  psi_c_f[no_ps][28] = get_vector_from_array_int(c_f_28, 0);
  int c_t_28[] = {  1}; //   1
  psi_c_t[no_ps][28] = get_vector_from_array_int(c_t_28, 1);
  int c_d_28[] = { 23,  16,  11,   4}; //   4
  psi_c_d[no_ps][28] = get_vector_from_array_int(c_d_28, 4);

  int c_p_29[] = {  0,  30,  28,  37}; //   4
  psi_c_p[no_ps][29] = get_vector_from_array_int(c_p_29, 4);
  int c_f_29[] = {}; //   0
  psi_c_f[no_ps][29] = get_vector_from_array_int(c_f_29, 0);
  int c_t_29[] = {  1}; //   1
  psi_c_t[no_ps][29] = get_vector_from_array_int(c_t_29, 1);
  int c_d_29[] = { 23,  16,  11,   4}; //   4
  psi_c_d[no_ps][29] = get_vector_from_array_int(c_d_29, 4);

  int c_p_30[] = {  5,  30,  38,  39}; //   4
  psi_c_p[no_ps][30] = get_vector_from_array_int(c_p_30, 4);
  int c_f_30[] = {}; //   0
  psi_c_f[no_ps][30] = get_vector_from_array_int(c_f_30, 0);
  int c_t_30[] = {  1}; //   1
  psi_c_t[no_ps][30] = get_vector_from_array_int(c_t_30, 1);
  int c_d_30[] = { 24,  14,  11,   4}; //   4
  psi_c_d[no_ps][30] = get_vector_from_array_int(c_d_30, 4);

  int c_p_31[] = {  0,  30,  38,  39}; //   4
  psi_c_p[no_ps][31] = get_vector_from_array_int(c_p_31, 4);
  int c_f_31[] = {}; //   0
  psi_c_f[no_ps][31] = get_vector_from_array_int(c_f_31, 0);
  int c_t_31[] = {  1}; //   1
  psi_c_t[no_ps][31] = get_vector_from_array_int(c_t_31, 1);
  int c_d_31[] = { 24,  14,  11,   4}; //   4
  psi_c_d[no_ps][31] = get_vector_from_array_int(c_d_31, 4);

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
