#include "../include/classes.cxx"
#include "../include/definitions.phasespace.set.cxx"
#include "../ppeexmxnm04/header/ppeexmxnm04.phasespace.h"
void ppeexmxnm04_ax_psp_140_gu_emepmupvmd(int no_ps, phasespace_set & psi){
  static Logger logger("ppeexmxnm04_ax_psp_140_gu_emepmupvmd");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;
  psi_v_smin[no_ps].resize(11);
  psi_needed_v_smin[no_ps].resize(11);
  int needed_v_smin_0[] = {   0,    1,    2,    4,    5,    6,    7,    8,    9,   10,   11,   12,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23}; //  22
  psi_needed_v_smin[no_ps][  0] = get_vector_from_array_int(needed_v_smin_0, 22);
  int needed_v_smin_1[] = {   0,   10}; //   2
  psi_needed_v_smin[no_ps][  1] = get_vector_from_array_int(needed_v_smin_1, 2);
  int needed_v_smin_2[] = {   0,   10}; //   2
  psi_needed_v_smin[no_ps][  2] = get_vector_from_array_int(needed_v_smin_2, 2);
  int needed_v_smin_3[] = {   1,    2,   11,   12}; //   4
  psi_needed_v_smin[no_ps][  3] = get_vector_from_array_int(needed_v_smin_3, 4);
  int needed_v_smin_4[] = {   1,    2,   11,   12}; //   4
  psi_needed_v_smin[no_ps][  4] = get_vector_from_array_int(needed_v_smin_4, 4);
  int needed_v_smin_5[] = {   3,    4,    5,    6,    7,    8,    9,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23}; //  18
  psi_needed_v_smin[no_ps][  5] = get_vector_from_array_int(needed_v_smin_5, 18);
  int needed_v_smin_6[] = {   3,   13}; //   2
  psi_needed_v_smin[no_ps][  6] = get_vector_from_array_int(needed_v_smin_6, 2);
  int needed_v_smin_7[] = {   3,   13}; //   2
  psi_needed_v_smin[no_ps][  7] = get_vector_from_array_int(needed_v_smin_7, 2);
  int needed_v_smin_8[] = {   4,    5,   14,   15,   20,   21,   22,   23}; //   8
  psi_needed_v_smin[no_ps][  8] = get_vector_from_array_int(needed_v_smin_8, 8);
  int needed_v_smin_9[] = {   6,    7,   18,   19}; //   4
  psi_needed_v_smin[no_ps][  9] = get_vector_from_array_int(needed_v_smin_9, 4);
  int needed_v_smin_10[] = {   8,    9,   16,   17}; //   4
  psi_needed_v_smin[no_ps][ 10] = get_vector_from_array_int(needed_v_smin_10, 4);

  psi_v_smax[no_ps].resize(14);
  psi_needed_v_smax[no_ps].resize(14);
  int needed_v_smax_0[] = {   0,    1,    2,    8,    9,   10,   11,   12,   18,   19,   22,   23}; //  12
  psi_needed_v_smax[no_ps][  0] = get_vector_from_array_int(needed_v_smax_0, 12);
  int needed_v_smax_1[] = {   0,   10}; //   2
  psi_needed_v_smax[no_ps][  1] = get_vector_from_array_int(needed_v_smax_1, 2);
  int needed_v_smax_2[] = {   0,    1,    2,    3,    4,    5,   10,   11,   12,   13,   14,   15,   20,   21,   22,   23}; //  16
  psi_needed_v_smax[no_ps][  2] = get_vector_from_array_int(needed_v_smax_2, 16);
  int needed_v_smax_3[] = {   1,    2,   11,   12}; //   4
  psi_needed_v_smax[no_ps][  3] = get_vector_from_array_int(needed_v_smax_3, 4);
  int needed_v_smax_4[] = {   3,    4,    5,    6,    7,   13,   14,   15,   16,   17,   20,   21}; //  12
  psi_needed_v_smax[no_ps][  4] = get_vector_from_array_int(needed_v_smax_4, 12);
  int needed_v_smax_5[] = {   3,   13}; //   2
  psi_needed_v_smax[no_ps][  5] = get_vector_from_array_int(needed_v_smax_5, 2);
  int needed_v_smax_6[] = {   4,    5,   14,   15,   16,   17,   20,   21}; //   8
  psi_needed_v_smax[no_ps][  6] = get_vector_from_array_int(needed_v_smax_6, 8);
  int needed_v_smax_7[] = {   6,    7}; //   2
  psi_needed_v_smax[no_ps][  7] = get_vector_from_array_int(needed_v_smax_7, 2);
  int needed_v_smax_8[] = {   6,    7}; //   2
  psi_needed_v_smax[no_ps][  8] = get_vector_from_array_int(needed_v_smax_8, 2);
  int needed_v_smax_9[] = {   8,    9}; //   2
  psi_needed_v_smax[no_ps][  9] = get_vector_from_array_int(needed_v_smax_9, 2);
  int needed_v_smax_10[] = {   8,    9}; //   2
  psi_needed_v_smax[no_ps][ 10] = get_vector_from_array_int(needed_v_smax_10, 2);
  int needed_v_smax_11[] = {  16,   17}; //   2
  psi_needed_v_smax[no_ps][ 11] = get_vector_from_array_int(needed_v_smax_11, 2);
  int needed_v_smax_12[] = {  18,   19,   22,   23}; //   4
  psi_needed_v_smax[no_ps][ 12] = get_vector_from_array_int(needed_v_smax_12, 4);
  int needed_v_smax_13[] = {  18,   19}; //   2
  psi_needed_v_smax[no_ps][ 13] = get_vector_from_array_int(needed_v_smax_13, 2);

  psi_container_IS_startvalue[no_ps][0] = psi_container_IS_name.size();
  psi_g_p[no_ps].resize(20);
  psi_needed_g_p[no_ps].resize(20);
  int needed_g_p_0[] = {   0,    2,    9,   10,   12,   19,   23}; //   7
  psi_needed_g_p[no_ps][0] = get_vector_from_array_int(needed_g_p_0, 7);
  psi_container_IS_name.push_back("propagator_23_smin0_smax0");
  int needed_g_p_1[] = {   0,   10}; //   2
  psi_needed_g_p[no_ps][1] = get_vector_from_array_int(needed_g_p_1, 2);
  psi_container_IS_name.push_back("propagator_0_smin1_smax1");
  int needed_g_p_2[] = {   0,   10}; //   2
  psi_needed_g_p[no_ps][2] = get_vector_from_array_int(needed_g_p_2, 2);
  psi_container_IS_name.push_back("propagator_24_smin2_smax2");
  int needed_g_p_3[] = {   1,    8,   11,   18,   22}; //   5
  psi_needed_g_p[no_ps][3] = get_vector_from_array_int(needed_g_p_3, 5);
  psi_container_IS_name.push_back("propagator_0_smin0_smax0");
  int needed_g_p_4[] = {   1,    2,   11,   12}; //   4
  psi_needed_g_p[no_ps][4] = get_vector_from_array_int(needed_g_p_4, 4);
  psi_container_IS_name.push_back("propagator_0_smin3_smax3");
  int needed_g_p_5[] = {   1,    2,   11,   12}; //   4
  psi_needed_g_p[no_ps][5] = get_vector_from_array_int(needed_g_p_5, 4);
  psi_container_IS_name.push_back("propagator_24_smin4_smax2");
  int needed_g_p_6[] = {   3,    4,    5,    6,    7,   13,   14,   15,   16,   17,   20,   21}; //  12
  psi_needed_g_p[no_ps][6] = get_vector_from_array_int(needed_g_p_6, 12);
  psi_container_IS_name.push_back("propagator_24_smin5_smax4");
  int needed_g_p_7[] = {   3,   13}; //   2
  psi_needed_g_p[no_ps][7] = get_vector_from_array_int(needed_g_p_7, 2);
  psi_container_IS_name.push_back("propagator_0_smin6_smax5");
  int needed_g_p_8[] = {   3,   13}; //   2
  psi_needed_g_p[no_ps][8] = get_vector_from_array_int(needed_g_p_8, 2);
  psi_container_IS_name.push_back("propagator_24_smin7_smax2");
  int needed_g_p_9[] = {   4,   14,   16,   20}; //   4
  psi_needed_g_p[no_ps][9] = get_vector_from_array_int(needed_g_p_9, 4);
  psi_container_IS_name.push_back("propagator_0_smin0_smax6");
  int needed_g_p_10[] = {   4,    5,   14,   15}; //   4
  psi_needed_g_p[no_ps][10] = get_vector_from_array_int(needed_g_p_10, 4);
  psi_container_IS_name.push_back("propagator_24_smin8_smax2");
  int needed_g_p_11[] = {   5,   15,   17,   21}; //   4
  psi_needed_g_p[no_ps][11] = get_vector_from_array_int(needed_g_p_11, 4);
  psi_container_IS_name.push_back("propagator_23_smin0_smax6");
  int needed_g_p_12[] = {   6,    7}; //   2
  psi_needed_g_p[no_ps][12] = get_vector_from_array_int(needed_g_p_12, 2);
  psi_container_IS_name.push_back("propagator_0_smin9_smax7");
  int needed_g_p_13[] = {   6}; //   1
  psi_needed_g_p[no_ps][13] = get_vector_from_array_int(needed_g_p_13, 1);
  psi_container_IS_name.push_back("propagator_0_smin0_smax8");
  int needed_g_p_14[] = {   7}; //   1
  psi_needed_g_p[no_ps][14] = get_vector_from_array_int(needed_g_p_14, 1);
  psi_container_IS_name.push_back("propagator_23_smin0_smax8");
  int needed_g_p_15[] = {   8,    9}; //   2
  psi_needed_g_p[no_ps][15] = get_vector_from_array_int(needed_g_p_15, 2);
  psi_container_IS_name.push_back("propagator_0_smin10_smax9");
  int needed_g_p_16[] = {   8,    9}; //   2
  psi_needed_g_p[no_ps][16] = get_vector_from_array_int(needed_g_p_16, 2);
  psi_container_IS_name.push_back("propagator_24_smin5_smax10");
  int needed_g_p_17[] = {  16,   17}; //   2
  psi_needed_g_p[no_ps][17] = get_vector_from_array_int(needed_g_p_17, 2);
  psi_container_IS_name.push_back("propagator_0_smin10_smax11");
  int needed_g_p_18[] = {  18,   19,   22,   23}; //   4
  psi_needed_g_p[no_ps][18] = get_vector_from_array_int(needed_g_p_18, 4);
  psi_container_IS_name.push_back("propagator_24_smin5_smax12");
  int needed_g_p_19[] = {  18,   19}; //   2
  psi_needed_g_p[no_ps][19] = get_vector_from_array_int(needed_g_p_19, 2);
  psi_container_IS_name.push_back("propagator_0_smin9_smax13");

  psi_container_IS_startvalue[no_ps][1] = psi_container_IS_name.size();
  psi_g_f[no_ps].resize(1);
  psi_needed_g_f[no_ps].resize(1);
  int needed_g_f_0[] = {  20,   21,   22,   23}; //   4
  psi_needed_g_f[no_ps][0] = get_vector_from_array_int(needed_g_f_0, 4);
  psi_container_IS_name.push_back("timelikeinvariant_smin8_smax2");

  psi_container_IS_startvalue[no_ps][2] = psi_container_IS_name.size();
  psi_g_t[no_ps].resize(5);
  psi_needed_g_t[no_ps].resize(5);
  int needed_g_t_0[] = {  10,   11,   12,   13,   14,   15,   20,   21,   22,   23}; //  10
  psi_needed_g_t[no_ps][0] = get_vector_from_array_int(needed_g_t_0, 10);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_2__64_60");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_2__64_60");
  int needed_g_t_1[] = {  16,   17}; //   2
  psi_needed_g_t[no_ps][1] = get_vector_from_array_int(needed_g_t_1, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_1__48_76");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_1__48_76");
  int needed_g_t_2[] = {  18,   19}; //   2
  psi_needed_g_t[no_ps][2] = get_vector_from_array_int(needed_g_t_2, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_1__12_112");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_1__12_112");
  int needed_g_t_3[] = {  20,   21}; //   2
  psi_needed_g_t[no_ps][3] = get_vector_from_array_int(needed_g_t_3, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_65__48_12");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_65__48_12");
  int needed_g_t_4[] = {  22,   23}; //   2
  psi_needed_g_t[no_ps][4] = get_vector_from_array_int(needed_g_t_4, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_65__12_48");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_65__12_48");

  psi_container_IS_startvalue[no_ps][3] = psi_container_IS_name.size();
  psi_g_d[no_ps].resize(14);
  psi_needed_g_d[no_ps].resize(14);
  int needed_g_d_0[] = {   0,    1,    2,    3,    4,    5}; //   6
  psi_needed_g_d[no_ps][0] = get_vector_from_array_int(needed_g_d_0, 6);
  psi_container_IS_name.push_back("costheta_of_decay_124__64_60");
  psi_container_IS_name.push_back("phi_of_decay_124__64_60");
  int needed_g_d_1[] = {   0,   10}; //   2
  psi_needed_g_d[no_ps][1] = get_vector_from_array_int(needed_g_d_1, 2);
  psi_container_IS_name.push_back("costheta_of_decay_60__16_44");
  psi_container_IS_name.push_back("phi_of_decay_60__16_44");
  int needed_g_d_2[] = {   0,   10}; //   2
  psi_needed_g_d[no_ps][2] = get_vector_from_array_int(needed_g_d_2, 2);
  psi_container_IS_name.push_back("costheta_of_decay_44__32_12");
  psi_container_IS_name.push_back("phi_of_decay_44__32_12");
  int needed_g_d_3[] = {   0,    1,    2,    4,    5,    6,    7,    8,    9,   10,   11,   12,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23}; //  22
  psi_needed_g_d[no_ps][3] = get_vector_from_array_int(needed_g_d_3, 22);
  psi_container_IS_name.push_back("costheta_of_decay_12__4_8");
  psi_container_IS_name.push_back("phi_of_decay_12__4_8");
  int needed_g_d_4[] = {   1,    2,   11,   12}; //   4
  psi_needed_g_d[no_ps][4] = get_vector_from_array_int(needed_g_d_4, 4);
  psi_container_IS_name.push_back("costheta_of_decay_60__32_28");
  psi_container_IS_name.push_back("phi_of_decay_60__32_28");
  int needed_g_d_5[] = {   1,    2,   11,   12}; //   4
  psi_needed_g_d[no_ps][5] = get_vector_from_array_int(needed_g_d_5, 4);
  psi_container_IS_name.push_back("costheta_of_decay_28__16_12");
  psi_container_IS_name.push_back("phi_of_decay_28__16_12");
  int needed_g_d_6[] = {   3,   13}; //   2
  psi_needed_g_d[no_ps][6] = get_vector_from_array_int(needed_g_d_6, 2);
  psi_container_IS_name.push_back("costheta_of_decay_60__8_52");
  psi_container_IS_name.push_back("phi_of_decay_60__8_52");
  int needed_g_d_7[] = {   3,   13}; //   2
  psi_needed_g_d[no_ps][7] = get_vector_from_array_int(needed_g_d_7, 2);
  psi_container_IS_name.push_back("costheta_of_decay_52__4_48");
  psi_container_IS_name.push_back("phi_of_decay_52__4_48");
  int needed_g_d_8[] = {   3,    4,    5,    6,    7,    8,    9,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23}; //  18
  psi_needed_g_d[no_ps][8] = get_vector_from_array_int(needed_g_d_8, 18);
  psi_container_IS_name.push_back("costheta_of_decay_48__16_32");
  psi_container_IS_name.push_back("phi_of_decay_48__16_32");
  int needed_g_d_9[] = {   4,    5,   14,   15}; //   4
  psi_needed_g_d[no_ps][9] = get_vector_from_array_int(needed_g_d_9, 4);
  psi_container_IS_name.push_back("costheta_of_decay_60__12_48");
  psi_container_IS_name.push_back("phi_of_decay_60__12_48");
  int needed_g_d_10[] = {   6,    7}; //   2
  psi_needed_g_d[no_ps][10] = get_vector_from_array_int(needed_g_d_10, 2);
  psi_container_IS_name.push_back("costheta_of_decay_124__12_112");
  psi_container_IS_name.push_back("phi_of_decay_124__12_112");
  int needed_g_d_11[] = {   6,    7,   18,   19}; //   4
  psi_needed_g_d[no_ps][11] = get_vector_from_array_int(needed_g_d_11, 4);
  psi_container_IS_name.push_back("costheta_of_decay_112__64_48");
  psi_container_IS_name.push_back("phi_of_decay_112__64_48");
  int needed_g_d_12[] = {   8,    9}; //   2
  psi_needed_g_d[no_ps][12] = get_vector_from_array_int(needed_g_d_12, 2);
  psi_container_IS_name.push_back("costheta_of_decay_124__48_76");
  psi_container_IS_name.push_back("phi_of_decay_124__48_76");
  int needed_g_d_13[] = {   8,    9,   16,   17}; //   4
  psi_needed_g_d[no_ps][13] = get_vector_from_array_int(needed_g_d_13, 4);
  psi_container_IS_name.push_back("costheta_of_decay_76__64_12");
  psi_container_IS_name.push_back("phi_of_decay_76__64_12");

  psi_c_p[no_ps].resize(24);
  psi_c_f[no_ps].resize(24);
  psi_c_t[no_ps].resize(24);
  psi_c_d[no_ps].resize(24);

  int c_p_0[] = {  0,   1,   2}; //   3
  psi_c_p[no_ps][0] = get_vector_from_array_int(c_p_0, 3);
  int c_f_0[] = {}; //   0
  psi_c_f[no_ps][0] = get_vector_from_array_int(c_f_0, 0);
  int c_t_0[] = {}; //   0
  psi_c_t[no_ps][0] = get_vector_from_array_int(c_t_0, 0);
  int c_d_0[] = {  0,   1,   2,   3}; //   4
  psi_c_d[no_ps][0] = get_vector_from_array_int(c_d_0, 4);

  int c_p_1[] = {  3,   4,   5}; //   3
  psi_c_p[no_ps][1] = get_vector_from_array_int(c_p_1, 3);
  int c_f_1[] = {}; //   0
  psi_c_f[no_ps][1] = get_vector_from_array_int(c_f_1, 0);
  int c_t_1[] = {}; //   0
  psi_c_t[no_ps][1] = get_vector_from_array_int(c_t_1, 0);
  int c_d_1[] = {  0,   4,   5,   3}; //   4
  psi_c_d[no_ps][1] = get_vector_from_array_int(c_d_1, 4);

  int c_p_2[] = {  0,   4,   5}; //   3
  psi_c_p[no_ps][2] = get_vector_from_array_int(c_p_2, 3);
  int c_f_2[] = {}; //   0
  psi_c_f[no_ps][2] = get_vector_from_array_int(c_f_2, 0);
  int c_t_2[] = {}; //   0
  psi_c_t[no_ps][2] = get_vector_from_array_int(c_t_2, 0);
  int c_d_2[] = {  0,   4,   5,   3}; //   4
  psi_c_d[no_ps][2] = get_vector_from_array_int(c_d_2, 4);

  int c_p_3[] = {  6,   7,   8}; //   3
  psi_c_p[no_ps][3] = get_vector_from_array_int(c_p_3, 3);
  int c_f_3[] = {}; //   0
  psi_c_f[no_ps][3] = get_vector_from_array_int(c_f_3, 0);
  int c_t_3[] = {}; //   0
  psi_c_t[no_ps][3] = get_vector_from_array_int(c_t_3, 0);
  int c_d_3[] = {  0,   6,   7,   8}; //   4
  psi_c_d[no_ps][3] = get_vector_from_array_int(c_d_3, 4);

  int c_p_4[] = {  6,   9,  10}; //   3
  psi_c_p[no_ps][4] = get_vector_from_array_int(c_p_4, 3);
  int c_f_4[] = {}; //   0
  psi_c_f[no_ps][4] = get_vector_from_array_int(c_f_4, 0);
  int c_t_4[] = {}; //   0
  psi_c_t[no_ps][4] = get_vector_from_array_int(c_t_4, 0);
  int c_d_4[] = {  0,   9,   3,   8}; //   4
  psi_c_d[no_ps][4] = get_vector_from_array_int(c_d_4, 4);

  int c_p_5[] = {  6,  11,  10}; //   3
  psi_c_p[no_ps][5] = get_vector_from_array_int(c_p_5, 3);
  int c_f_5[] = {}; //   0
  psi_c_f[no_ps][5] = get_vector_from_array_int(c_f_5, 0);
  int c_t_5[] = {}; //   0
  psi_c_t[no_ps][5] = get_vector_from_array_int(c_t_5, 0);
  int c_d_5[] = {  0,   9,   3,   8}; //   4
  psi_c_d[no_ps][5] = get_vector_from_array_int(c_d_5, 4);

  int c_p_6[] = {  6,  12,  13}; //   3
  psi_c_p[no_ps][6] = get_vector_from_array_int(c_p_6, 3);
  int c_f_6[] = {}; //   0
  psi_c_f[no_ps][6] = get_vector_from_array_int(c_f_6, 0);
  int c_t_6[] = {}; //   0
  psi_c_t[no_ps][6] = get_vector_from_array_int(c_t_6, 0);
  int c_d_6[] = { 10,   3,  11,   8}; //   4
  psi_c_d[no_ps][6] = get_vector_from_array_int(c_d_6, 4);

  int c_p_7[] = {  6,  12,  14}; //   3
  psi_c_p[no_ps][7] = get_vector_from_array_int(c_p_7, 3);
  int c_f_7[] = {}; //   0
  psi_c_f[no_ps][7] = get_vector_from_array_int(c_f_7, 0);
  int c_t_7[] = {}; //   0
  psi_c_t[no_ps][7] = get_vector_from_array_int(c_t_7, 0);
  int c_d_7[] = { 10,   3,  11,   8}; //   4
  psi_c_d[no_ps][7] = get_vector_from_array_int(c_d_7, 4);

  int c_p_8[] = {  3,  15,  16}; //   3
  psi_c_p[no_ps][8] = get_vector_from_array_int(c_p_8, 3);
  int c_f_8[] = {}; //   0
  psi_c_f[no_ps][8] = get_vector_from_array_int(c_f_8, 0);
  int c_t_8[] = {}; //   0
  psi_c_t[no_ps][8] = get_vector_from_array_int(c_t_8, 0);
  int c_d_8[] = { 12,   8,  13,   3}; //   4
  psi_c_d[no_ps][8] = get_vector_from_array_int(c_d_8, 4);

  int c_p_9[] = {  0,  15,  16}; //   3
  psi_c_p[no_ps][9] = get_vector_from_array_int(c_p_9, 3);
  int c_f_9[] = {}; //   0
  psi_c_f[no_ps][9] = get_vector_from_array_int(c_f_9, 0);
  int c_t_9[] = {}; //   0
  psi_c_t[no_ps][9] = get_vector_from_array_int(c_t_9, 0);
  int c_d_9[] = { 12,   8,  13,   3}; //   4
  psi_c_d[no_ps][9] = get_vector_from_array_int(c_d_9, 4);

  int c_p_10[] = {  0,   1,   2}; //   3
  psi_c_p[no_ps][10] = get_vector_from_array_int(c_p_10, 3);
  int c_f_10[] = {}; //   0
  psi_c_f[no_ps][10] = get_vector_from_array_int(c_f_10, 0);
  int c_t_10[] = {  0}; //   1
  psi_c_t[no_ps][10] = get_vector_from_array_int(c_t_10, 1);
  int c_d_10[] = {  1,   2,   3}; //   3
  psi_c_d[no_ps][10] = get_vector_from_array_int(c_d_10, 3);

  int c_p_11[] = {  3,   4,   5}; //   3
  psi_c_p[no_ps][11] = get_vector_from_array_int(c_p_11, 3);
  int c_f_11[] = {}; //   0
  psi_c_f[no_ps][11] = get_vector_from_array_int(c_f_11, 0);
  int c_t_11[] = {  0}; //   1
  psi_c_t[no_ps][11] = get_vector_from_array_int(c_t_11, 1);
  int c_d_11[] = {  4,   5,   3}; //   3
  psi_c_d[no_ps][11] = get_vector_from_array_int(c_d_11, 3);

  int c_p_12[] = {  0,   4,   5}; //   3
  psi_c_p[no_ps][12] = get_vector_from_array_int(c_p_12, 3);
  int c_f_12[] = {}; //   0
  psi_c_f[no_ps][12] = get_vector_from_array_int(c_f_12, 0);
  int c_t_12[] = {  0}; //   1
  psi_c_t[no_ps][12] = get_vector_from_array_int(c_t_12, 1);
  int c_d_12[] = {  4,   5,   3}; //   3
  psi_c_d[no_ps][12] = get_vector_from_array_int(c_d_12, 3);

  int c_p_13[] = {  6,   7,   8}; //   3
  psi_c_p[no_ps][13] = get_vector_from_array_int(c_p_13, 3);
  int c_f_13[] = {}; //   0
  psi_c_f[no_ps][13] = get_vector_from_array_int(c_f_13, 0);
  int c_t_13[] = {  0}; //   1
  psi_c_t[no_ps][13] = get_vector_from_array_int(c_t_13, 1);
  int c_d_13[] = {  6,   7,   8}; //   3
  psi_c_d[no_ps][13] = get_vector_from_array_int(c_d_13, 3);

  int c_p_14[] = {  6,   9,  10}; //   3
  psi_c_p[no_ps][14] = get_vector_from_array_int(c_p_14, 3);
  int c_f_14[] = {}; //   0
  psi_c_f[no_ps][14] = get_vector_from_array_int(c_f_14, 0);
  int c_t_14[] = {  0}; //   1
  psi_c_t[no_ps][14] = get_vector_from_array_int(c_t_14, 1);
  int c_d_14[] = {  9,   3,   8}; //   3
  psi_c_d[no_ps][14] = get_vector_from_array_int(c_d_14, 3);

  int c_p_15[] = {  6,  11,  10}; //   3
  psi_c_p[no_ps][15] = get_vector_from_array_int(c_p_15, 3);
  int c_f_15[] = {}; //   0
  psi_c_f[no_ps][15] = get_vector_from_array_int(c_f_15, 0);
  int c_t_15[] = {  0}; //   1
  psi_c_t[no_ps][15] = get_vector_from_array_int(c_t_15, 1);
  int c_d_15[] = {  9,   3,   8}; //   3
  psi_c_d[no_ps][15] = get_vector_from_array_int(c_d_15, 3);

  int c_p_16[] = {  6,   9,  17}; //   3
  psi_c_p[no_ps][16] = get_vector_from_array_int(c_p_16, 3);
  int c_f_16[] = {}; //   0
  psi_c_f[no_ps][16] = get_vector_from_array_int(c_f_16, 0);
  int c_t_16[] = {  1}; //   1
  psi_c_t[no_ps][16] = get_vector_from_array_int(c_t_16, 1);
  int c_d_16[] = { 13,   3,   8}; //   3
  psi_c_d[no_ps][16] = get_vector_from_array_int(c_d_16, 3);

  int c_p_17[] = {  6,  11,  17}; //   3
  psi_c_p[no_ps][17] = get_vector_from_array_int(c_p_17, 3);
  int c_f_17[] = {}; //   0
  psi_c_f[no_ps][17] = get_vector_from_array_int(c_f_17, 0);
  int c_t_17[] = {  1}; //   1
  psi_c_t[no_ps][17] = get_vector_from_array_int(c_t_17, 1);
  int c_d_17[] = { 13,   3,   8}; //   3
  psi_c_d[no_ps][17] = get_vector_from_array_int(c_d_17, 3);

  int c_p_18[] = {  3,  18,  19}; //   3
  psi_c_p[no_ps][18] = get_vector_from_array_int(c_p_18, 3);
  int c_f_18[] = {}; //   0
  psi_c_f[no_ps][18] = get_vector_from_array_int(c_f_18, 0);
  int c_t_18[] = {  2}; //   1
  psi_c_t[no_ps][18] = get_vector_from_array_int(c_t_18, 1);
  int c_d_18[] = { 11,   8,   3}; //   3
  psi_c_d[no_ps][18] = get_vector_from_array_int(c_d_18, 3);

  int c_p_19[] = {  0,  18,  19}; //   3
  psi_c_p[no_ps][19] = get_vector_from_array_int(c_p_19, 3);
  int c_f_19[] = {}; //   0
  psi_c_f[no_ps][19] = get_vector_from_array_int(c_f_19, 0);
  int c_t_19[] = {  2}; //   1
  psi_c_t[no_ps][19] = get_vector_from_array_int(c_t_19, 1);
  int c_d_19[] = { 11,   8,   3}; //   3
  psi_c_d[no_ps][19] = get_vector_from_array_int(c_d_19, 3);

  int c_p_20[] = {  6,   9}; //   2
  psi_c_p[no_ps][20] = get_vector_from_array_int(c_p_20, 2);
  int c_f_20[] = {  0}; //   1
  psi_c_f[no_ps][20] = get_vector_from_array_int(c_f_20, 1);
  int c_t_20[] = {  0,   3}; //   2
  psi_c_t[no_ps][20] = get_vector_from_array_int(c_t_20, 2);
  int c_d_20[] = {  3,   8}; //   2
  psi_c_d[no_ps][20] = get_vector_from_array_int(c_d_20, 2);

  int c_p_21[] = {  6,  11}; //   2
  psi_c_p[no_ps][21] = get_vector_from_array_int(c_p_21, 2);
  int c_f_21[] = {  0}; //   1
  psi_c_f[no_ps][21] = get_vector_from_array_int(c_f_21, 1);
  int c_t_21[] = {  0,   3}; //   2
  psi_c_t[no_ps][21] = get_vector_from_array_int(c_t_21, 2);
  int c_d_21[] = {  3,   8}; //   2
  psi_c_d[no_ps][21] = get_vector_from_array_int(c_d_21, 2);

  int c_p_22[] = {  3,  18}; //   2
  psi_c_p[no_ps][22] = get_vector_from_array_int(c_p_22, 2);
  int c_f_22[] = {  0}; //   1
  psi_c_f[no_ps][22] = get_vector_from_array_int(c_f_22, 1);
  int c_t_22[] = {  0,   4}; //   2
  psi_c_t[no_ps][22] = get_vector_from_array_int(c_t_22, 2);
  int c_d_22[] = {  8,   3}; //   2
  psi_c_d[no_ps][22] = get_vector_from_array_int(c_d_22, 2);

  int c_p_23[] = {  0,  18}; //   2
  psi_c_p[no_ps][23] = get_vector_from_array_int(c_p_23, 2);
  int c_f_23[] = {  0}; //   1
  psi_c_f[no_ps][23] = get_vector_from_array_int(c_f_23, 1);
  int c_t_23[] = {  0,   4}; //   2
  psi_c_t[no_ps][23] = get_vector_from_array_int(c_t_23, 2);
  int c_d_23[] = {  8,   3}; //   2
  psi_c_d[no_ps][23] = get_vector_from_array_int(c_d_23, 2);

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
