#include "../include/classes.cxx"
#include "../include/definitions.phasespace.set.cxx"
#include "../ppeexnmnmx04/header/ppeexnmnmx04.phasespace.h"
void ppeexnmnmx04_ax_psp_240_gg_emepvmvmx(int no_ps, phasespace_set & psi){
  static Logger logger("ppeexnmnmx04_ax_psp_240_gg_emepvmvmx");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;
  psi_v_smin[no_ps].resize(6);
  psi_needed_v_smin[no_ps].resize(6);
  int needed_v_smin_0[] = {   0,    1,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18}; //  17
  psi_needed_v_smin[no_ps][  0] = get_vector_from_array_int(needed_v_smin_0, 17);
  int needed_v_smin_1[] = {   0,    1}; //   2
  psi_needed_v_smin[no_ps][  1] = get_vector_from_array_int(needed_v_smin_1, 2);
  int needed_v_smin_2[] = {   2,    3,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18}; //  15
  psi_needed_v_smin[no_ps][  2] = get_vector_from_array_int(needed_v_smin_2, 15);
  int needed_v_smin_3[] = {   2}; //   1
  psi_needed_v_smin[no_ps][  3] = get_vector_from_array_int(needed_v_smin_3, 1);
  int needed_v_smin_4[] = {   3}; //   1
  psi_needed_v_smin[no_ps][  4] = get_vector_from_array_int(needed_v_smin_4, 1);
  int needed_v_smin_5[] = {   4,    5}; //   2
  psi_needed_v_smin[no_ps][  5] = get_vector_from_array_int(needed_v_smin_5, 2);

  psi_v_smax[no_ps].resize(8);
  psi_needed_v_smax[no_ps].resize(8);
  int needed_v_smax_0[] = {   0,    1,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14}; //  13
  psi_needed_v_smax[no_ps][  0] = get_vector_from_array_int(needed_v_smax_0, 13);
  int needed_v_smax_1[] = {   0,    1}; //   2
  psi_needed_v_smax[no_ps][  1] = get_vector_from_array_int(needed_v_smax_1, 2);
  int needed_v_smax_2[] = {   2,    3,   15,   16,   17,   18}; //   6
  psi_needed_v_smax[no_ps][  2] = get_vector_from_array_int(needed_v_smax_2, 6);
  int needed_v_smax_3[] = {   2}; //   1
  psi_needed_v_smax[no_ps][  3] = get_vector_from_array_int(needed_v_smax_3, 1);
  int needed_v_smax_4[] = {   3}; //   1
  psi_needed_v_smax[no_ps][  4] = get_vector_from_array_int(needed_v_smax_4, 1);
  int needed_v_smax_5[] = {   4,    5}; //   2
  psi_needed_v_smax[no_ps][  5] = get_vector_from_array_int(needed_v_smax_5, 2);
  int needed_v_smax_6[] = {   6,    7,    8,    9,   10,   11,   12,   13,   14}; //   9
  psi_needed_v_smax[no_ps][  6] = get_vector_from_array_int(needed_v_smax_6, 9);
  int needed_v_smax_7[] = {  15,   16,   17,   18}; //   4
  psi_needed_v_smax[no_ps][  7] = get_vector_from_array_int(needed_v_smax_7, 4);

  psi_container_IS_startvalue[no_ps][0] = psi_container_IS_name.size();
  psi_g_p[no_ps].resize(10);
  psi_needed_g_p[no_ps].resize(10);
  int needed_g_p_0[] = {   0,    1,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14}; //  13
  psi_needed_g_p[no_ps][0] = get_vector_from_array_int(needed_g_p_0, 13);
  psi_container_IS_name.push_back("propagator_23_smin0_smax0");
  int needed_g_p_1[] = {   0,    1}; //   2
  psi_needed_g_p[no_ps][1] = get_vector_from_array_int(needed_g_p_1, 2);
  psi_container_IS_name.push_back("propagator_0_smin1_smax1");
  int needed_g_p_2[] = {   2,    3,   17,   18}; //   4
  psi_needed_g_p[no_ps][2] = get_vector_from_array_int(needed_g_p_2, 4);
  psi_container_IS_name.push_back("propagator_23_smin2_smax2");
  int needed_g_p_3[] = {   2}; //   1
  psi_needed_g_p[no_ps][3] = get_vector_from_array_int(needed_g_p_3, 1);
  psi_container_IS_name.push_back("propagator_0_smin3_smax3");
  int needed_g_p_4[] = {   3}; //   1
  psi_needed_g_p[no_ps][4] = get_vector_from_array_int(needed_g_p_4, 1);
  psi_container_IS_name.push_back("propagator_0_smin4_smax4");
  int needed_g_p_5[] = {   4,    5}; //   2
  psi_needed_g_p[no_ps][5] = get_vector_from_array_int(needed_g_p_5, 2);
  psi_container_IS_name.push_back("propagator_0_smin5_smax5");
  int needed_g_p_6[] = {   6,    7,   11,   12}; //   4
  psi_needed_g_p[no_ps][6] = get_vector_from_array_int(needed_g_p_6, 4);
  psi_container_IS_name.push_back("propagator_0_smin2_smax6");
  int needed_g_p_7[] = {   8,    9,   10,   13,   14}; //   5
  psi_needed_g_p[no_ps][7] = get_vector_from_array_int(needed_g_p_7, 5);
  psi_container_IS_name.push_back("propagator_23_smin2_smax6");
  int needed_g_p_8[] = {  15,   16}; //   2
  psi_needed_g_p[no_ps][8] = get_vector_from_array_int(needed_g_p_8, 2);
  psi_container_IS_name.push_back("propagator_0_smin2_smax2");
  int needed_g_p_9[] = {  15,   16,   17,   18}; //   4
  psi_needed_g_p[no_ps][9] = get_vector_from_array_int(needed_g_p_9, 4);
  psi_container_IS_name.push_back("propagator_23_smin0_smax7");

  psi_container_IS_startvalue[no_ps][1] = psi_container_IS_name.size();
  psi_g_f[no_ps].resize(0);
  psi_needed_g_f[no_ps].resize(0);

  psi_container_IS_startvalue[no_ps][2] = psi_container_IS_name.size();
  psi_g_t[no_ps].resize(4);
  psi_needed_g_t[no_ps].resize(4);
  int needed_g_t_0[] = {  11,   13}; //   2
  psi_needed_g_t[no_ps][0] = get_vector_from_array_int(needed_g_t_0, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_2__12_48");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_2__12_48");
  int needed_g_t_1[] = {  12,   14}; //   2
  psi_needed_g_t[no_ps][1] = get_vector_from_array_int(needed_g_t_1, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_6__1_2__12_48");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_6__1_2__12_48");
  int needed_g_t_2[] = {  15,   17}; //   2
  psi_needed_g_t[no_ps][2] = get_vector_from_array_int(needed_g_t_2, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_2__48_12");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_2__48_12");
  int needed_g_t_3[] = {  16,   18}; //   2
  psi_needed_g_t[no_ps][3] = get_vector_from_array_int(needed_g_t_3, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_6__1_2__48_12");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_6__1_2__48_12");

  psi_container_IS_startvalue[no_ps][3] = psi_container_IS_name.size();
  psi_g_d[no_ps].resize(11);
  psi_needed_g_d[no_ps].resize(11);
  int needed_g_d_0[] = {   0,    1}; //   2
  psi_needed_g_d[no_ps][0] = get_vector_from_array_int(needed_g_d_0, 2);
  psi_container_IS_name.push_back("costheta_of_decay_60__4_56");
  psi_container_IS_name.push_back("phi_of_decay_60__4_56");
  int needed_g_d_1[] = {   0,    1}; //   2
  psi_needed_g_d[no_ps][1] = get_vector_from_array_int(needed_g_d_1, 2);
  psi_container_IS_name.push_back("costheta_of_decay_56__8_48");
  psi_container_IS_name.push_back("phi_of_decay_56__8_48");
  int needed_g_d_2[] = {   0,    1,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18}; //  17
  psi_needed_g_d[no_ps][2] = get_vector_from_array_int(needed_g_d_2, 17);
  psi_container_IS_name.push_back("costheta_of_decay_48__16_32");
  psi_container_IS_name.push_back("phi_of_decay_48__16_32");
  int needed_g_d_3[] = {   2}; //   1
  psi_needed_g_d[no_ps][3] = get_vector_from_array_int(needed_g_d_3, 1);
  psi_container_IS_name.push_back("costheta_of_decay_60__16_44");
  psi_container_IS_name.push_back("phi_of_decay_60__16_44");
  int needed_g_d_4[] = {   2}; //   1
  psi_needed_g_d[no_ps][4] = get_vector_from_array_int(needed_g_d_4, 1);
  psi_container_IS_name.push_back("costheta_of_decay_44__32_12");
  psi_container_IS_name.push_back("phi_of_decay_44__32_12");
  int needed_g_d_5[] = {   2,    3,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18}; //  15
  psi_needed_g_d[no_ps][5] = get_vector_from_array_int(needed_g_d_5, 15);
  psi_container_IS_name.push_back("costheta_of_decay_12__4_8");
  psi_container_IS_name.push_back("phi_of_decay_12__4_8");
  int needed_g_d_6[] = {   3}; //   1
  psi_needed_g_d[no_ps][6] = get_vector_from_array_int(needed_g_d_6, 1);
  psi_container_IS_name.push_back("costheta_of_decay_60__32_28");
  psi_container_IS_name.push_back("phi_of_decay_60__32_28");
  int needed_g_d_7[] = {   3}; //   1
  psi_needed_g_d[no_ps][7] = get_vector_from_array_int(needed_g_d_7, 1);
  psi_container_IS_name.push_back("costheta_of_decay_28__16_12");
  psi_container_IS_name.push_back("phi_of_decay_28__16_12");
  int needed_g_d_8[] = {   4,    5}; //   2
  psi_needed_g_d[no_ps][8] = get_vector_from_array_int(needed_g_d_8, 2);
  psi_container_IS_name.push_back("costheta_of_decay_60__8_52");
  psi_container_IS_name.push_back("phi_of_decay_60__8_52");
  int needed_g_d_9[] = {   4,    5}; //   2
  psi_needed_g_d[no_ps][9] = get_vector_from_array_int(needed_g_d_9, 2);
  psi_container_IS_name.push_back("costheta_of_decay_52__4_48");
  psi_container_IS_name.push_back("phi_of_decay_52__4_48");
  int needed_g_d_10[] = {   6,    7,    8,    9,   10}; //   5
  psi_needed_g_d[no_ps][10] = get_vector_from_array_int(needed_g_d_10, 5);
  psi_container_IS_name.push_back("costheta_of_decay_60__12_48");
  psi_container_IS_name.push_back("phi_of_decay_60__12_48");

  psi_c_p[no_ps].resize(19);
  psi_c_f[no_ps].resize(19);
  psi_c_t[no_ps].resize(19);
  psi_c_d[no_ps].resize(19);

  int c_p_0[] = {  0,   1}; //   2
  psi_c_p[no_ps][0] = get_vector_from_array_int(c_p_0, 2);
  int c_f_0[] = {}; //   0
  psi_c_f[no_ps][0] = get_vector_from_array_int(c_f_0, 0);
  int c_t_0[] = {}; //   0
  psi_c_t[no_ps][0] = get_vector_from_array_int(c_t_0, 0);
  int c_d_0[] = {  0,   1,   2}; //   3
  psi_c_d[no_ps][0] = get_vector_from_array_int(c_d_0, 3);

  int c_p_1[] = {  0,   1}; //   2
  psi_c_p[no_ps][1] = get_vector_from_array_int(c_p_1, 2);
  int c_f_1[] = {}; //   0
  psi_c_f[no_ps][1] = get_vector_from_array_int(c_f_1, 0);
  int c_t_1[] = {}; //   0
  psi_c_t[no_ps][1] = get_vector_from_array_int(c_t_1, 0);
  int c_d_1[] = {  0,   1,   2}; //   3
  psi_c_d[no_ps][1] = get_vector_from_array_int(c_d_1, 3);

  int c_p_2[] = {  2,   3}; //   2
  psi_c_p[no_ps][2] = get_vector_from_array_int(c_p_2, 2);
  int c_f_2[] = {}; //   0
  psi_c_f[no_ps][2] = get_vector_from_array_int(c_f_2, 0);
  int c_t_2[] = {}; //   0
  psi_c_t[no_ps][2] = get_vector_from_array_int(c_t_2, 0);
  int c_d_2[] = {  3,   4,   5}; //   3
  psi_c_d[no_ps][2] = get_vector_from_array_int(c_d_2, 3);

  int c_p_3[] = {  2,   4}; //   2
  psi_c_p[no_ps][3] = get_vector_from_array_int(c_p_3, 2);
  int c_f_3[] = {}; //   0
  psi_c_f[no_ps][3] = get_vector_from_array_int(c_f_3, 0);
  int c_t_3[] = {}; //   0
  psi_c_t[no_ps][3] = get_vector_from_array_int(c_t_3, 0);
  int c_d_3[] = {  6,   7,   5}; //   3
  psi_c_d[no_ps][3] = get_vector_from_array_int(c_d_3, 3);

  int c_p_4[] = {  0,   5}; //   2
  psi_c_p[no_ps][4] = get_vector_from_array_int(c_p_4, 2);
  int c_f_4[] = {}; //   0
  psi_c_f[no_ps][4] = get_vector_from_array_int(c_f_4, 0);
  int c_t_4[] = {}; //   0
  psi_c_t[no_ps][4] = get_vector_from_array_int(c_t_4, 0);
  int c_d_4[] = {  8,   9,   2}; //   3
  psi_c_d[no_ps][4] = get_vector_from_array_int(c_d_4, 3);

  int c_p_5[] = {  0,   5}; //   2
  psi_c_p[no_ps][5] = get_vector_from_array_int(c_p_5, 2);
  int c_f_5[] = {}; //   0
  psi_c_f[no_ps][5] = get_vector_from_array_int(c_f_5, 0);
  int c_t_5[] = {}; //   0
  psi_c_t[no_ps][5] = get_vector_from_array_int(c_t_5, 0);
  int c_d_5[] = {  8,   9,   2}; //   3
  psi_c_d[no_ps][5] = get_vector_from_array_int(c_d_5, 3);

  int c_p_6[] = {  0,   6}; //   2
  psi_c_p[no_ps][6] = get_vector_from_array_int(c_p_6, 2);
  int c_f_6[] = {}; //   0
  psi_c_f[no_ps][6] = get_vector_from_array_int(c_f_6, 0);
  int c_t_6[] = {}; //   0
  psi_c_t[no_ps][6] = get_vector_from_array_int(c_t_6, 0);
  int c_d_6[] = { 10,   5,   2}; //   3
  psi_c_d[no_ps][6] = get_vector_from_array_int(c_d_6, 3);

  int c_p_7[] = {  0,   6}; //   2
  psi_c_p[no_ps][7] = get_vector_from_array_int(c_p_7, 2);
  int c_f_7[] = {}; //   0
  psi_c_f[no_ps][7] = get_vector_from_array_int(c_f_7, 0);
  int c_t_7[] = {}; //   0
  psi_c_t[no_ps][7] = get_vector_from_array_int(c_t_7, 0);
  int c_d_7[] = { 10,   5,   2}; //   3
  psi_c_d[no_ps][7] = get_vector_from_array_int(c_d_7, 3);

  int c_p_8[] = {  0,   7}; //   2
  psi_c_p[no_ps][8] = get_vector_from_array_int(c_p_8, 2);
  int c_f_8[] = {}; //   0
  psi_c_f[no_ps][8] = get_vector_from_array_int(c_f_8, 0);
  int c_t_8[] = {}; //   0
  psi_c_t[no_ps][8] = get_vector_from_array_int(c_t_8, 0);
  int c_d_8[] = { 10,   5,   2}; //   3
  psi_c_d[no_ps][8] = get_vector_from_array_int(c_d_8, 3);

  int c_p_9[] = {  0,   7}; //   2
  psi_c_p[no_ps][9] = get_vector_from_array_int(c_p_9, 2);
  int c_f_9[] = {}; //   0
  psi_c_f[no_ps][9] = get_vector_from_array_int(c_f_9, 0);
  int c_t_9[] = {}; //   0
  psi_c_t[no_ps][9] = get_vector_from_array_int(c_t_9, 0);
  int c_d_9[] = { 10,   5,   2}; //   3
  psi_c_d[no_ps][9] = get_vector_from_array_int(c_d_9, 3);

  int c_p_10[] = {  0,   7}; //   2
  psi_c_p[no_ps][10] = get_vector_from_array_int(c_p_10, 2);
  int c_f_10[] = {}; //   0
  psi_c_f[no_ps][10] = get_vector_from_array_int(c_f_10, 0);
  int c_t_10[] = {}; //   0
  psi_c_t[no_ps][10] = get_vector_from_array_int(c_t_10, 0);
  int c_d_10[] = { 10,   5,   2}; //   3
  psi_c_d[no_ps][10] = get_vector_from_array_int(c_d_10, 3);

  int c_p_11[] = {  0,   6}; //   2
  psi_c_p[no_ps][11] = get_vector_from_array_int(c_p_11, 2);
  int c_f_11[] = {}; //   0
  psi_c_f[no_ps][11] = get_vector_from_array_int(c_f_11, 0);
  int c_t_11[] = {  0}; //   1
  psi_c_t[no_ps][11] = get_vector_from_array_int(c_t_11, 1);
  int c_d_11[] = {  5,   2}; //   2
  psi_c_d[no_ps][11] = get_vector_from_array_int(c_d_11, 2);

  int c_p_12[] = {  0,   6}; //   2
  psi_c_p[no_ps][12] = get_vector_from_array_int(c_p_12, 2);
  int c_f_12[] = {}; //   0
  psi_c_f[no_ps][12] = get_vector_from_array_int(c_f_12, 0);
  int c_t_12[] = {  1}; //   1
  psi_c_t[no_ps][12] = get_vector_from_array_int(c_t_12, 1);
  int c_d_12[] = {  5,   2}; //   2
  psi_c_d[no_ps][12] = get_vector_from_array_int(c_d_12, 2);

  int c_p_13[] = {  0,   7}; //   2
  psi_c_p[no_ps][13] = get_vector_from_array_int(c_p_13, 2);
  int c_f_13[] = {}; //   0
  psi_c_f[no_ps][13] = get_vector_from_array_int(c_f_13, 0);
  int c_t_13[] = {  0}; //   1
  psi_c_t[no_ps][13] = get_vector_from_array_int(c_t_13, 1);
  int c_d_13[] = {  5,   2}; //   2
  psi_c_d[no_ps][13] = get_vector_from_array_int(c_d_13, 2);

  int c_p_14[] = {  0,   7}; //   2
  psi_c_p[no_ps][14] = get_vector_from_array_int(c_p_14, 2);
  int c_f_14[] = {}; //   0
  psi_c_f[no_ps][14] = get_vector_from_array_int(c_f_14, 0);
  int c_t_14[] = {  1}; //   1
  psi_c_t[no_ps][14] = get_vector_from_array_int(c_t_14, 1);
  int c_d_14[] = {  5,   2}; //   2
  psi_c_d[no_ps][14] = get_vector_from_array_int(c_d_14, 2);

  int c_p_15[] = {  8,   9}; //   2
  psi_c_p[no_ps][15] = get_vector_from_array_int(c_p_15, 2);
  int c_f_15[] = {}; //   0
  psi_c_f[no_ps][15] = get_vector_from_array_int(c_f_15, 0);
  int c_t_15[] = {  2}; //   1
  psi_c_t[no_ps][15] = get_vector_from_array_int(c_t_15, 1);
  int c_d_15[] = {  2,   5}; //   2
  psi_c_d[no_ps][15] = get_vector_from_array_int(c_d_15, 2);

  int c_p_16[] = {  8,   9}; //   2
  psi_c_p[no_ps][16] = get_vector_from_array_int(c_p_16, 2);
  int c_f_16[] = {}; //   0
  psi_c_f[no_ps][16] = get_vector_from_array_int(c_f_16, 0);
  int c_t_16[] = {  3}; //   1
  psi_c_t[no_ps][16] = get_vector_from_array_int(c_t_16, 1);
  int c_d_16[] = {  2,   5}; //   2
  psi_c_d[no_ps][16] = get_vector_from_array_int(c_d_16, 2);

  int c_p_17[] = {  2,   9}; //   2
  psi_c_p[no_ps][17] = get_vector_from_array_int(c_p_17, 2);
  int c_f_17[] = {}; //   0
  psi_c_f[no_ps][17] = get_vector_from_array_int(c_f_17, 0);
  int c_t_17[] = {  2}; //   1
  psi_c_t[no_ps][17] = get_vector_from_array_int(c_t_17, 1);
  int c_d_17[] = {  2,   5}; //   2
  psi_c_d[no_ps][17] = get_vector_from_array_int(c_d_17, 2);

  int c_p_18[] = {  2,   9}; //   2
  psi_c_p[no_ps][18] = get_vector_from_array_int(c_p_18, 2);
  int c_f_18[] = {}; //   0
  psi_c_f[no_ps][18] = get_vector_from_array_int(c_f_18, 0);
  int c_t_18[] = {  3}; //   1
  psi_c_t[no_ps][18] = get_vector_from_array_int(c_t_18, 1);
  int c_d_18[] = {  2,   5}; //   2
  psi_c_d[no_ps][18] = get_vector_from_array_int(c_d_18, 2);

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
