#include "../include/classes.cxx"
#include "../include/definitions.phasespace.set.cxx"
#include "../ppeexnmnmx04/header/ppeexnmnmx04.phasespace.h"
void ppeexnmnmx04_optimize_minv_doublereal(phasespace_set & psi){
  static Logger logger("ppeexnmnmx04_optimize_minv_doublereal");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

#include "user/specify.optimize.phasespace.minv.doublereal.cxx"

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

int ppeexnmnmx04_determination_MCchannels_doublereal(int no_ps, phasespace_set & psi){
  static Logger logger("ppeexnmnmx04_determination_MCchannels_doublereal");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  int n_channel = 0;
  if      (psi_no_map[no_ps] ==  0){n_channel = 262;}
  else if (psi_no_map[no_ps] ==  2){n_channel = 108;}
  else if (psi_no_map[no_ps] ==  3){n_channel = 108;}
  else if (psi_no_map[no_ps] ==  4){n_channel = 108;}
  else if (psi_no_map[no_ps] ==  5){n_channel = 108;}
  else if (psi_no_map[no_ps] ==  6){n_channel = 108;}
  else if (psi_no_map[no_ps] ==  7){n_channel = 108;}
  else if (psi_no_map[no_ps] ==  8){n_channel = 128;}
  else if (psi_no_map[no_ps] ==  9){n_channel = 64;}
  else if (psi_no_map[no_ps] == 10){n_channel = 64;}
  else if (psi_no_map[no_ps] == 11){n_channel = 64;}
  else if (psi_no_map[no_ps] == 13){n_channel = 108;}
  else if (psi_no_map[no_ps] == 14){n_channel = 128;}
  else if (psi_no_map[no_ps] == 15){n_channel = 64;}
  else if (psi_no_map[no_ps] == 16){n_channel = 64;}
  else if (psi_no_map[no_ps] == 17){n_channel = 64;}
  else if (psi_no_map[no_ps] == 18){n_channel = 64;}
  else if (psi_no_map[no_ps] == 20){n_channel = 64;}
  else if (psi_no_map[no_ps] == 22){n_channel = 64;}
  else if (psi_no_map[no_ps] == 23){n_channel = 128;}
  else if (psi_no_map[no_ps] == 24){n_channel = 64;}
  else if (psi_no_map[no_ps] == 25){n_channel = 64;}
  else if (psi_no_map[no_ps] == 27){n_channel = 108;}
  else if (psi_no_map[no_ps] == 28){n_channel = 64;}
  else if (psi_no_map[no_ps] == 29){n_channel = 128;}
  else if (psi_no_map[no_ps] == 30){n_channel = 64;}
  else if (psi_no_map[no_ps] == 31){n_channel = 64;}
  else if (psi_no_map[no_ps] == 32){n_channel = 64;}
  else if (psi_no_map[no_ps] == 34){n_channel = 64;}
  else if (psi_no_map[no_ps] == 35){n_channel = 128;}
  else if (psi_no_map[no_ps] == 36){n_channel = 64;}
  else if (psi_no_map[no_ps] == 37){n_channel = 64;}
  else if (psi_no_map[no_ps] == 38){n_channel = 64;}
  else if (psi_no_map[no_ps] == 40){n_channel = 128;}
  else if (psi_no_map[no_ps] == 41){n_channel = 64;}
  return n_channel;

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

void ppeexnmnmx04_ac_tau_psp_doublereal(int no_ps, vector<int> & tau_MC_map, phasespace_set & psi){
  static Logger logger("ppeexnmnmx04_ac_tau_psp_doublereal");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  if      (psi.no_map[no_ps] == 0){}
  else if (psi.no_map[no_ps] ==  2){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  3){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  4){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  5){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  6){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  7){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  8){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  9){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 10){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 11){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 13){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 14){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 15){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 16){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 17){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 18){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 20){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 22){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 23){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 24){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 25){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 27){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 28){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 29){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 30){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 31){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 32){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 34){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 35){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 36){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 37){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 38){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 40){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 41){
    tau_MC_map.push_back(0);
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

void ppeexnmnmx04_ax_psp_doublereal(int no_ps, phasespace_set & psi){
  static Logger logger("ppeexnmnmx04_ax_psp_doublereal");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;
  if (psi_no_map[no_ps] == 0){}
  else if (psi_no_map[no_ps] ==  2){ppeexnmnmx04_ax_psp_240_gg_emepvmvmxddx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  3){ppeexnmnmx04_ax_psp_240_gg_emepvmvmxuux(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  4){ppeexnmnmx04_ax_psp_240_gd_emepvmvmxgd(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  5){ppeexnmnmx04_ax_psp_240_gu_emepvmvmxgu(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  6){ppeexnmnmx04_ax_psp_240_gdx_emepvmvmxgdx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  7){ppeexnmnmx04_ax_psp_240_gux_emepvmvmxgux(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  8){ppeexnmnmx04_ax_psp_240_dd_emepvmvmxdd(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  9){ppeexnmnmx04_ax_psp_240_du_emepvmvmxdu(no_ps, psi);}
  else if (psi_no_map[no_ps] == 10){ppeexnmnmx04_ax_psp_240_ds_emepvmvmxds(no_ps, psi);}
  else if (psi_no_map[no_ps] == 11){ppeexnmnmx04_ax_psp_240_dc_emepvmvmxdc(no_ps, psi);}
  else if (psi_no_map[no_ps] == 13){ppeexnmnmx04_ax_psp_240_ddx_emepvmvmxgg(no_ps, psi);}
  else if (psi_no_map[no_ps] == 14){ppeexnmnmx04_ax_psp_240_ddx_emepvmvmxddx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 15){ppeexnmnmx04_ax_psp_240_ddx_emepvmvmxuux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 16){ppeexnmnmx04_ax_psp_240_ddx_emepvmvmxssx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 17){ppeexnmnmx04_ax_psp_240_ddx_emepvmvmxccx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 18){ppeexnmnmx04_ax_psp_240_dux_emepvmvmxdux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 20){ppeexnmnmx04_ax_psp_240_dsx_emepvmvmxdsx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 22){ppeexnmnmx04_ax_psp_240_dcx_emepvmvmxdcx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 23){ppeexnmnmx04_ax_psp_240_uu_emepvmvmxuu(no_ps, psi);}
  else if (psi_no_map[no_ps] == 24){ppeexnmnmx04_ax_psp_240_uc_emepvmvmxuc(no_ps, psi);}
  else if (psi_no_map[no_ps] == 25){ppeexnmnmx04_ax_psp_240_udx_emepvmvmxudx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 27){ppeexnmnmx04_ax_psp_240_uux_emepvmvmxgg(no_ps, psi);}
  else if (psi_no_map[no_ps] == 28){ppeexnmnmx04_ax_psp_240_uux_emepvmvmxddx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 29){ppeexnmnmx04_ax_psp_240_uux_emepvmvmxuux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 30){ppeexnmnmx04_ax_psp_240_uux_emepvmvmxssx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 31){ppeexnmnmx04_ax_psp_240_uux_emepvmvmxccx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 32){ppeexnmnmx04_ax_psp_240_usx_emepvmvmxusx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 34){ppeexnmnmx04_ax_psp_240_ucx_emepvmvmxucx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 35){ppeexnmnmx04_ax_psp_240_dxdx_emepvmvmxdxdx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 36){ppeexnmnmx04_ax_psp_240_dxux_emepvmvmxdxux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 37){ppeexnmnmx04_ax_psp_240_dxsx_emepvmvmxdxsx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 38){ppeexnmnmx04_ax_psp_240_dxcx_emepvmvmxdxcx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 40){ppeexnmnmx04_ax_psp_240_uxux_emepvmvmxuxux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 41){ppeexnmnmx04_ax_psp_240_uxcx_emepvmvmxuxcx(no_ps, psi);}

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
