#include "../include/classes.cxx"
#include "../include/definitions.phasespace.set.cxx"
#include "../ppemexmx04/header/ppemexmx04.phasespace.h"
void ppemexmx04_ag_psp_240_gg_emmumepmup(int no_ps, int zero, phasespace_set & psi){
  static Logger logger("ppemexmx04_ag_psp_240_gg_emmumepmup");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;
  if (psi_xbp[no_ps][20] == nullvector){psi_xbp[no_ps][20] = psi_xbp[no_ps][4] + psi_xbp[no_ps][16];}
  if (psi_xbs[no_ps][20] == 0.){psi_xbs[no_ps][20] = psi_xbp[no_ps][20].m2();}
  if (psi_xbsqrts[no_ps][20] == 0.){psi_xbsqrts[no_ps][20] = sqrt(psi_xbs[no_ps][20]);}
  if (psi_xbp[no_ps][40] == nullvector){psi_xbp[no_ps][40] = psi_xbp[no_ps][8] + psi_xbp[no_ps][32];}
  if (psi_xbs[no_ps][40] == 0.){psi_xbs[no_ps][40] = psi_xbp[no_ps][40].m2();}
  if (psi_xbsqrts[no_ps][40] == 0.){psi_xbsqrts[no_ps][40] = sqrt(psi_xbs[no_ps][40]);}
  if (psi_xbp[no_ps][21] == nullvector){psi_xbp[no_ps][21] = psi_xbp[no_ps][1] - psi_xbp[no_ps][4] - psi_xbp[no_ps][16];}
  if (psi_xbs[no_ps][21] == 0.){psi_xbs[no_ps][21] = psi_xbp[no_ps][21].m2();}
  if (psi_xbp[no_ps][28] == nullvector){psi_xbp[no_ps][28] = psi_xbp[no_ps][4] + psi_xbp[no_ps][8] + psi_xbp[no_ps][16];}
  if (psi_xbs[no_ps][28] == 0.){psi_xbs[no_ps][28] = psi_xbp[no_ps][28].m2();}
  if (psi_xbp[no_ps][41] == nullvector){psi_xbp[no_ps][41] = psi_xbp[no_ps][1] - psi_xbp[no_ps][8] - psi_xbp[no_ps][32];}
  if (psi_xbs[no_ps][41] == 0.){psi_xbs[no_ps][41] = psi_xbp[no_ps][41].m2();}
  if (psi_xbp[no_ps][44] == nullvector){psi_xbp[no_ps][44] = psi_xbp[no_ps][4] + psi_xbp[no_ps][8] + psi_xbp[no_ps][32];}
  if (psi_xbs[no_ps][44] == 0.){psi_xbs[no_ps][44] = psi_xbp[no_ps][44].m2();}
  if (psi_xbp[no_ps][52] == nullvector){psi_xbp[no_ps][52] = psi_xbp[no_ps][4] + psi_xbp[no_ps][16] + psi_xbp[no_ps][32];}
  if (psi_xbs[no_ps][52] == 0.){psi_xbs[no_ps][52] = psi_xbp[no_ps][52].m2();}
  if (psi_xbp[no_ps][56] == nullvector){psi_xbp[no_ps][56] = psi_xbp[no_ps][8] + psi_xbp[no_ps][16] + psi_xbp[no_ps][32];}
  if (psi_xbs[no_ps][56] == 0.){psi_xbs[no_ps][56] = psi_xbp[no_ps][56].m2();}
  if (psi_xbp[no_ps][60] == nullvector){psi_xbp[no_ps][60] = psi_xbp[no_ps][4] + psi_xbp[no_ps][8] + psi_xbp[no_ps][16] + psi_xbp[no_ps][32];}
  if (psi_xbs[no_ps][60] == 0.){psi_xbs[no_ps][60] = psi_xbp[no_ps][60].m2();}

  psi_v_smin[no_ps][  0] = psi_smin_opt[no_ps][40]; // 33 times
  psi_v_smin[no_ps][  1] = GSL_MAX_DBL(pow(psi_sqrtsmin_opt[no_ps][16] + psi_xbsqrts[no_ps][40], 2), psi_smin_opt[no_ps][56]); // 4 times
  psi_v_smin[no_ps][  2] = GSL_MAX_DBL(pow(psi_sqrtsmin_opt[no_ps][4] + psi_xbsqrts[no_ps][40], 2), psi_smin_opt[no_ps][44]); // 4 times
  psi_v_smin[no_ps][  3] = psi_smin_opt[no_ps][20]; // 33 times
  psi_v_smin[no_ps][  4] = GSL_MAX_DBL(pow(psi_sqrtsmin_opt[no_ps][32] + psi_xbsqrts[no_ps][20], 2), psi_smin_opt[no_ps][52]); // 4 times
  psi_v_smin[no_ps][  5] = GSL_MAX_DBL(pow(psi_sqrtsmin_opt[no_ps][8] + psi_xbsqrts[no_ps][20], 2), psi_smin_opt[no_ps][28]); // 4 times

  psi_v_smax[no_ps][  0] = pow(psi_xbsqrts[no_ps][0] - psi_sqrtsmin_opt[no_ps][20], 2); // 25 times
  psi_v_smax[no_ps][  1] = pow(psi_xbsqrts[no_ps][0] - psi_sqrtsmin_opt[no_ps][4], 2); // 4 times
  psi_v_smax[no_ps][  2] = pow(psi_xbsqrts[no_ps][0] - psi_sqrtsmin_opt[no_ps][16], 2); // 4 times
  psi_v_smax[no_ps][  3] = pow(psi_xbsqrts[no_ps][0] - psi_sqrtsmin_opt[no_ps][40], 2); // 16 times
  psi_v_smax[no_ps][  4] = pow(psi_xbsqrts[no_ps][0] - psi_sqrtsmin_opt[no_ps][8], 2); // 4 times
  psi_v_smax[no_ps][  5] = pow(psi_xbsqrts[no_ps][0] - psi_sqrtsmin_opt[no_ps][32], 2); // 4 times
  psi_v_smax[no_ps][  6] = pow(psi_xbsqrts[no_ps][0] - psi_xbsqrts[no_ps][40], 2); // 17 times
  psi_v_smax[no_ps][  7] = pow(psi_xbsqrts[no_ps][0] - psi_xbsqrts[no_ps][20], 2); // 8 times

  //  vector<double> g_p(12);
  {psi_g_p[no_ps][  0] = psi.g_propagator(no_ps,   0,  40, psi_v_smin[no_ps][  0], psi_v_smax[no_ps][  0]); /* npp 2 */} // 12 times
  {psi_g_p[no_ps][  1] = psi.g_propagator(no_ps,   0,  56, psi_v_smin[no_ps][  1], psi_v_smax[no_ps][  1]); /* npp 3 */} // 4 times
  {psi_g_p[no_ps][  2] = psi.g_propagator(no_ps,  23,  40, psi_v_smin[no_ps][  0], psi_v_smax[no_ps][  0]); /* npp 2 */} // 13 times
  {psi_g_p[no_ps][  3] = psi.g_propagator(no_ps,   0,  44, psi_v_smin[no_ps][  2], psi_v_smax[no_ps][  2]); /* npp 3 */} // 4 times
  {psi_g_p[no_ps][  4] = psi.g_propagator(no_ps,   0,  20, psi_v_smin[no_ps][  3], psi_v_smax[no_ps][  3]); /* npp 2 */} // 8 times
  {psi_g_p[no_ps][  5] = psi.g_propagator(no_ps,   0,  52, psi_v_smin[no_ps][  4], psi_v_smax[no_ps][  4]); /* npp 3 */} // 4 times
  {psi_g_p[no_ps][  6] = psi.g_propagator(no_ps,  23,  20, psi_v_smin[no_ps][  3], psi_v_smax[no_ps][  3]); /* npp 2 */} // 8 times
  {psi_g_p[no_ps][  7] = psi.g_propagator(no_ps,   0,  28, psi_v_smin[no_ps][  5], psi_v_smax[no_ps][  5]); /* npp 3 */} // 4 times
  {psi_g_p[no_ps][  8] = psi.g_propagator(no_ps,   0,  20, psi_v_smin[no_ps][  3], psi_v_smax[no_ps][  6]); /* npp 2 */} // 8 times
  {psi_g_p[no_ps][  9] = psi.g_propagator(no_ps,  23,  20, psi_v_smin[no_ps][  3], psi_v_smax[no_ps][  6]); /* npp 2 */} // 9 times
  {psi_g_p[no_ps][ 10] = psi.g_propagator(no_ps,   0,  40, psi_v_smin[no_ps][  0], psi_v_smax[no_ps][  7]); /* npp 2 */} // 4 times
  {psi_g_p[no_ps][ 11] = psi.g_propagator(no_ps,  23,  40, psi_v_smin[no_ps][  0], psi_v_smax[no_ps][  7]); /* npp 2 */} // 4 times

  //  vector<double> g_f(0);

  //  vector<double> g_t(4);
  {psi_g_t[no_ps][  0] = psi.g_tchannel_opt(no_ps,   0,  60,   1,   2,  20,  40); /* ntp 0 */} // 4 times
  {psi_g_t[no_ps][  1] = psi.g_tchannel_opt(no_ps,   6,  60,   1,   2,  20,  40); /* ntp 0 */} // 4 times
  {psi_g_t[no_ps][  2] = psi.g_tchannel_opt(no_ps,   0,  60,   1,   2,  40,  20); /* ntp 0 */} // 4 times
  {psi_g_t[no_ps][  3] = psi.g_tchannel_opt(no_ps,   6,  60,   1,   2,  40,  20); /* ntp 0 */} // 4 times

  //  vector<double> g_d(11);
  {psi_g_d[no_ps][  0] = psi.g_decay(no_ps,  60,   4,  56); /* ndp 4 */} // 4 times
  {psi_g_d[no_ps][  1] = psi.g_decay(no_ps,  56,  16,  40); /* ndp 3 */} // 4 times
  {psi_g_d[no_ps][  2] = psi.g_decay(no_ps,  40,   8,  32); /* ndp 2 */} // 33 times
  {psi_g_d[no_ps][  3] = psi.g_decay(no_ps,  60,  16,  44); /* ndp 4 */} // 4 times
  {psi_g_d[no_ps][  4] = psi.g_decay(no_ps,  44,   4,  40); /* ndp 3 */} // 4 times
  {psi_g_d[no_ps][  5] = psi.g_decay(no_ps,  60,   8,  52); /* ndp 4 */} // 4 times
  {psi_g_d[no_ps][  6] = psi.g_decay(no_ps,  52,  32,  20); /* ndp 3 */} // 4 times
  {psi_g_d[no_ps][  7] = psi.g_decay(no_ps,  20,   4,  16); /* ndp 2 */} // 33 times
  {psi_g_d[no_ps][  8] = psi.g_decay(no_ps,  60,  32,  28); /* ndp 4 */} // 4 times
  {psi_g_d[no_ps][  9] = psi.g_decay(no_ps,  28,   8,  20); /* ndp 3 */} // 4 times
  {psi_g_d[no_ps][ 10] = psi.g_decay(no_ps,  60,  20,  40); /* ndp 4 */} // 9 times


  if (psi_weight_IS == 2 || psi_weight_IS == 4){
    double g_IS_temp;
    vector<vector<double> > inv_r(4);
    inv_r[0].resize(12);
    inv_r[1].resize(0);
    inv_r[2].resize(8);
    inv_r[3].resize(22);

    {psi.inv_propagator(no_ps,   0,  40, psi_v_smin[no_ps][  0], psi_v_smax[no_ps][  0], inv_r[0][0]);} // 12 times
    {psi.inv_propagator(no_ps,   0,  56, psi_v_smin[no_ps][  1], psi_v_smax[no_ps][  1], inv_r[0][1]);} // 4 times
    {psi.inv_propagator(no_ps,  23,  40, psi_v_smin[no_ps][  0], psi_v_smax[no_ps][  0], inv_r[0][2]);} // 13 times
    {psi.inv_propagator(no_ps,   0,  44, psi_v_smin[no_ps][  2], psi_v_smax[no_ps][  2], inv_r[0][3]);} // 4 times
    {psi.inv_propagator(no_ps,   0,  20, psi_v_smin[no_ps][  3], psi_v_smax[no_ps][  3], inv_r[0][4]);} // 8 times
    {psi.inv_propagator(no_ps,   0,  52, psi_v_smin[no_ps][  4], psi_v_smax[no_ps][  4], inv_r[0][5]);} // 4 times
    {psi.inv_propagator(no_ps,  23,  20, psi_v_smin[no_ps][  3], psi_v_smax[no_ps][  3], inv_r[0][6]);} // 8 times
    {psi.inv_propagator(no_ps,   0,  28, psi_v_smin[no_ps][  5], psi_v_smax[no_ps][  5], inv_r[0][7]);} // 4 times
    {psi.inv_propagator(no_ps,   0,  20, psi_v_smin[no_ps][  3], psi_v_smax[no_ps][  6], inv_r[0][8]);} // 8 times
    {psi.inv_propagator(no_ps,  23,  20, psi_v_smin[no_ps][  3], psi_v_smax[no_ps][  6], inv_r[0][9]);} // 9 times
    {psi.inv_propagator(no_ps,   0,  40, psi_v_smin[no_ps][  0], psi_v_smax[no_ps][  7], inv_r[0][10]);} // 4 times
    {psi.inv_propagator(no_ps,  23,  40, psi_v_smin[no_ps][  0], psi_v_smax[no_ps][  7], inv_r[0][11]);} // 4 times


    {psi.inv_tchannel_opt(no_ps,   0,  60,   1,   2,  20,  40, inv_r[2][0], inv_r[2][1]);} // 4 times
    {psi.inv_tchannel_opt(no_ps,   6,  60,   1,   2,  20,  40, inv_r[2][2], inv_r[2][3]);} // 4 times
    {psi.inv_tchannel_opt(no_ps,   0,  60,   1,   2,  40,  20, inv_r[2][4], inv_r[2][5]);} // 4 times
    {psi.inv_tchannel_opt(no_ps,   6,  60,   1,   2,  40,  20, inv_r[2][6], inv_r[2][7]);} // 4 times

    {psi.inv_decay(no_ps,  60,   4,  56, inv_r[3][0], inv_r[3][1]);} // 4 times
    {psi.inv_decay(no_ps,  56,  16,  40, inv_r[3][2], inv_r[3][3]);} // 4 times
    {psi.inv_decay(no_ps,  40,   8,  32, inv_r[3][4], inv_r[3][5]);} // 33 times
    {psi.inv_decay(no_ps,  60,  16,  44, inv_r[3][6], inv_r[3][7]);} // 4 times
    {psi.inv_decay(no_ps,  44,   4,  40, inv_r[3][8], inv_r[3][9]);} // 4 times
    {psi.inv_decay(no_ps,  60,   8,  52, inv_r[3][10], inv_r[3][11]);} // 4 times
    {psi.inv_decay(no_ps,  52,  32,  20, inv_r[3][12], inv_r[3][13]);} // 4 times
    {psi.inv_decay(no_ps,  20,   4,  16, inv_r[3][14], inv_r[3][15]);} // 33 times
    {psi.inv_decay(no_ps,  60,  32,  28, inv_r[3][16], inv_r[3][17]);} // 4 times
    {psi.inv_decay(no_ps,  28,   8,  20, inv_r[3][18], inv_r[3][19]);} // 4 times
    {psi.inv_decay(no_ps,  60,  20,  40, inv_r[3][20], inv_r[3][21]);} // 9 times

    if (psi_weight_IS == 2){
      int n_random = 3 * psi_n_particle - 4;;
      vector<vector<double> > inv_channel_r(41, vector<double> (8));
      vector<double> g_IS(41, 1.);
      for (int i_c = 0; i_c < 41; i_c++){
        int ran = 0;
        if (psi_MC_alpha[zero + i_c] != 0.){
          for (int i_p = 0; i_p < psi_c_p[no_ps][i_c].size(); i_p++){
            inv_channel_r[i_c][i_p] = inv_r[0][psi_c_p[no_ps][i_c][i_p]];
          }
          ran += psi_c_p[no_ps][i_c].size();
          for (int i_f = 0; i_f < psi_c_f[no_ps][i_c].size(); i_f++){
            inv_channel_r[i_c][ran + i_f] = inv_r[1][psi_c_f[no_ps][i_c][i_f]];
          }
          ran += psi_c_f[no_ps][i_c].size();
          for (int i_t = 0; i_t < psi_c_t[no_ps][i_c].size(); i_t++){
            inv_channel_r[i_c][ran + 2 * i_t] = inv_r[2][2 * psi_c_t[no_ps][i_c][i_t]];
            inv_channel_r[i_c][ran + 2 * i_t + 1] = inv_r[2][2 * psi_c_t[no_ps][i_c][i_t] + 1];
          }
          ran += 2 * psi_c_t[no_ps][i_c].size();
          for (int i_d = 0; i_d < psi_c_d[no_ps][i_c].size(); i_d++){
            inv_channel_r[i_c][ran + 2 * i_d] = inv_r[3][2 * psi_c_d[no_ps][i_c][i_d]];
            inv_channel_r[i_c][ran + 2 * i_d + 1] = inv_r[3][2 * psi_c_d[no_ps][i_c][i_d] + 1];
          }
          ran += 2 * psi_c_d[no_ps][i_c].size();
          for (int i_r = 0; i_r < 8; i_r++){
            psi_phasespace_randoms[(zero + i_c) * n_random + i_r]->get_g_IS(inv_channel_r[i_c][i_r], g_IS_temp);
            g_IS[i_c] *= g_IS_temp;
          }
        }
      }
      if (psi_MC_alpha[zero +   0] != 0.){psi_MC_g_channel[zero +   0] = g_IS[  0] * psi_g_p[no_ps][  0] * psi_g_p[no_ps][  1] * psi_g_d[no_ps][  0] * psi_g_d[no_ps][  1] * psi_g_d[no_ps][  2];}
      if (psi_MC_alpha[zero +   1] != 0.){psi_MC_g_channel[zero +   1] = g_IS[  1] * psi_g_p[no_ps][  0] * psi_g_p[no_ps][  1] * psi_g_d[no_ps][  0] * psi_g_d[no_ps][  1] * psi_g_d[no_ps][  2];}
      if (psi_MC_alpha[zero +   2] != 0.){psi_MC_g_channel[zero +   2] = g_IS[  2] * psi_g_p[no_ps][  2] * psi_g_p[no_ps][  1] * psi_g_d[no_ps][  0] * psi_g_d[no_ps][  1] * psi_g_d[no_ps][  2];}
      if (psi_MC_alpha[zero +   3] != 0.){psi_MC_g_channel[zero +   3] = g_IS[  3] * psi_g_p[no_ps][  2] * psi_g_p[no_ps][  1] * psi_g_d[no_ps][  0] * psi_g_d[no_ps][  1] * psi_g_d[no_ps][  2];}
      if (psi_MC_alpha[zero +   4] != 0.){psi_MC_g_channel[zero +   4] = g_IS[  4] * psi_g_p[no_ps][  0] * psi_g_p[no_ps][  3] * psi_g_d[no_ps][  3] * psi_g_d[no_ps][  4] * psi_g_d[no_ps][  2];}
      if (psi_MC_alpha[zero +   5] != 0.){psi_MC_g_channel[zero +   5] = g_IS[  5] * psi_g_p[no_ps][  0] * psi_g_p[no_ps][  3] * psi_g_d[no_ps][  3] * psi_g_d[no_ps][  4] * psi_g_d[no_ps][  2];}
      if (psi_MC_alpha[zero +   6] != 0.){psi_MC_g_channel[zero +   6] = g_IS[  6] * psi_g_p[no_ps][  2] * psi_g_p[no_ps][  3] * psi_g_d[no_ps][  3] * psi_g_d[no_ps][  4] * psi_g_d[no_ps][  2];}
      if (psi_MC_alpha[zero +   7] != 0.){psi_MC_g_channel[zero +   7] = g_IS[  7] * psi_g_p[no_ps][  2] * psi_g_p[no_ps][  3] * psi_g_d[no_ps][  3] * psi_g_d[no_ps][  4] * psi_g_d[no_ps][  2];}
      if (psi_MC_alpha[zero +   8] != 0.){psi_MC_g_channel[zero +   8] = g_IS[  8] * psi_g_p[no_ps][  4] * psi_g_p[no_ps][  5] * psi_g_d[no_ps][  5] * psi_g_d[no_ps][  6] * psi_g_d[no_ps][  7];}
      if (psi_MC_alpha[zero +   9] != 0.){psi_MC_g_channel[zero +   9] = g_IS[  9] * psi_g_p[no_ps][  4] * psi_g_p[no_ps][  5] * psi_g_d[no_ps][  5] * psi_g_d[no_ps][  6] * psi_g_d[no_ps][  7];}
      if (psi_MC_alpha[zero +  10] != 0.){psi_MC_g_channel[zero +  10] = g_IS[ 10] * psi_g_p[no_ps][  6] * psi_g_p[no_ps][  5] * psi_g_d[no_ps][  5] * psi_g_d[no_ps][  6] * psi_g_d[no_ps][  7];}
      if (psi_MC_alpha[zero +  11] != 0.){psi_MC_g_channel[zero +  11] = g_IS[ 11] * psi_g_p[no_ps][  6] * psi_g_p[no_ps][  5] * psi_g_d[no_ps][  5] * psi_g_d[no_ps][  6] * psi_g_d[no_ps][  7];}
      if (psi_MC_alpha[zero +  12] != 0.){psi_MC_g_channel[zero +  12] = g_IS[ 12] * psi_g_p[no_ps][  4] * psi_g_p[no_ps][  7] * psi_g_d[no_ps][  8] * psi_g_d[no_ps][  9] * psi_g_d[no_ps][  7];}
      if (psi_MC_alpha[zero +  13] != 0.){psi_MC_g_channel[zero +  13] = g_IS[ 13] * psi_g_p[no_ps][  4] * psi_g_p[no_ps][  7] * psi_g_d[no_ps][  8] * psi_g_d[no_ps][  9] * psi_g_d[no_ps][  7];}
      if (psi_MC_alpha[zero +  14] != 0.){psi_MC_g_channel[zero +  14] = g_IS[ 14] * psi_g_p[no_ps][  6] * psi_g_p[no_ps][  7] * psi_g_d[no_ps][  8] * psi_g_d[no_ps][  9] * psi_g_d[no_ps][  7];}
      if (psi_MC_alpha[zero +  15] != 0.){psi_MC_g_channel[zero +  15] = g_IS[ 15] * psi_g_p[no_ps][  6] * psi_g_p[no_ps][  7] * psi_g_d[no_ps][  8] * psi_g_d[no_ps][  9] * psi_g_d[no_ps][  7];}
      if (psi_MC_alpha[zero +  16] != 0.){psi_MC_g_channel[zero +  16] = g_IS[ 16] * psi_g_p[no_ps][  0] * psi_g_p[no_ps][  8] * psi_g_d[no_ps][ 10] * psi_g_d[no_ps][  7] * psi_g_d[no_ps][  2];}
      if (psi_MC_alpha[zero +  17] != 0.){psi_MC_g_channel[zero +  17] = g_IS[ 17] * psi_g_p[no_ps][  0] * psi_g_p[no_ps][  8] * psi_g_d[no_ps][ 10] * psi_g_d[no_ps][  7] * psi_g_d[no_ps][  2];}
      if (psi_MC_alpha[zero +  18] != 0.){psi_MC_g_channel[zero +  18] = g_IS[ 18] * psi_g_p[no_ps][  0] * psi_g_p[no_ps][  9] * psi_g_d[no_ps][ 10] * psi_g_d[no_ps][  7] * psi_g_d[no_ps][  2];}
      if (psi_MC_alpha[zero +  19] != 0.){psi_MC_g_channel[zero +  19] = g_IS[ 19] * psi_g_p[no_ps][  0] * psi_g_p[no_ps][  9] * psi_g_d[no_ps][ 10] * psi_g_d[no_ps][  7] * psi_g_d[no_ps][  2];}
      if (psi_MC_alpha[zero +  20] != 0.){psi_MC_g_channel[zero +  20] = g_IS[ 20] * psi_g_p[no_ps][  2] * psi_g_p[no_ps][  8] * psi_g_d[no_ps][ 10] * psi_g_d[no_ps][  7] * psi_g_d[no_ps][  2];}
      if (psi_MC_alpha[zero +  21] != 0.){psi_MC_g_channel[zero +  21] = g_IS[ 21] * psi_g_p[no_ps][  2] * psi_g_p[no_ps][  8] * psi_g_d[no_ps][ 10] * psi_g_d[no_ps][  7] * psi_g_d[no_ps][  2];}
      if (psi_MC_alpha[zero +  22] != 0.){psi_MC_g_channel[zero +  22] = g_IS[ 22] * psi_g_p[no_ps][  2] * psi_g_p[no_ps][  9] * psi_g_d[no_ps][ 10] * psi_g_d[no_ps][  7] * psi_g_d[no_ps][  2];}
      if (psi_MC_alpha[zero +  23] != 0.){psi_MC_g_channel[zero +  23] = g_IS[ 23] * psi_g_p[no_ps][  2] * psi_g_p[no_ps][  9] * psi_g_d[no_ps][ 10] * psi_g_d[no_ps][  7] * psi_g_d[no_ps][  2];}
      if (psi_MC_alpha[zero +  24] != 0.){psi_MC_g_channel[zero +  24] = g_IS[ 24] * psi_g_p[no_ps][  2] * psi_g_p[no_ps][  9] * psi_g_d[no_ps][ 10] * psi_g_d[no_ps][  7] * psi_g_d[no_ps][  2];}
      if (psi_MC_alpha[zero +  25] != 0.){psi_MC_g_channel[zero +  25] = g_IS[ 25] * psi_g_p[no_ps][  0] * psi_g_p[no_ps][  8] * psi_g_t[no_ps][  0] * psi_g_d[no_ps][  7] * psi_g_d[no_ps][  2];}
      if (psi_MC_alpha[zero +  26] != 0.){psi_MC_g_channel[zero +  26] = g_IS[ 26] * psi_g_p[no_ps][  0] * psi_g_p[no_ps][  8] * psi_g_t[no_ps][  1] * psi_g_d[no_ps][  7] * psi_g_d[no_ps][  2];}
      if (psi_MC_alpha[zero +  27] != 0.){psi_MC_g_channel[zero +  27] = g_IS[ 27] * psi_g_p[no_ps][  0] * psi_g_p[no_ps][  9] * psi_g_t[no_ps][  0] * psi_g_d[no_ps][  7] * psi_g_d[no_ps][  2];}
      if (psi_MC_alpha[zero +  28] != 0.){psi_MC_g_channel[zero +  28] = g_IS[ 28] * psi_g_p[no_ps][  0] * psi_g_p[no_ps][  9] * psi_g_t[no_ps][  1] * psi_g_d[no_ps][  7] * psi_g_d[no_ps][  2];}
      if (psi_MC_alpha[zero +  29] != 0.){psi_MC_g_channel[zero +  29] = g_IS[ 29] * psi_g_p[no_ps][  2] * psi_g_p[no_ps][  8] * psi_g_t[no_ps][  0] * psi_g_d[no_ps][  7] * psi_g_d[no_ps][  2];}
      if (psi_MC_alpha[zero +  30] != 0.){psi_MC_g_channel[zero +  30] = g_IS[ 30] * psi_g_p[no_ps][  2] * psi_g_p[no_ps][  8] * psi_g_t[no_ps][  1] * psi_g_d[no_ps][  7] * psi_g_d[no_ps][  2];}
      if (psi_MC_alpha[zero +  31] != 0.){psi_MC_g_channel[zero +  31] = g_IS[ 31] * psi_g_p[no_ps][  2] * psi_g_p[no_ps][  9] * psi_g_t[no_ps][  0] * psi_g_d[no_ps][  7] * psi_g_d[no_ps][  2];}
      if (psi_MC_alpha[zero +  32] != 0.){psi_MC_g_channel[zero +  32] = g_IS[ 32] * psi_g_p[no_ps][  2] * psi_g_p[no_ps][  9] * psi_g_t[no_ps][  1] * psi_g_d[no_ps][  7] * psi_g_d[no_ps][  2];}
      if (psi_MC_alpha[zero +  33] != 0.){psi_MC_g_channel[zero +  33] = g_IS[ 33] * psi_g_p[no_ps][  4] * psi_g_p[no_ps][ 10] * psi_g_t[no_ps][  2] * psi_g_d[no_ps][  2] * psi_g_d[no_ps][  7];}
      if (psi_MC_alpha[zero +  34] != 0.){psi_MC_g_channel[zero +  34] = g_IS[ 34] * psi_g_p[no_ps][  4] * psi_g_p[no_ps][ 10] * psi_g_t[no_ps][  3] * psi_g_d[no_ps][  2] * psi_g_d[no_ps][  7];}
      if (psi_MC_alpha[zero +  35] != 0.){psi_MC_g_channel[zero +  35] = g_IS[ 35] * psi_g_p[no_ps][  4] * psi_g_p[no_ps][ 11] * psi_g_t[no_ps][  2] * psi_g_d[no_ps][  2] * psi_g_d[no_ps][  7];}
      if (psi_MC_alpha[zero +  36] != 0.){psi_MC_g_channel[zero +  36] = g_IS[ 36] * psi_g_p[no_ps][  4] * psi_g_p[no_ps][ 11] * psi_g_t[no_ps][  3] * psi_g_d[no_ps][  2] * psi_g_d[no_ps][  7];}
      if (psi_MC_alpha[zero +  37] != 0.){psi_MC_g_channel[zero +  37] = g_IS[ 37] * psi_g_p[no_ps][  6] * psi_g_p[no_ps][ 10] * psi_g_t[no_ps][  2] * psi_g_d[no_ps][  2] * psi_g_d[no_ps][  7];}
      if (psi_MC_alpha[zero +  38] != 0.){psi_MC_g_channel[zero +  38] = g_IS[ 38] * psi_g_p[no_ps][  6] * psi_g_p[no_ps][ 10] * psi_g_t[no_ps][  3] * psi_g_d[no_ps][  2] * psi_g_d[no_ps][  7];}
      if (psi_MC_alpha[zero +  39] != 0.){psi_MC_g_channel[zero +  39] = g_IS[ 39] * psi_g_p[no_ps][  6] * psi_g_p[no_ps][ 11] * psi_g_t[no_ps][  2] * psi_g_d[no_ps][  2] * psi_g_d[no_ps][  7];}
      if (psi_MC_alpha[zero +  40] != 0.){psi_MC_g_channel[zero +  40] = g_IS[ 40] * psi_g_p[no_ps][  6] * psi_g_p[no_ps][ 11] * psi_g_t[no_ps][  3] * psi_g_d[no_ps][  2] * psi_g_d[no_ps][  7];}

    }
    else if (psi_weight_IS == 4){
      vector<vector<double> > g_IS(4);
      g_IS[0].resize(12, 1.);
      g_IS[1].resize(0, 1.);
      g_IS[2].resize(4, 1.);
      g_IS[3].resize(11, 1.);

      for (int i_m = 0; i_m < 4; i_m++){
        for (int i_r = 0; i_r < inv_r[i_m].size(); i_r++){
          psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][i_m] + i_r]->get_g_IS(inv_r[i_m][i_r], g_IS_temp);
          int i_g = i_r;
          if (i_m > 1){i_g = i_r / 2;}
          g_IS[i_m][i_g] *= g_IS_temp;
        }
      }
      if (psi_MC_alpha[zero +   0] != 0.){psi_MC_g_channel[zero +   0] = psi_g_p[no_ps][  0] * g_IS[0][  0] * psi_g_p[no_ps][  1] * g_IS[0][  1] * psi_g_d[no_ps][  0] * g_IS[3][  0] * psi_g_d[no_ps][  1] * g_IS[3][  1] * psi_g_d[no_ps][  2] * g_IS[3][  2];}
      if (psi_MC_alpha[zero +   1] != 0.){psi_MC_g_channel[zero +   1] = psi_g_p[no_ps][  0] * g_IS[0][  0] * psi_g_p[no_ps][  1] * g_IS[0][  1] * psi_g_d[no_ps][  0] * g_IS[3][  0] * psi_g_d[no_ps][  1] * g_IS[3][  1] * psi_g_d[no_ps][  2] * g_IS[3][  2];}
      if (psi_MC_alpha[zero +   2] != 0.){psi_MC_g_channel[zero +   2] = psi_g_p[no_ps][  2] * g_IS[0][  2] * psi_g_p[no_ps][  1] * g_IS[0][  1] * psi_g_d[no_ps][  0] * g_IS[3][  0] * psi_g_d[no_ps][  1] * g_IS[3][  1] * psi_g_d[no_ps][  2] * g_IS[3][  2];}
      if (psi_MC_alpha[zero +   3] != 0.){psi_MC_g_channel[zero +   3] = psi_g_p[no_ps][  2] * g_IS[0][  2] * psi_g_p[no_ps][  1] * g_IS[0][  1] * psi_g_d[no_ps][  0] * g_IS[3][  0] * psi_g_d[no_ps][  1] * g_IS[3][  1] * psi_g_d[no_ps][  2] * g_IS[3][  2];}
      if (psi_MC_alpha[zero +   4] != 0.){psi_MC_g_channel[zero +   4] = psi_g_p[no_ps][  0] * g_IS[0][  0] * psi_g_p[no_ps][  3] * g_IS[0][  3] * psi_g_d[no_ps][  3] * g_IS[3][  3] * psi_g_d[no_ps][  4] * g_IS[3][  4] * psi_g_d[no_ps][  2] * g_IS[3][  2];}
      if (psi_MC_alpha[zero +   5] != 0.){psi_MC_g_channel[zero +   5] = psi_g_p[no_ps][  0] * g_IS[0][  0] * psi_g_p[no_ps][  3] * g_IS[0][  3] * psi_g_d[no_ps][  3] * g_IS[3][  3] * psi_g_d[no_ps][  4] * g_IS[3][  4] * psi_g_d[no_ps][  2] * g_IS[3][  2];}
      if (psi_MC_alpha[zero +   6] != 0.){psi_MC_g_channel[zero +   6] = psi_g_p[no_ps][  2] * g_IS[0][  2] * psi_g_p[no_ps][  3] * g_IS[0][  3] * psi_g_d[no_ps][  3] * g_IS[3][  3] * psi_g_d[no_ps][  4] * g_IS[3][  4] * psi_g_d[no_ps][  2] * g_IS[3][  2];}
      if (psi_MC_alpha[zero +   7] != 0.){psi_MC_g_channel[zero +   7] = psi_g_p[no_ps][  2] * g_IS[0][  2] * psi_g_p[no_ps][  3] * g_IS[0][  3] * psi_g_d[no_ps][  3] * g_IS[3][  3] * psi_g_d[no_ps][  4] * g_IS[3][  4] * psi_g_d[no_ps][  2] * g_IS[3][  2];}
      if (psi_MC_alpha[zero +   8] != 0.){psi_MC_g_channel[zero +   8] = psi_g_p[no_ps][  4] * g_IS[0][  4] * psi_g_p[no_ps][  5] * g_IS[0][  5] * psi_g_d[no_ps][  5] * g_IS[3][  5] * psi_g_d[no_ps][  6] * g_IS[3][  6] * psi_g_d[no_ps][  7] * g_IS[3][  7];}
      if (psi_MC_alpha[zero +   9] != 0.){psi_MC_g_channel[zero +   9] = psi_g_p[no_ps][  4] * g_IS[0][  4] * psi_g_p[no_ps][  5] * g_IS[0][  5] * psi_g_d[no_ps][  5] * g_IS[3][  5] * psi_g_d[no_ps][  6] * g_IS[3][  6] * psi_g_d[no_ps][  7] * g_IS[3][  7];}
      if (psi_MC_alpha[zero +  10] != 0.){psi_MC_g_channel[zero +  10] = psi_g_p[no_ps][  6] * g_IS[0][  6] * psi_g_p[no_ps][  5] * g_IS[0][  5] * psi_g_d[no_ps][  5] * g_IS[3][  5] * psi_g_d[no_ps][  6] * g_IS[3][  6] * psi_g_d[no_ps][  7] * g_IS[3][  7];}
      if (psi_MC_alpha[zero +  11] != 0.){psi_MC_g_channel[zero +  11] = psi_g_p[no_ps][  6] * g_IS[0][  6] * psi_g_p[no_ps][  5] * g_IS[0][  5] * psi_g_d[no_ps][  5] * g_IS[3][  5] * psi_g_d[no_ps][  6] * g_IS[3][  6] * psi_g_d[no_ps][  7] * g_IS[3][  7];}
      if (psi_MC_alpha[zero +  12] != 0.){psi_MC_g_channel[zero +  12] = psi_g_p[no_ps][  4] * g_IS[0][  4] * psi_g_p[no_ps][  7] * g_IS[0][  7] * psi_g_d[no_ps][  8] * g_IS[3][  8] * psi_g_d[no_ps][  9] * g_IS[3][  9] * psi_g_d[no_ps][  7] * g_IS[3][  7];}
      if (psi_MC_alpha[zero +  13] != 0.){psi_MC_g_channel[zero +  13] = psi_g_p[no_ps][  4] * g_IS[0][  4] * psi_g_p[no_ps][  7] * g_IS[0][  7] * psi_g_d[no_ps][  8] * g_IS[3][  8] * psi_g_d[no_ps][  9] * g_IS[3][  9] * psi_g_d[no_ps][  7] * g_IS[3][  7];}
      if (psi_MC_alpha[zero +  14] != 0.){psi_MC_g_channel[zero +  14] = psi_g_p[no_ps][  6] * g_IS[0][  6] * psi_g_p[no_ps][  7] * g_IS[0][  7] * psi_g_d[no_ps][  8] * g_IS[3][  8] * psi_g_d[no_ps][  9] * g_IS[3][  9] * psi_g_d[no_ps][  7] * g_IS[3][  7];}
      if (psi_MC_alpha[zero +  15] != 0.){psi_MC_g_channel[zero +  15] = psi_g_p[no_ps][  6] * g_IS[0][  6] * psi_g_p[no_ps][  7] * g_IS[0][  7] * psi_g_d[no_ps][  8] * g_IS[3][  8] * psi_g_d[no_ps][  9] * g_IS[3][  9] * psi_g_d[no_ps][  7] * g_IS[3][  7];}
      if (psi_MC_alpha[zero +  16] != 0.){psi_MC_g_channel[zero +  16] = psi_g_p[no_ps][  0] * g_IS[0][  0] * psi_g_p[no_ps][  8] * g_IS[0][  8] * psi_g_d[no_ps][ 10] * g_IS[3][ 10] * psi_g_d[no_ps][  7] * g_IS[3][  7] * psi_g_d[no_ps][  2] * g_IS[3][  2];}
      if (psi_MC_alpha[zero +  17] != 0.){psi_MC_g_channel[zero +  17] = psi_g_p[no_ps][  0] * g_IS[0][  0] * psi_g_p[no_ps][  8] * g_IS[0][  8] * psi_g_d[no_ps][ 10] * g_IS[3][ 10] * psi_g_d[no_ps][  7] * g_IS[3][  7] * psi_g_d[no_ps][  2] * g_IS[3][  2];}
      if (psi_MC_alpha[zero +  18] != 0.){psi_MC_g_channel[zero +  18] = psi_g_p[no_ps][  0] * g_IS[0][  0] * psi_g_p[no_ps][  9] * g_IS[0][  9] * psi_g_d[no_ps][ 10] * g_IS[3][ 10] * psi_g_d[no_ps][  7] * g_IS[3][  7] * psi_g_d[no_ps][  2] * g_IS[3][  2];}
      if (psi_MC_alpha[zero +  19] != 0.){psi_MC_g_channel[zero +  19] = psi_g_p[no_ps][  0] * g_IS[0][  0] * psi_g_p[no_ps][  9] * g_IS[0][  9] * psi_g_d[no_ps][ 10] * g_IS[3][ 10] * psi_g_d[no_ps][  7] * g_IS[3][  7] * psi_g_d[no_ps][  2] * g_IS[3][  2];}
      if (psi_MC_alpha[zero +  20] != 0.){psi_MC_g_channel[zero +  20] = psi_g_p[no_ps][  2] * g_IS[0][  2] * psi_g_p[no_ps][  8] * g_IS[0][  8] * psi_g_d[no_ps][ 10] * g_IS[3][ 10] * psi_g_d[no_ps][  7] * g_IS[3][  7] * psi_g_d[no_ps][  2] * g_IS[3][  2];}
      if (psi_MC_alpha[zero +  21] != 0.){psi_MC_g_channel[zero +  21] = psi_g_p[no_ps][  2] * g_IS[0][  2] * psi_g_p[no_ps][  8] * g_IS[0][  8] * psi_g_d[no_ps][ 10] * g_IS[3][ 10] * psi_g_d[no_ps][  7] * g_IS[3][  7] * psi_g_d[no_ps][  2] * g_IS[3][  2];}
      if (psi_MC_alpha[zero +  22] != 0.){psi_MC_g_channel[zero +  22] = psi_g_p[no_ps][  2] * g_IS[0][  2] * psi_g_p[no_ps][  9] * g_IS[0][  9] * psi_g_d[no_ps][ 10] * g_IS[3][ 10] * psi_g_d[no_ps][  7] * g_IS[3][  7] * psi_g_d[no_ps][  2] * g_IS[3][  2];}
      if (psi_MC_alpha[zero +  23] != 0.){psi_MC_g_channel[zero +  23] = psi_g_p[no_ps][  2] * g_IS[0][  2] * psi_g_p[no_ps][  9] * g_IS[0][  9] * psi_g_d[no_ps][ 10] * g_IS[3][ 10] * psi_g_d[no_ps][  7] * g_IS[3][  7] * psi_g_d[no_ps][  2] * g_IS[3][  2];}
      if (psi_MC_alpha[zero +  24] != 0.){psi_MC_g_channel[zero +  24] = psi_g_p[no_ps][  2] * g_IS[0][  2] * psi_g_p[no_ps][  9] * g_IS[0][  9] * psi_g_d[no_ps][ 10] * g_IS[3][ 10] * psi_g_d[no_ps][  7] * g_IS[3][  7] * psi_g_d[no_ps][  2] * g_IS[3][  2];}
      if (psi_MC_alpha[zero +  25] != 0.){psi_MC_g_channel[zero +  25] = psi_g_p[no_ps][  0] * g_IS[0][  0] * psi_g_p[no_ps][  8] * g_IS[0][  8] * psi_g_t[no_ps][  0] * g_IS[2][  0] * psi_g_d[no_ps][  7] * g_IS[3][  7] * psi_g_d[no_ps][  2] * g_IS[3][  2];}
      if (psi_MC_alpha[zero +  26] != 0.){psi_MC_g_channel[zero +  26] = psi_g_p[no_ps][  0] * g_IS[0][  0] * psi_g_p[no_ps][  8] * g_IS[0][  8] * psi_g_t[no_ps][  1] * g_IS[2][  1] * psi_g_d[no_ps][  7] * g_IS[3][  7] * psi_g_d[no_ps][  2] * g_IS[3][  2];}
      if (psi_MC_alpha[zero +  27] != 0.){psi_MC_g_channel[zero +  27] = psi_g_p[no_ps][  0] * g_IS[0][  0] * psi_g_p[no_ps][  9] * g_IS[0][  9] * psi_g_t[no_ps][  0] * g_IS[2][  0] * psi_g_d[no_ps][  7] * g_IS[3][  7] * psi_g_d[no_ps][  2] * g_IS[3][  2];}
      if (psi_MC_alpha[zero +  28] != 0.){psi_MC_g_channel[zero +  28] = psi_g_p[no_ps][  0] * g_IS[0][  0] * psi_g_p[no_ps][  9] * g_IS[0][  9] * psi_g_t[no_ps][  1] * g_IS[2][  1] * psi_g_d[no_ps][  7] * g_IS[3][  7] * psi_g_d[no_ps][  2] * g_IS[3][  2];}
      if (psi_MC_alpha[zero +  29] != 0.){psi_MC_g_channel[zero +  29] = psi_g_p[no_ps][  2] * g_IS[0][  2] * psi_g_p[no_ps][  8] * g_IS[0][  8] * psi_g_t[no_ps][  0] * g_IS[2][  0] * psi_g_d[no_ps][  7] * g_IS[3][  7] * psi_g_d[no_ps][  2] * g_IS[3][  2];}
      if (psi_MC_alpha[zero +  30] != 0.){psi_MC_g_channel[zero +  30] = psi_g_p[no_ps][  2] * g_IS[0][  2] * psi_g_p[no_ps][  8] * g_IS[0][  8] * psi_g_t[no_ps][  1] * g_IS[2][  1] * psi_g_d[no_ps][  7] * g_IS[3][  7] * psi_g_d[no_ps][  2] * g_IS[3][  2];}
      if (psi_MC_alpha[zero +  31] != 0.){psi_MC_g_channel[zero +  31] = psi_g_p[no_ps][  2] * g_IS[0][  2] * psi_g_p[no_ps][  9] * g_IS[0][  9] * psi_g_t[no_ps][  0] * g_IS[2][  0] * psi_g_d[no_ps][  7] * g_IS[3][  7] * psi_g_d[no_ps][  2] * g_IS[3][  2];}
      if (psi_MC_alpha[zero +  32] != 0.){psi_MC_g_channel[zero +  32] = psi_g_p[no_ps][  2] * g_IS[0][  2] * psi_g_p[no_ps][  9] * g_IS[0][  9] * psi_g_t[no_ps][  1] * g_IS[2][  1] * psi_g_d[no_ps][  7] * g_IS[3][  7] * psi_g_d[no_ps][  2] * g_IS[3][  2];}
      if (psi_MC_alpha[zero +  33] != 0.){psi_MC_g_channel[zero +  33] = psi_g_p[no_ps][  4] * g_IS[0][  4] * psi_g_p[no_ps][ 10] * g_IS[0][ 10] * psi_g_t[no_ps][  2] * g_IS[2][  2] * psi_g_d[no_ps][  2] * g_IS[3][  2] * psi_g_d[no_ps][  7] * g_IS[3][  7];}
      if (psi_MC_alpha[zero +  34] != 0.){psi_MC_g_channel[zero +  34] = psi_g_p[no_ps][  4] * g_IS[0][  4] * psi_g_p[no_ps][ 10] * g_IS[0][ 10] * psi_g_t[no_ps][  3] * g_IS[2][  3] * psi_g_d[no_ps][  2] * g_IS[3][  2] * psi_g_d[no_ps][  7] * g_IS[3][  7];}
      if (psi_MC_alpha[zero +  35] != 0.){psi_MC_g_channel[zero +  35] = psi_g_p[no_ps][  4] * g_IS[0][  4] * psi_g_p[no_ps][ 11] * g_IS[0][ 11] * psi_g_t[no_ps][  2] * g_IS[2][  2] * psi_g_d[no_ps][  2] * g_IS[3][  2] * psi_g_d[no_ps][  7] * g_IS[3][  7];}
      if (psi_MC_alpha[zero +  36] != 0.){psi_MC_g_channel[zero +  36] = psi_g_p[no_ps][  4] * g_IS[0][  4] * psi_g_p[no_ps][ 11] * g_IS[0][ 11] * psi_g_t[no_ps][  3] * g_IS[2][  3] * psi_g_d[no_ps][  2] * g_IS[3][  2] * psi_g_d[no_ps][  7] * g_IS[3][  7];}
      if (psi_MC_alpha[zero +  37] != 0.){psi_MC_g_channel[zero +  37] = psi_g_p[no_ps][  6] * g_IS[0][  6] * psi_g_p[no_ps][ 10] * g_IS[0][ 10] * psi_g_t[no_ps][  2] * g_IS[2][  2] * psi_g_d[no_ps][  2] * g_IS[3][  2] * psi_g_d[no_ps][  7] * g_IS[3][  7];}
      if (psi_MC_alpha[zero +  38] != 0.){psi_MC_g_channel[zero +  38] = psi_g_p[no_ps][  6] * g_IS[0][  6] * psi_g_p[no_ps][ 10] * g_IS[0][ 10] * psi_g_t[no_ps][  3] * g_IS[2][  3] * psi_g_d[no_ps][  2] * g_IS[3][  2] * psi_g_d[no_ps][  7] * g_IS[3][  7];}
      if (psi_MC_alpha[zero +  39] != 0.){psi_MC_g_channel[zero +  39] = psi_g_p[no_ps][  6] * g_IS[0][  6] * psi_g_p[no_ps][ 11] * g_IS[0][ 11] * psi_g_t[no_ps][  2] * g_IS[2][  2] * psi_g_d[no_ps][  2] * g_IS[3][  2] * psi_g_d[no_ps][  7] * g_IS[3][  7];}
      if (psi_MC_alpha[zero +  40] != 0.){psi_MC_g_channel[zero +  40] = psi_g_p[no_ps][  6] * g_IS[0][  6] * psi_g_p[no_ps][ 11] * g_IS[0][ 11] * psi_g_t[no_ps][  3] * g_IS[2][  3] * psi_g_d[no_ps][  2] * g_IS[3][  2] * psi_g_d[no_ps][  7] * g_IS[3][  7];}
    }
  }

  else {
    if (psi_MC_alpha[zero +   0] != 0.){psi_MC_g_channel[zero +   0] = psi_g_p[no_ps][  0] * psi_g_p[no_ps][  1] * psi_g_d[no_ps][  0] * psi_g_d[no_ps][  1] * psi_g_d[no_ps][  2];}
    if (psi_MC_alpha[zero +   1] != 0.){psi_MC_g_channel[zero +   1] = psi_g_p[no_ps][  0] * psi_g_p[no_ps][  1] * psi_g_d[no_ps][  0] * psi_g_d[no_ps][  1] * psi_g_d[no_ps][  2];}
    if (psi_MC_alpha[zero +   2] != 0.){psi_MC_g_channel[zero +   2] = psi_g_p[no_ps][  2] * psi_g_p[no_ps][  1] * psi_g_d[no_ps][  0] * psi_g_d[no_ps][  1] * psi_g_d[no_ps][  2];}
    if (psi_MC_alpha[zero +   3] != 0.){psi_MC_g_channel[zero +   3] = psi_g_p[no_ps][  2] * psi_g_p[no_ps][  1] * psi_g_d[no_ps][  0] * psi_g_d[no_ps][  1] * psi_g_d[no_ps][  2];}
    if (psi_MC_alpha[zero +   4] != 0.){psi_MC_g_channel[zero +   4] = psi_g_p[no_ps][  0] * psi_g_p[no_ps][  3] * psi_g_d[no_ps][  3] * psi_g_d[no_ps][  4] * psi_g_d[no_ps][  2];}
    if (psi_MC_alpha[zero +   5] != 0.){psi_MC_g_channel[zero +   5] = psi_g_p[no_ps][  0] * psi_g_p[no_ps][  3] * psi_g_d[no_ps][  3] * psi_g_d[no_ps][  4] * psi_g_d[no_ps][  2];}
    if (psi_MC_alpha[zero +   6] != 0.){psi_MC_g_channel[zero +   6] = psi_g_p[no_ps][  2] * psi_g_p[no_ps][  3] * psi_g_d[no_ps][  3] * psi_g_d[no_ps][  4] * psi_g_d[no_ps][  2];}
    if (psi_MC_alpha[zero +   7] != 0.){psi_MC_g_channel[zero +   7] = psi_g_p[no_ps][  2] * psi_g_p[no_ps][  3] * psi_g_d[no_ps][  3] * psi_g_d[no_ps][  4] * psi_g_d[no_ps][  2];}
    if (psi_MC_alpha[zero +   8] != 0.){psi_MC_g_channel[zero +   8] = psi_g_p[no_ps][  4] * psi_g_p[no_ps][  5] * psi_g_d[no_ps][  5] * psi_g_d[no_ps][  6] * psi_g_d[no_ps][  7];}
    if (psi_MC_alpha[zero +   9] != 0.){psi_MC_g_channel[zero +   9] = psi_g_p[no_ps][  4] * psi_g_p[no_ps][  5] * psi_g_d[no_ps][  5] * psi_g_d[no_ps][  6] * psi_g_d[no_ps][  7];}
    if (psi_MC_alpha[zero +  10] != 0.){psi_MC_g_channel[zero +  10] = psi_g_p[no_ps][  6] * psi_g_p[no_ps][  5] * psi_g_d[no_ps][  5] * psi_g_d[no_ps][  6] * psi_g_d[no_ps][  7];}
    if (psi_MC_alpha[zero +  11] != 0.){psi_MC_g_channel[zero +  11] = psi_g_p[no_ps][  6] * psi_g_p[no_ps][  5] * psi_g_d[no_ps][  5] * psi_g_d[no_ps][  6] * psi_g_d[no_ps][  7];}
    if (psi_MC_alpha[zero +  12] != 0.){psi_MC_g_channel[zero +  12] = psi_g_p[no_ps][  4] * psi_g_p[no_ps][  7] * psi_g_d[no_ps][  8] * psi_g_d[no_ps][  9] * psi_g_d[no_ps][  7];}
    if (psi_MC_alpha[zero +  13] != 0.){psi_MC_g_channel[zero +  13] = psi_g_p[no_ps][  4] * psi_g_p[no_ps][  7] * psi_g_d[no_ps][  8] * psi_g_d[no_ps][  9] * psi_g_d[no_ps][  7];}
    if (psi_MC_alpha[zero +  14] != 0.){psi_MC_g_channel[zero +  14] = psi_g_p[no_ps][  6] * psi_g_p[no_ps][  7] * psi_g_d[no_ps][  8] * psi_g_d[no_ps][  9] * psi_g_d[no_ps][  7];}
    if (psi_MC_alpha[zero +  15] != 0.){psi_MC_g_channel[zero +  15] = psi_g_p[no_ps][  6] * psi_g_p[no_ps][  7] * psi_g_d[no_ps][  8] * psi_g_d[no_ps][  9] * psi_g_d[no_ps][  7];}
    if (psi_MC_alpha[zero +  16] != 0.){psi_MC_g_channel[zero +  16] = psi_g_p[no_ps][  0] * psi_g_p[no_ps][  8] * psi_g_d[no_ps][ 10] * psi_g_d[no_ps][  7] * psi_g_d[no_ps][  2];}
    if (psi_MC_alpha[zero +  17] != 0.){psi_MC_g_channel[zero +  17] = psi_g_p[no_ps][  0] * psi_g_p[no_ps][  8] * psi_g_d[no_ps][ 10] * psi_g_d[no_ps][  7] * psi_g_d[no_ps][  2];}
    if (psi_MC_alpha[zero +  18] != 0.){psi_MC_g_channel[zero +  18] = psi_g_p[no_ps][  0] * psi_g_p[no_ps][  9] * psi_g_d[no_ps][ 10] * psi_g_d[no_ps][  7] * psi_g_d[no_ps][  2];}
    if (psi_MC_alpha[zero +  19] != 0.){psi_MC_g_channel[zero +  19] = psi_g_p[no_ps][  0] * psi_g_p[no_ps][  9] * psi_g_d[no_ps][ 10] * psi_g_d[no_ps][  7] * psi_g_d[no_ps][  2];}
    if (psi_MC_alpha[zero +  20] != 0.){psi_MC_g_channel[zero +  20] = psi_g_p[no_ps][  2] * psi_g_p[no_ps][  8] * psi_g_d[no_ps][ 10] * psi_g_d[no_ps][  7] * psi_g_d[no_ps][  2];}
    if (psi_MC_alpha[zero +  21] != 0.){psi_MC_g_channel[zero +  21] = psi_g_p[no_ps][  2] * psi_g_p[no_ps][  8] * psi_g_d[no_ps][ 10] * psi_g_d[no_ps][  7] * psi_g_d[no_ps][  2];}
    if (psi_MC_alpha[zero +  22] != 0.){psi_MC_g_channel[zero +  22] = psi_g_p[no_ps][  2] * psi_g_p[no_ps][  9] * psi_g_d[no_ps][ 10] * psi_g_d[no_ps][  7] * psi_g_d[no_ps][  2];}
    if (psi_MC_alpha[zero +  23] != 0.){psi_MC_g_channel[zero +  23] = psi_g_p[no_ps][  2] * psi_g_p[no_ps][  9] * psi_g_d[no_ps][ 10] * psi_g_d[no_ps][  7] * psi_g_d[no_ps][  2];}
    if (psi_MC_alpha[zero +  24] != 0.){psi_MC_g_channel[zero +  24] = psi_g_p[no_ps][  2] * psi_g_p[no_ps][  9] * psi_g_d[no_ps][ 10] * psi_g_d[no_ps][  7] * psi_g_d[no_ps][  2];}
    if (psi_MC_alpha[zero +  25] != 0.){psi_MC_g_channel[zero +  25] = psi_g_p[no_ps][  0] * psi_g_p[no_ps][  8] * psi_g_t[no_ps][  0] * psi_g_d[no_ps][  7] * psi_g_d[no_ps][  2];}
    if (psi_MC_alpha[zero +  26] != 0.){psi_MC_g_channel[zero +  26] = psi_g_p[no_ps][  0] * psi_g_p[no_ps][  8] * psi_g_t[no_ps][  1] * psi_g_d[no_ps][  7] * psi_g_d[no_ps][  2];}
    if (psi_MC_alpha[zero +  27] != 0.){psi_MC_g_channel[zero +  27] = psi_g_p[no_ps][  0] * psi_g_p[no_ps][  9] * psi_g_t[no_ps][  0] * psi_g_d[no_ps][  7] * psi_g_d[no_ps][  2];}
    if (psi_MC_alpha[zero +  28] != 0.){psi_MC_g_channel[zero +  28] = psi_g_p[no_ps][  0] * psi_g_p[no_ps][  9] * psi_g_t[no_ps][  1] * psi_g_d[no_ps][  7] * psi_g_d[no_ps][  2];}
    if (psi_MC_alpha[zero +  29] != 0.){psi_MC_g_channel[zero +  29] = psi_g_p[no_ps][  2] * psi_g_p[no_ps][  8] * psi_g_t[no_ps][  0] * psi_g_d[no_ps][  7] * psi_g_d[no_ps][  2];}
    if (psi_MC_alpha[zero +  30] != 0.){psi_MC_g_channel[zero +  30] = psi_g_p[no_ps][  2] * psi_g_p[no_ps][  8] * psi_g_t[no_ps][  1] * psi_g_d[no_ps][  7] * psi_g_d[no_ps][  2];}
    if (psi_MC_alpha[zero +  31] != 0.){psi_MC_g_channel[zero +  31] = psi_g_p[no_ps][  2] * psi_g_p[no_ps][  9] * psi_g_t[no_ps][  0] * psi_g_d[no_ps][  7] * psi_g_d[no_ps][  2];}
    if (psi_MC_alpha[zero +  32] != 0.){psi_MC_g_channel[zero +  32] = psi_g_p[no_ps][  2] * psi_g_p[no_ps][  9] * psi_g_t[no_ps][  1] * psi_g_d[no_ps][  7] * psi_g_d[no_ps][  2];}
    if (psi_MC_alpha[zero +  33] != 0.){psi_MC_g_channel[zero +  33] = psi_g_p[no_ps][  4] * psi_g_p[no_ps][ 10] * psi_g_t[no_ps][  2] * psi_g_d[no_ps][  2] * psi_g_d[no_ps][  7];}
    if (psi_MC_alpha[zero +  34] != 0.){psi_MC_g_channel[zero +  34] = psi_g_p[no_ps][  4] * psi_g_p[no_ps][ 10] * psi_g_t[no_ps][  3] * psi_g_d[no_ps][  2] * psi_g_d[no_ps][  7];}
    if (psi_MC_alpha[zero +  35] != 0.){psi_MC_g_channel[zero +  35] = psi_g_p[no_ps][  4] * psi_g_p[no_ps][ 11] * psi_g_t[no_ps][  2] * psi_g_d[no_ps][  2] * psi_g_d[no_ps][  7];}
    if (psi_MC_alpha[zero +  36] != 0.){psi_MC_g_channel[zero +  36] = psi_g_p[no_ps][  4] * psi_g_p[no_ps][ 11] * psi_g_t[no_ps][  3] * psi_g_d[no_ps][  2] * psi_g_d[no_ps][  7];}
    if (psi_MC_alpha[zero +  37] != 0.){psi_MC_g_channel[zero +  37] = psi_g_p[no_ps][  6] * psi_g_p[no_ps][ 10] * psi_g_t[no_ps][  2] * psi_g_d[no_ps][  2] * psi_g_d[no_ps][  7];}
    if (psi_MC_alpha[zero +  38] != 0.){psi_MC_g_channel[zero +  38] = psi_g_p[no_ps][  6] * psi_g_p[no_ps][ 10] * psi_g_t[no_ps][  3] * psi_g_d[no_ps][  2] * psi_g_d[no_ps][  7];}
    if (psi_MC_alpha[zero +  39] != 0.){psi_MC_g_channel[zero +  39] = psi_g_p[no_ps][  6] * psi_g_p[no_ps][ 11] * psi_g_t[no_ps][  2] * psi_g_d[no_ps][  2] * psi_g_d[no_ps][  7];}
    if (psi_MC_alpha[zero +  40] != 0.){psi_MC_g_channel[zero +  40] = psi_g_p[no_ps][  6] * psi_g_p[no_ps][ 11] * psi_g_t[no_ps][  3] * psi_g_d[no_ps][  2] * psi_g_d[no_ps][  7];}
  }

/*
  if (psi_MC_alpha[   0] != 0.){ag_channel_4yyv(g, 1, 2, 4, 16, 8, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  if (psi_MC_alpha[   1] != 0.){ag_channel_4yyv(g, 1, 2, 4, 16, 8, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,  23, psi);}
  if (psi_MC_alpha[   2] != 0.){ag_channel_4yyv(g, 1, 2, 4, 16, 8, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,   0, psi);}
  if (psi_MC_alpha[   3] != 0.){ag_channel_4yyv(g, 1, 2, 4, 16, 8, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,  23, psi);}
  if (psi_MC_alpha[   4] != 0.){ag_channel_4yyv(g, 1, 2, 16, 4, 8, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  if (psi_MC_alpha[   5] != 0.){ag_channel_4yyv(g, 1, 2, 16, 4, 8, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,  23, psi);}
  if (psi_MC_alpha[   6] != 0.){ag_channel_4yyv(g, 1, 2, 16, 4, 8, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,   0, psi);}
  if (psi_MC_alpha[   7] != 0.){ag_channel_4yyv(g, 1, 2, 16, 4, 8, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,  23, psi);}
  if (psi_MC_alpha[   8] != 0.){ag_channel_4yyv(g, 1, 2, 8, 32, 4, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  if (psi_MC_alpha[   9] != 0.){ag_channel_4yyv(g, 1, 2, 8, 32, 4, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,  23, psi);}
  if (psi_MC_alpha[  10] != 0.){ag_channel_4yyv(g, 1, 2, 8, 32, 4, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,   0, psi);}
  if (psi_MC_alpha[  11] != 0.){ag_channel_4yyv(g, 1, 2, 8, 32, 4, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,  23, psi);}
  if (psi_MC_alpha[  12] != 0.){ag_channel_4yyv(g, 1, 2, 32, 8, 4, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  if (psi_MC_alpha[  13] != 0.){ag_channel_4yyv(g, 1, 2, 32, 8, 4, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,  23, psi);}
  if (psi_MC_alpha[  14] != 0.){ag_channel_4yyv(g, 1, 2, 32, 8, 4, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,   0, psi);}
  if (psi_MC_alpha[  15] != 0.){ag_channel_4yyv(g, 1, 2, 32, 8, 4, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,  23, psi);}
  if (psi_MC_alpha[  16] != 0.){ag_channel_42vv(g, 1, 2, 4, 16, 8, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  if (psi_MC_alpha[  17] != 0.){ag_channel_42vv(g, 1, 2, 4, 16, 8, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   6, psi);}
  if (psi_MC_alpha[  18] != 0.){ag_channel_42vv(g, 1, 2, 4, 16, 8, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,  23,   0, psi);}
  if (psi_MC_alpha[  19] != 0.){ag_channel_42vv(g, 1, 2, 4, 16, 8, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,  23,   6, psi);}
  if (psi_MC_alpha[  20] != 0.){ag_channel_42vv(g, 1, 2, 4, 16, 8, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,   0, psi);}
  if (psi_MC_alpha[  21] != 0.){ag_channel_42vv(g, 1, 2, 4, 16, 8, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,   6, psi);}
  if (psi_MC_alpha[  22] != 0.){ag_channel_42vv(g, 1, 2, 4, 16, 8, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,  23,  25, psi);}
  if (psi_MC_alpha[  23] != 0.){ag_channel_42vv(g, 1, 2, 4, 16, 8, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,  23,   0, psi);}
  if (psi_MC_alpha[  24] != 0.){ag_channel_42vv(g, 1, 2, 4, 16, 8, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,  23,   6, psi);}
  if (psi_MC_alpha[  25] != 0.){ag_channel_2v2v(g, 1, 2, 4, 16, 8, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  if (psi_MC_alpha[  26] != 0.){ag_channel_2v2v(g, 1, 2, 4, 16, 8, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   6, psi);}
  if (psi_MC_alpha[  27] != 0.){ag_channel_2v2v(g, 1, 2, 4, 16, 8, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,  23,   0, psi);}
  if (psi_MC_alpha[  28] != 0.){ag_channel_2v2v(g, 1, 2, 4, 16, 8, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,  23,   6, psi);}
  if (psi_MC_alpha[  29] != 0.){ag_channel_2v2v(g, 1, 2, 4, 16, 8, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,   0, psi);}
  if (psi_MC_alpha[  30] != 0.){ag_channel_2v2v(g, 1, 2, 4, 16, 8, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,   6, psi);}
  if (psi_MC_alpha[  31] != 0.){ag_channel_2v2v(g, 1, 2, 4, 16, 8, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,  23,   0, psi);}
  if (psi_MC_alpha[  32] != 0.){ag_channel_2v2v(g, 1, 2, 4, 16, 8, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,  23,   6, psi);}
  if (psi_MC_alpha[  33] != 0.){ag_channel_2v2v(g, 1, 2, 8, 32, 4, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  if (psi_MC_alpha[  34] != 0.){ag_channel_2v2v(g, 1, 2, 8, 32, 4, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   6, psi);}
  if (psi_MC_alpha[  35] != 0.){ag_channel_2v2v(g, 1, 2, 8, 32, 4, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,  23,   0, psi);}
  if (psi_MC_alpha[  36] != 0.){ag_channel_2v2v(g, 1, 2, 8, 32, 4, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,  23,   6, psi);}
  if (psi_MC_alpha[  37] != 0.){ag_channel_2v2v(g, 1, 2, 8, 32, 4, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,   0, psi);}
  if (psi_MC_alpha[  38] != 0.){ag_channel_2v2v(g, 1, 2, 8, 32, 4, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,   6, psi);}
  if (psi_MC_alpha[  39] != 0.){ag_channel_2v2v(g, 1, 2, 8, 32, 4, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,  23,   0, psi);}
  if (psi_MC_alpha[  40] != 0.){ag_channel_2v2v(g, 1, 2, 8, 32, 4, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,  23,   6, psi);}
  // channel    0: 4yyv(1, 2, 4, 16, 8, 32;   0,   0,   0)
  // channel    1: 4yyv(1, 2, 4, 16, 8, 32;   0,   0,  23)
  // channel    2: 4yyv(1, 2, 4, 16, 8, 32;  23,   0,   0)
  // channel    3: 4yyv(1, 2, 4, 16, 8, 32;  23,   0,  23)
  // channel    4: 4yyv(1, 2, 16, 4, 8, 32;   0,   0,   0)
  // channel    5: 4yyv(1, 2, 16, 4, 8, 32;   0,   0,  23)
  // channel    6: 4yyv(1, 2, 16, 4, 8, 32;  23,   0,   0)
  // channel    7: 4yyv(1, 2, 16, 4, 8, 32;  23,   0,  23)
  // channel    8: 4yyv(1, 2, 8, 32, 4, 16;   0,   0,   0)
  // channel    9: 4yyv(1, 2, 8, 32, 4, 16;   0,   0,  23)
  // channel   10: 4yyv(1, 2, 8, 32, 4, 16;  23,   0,   0)
  // channel   11: 4yyv(1, 2, 8, 32, 4, 16;  23,   0,  23)
  // channel   12: 4yyv(1, 2, 32, 8, 4, 16;   0,   0,   0)
  // channel   13: 4yyv(1, 2, 32, 8, 4, 16;   0,   0,  23)
  // channel   14: 4yyv(1, 2, 32, 8, 4, 16;  23,   0,   0)
  // channel   15: 4yyv(1, 2, 32, 8, 4, 16;  23,   0,  23)
  // channel   16: 42vv(1, 2, 4, 16, 8, 32;   0,   0,   0)
  // channel   17: 42vv(1, 2, 4, 16, 8, 32;   0,   0,   6)
  // channel   18: 42vv(1, 2, 4, 16, 8, 32;   0,  23,   0)
  // channel   19: 42vv(1, 2, 4, 16, 8, 32;   0,  23,   6)
  // channel   20: 42vv(1, 2, 4, 16, 8, 32;  23,   0,   0)
  // channel   21: 42vv(1, 2, 4, 16, 8, 32;  23,   0,   6)
  // channel   22: 42vv(1, 2, 4, 16, 8, 32;  23,  23,  25)
  // channel   23: 42vv(1, 2, 4, 16, 8, 32;  23,  23,   0)
  // channel   24: 42vv(1, 2, 4, 16, 8, 32;  23,  23,   6)
  // channel   25: 2v2v(1, 2, 4, 16, 8, 32;   0,   0,   0)
  // channel   26: 2v2v(1, 2, 4, 16, 8, 32;   0,   0,   6)
  // channel   27: 2v2v(1, 2, 4, 16, 8, 32;   0,  23,   0)
  // channel   28: 2v2v(1, 2, 4, 16, 8, 32;   0,  23,   6)
  // channel   29: 2v2v(1, 2, 4, 16, 8, 32;  23,   0,   0)
  // channel   30: 2v2v(1, 2, 4, 16, 8, 32;  23,   0,   6)
  // channel   31: 2v2v(1, 2, 4, 16, 8, 32;  23,  23,   0)
  // channel   32: 2v2v(1, 2, 4, 16, 8, 32;  23,  23,   6)
  // channel   33: 2v2v(1, 2, 8, 32, 4, 16;   0,   0,   0)
  // channel   34: 2v2v(1, 2, 8, 32, 4, 16;   0,   0,   6)
  // channel   35: 2v2v(1, 2, 8, 32, 4, 16;   0,  23,   0)
  // channel   36: 2v2v(1, 2, 8, 32, 4, 16;   0,  23,   6)
  // channel   37: 2v2v(1, 2, 8, 32, 4, 16;  23,   0,   0)
  // channel   38: 2v2v(1, 2, 8, 32, 4, 16;  23,   0,   6)
  // channel   39: 2v2v(1, 2, 8, 32, 4, 16;  23,  23,   0)
  // channel   40: 2v2v(1, 2, 8, 32, 4, 16;  23,  23,   6)
*/

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
