#include "../include/classes.cxx"
#include "../include/definitions.phasespace.set.cxx"
#include "../ppemexmx04/header/ppemexmx04.phasespace.h"
void ppemexmx04_ax_psp_140_gu_emmumepmupu(int no_ps, phasespace_set & psi){
  static Logger logger("ppemexmx04_ax_psp_140_gu_emmumepmupu");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;
  psi_v_smin[no_ps].resize(13);
  psi_needed_v_smin[no_ps].resize(13);
  int needed_v_smin_0[] = {   0,    1,    2,    3,    4,    5,    6,    7,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,   40,   41,   42,   43,   44,   45,   46,   47,   48,   49,   50,   51,   52,   53,   54,   55}; //  40
  psi_needed_v_smin[no_ps][  0] = get_vector_from_array_int(needed_v_smin_0, 40);
  int needed_v_smin_1[] = {   0,    1,    2,    3,   24,   25,   26,   27}; //   8
  psi_needed_v_smin[no_ps][  1] = get_vector_from_array_int(needed_v_smin_1, 8);
  int needed_v_smin_2[] = {   0,    1,    2,    3,   24,   25,   26,   27}; //   8
  psi_needed_v_smin[no_ps][  2] = get_vector_from_array_int(needed_v_smin_2, 8);
  int needed_v_smin_3[] = {   4,    5,    6,    7,   28,   29,   30,   31}; //   8
  psi_needed_v_smin[no_ps][  3] = get_vector_from_array_int(needed_v_smin_3, 8);
  int needed_v_smin_4[] = {   4,    5,    6,    7,   28,   29,   30,   31}; //   8
  psi_needed_v_smin[no_ps][  4] = get_vector_from_array_int(needed_v_smin_4, 8);
  int needed_v_smin_5[] = {   8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   32,   33,   34,   35,   36,   37,   38,   39,   40,   41,   42,   43,   44,   45,   46,   47,   48,   49,   50,   51,   52,   53,   54,   55}; //  40
  psi_needed_v_smin[no_ps][  5] = get_vector_from_array_int(needed_v_smin_5, 40);
  int needed_v_smin_6[] = {   8,    9,   10,   11,   32,   33,   34,   35}; //   8
  psi_needed_v_smin[no_ps][  6] = get_vector_from_array_int(needed_v_smin_6, 8);
  int needed_v_smin_7[] = {   8,    9,   10,   11,   32,   33,   34,   35}; //   8
  psi_needed_v_smin[no_ps][  7] = get_vector_from_array_int(needed_v_smin_7, 8);
  int needed_v_smin_8[] = {  12,   13,   14,   15,   36,   37,   38,   39}; //   8
  psi_needed_v_smin[no_ps][  8] = get_vector_from_array_int(needed_v_smin_8, 8);
  int needed_v_smin_9[] = {  12,   13,   14,   15,   36,   37,   38,   39}; //   8
  psi_needed_v_smin[no_ps][  9] = get_vector_from_array_int(needed_v_smin_9, 8);
  int needed_v_smin_10[] = {  16,   17,   18,   19,   44,   45,   46,   47}; //   8
  psi_needed_v_smin[no_ps][ 10] = get_vector_from_array_int(needed_v_smin_10, 8);
  int needed_v_smin_11[] = {  20,   21,   22,   23,   40,   41,   42,   43}; //   8
  psi_needed_v_smin[no_ps][ 11] = get_vector_from_array_int(needed_v_smin_11, 8);
  int needed_v_smin_12[] = {  48,   49,   50,   51,   52,   53,   54,   55}; //   8
  psi_needed_v_smin[no_ps][ 12] = get_vector_from_array_int(needed_v_smin_12, 8);

  psi_v_smax[no_ps].resize(15);
  psi_needed_v_smax[no_ps].resize(15);
  int needed_v_smax_0[] = {   0,    1,    2,    3,    4,    5,    6,    7,   16,   17,   18,   19,   24,   25,   26,   27,   28,   29,   30,   31,   40,   41,   42,   43,   48,   49,   50,   51}; //  28
  psi_needed_v_smax[no_ps][  0] = get_vector_from_array_int(needed_v_smax_0, 28);
  int needed_v_smax_1[] = {   0,    1,    2,    3,   24,   25,   26,   27}; //   8
  psi_needed_v_smax[no_ps][  1] = get_vector_from_array_int(needed_v_smax_1, 8);
  int needed_v_smax_2[] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   48,   49,   50,   51,   52,   53,   54,   55}; //  40
  psi_needed_v_smax[no_ps][  2] = get_vector_from_array_int(needed_v_smax_2, 40);
  int needed_v_smax_3[] = {   4,    5,    6,    7,   28,   29,   30,   31}; //   8
  psi_needed_v_smax[no_ps][  3] = get_vector_from_array_int(needed_v_smax_3, 8);
  int needed_v_smax_4[] = {   8,    9,   10,   11,   12,   13,   14,   15,   20,   21,   22,   23,   32,   33,   34,   35,   36,   37,   38,   39,   44,   45,   46,   47,   52,   53,   54,   55}; //  28
  psi_needed_v_smax[no_ps][  4] = get_vector_from_array_int(needed_v_smax_4, 28);
  int needed_v_smax_5[] = {   8,    9,   10,   11,   32,   33,   34,   35}; //   8
  psi_needed_v_smax[no_ps][  5] = get_vector_from_array_int(needed_v_smax_5, 8);
  int needed_v_smax_6[] = {  12,   13,   14,   15,   36,   37,   38,   39}; //   8
  psi_needed_v_smax[no_ps][  6] = get_vector_from_array_int(needed_v_smax_6, 8);
  int needed_v_smax_7[] = {  16,   17,   18,   19}; //   4
  psi_needed_v_smax[no_ps][  7] = get_vector_from_array_int(needed_v_smax_7, 4);
  int needed_v_smax_8[] = {  16,   17,   18,   19}; //   4
  psi_needed_v_smax[no_ps][  8] = get_vector_from_array_int(needed_v_smax_8, 4);
  int needed_v_smax_9[] = {  20,   21,   22,   23}; //   4
  psi_needed_v_smax[no_ps][  9] = get_vector_from_array_int(needed_v_smax_9, 4);
  int needed_v_smax_10[] = {  20,   21,   22,   23}; //   4
  psi_needed_v_smax[no_ps][ 10] = get_vector_from_array_int(needed_v_smax_10, 4);
  int needed_v_smax_11[] = {  40,   41,   42,   43,   48,   49,   50,   51}; //   8
  psi_needed_v_smax[no_ps][ 11] = get_vector_from_array_int(needed_v_smax_11, 8);
  int needed_v_smax_12[] = {  40,   41,   42,   43}; //   4
  psi_needed_v_smax[no_ps][ 12] = get_vector_from_array_int(needed_v_smax_12, 4);
  int needed_v_smax_13[] = {  44,   45,   46,   47,   52,   53,   54,   55}; //   8
  psi_needed_v_smax[no_ps][ 13] = get_vector_from_array_int(needed_v_smax_13, 8);
  int needed_v_smax_14[] = {  44,   45,   46,   47}; //   4
  psi_needed_v_smax[no_ps][ 14] = get_vector_from_array_int(needed_v_smax_14, 4);

  psi_container_IS_startvalue[no_ps][0] = psi_container_IS_name.size();
  psi_g_p[no_ps].resize(28);
  psi_needed_g_p[no_ps].resize(28);
  int needed_g_p_0[] = {   0,    1,    4,    5,   16,   17,   24,   25,   28,   29,   40,   41,   48,   49}; //  14
  psi_needed_g_p[no_ps][0] = get_vector_from_array_int(needed_g_p_0, 14);
  psi_container_IS_name.push_back("propagator_0_smin0_smax0");
  int needed_g_p_1[] = {   0,    1,    2,    3,   24,   25,   26,   27}; //   8
  psi_needed_g_p[no_ps][1] = get_vector_from_array_int(needed_g_p_1, 8);
  psi_container_IS_name.push_back("propagator_0_smin1_smax1");
  int needed_g_p_2[] = {   0,    2,   24,   26}; //   4
  psi_needed_g_p[no_ps][2] = get_vector_from_array_int(needed_g_p_2, 4);
  psi_container_IS_name.push_back("propagator_0_smin2_smax2");
  int needed_g_p_3[] = {   1,    3,   25,   27}; //   4
  psi_needed_g_p[no_ps][3] = get_vector_from_array_int(needed_g_p_3, 4);
  psi_container_IS_name.push_back("propagator_23_smin2_smax2");
  int needed_g_p_4[] = {   2,    3,    6,    7,   18,   19,   26,   27,   30,   31,   42,   43,   50,   51}; //  14
  psi_needed_g_p[no_ps][4] = get_vector_from_array_int(needed_g_p_4, 14);
  psi_container_IS_name.push_back("propagator_23_smin0_smax0");
  int needed_g_p_5[] = {   4,    5,    6,    7,   28,   29,   30,   31}; //   8
  psi_needed_g_p[no_ps][5] = get_vector_from_array_int(needed_g_p_5, 8);
  psi_container_IS_name.push_back("propagator_0_smin3_smax3");
  int needed_g_p_6[] = {   4,    6,   28,   30}; //   4
  psi_needed_g_p[no_ps][6] = get_vector_from_array_int(needed_g_p_6, 4);
  psi_container_IS_name.push_back("propagator_0_smin4_smax2");
  int needed_g_p_7[] = {   5,    7,   29,   31}; //   4
  psi_needed_g_p[no_ps][7] = get_vector_from_array_int(needed_g_p_7, 4);
  psi_container_IS_name.push_back("propagator_23_smin4_smax2");
  int needed_g_p_8[] = {   8,    9,   12,   13,   20,   21,   32,   33,   36,   37,   44,   45,   52,   53}; //  14
  psi_needed_g_p[no_ps][8] = get_vector_from_array_int(needed_g_p_8, 14);
  psi_container_IS_name.push_back("propagator_0_smin5_smax4");
  int needed_g_p_9[] = {   8,    9,   10,   11,   32,   33,   34,   35}; //   8
  psi_needed_g_p[no_ps][9] = get_vector_from_array_int(needed_g_p_9, 8);
  psi_container_IS_name.push_back("propagator_0_smin6_smax5");
  int needed_g_p_10[] = {   8,   10,   32,   34}; //   4
  psi_needed_g_p[no_ps][10] = get_vector_from_array_int(needed_g_p_10, 4);
  psi_container_IS_name.push_back("propagator_0_smin7_smax2");
  int needed_g_p_11[] = {   9,   11,   33,   35}; //   4
  psi_needed_g_p[no_ps][11] = get_vector_from_array_int(needed_g_p_11, 4);
  psi_container_IS_name.push_back("propagator_23_smin7_smax2");
  int needed_g_p_12[] = {  10,   11,   14,   15,   22,   23,   34,   35,   38,   39,   46,   47,   54,   55}; //  14
  psi_needed_g_p[no_ps][12] = get_vector_from_array_int(needed_g_p_12, 14);
  psi_container_IS_name.push_back("propagator_23_smin5_smax4");
  int needed_g_p_13[] = {  12,   13,   14,   15,   36,   37,   38,   39}; //   8
  psi_needed_g_p[no_ps][13] = get_vector_from_array_int(needed_g_p_13, 8);
  psi_container_IS_name.push_back("propagator_0_smin8_smax6");
  int needed_g_p_14[] = {  12,   14,   36,   38}; //   4
  psi_needed_g_p[no_ps][14] = get_vector_from_array_int(needed_g_p_14, 4);
  psi_container_IS_name.push_back("propagator_0_smin9_smax2");
  int needed_g_p_15[] = {  13,   15,   37,   39}; //   4
  psi_needed_g_p[no_ps][15] = get_vector_from_array_int(needed_g_p_15, 4);
  psi_container_IS_name.push_back("propagator_23_smin9_smax2");
  int needed_g_p_16[] = {  16,   17,   18,   19}; //   4
  psi_needed_g_p[no_ps][16] = get_vector_from_array_int(needed_g_p_16, 4);
  psi_container_IS_name.push_back("propagator_0_smin10_smax7");
  int needed_g_p_17[] = {  16,   18}; //   2
  psi_needed_g_p[no_ps][17] = get_vector_from_array_int(needed_g_p_17, 2);
  psi_container_IS_name.push_back("propagator_0_smin5_smax8");
  int needed_g_p_18[] = {  17,   19}; //   2
  psi_needed_g_p[no_ps][18] = get_vector_from_array_int(needed_g_p_18, 2);
  psi_container_IS_name.push_back("propagator_23_smin5_smax8");
  int needed_g_p_19[] = {  20,   21,   22,   23}; //   4
  psi_needed_g_p[no_ps][19] = get_vector_from_array_int(needed_g_p_19, 4);
  psi_container_IS_name.push_back("propagator_0_smin11_smax9");
  int needed_g_p_20[] = {  20,   22}; //   2
  psi_needed_g_p[no_ps][20] = get_vector_from_array_int(needed_g_p_20, 2);
  psi_container_IS_name.push_back("propagator_0_smin0_smax10");
  int needed_g_p_21[] = {  21,   23}; //   2
  psi_needed_g_p[no_ps][21] = get_vector_from_array_int(needed_g_p_21, 2);
  psi_container_IS_name.push_back("propagator_23_smin0_smax10");
  int needed_g_p_22[] = {  40,   42,   48,   50}; //   4
  psi_needed_g_p[no_ps][22] = get_vector_from_array_int(needed_g_p_22, 4);
  psi_container_IS_name.push_back("propagator_0_smin5_smax11");
  int needed_g_p_23[] = {  40,   41,   42,   43}; //   4
  psi_needed_g_p[no_ps][23] = get_vector_from_array_int(needed_g_p_23, 4);
  psi_container_IS_name.push_back("propagator_0_smin11_smax12");
  int needed_g_p_24[] = {  41,   43,   49,   51}; //   4
  psi_needed_g_p[no_ps][24] = get_vector_from_array_int(needed_g_p_24, 4);
  psi_container_IS_name.push_back("propagator_23_smin5_smax11");
  int needed_g_p_25[] = {  44,   46,   52,   54}; //   4
  psi_needed_g_p[no_ps][25] = get_vector_from_array_int(needed_g_p_25, 4);
  psi_container_IS_name.push_back("propagator_0_smin0_smax13");
  int needed_g_p_26[] = {  44,   45,   46,   47}; //   4
  psi_needed_g_p[no_ps][26] = get_vector_from_array_int(needed_g_p_26, 4);
  psi_container_IS_name.push_back("propagator_0_smin10_smax14");
  int needed_g_p_27[] = {  45,   47,   53,   55}; //   4
  psi_needed_g_p[no_ps][27] = get_vector_from_array_int(needed_g_p_27, 4);
  psi_container_IS_name.push_back("propagator_23_smin0_smax13");

  psi_container_IS_startvalue[no_ps][1] = psi_container_IS_name.size();
  psi_g_f[no_ps].resize(1);
  psi_needed_g_f[no_ps].resize(1);
  int needed_g_f_0[] = {  48,   49,   50,   51,   52,   53,   54,   55}; //   8
  psi_needed_g_f[no_ps][0] = get_vector_from_array_int(needed_g_f_0, 8);
  psi_container_IS_name.push_back("timelikeinvariant_smin12_smax2");

  psi_container_IS_startvalue[no_ps][2] = psi_container_IS_name.size();
  psi_g_t[no_ps].resize(5);
  psi_needed_g_t[no_ps].resize(5);
  int needed_g_t_0[] = {  24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   48,   49,   50,   51,   52,   53,   54,   55}; //  24
  psi_needed_g_t[no_ps][0] = get_vector_from_array_int(needed_g_t_0, 24);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_2__64_60");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_2__64_60");
  int needed_g_t_1[] = {  40,   41,   42,   43}; //   4
  psi_needed_g_t[no_ps][1] = get_vector_from_array_int(needed_g_t_1, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_1__40_84");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_1__40_84");
  int needed_g_t_2[] = {  44,   45,   46,   47}; //   4
  psi_needed_g_t[no_ps][2] = get_vector_from_array_int(needed_g_t_2, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_1__20_104");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_1__20_104");
  int needed_g_t_3[] = {  48,   49,   50,   51}; //   4
  psi_needed_g_t[no_ps][3] = get_vector_from_array_int(needed_g_t_3, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_65__40_20");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_65__40_20");
  int needed_g_t_4[] = {  52,   53,   54,   55}; //   4
  psi_needed_g_t[no_ps][4] = get_vector_from_array_int(needed_g_t_4, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_65__20_40");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_65__20_40");

  psi_container_IS_startvalue[no_ps][3] = psi_container_IS_name.size();
  psi_g_d[no_ps].resize(15);
  psi_needed_g_d[no_ps].resize(15);
  int needed_g_d_0[] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15}; //  16
  psi_needed_g_d[no_ps][0] = get_vector_from_array_int(needed_g_d_0, 16);
  psi_container_IS_name.push_back("costheta_of_decay_124__64_60");
  psi_container_IS_name.push_back("phi_of_decay_124__64_60");
  int needed_g_d_1[] = {   0,    1,    2,    3,   24,   25,   26,   27}; //   8
  psi_needed_g_d[no_ps][1] = get_vector_from_array_int(needed_g_d_1, 8);
  psi_container_IS_name.push_back("costheta_of_decay_60__4_56");
  psi_container_IS_name.push_back("phi_of_decay_60__4_56");
  int needed_g_d_2[] = {   0,    1,    2,    3,   24,   25,   26,   27}; //   8
  psi_needed_g_d[no_ps][2] = get_vector_from_array_int(needed_g_d_2, 8);
  psi_container_IS_name.push_back("costheta_of_decay_56__16_40");
  psi_container_IS_name.push_back("phi_of_decay_56__16_40");
  int needed_g_d_3[] = {   0,    1,    2,    3,    4,    5,    6,    7,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,   40,   41,   42,   43,   44,   45,   46,   47,   48,   49,   50,   51,   52,   53,   54,   55}; //  40
  psi_needed_g_d[no_ps][3] = get_vector_from_array_int(needed_g_d_3, 40);
  psi_container_IS_name.push_back("costheta_of_decay_40__8_32");
  psi_container_IS_name.push_back("phi_of_decay_40__8_32");
  int needed_g_d_4[] = {   4,    5,    6,    7,   28,   29,   30,   31}; //   8
  psi_needed_g_d[no_ps][4] = get_vector_from_array_int(needed_g_d_4, 8);
  psi_container_IS_name.push_back("costheta_of_decay_60__16_44");
  psi_container_IS_name.push_back("phi_of_decay_60__16_44");
  int needed_g_d_5[] = {   4,    5,    6,    7,   28,   29,   30,   31}; //   8
  psi_needed_g_d[no_ps][5] = get_vector_from_array_int(needed_g_d_5, 8);
  psi_container_IS_name.push_back("costheta_of_decay_44__4_40");
  psi_container_IS_name.push_back("phi_of_decay_44__4_40");
  int needed_g_d_6[] = {   8,    9,   10,   11,   32,   33,   34,   35}; //   8
  psi_needed_g_d[no_ps][6] = get_vector_from_array_int(needed_g_d_6, 8);
  psi_container_IS_name.push_back("costheta_of_decay_60__8_52");
  psi_container_IS_name.push_back("phi_of_decay_60__8_52");
  int needed_g_d_7[] = {   8,    9,   10,   11,   32,   33,   34,   35}; //   8
  psi_needed_g_d[no_ps][7] = get_vector_from_array_int(needed_g_d_7, 8);
  psi_container_IS_name.push_back("costheta_of_decay_52__32_20");
  psi_container_IS_name.push_back("phi_of_decay_52__32_20");
  int needed_g_d_8[] = {   8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   32,   33,   34,   35,   36,   37,   38,   39,   40,   41,   42,   43,   44,   45,   46,   47,   48,   49,   50,   51,   52,   53,   54,   55}; //  40
  psi_needed_g_d[no_ps][8] = get_vector_from_array_int(needed_g_d_8, 40);
  psi_container_IS_name.push_back("costheta_of_decay_20__4_16");
  psi_container_IS_name.push_back("phi_of_decay_20__4_16");
  int needed_g_d_9[] = {  12,   13,   14,   15,   36,   37,   38,   39}; //   8
  psi_needed_g_d[no_ps][9] = get_vector_from_array_int(needed_g_d_9, 8);
  psi_container_IS_name.push_back("costheta_of_decay_60__32_28");
  psi_container_IS_name.push_back("phi_of_decay_60__32_28");
  int needed_g_d_10[] = {  12,   13,   14,   15,   36,   37,   38,   39}; //   8
  psi_needed_g_d[no_ps][10] = get_vector_from_array_int(needed_g_d_10, 8);
  psi_container_IS_name.push_back("costheta_of_decay_28__8_20");
  psi_container_IS_name.push_back("phi_of_decay_28__8_20");
  int needed_g_d_11[] = {  16,   17,   18,   19}; //   4
  psi_needed_g_d[no_ps][11] = get_vector_from_array_int(needed_g_d_11, 4);
  psi_container_IS_name.push_back("costheta_of_decay_124__20_104");
  psi_container_IS_name.push_back("phi_of_decay_124__20_104");
  int needed_g_d_12[] = {  16,   17,   18,   19,   44,   45,   46,   47}; //   8
  psi_needed_g_d[no_ps][12] = get_vector_from_array_int(needed_g_d_12, 8);
  psi_container_IS_name.push_back("costheta_of_decay_104__64_40");
  psi_container_IS_name.push_back("phi_of_decay_104__64_40");
  int needed_g_d_13[] = {  20,   21,   22,   23}; //   4
  psi_needed_g_d[no_ps][13] = get_vector_from_array_int(needed_g_d_13, 4);
  psi_container_IS_name.push_back("costheta_of_decay_124__40_84");
  psi_container_IS_name.push_back("phi_of_decay_124__40_84");
  int needed_g_d_14[] = {  20,   21,   22,   23,   40,   41,   42,   43}; //   8
  psi_needed_g_d[no_ps][14] = get_vector_from_array_int(needed_g_d_14, 8);
  psi_container_IS_name.push_back("costheta_of_decay_84__64_20");
  psi_container_IS_name.push_back("phi_of_decay_84__64_20");

  psi_c_p[no_ps].resize(56);
  psi_c_f[no_ps].resize(56);
  psi_c_t[no_ps].resize(56);
  psi_c_d[no_ps].resize(56);

  int c_p_0[] = {  0,   1,   2}; //   3
  psi_c_p[no_ps][0] = get_vector_from_array_int(c_p_0, 3);
  int c_f_0[] = {}; //   0
  psi_c_f[no_ps][0] = get_vector_from_array_int(c_f_0, 0);
  int c_t_0[] = {}; //   0
  psi_c_t[no_ps][0] = get_vector_from_array_int(c_t_0, 0);
  int c_d_0[] = {  0,   1,   2,   3}; //   4
  psi_c_d[no_ps][0] = get_vector_from_array_int(c_d_0, 4);

  int c_p_1[] = {  0,   1,   3}; //   3
  psi_c_p[no_ps][1] = get_vector_from_array_int(c_p_1, 3);
  int c_f_1[] = {}; //   0
  psi_c_f[no_ps][1] = get_vector_from_array_int(c_f_1, 0);
  int c_t_1[] = {}; //   0
  psi_c_t[no_ps][1] = get_vector_from_array_int(c_t_1, 0);
  int c_d_1[] = {  0,   1,   2,   3}; //   4
  psi_c_d[no_ps][1] = get_vector_from_array_int(c_d_1, 4);

  int c_p_2[] = {  4,   1,   2}; //   3
  psi_c_p[no_ps][2] = get_vector_from_array_int(c_p_2, 3);
  int c_f_2[] = {}; //   0
  psi_c_f[no_ps][2] = get_vector_from_array_int(c_f_2, 0);
  int c_t_2[] = {}; //   0
  psi_c_t[no_ps][2] = get_vector_from_array_int(c_t_2, 0);
  int c_d_2[] = {  0,   1,   2,   3}; //   4
  psi_c_d[no_ps][2] = get_vector_from_array_int(c_d_2, 4);

  int c_p_3[] = {  4,   1,   3}; //   3
  psi_c_p[no_ps][3] = get_vector_from_array_int(c_p_3, 3);
  int c_f_3[] = {}; //   0
  psi_c_f[no_ps][3] = get_vector_from_array_int(c_f_3, 0);
  int c_t_3[] = {}; //   0
  psi_c_t[no_ps][3] = get_vector_from_array_int(c_t_3, 0);
  int c_d_3[] = {  0,   1,   2,   3}; //   4
  psi_c_d[no_ps][3] = get_vector_from_array_int(c_d_3, 4);

  int c_p_4[] = {  0,   5,   6}; //   3
  psi_c_p[no_ps][4] = get_vector_from_array_int(c_p_4, 3);
  int c_f_4[] = {}; //   0
  psi_c_f[no_ps][4] = get_vector_from_array_int(c_f_4, 0);
  int c_t_4[] = {}; //   0
  psi_c_t[no_ps][4] = get_vector_from_array_int(c_t_4, 0);
  int c_d_4[] = {  0,   4,   5,   3}; //   4
  psi_c_d[no_ps][4] = get_vector_from_array_int(c_d_4, 4);

  int c_p_5[] = {  0,   5,   7}; //   3
  psi_c_p[no_ps][5] = get_vector_from_array_int(c_p_5, 3);
  int c_f_5[] = {}; //   0
  psi_c_f[no_ps][5] = get_vector_from_array_int(c_f_5, 0);
  int c_t_5[] = {}; //   0
  psi_c_t[no_ps][5] = get_vector_from_array_int(c_t_5, 0);
  int c_d_5[] = {  0,   4,   5,   3}; //   4
  psi_c_d[no_ps][5] = get_vector_from_array_int(c_d_5, 4);

  int c_p_6[] = {  4,   5,   6}; //   3
  psi_c_p[no_ps][6] = get_vector_from_array_int(c_p_6, 3);
  int c_f_6[] = {}; //   0
  psi_c_f[no_ps][6] = get_vector_from_array_int(c_f_6, 0);
  int c_t_6[] = {}; //   0
  psi_c_t[no_ps][6] = get_vector_from_array_int(c_t_6, 0);
  int c_d_6[] = {  0,   4,   5,   3}; //   4
  psi_c_d[no_ps][6] = get_vector_from_array_int(c_d_6, 4);

  int c_p_7[] = {  4,   5,   7}; //   3
  psi_c_p[no_ps][7] = get_vector_from_array_int(c_p_7, 3);
  int c_f_7[] = {}; //   0
  psi_c_f[no_ps][7] = get_vector_from_array_int(c_f_7, 0);
  int c_t_7[] = {}; //   0
  psi_c_t[no_ps][7] = get_vector_from_array_int(c_t_7, 0);
  int c_d_7[] = {  0,   4,   5,   3}; //   4
  psi_c_d[no_ps][7] = get_vector_from_array_int(c_d_7, 4);

  int c_p_8[] = {  8,   9,  10}; //   3
  psi_c_p[no_ps][8] = get_vector_from_array_int(c_p_8, 3);
  int c_f_8[] = {}; //   0
  psi_c_f[no_ps][8] = get_vector_from_array_int(c_f_8, 0);
  int c_t_8[] = {}; //   0
  psi_c_t[no_ps][8] = get_vector_from_array_int(c_t_8, 0);
  int c_d_8[] = {  0,   6,   7,   8}; //   4
  psi_c_d[no_ps][8] = get_vector_from_array_int(c_d_8, 4);

  int c_p_9[] = {  8,   9,  11}; //   3
  psi_c_p[no_ps][9] = get_vector_from_array_int(c_p_9, 3);
  int c_f_9[] = {}; //   0
  psi_c_f[no_ps][9] = get_vector_from_array_int(c_f_9, 0);
  int c_t_9[] = {}; //   0
  psi_c_t[no_ps][9] = get_vector_from_array_int(c_t_9, 0);
  int c_d_9[] = {  0,   6,   7,   8}; //   4
  psi_c_d[no_ps][9] = get_vector_from_array_int(c_d_9, 4);

  int c_p_10[] = { 12,   9,  10}; //   3
  psi_c_p[no_ps][10] = get_vector_from_array_int(c_p_10, 3);
  int c_f_10[] = {}; //   0
  psi_c_f[no_ps][10] = get_vector_from_array_int(c_f_10, 0);
  int c_t_10[] = {}; //   0
  psi_c_t[no_ps][10] = get_vector_from_array_int(c_t_10, 0);
  int c_d_10[] = {  0,   6,   7,   8}; //   4
  psi_c_d[no_ps][10] = get_vector_from_array_int(c_d_10, 4);

  int c_p_11[] = { 12,   9,  11}; //   3
  psi_c_p[no_ps][11] = get_vector_from_array_int(c_p_11, 3);
  int c_f_11[] = {}; //   0
  psi_c_f[no_ps][11] = get_vector_from_array_int(c_f_11, 0);
  int c_t_11[] = {}; //   0
  psi_c_t[no_ps][11] = get_vector_from_array_int(c_t_11, 0);
  int c_d_11[] = {  0,   6,   7,   8}; //   4
  psi_c_d[no_ps][11] = get_vector_from_array_int(c_d_11, 4);

  int c_p_12[] = {  8,  13,  14}; //   3
  psi_c_p[no_ps][12] = get_vector_from_array_int(c_p_12, 3);
  int c_f_12[] = {}; //   0
  psi_c_f[no_ps][12] = get_vector_from_array_int(c_f_12, 0);
  int c_t_12[] = {}; //   0
  psi_c_t[no_ps][12] = get_vector_from_array_int(c_t_12, 0);
  int c_d_12[] = {  0,   9,  10,   8}; //   4
  psi_c_d[no_ps][12] = get_vector_from_array_int(c_d_12, 4);

  int c_p_13[] = {  8,  13,  15}; //   3
  psi_c_p[no_ps][13] = get_vector_from_array_int(c_p_13, 3);
  int c_f_13[] = {}; //   0
  psi_c_f[no_ps][13] = get_vector_from_array_int(c_f_13, 0);
  int c_t_13[] = {}; //   0
  psi_c_t[no_ps][13] = get_vector_from_array_int(c_t_13, 0);
  int c_d_13[] = {  0,   9,  10,   8}; //   4
  psi_c_d[no_ps][13] = get_vector_from_array_int(c_d_13, 4);

  int c_p_14[] = { 12,  13,  14}; //   3
  psi_c_p[no_ps][14] = get_vector_from_array_int(c_p_14, 3);
  int c_f_14[] = {}; //   0
  psi_c_f[no_ps][14] = get_vector_from_array_int(c_f_14, 0);
  int c_t_14[] = {}; //   0
  psi_c_t[no_ps][14] = get_vector_from_array_int(c_t_14, 0);
  int c_d_14[] = {  0,   9,  10,   8}; //   4
  psi_c_d[no_ps][14] = get_vector_from_array_int(c_d_14, 4);

  int c_p_15[] = { 12,  13,  15}; //   3
  psi_c_p[no_ps][15] = get_vector_from_array_int(c_p_15, 3);
  int c_f_15[] = {}; //   0
  psi_c_f[no_ps][15] = get_vector_from_array_int(c_f_15, 0);
  int c_t_15[] = {}; //   0
  psi_c_t[no_ps][15] = get_vector_from_array_int(c_t_15, 0);
  int c_d_15[] = {  0,   9,  10,   8}; //   4
  psi_c_d[no_ps][15] = get_vector_from_array_int(c_d_15, 4);

  int c_p_16[] = {  0,  16,  17}; //   3
  psi_c_p[no_ps][16] = get_vector_from_array_int(c_p_16, 3);
  int c_f_16[] = {}; //   0
  psi_c_f[no_ps][16] = get_vector_from_array_int(c_f_16, 0);
  int c_t_16[] = {}; //   0
  psi_c_t[no_ps][16] = get_vector_from_array_int(c_t_16, 0);
  int c_d_16[] = { 11,   8,  12,   3}; //   4
  psi_c_d[no_ps][16] = get_vector_from_array_int(c_d_16, 4);

  int c_p_17[] = {  0,  16,  18}; //   3
  psi_c_p[no_ps][17] = get_vector_from_array_int(c_p_17, 3);
  int c_f_17[] = {}; //   0
  psi_c_f[no_ps][17] = get_vector_from_array_int(c_f_17, 0);
  int c_t_17[] = {}; //   0
  psi_c_t[no_ps][17] = get_vector_from_array_int(c_t_17, 0);
  int c_d_17[] = { 11,   8,  12,   3}; //   4
  psi_c_d[no_ps][17] = get_vector_from_array_int(c_d_17, 4);

  int c_p_18[] = {  4,  16,  17}; //   3
  psi_c_p[no_ps][18] = get_vector_from_array_int(c_p_18, 3);
  int c_f_18[] = {}; //   0
  psi_c_f[no_ps][18] = get_vector_from_array_int(c_f_18, 0);
  int c_t_18[] = {}; //   0
  psi_c_t[no_ps][18] = get_vector_from_array_int(c_t_18, 0);
  int c_d_18[] = { 11,   8,  12,   3}; //   4
  psi_c_d[no_ps][18] = get_vector_from_array_int(c_d_18, 4);

  int c_p_19[] = {  4,  16,  18}; //   3
  psi_c_p[no_ps][19] = get_vector_from_array_int(c_p_19, 3);
  int c_f_19[] = {}; //   0
  psi_c_f[no_ps][19] = get_vector_from_array_int(c_f_19, 0);
  int c_t_19[] = {}; //   0
  psi_c_t[no_ps][19] = get_vector_from_array_int(c_t_19, 0);
  int c_d_19[] = { 11,   8,  12,   3}; //   4
  psi_c_d[no_ps][19] = get_vector_from_array_int(c_d_19, 4);

  int c_p_20[] = {  8,  19,  20}; //   3
  psi_c_p[no_ps][20] = get_vector_from_array_int(c_p_20, 3);
  int c_f_20[] = {}; //   0
  psi_c_f[no_ps][20] = get_vector_from_array_int(c_f_20, 0);
  int c_t_20[] = {}; //   0
  psi_c_t[no_ps][20] = get_vector_from_array_int(c_t_20, 0);
  int c_d_20[] = { 13,   3,  14,   8}; //   4
  psi_c_d[no_ps][20] = get_vector_from_array_int(c_d_20, 4);

  int c_p_21[] = {  8,  19,  21}; //   3
  psi_c_p[no_ps][21] = get_vector_from_array_int(c_p_21, 3);
  int c_f_21[] = {}; //   0
  psi_c_f[no_ps][21] = get_vector_from_array_int(c_f_21, 0);
  int c_t_21[] = {}; //   0
  psi_c_t[no_ps][21] = get_vector_from_array_int(c_t_21, 0);
  int c_d_21[] = { 13,   3,  14,   8}; //   4
  psi_c_d[no_ps][21] = get_vector_from_array_int(c_d_21, 4);

  int c_p_22[] = { 12,  19,  20}; //   3
  psi_c_p[no_ps][22] = get_vector_from_array_int(c_p_22, 3);
  int c_f_22[] = {}; //   0
  psi_c_f[no_ps][22] = get_vector_from_array_int(c_f_22, 0);
  int c_t_22[] = {}; //   0
  psi_c_t[no_ps][22] = get_vector_from_array_int(c_t_22, 0);
  int c_d_22[] = { 13,   3,  14,   8}; //   4
  psi_c_d[no_ps][22] = get_vector_from_array_int(c_d_22, 4);

  int c_p_23[] = { 12,  19,  21}; //   3
  psi_c_p[no_ps][23] = get_vector_from_array_int(c_p_23, 3);
  int c_f_23[] = {}; //   0
  psi_c_f[no_ps][23] = get_vector_from_array_int(c_f_23, 0);
  int c_t_23[] = {}; //   0
  psi_c_t[no_ps][23] = get_vector_from_array_int(c_t_23, 0);
  int c_d_23[] = { 13,   3,  14,   8}; //   4
  psi_c_d[no_ps][23] = get_vector_from_array_int(c_d_23, 4);

  int c_p_24[] = {  0,   1,   2}; //   3
  psi_c_p[no_ps][24] = get_vector_from_array_int(c_p_24, 3);
  int c_f_24[] = {}; //   0
  psi_c_f[no_ps][24] = get_vector_from_array_int(c_f_24, 0);
  int c_t_24[] = {  0}; //   1
  psi_c_t[no_ps][24] = get_vector_from_array_int(c_t_24, 1);
  int c_d_24[] = {  1,   2,   3}; //   3
  psi_c_d[no_ps][24] = get_vector_from_array_int(c_d_24, 3);

  int c_p_25[] = {  0,   1,   3}; //   3
  psi_c_p[no_ps][25] = get_vector_from_array_int(c_p_25, 3);
  int c_f_25[] = {}; //   0
  psi_c_f[no_ps][25] = get_vector_from_array_int(c_f_25, 0);
  int c_t_25[] = {  0}; //   1
  psi_c_t[no_ps][25] = get_vector_from_array_int(c_t_25, 1);
  int c_d_25[] = {  1,   2,   3}; //   3
  psi_c_d[no_ps][25] = get_vector_from_array_int(c_d_25, 3);

  int c_p_26[] = {  4,   1,   2}; //   3
  psi_c_p[no_ps][26] = get_vector_from_array_int(c_p_26, 3);
  int c_f_26[] = {}; //   0
  psi_c_f[no_ps][26] = get_vector_from_array_int(c_f_26, 0);
  int c_t_26[] = {  0}; //   1
  psi_c_t[no_ps][26] = get_vector_from_array_int(c_t_26, 1);
  int c_d_26[] = {  1,   2,   3}; //   3
  psi_c_d[no_ps][26] = get_vector_from_array_int(c_d_26, 3);

  int c_p_27[] = {  4,   1,   3}; //   3
  psi_c_p[no_ps][27] = get_vector_from_array_int(c_p_27, 3);
  int c_f_27[] = {}; //   0
  psi_c_f[no_ps][27] = get_vector_from_array_int(c_f_27, 0);
  int c_t_27[] = {  0}; //   1
  psi_c_t[no_ps][27] = get_vector_from_array_int(c_t_27, 1);
  int c_d_27[] = {  1,   2,   3}; //   3
  psi_c_d[no_ps][27] = get_vector_from_array_int(c_d_27, 3);

  int c_p_28[] = {  0,   5,   6}; //   3
  psi_c_p[no_ps][28] = get_vector_from_array_int(c_p_28, 3);
  int c_f_28[] = {}; //   0
  psi_c_f[no_ps][28] = get_vector_from_array_int(c_f_28, 0);
  int c_t_28[] = {  0}; //   1
  psi_c_t[no_ps][28] = get_vector_from_array_int(c_t_28, 1);
  int c_d_28[] = {  4,   5,   3}; //   3
  psi_c_d[no_ps][28] = get_vector_from_array_int(c_d_28, 3);

  int c_p_29[] = {  0,   5,   7}; //   3
  psi_c_p[no_ps][29] = get_vector_from_array_int(c_p_29, 3);
  int c_f_29[] = {}; //   0
  psi_c_f[no_ps][29] = get_vector_from_array_int(c_f_29, 0);
  int c_t_29[] = {  0}; //   1
  psi_c_t[no_ps][29] = get_vector_from_array_int(c_t_29, 1);
  int c_d_29[] = {  4,   5,   3}; //   3
  psi_c_d[no_ps][29] = get_vector_from_array_int(c_d_29, 3);

  int c_p_30[] = {  4,   5,   6}; //   3
  psi_c_p[no_ps][30] = get_vector_from_array_int(c_p_30, 3);
  int c_f_30[] = {}; //   0
  psi_c_f[no_ps][30] = get_vector_from_array_int(c_f_30, 0);
  int c_t_30[] = {  0}; //   1
  psi_c_t[no_ps][30] = get_vector_from_array_int(c_t_30, 1);
  int c_d_30[] = {  4,   5,   3}; //   3
  psi_c_d[no_ps][30] = get_vector_from_array_int(c_d_30, 3);

  int c_p_31[] = {  4,   5,   7}; //   3
  psi_c_p[no_ps][31] = get_vector_from_array_int(c_p_31, 3);
  int c_f_31[] = {}; //   0
  psi_c_f[no_ps][31] = get_vector_from_array_int(c_f_31, 0);
  int c_t_31[] = {  0}; //   1
  psi_c_t[no_ps][31] = get_vector_from_array_int(c_t_31, 1);
  int c_d_31[] = {  4,   5,   3}; //   3
  psi_c_d[no_ps][31] = get_vector_from_array_int(c_d_31, 3);

  int c_p_32[] = {  8,   9,  10}; //   3
  psi_c_p[no_ps][32] = get_vector_from_array_int(c_p_32, 3);
  int c_f_32[] = {}; //   0
  psi_c_f[no_ps][32] = get_vector_from_array_int(c_f_32, 0);
  int c_t_32[] = {  0}; //   1
  psi_c_t[no_ps][32] = get_vector_from_array_int(c_t_32, 1);
  int c_d_32[] = {  6,   7,   8}; //   3
  psi_c_d[no_ps][32] = get_vector_from_array_int(c_d_32, 3);

  int c_p_33[] = {  8,   9,  11}; //   3
  psi_c_p[no_ps][33] = get_vector_from_array_int(c_p_33, 3);
  int c_f_33[] = {}; //   0
  psi_c_f[no_ps][33] = get_vector_from_array_int(c_f_33, 0);
  int c_t_33[] = {  0}; //   1
  psi_c_t[no_ps][33] = get_vector_from_array_int(c_t_33, 1);
  int c_d_33[] = {  6,   7,   8}; //   3
  psi_c_d[no_ps][33] = get_vector_from_array_int(c_d_33, 3);

  int c_p_34[] = { 12,   9,  10}; //   3
  psi_c_p[no_ps][34] = get_vector_from_array_int(c_p_34, 3);
  int c_f_34[] = {}; //   0
  psi_c_f[no_ps][34] = get_vector_from_array_int(c_f_34, 0);
  int c_t_34[] = {  0}; //   1
  psi_c_t[no_ps][34] = get_vector_from_array_int(c_t_34, 1);
  int c_d_34[] = {  6,   7,   8}; //   3
  psi_c_d[no_ps][34] = get_vector_from_array_int(c_d_34, 3);

  int c_p_35[] = { 12,   9,  11}; //   3
  psi_c_p[no_ps][35] = get_vector_from_array_int(c_p_35, 3);
  int c_f_35[] = {}; //   0
  psi_c_f[no_ps][35] = get_vector_from_array_int(c_f_35, 0);
  int c_t_35[] = {  0}; //   1
  psi_c_t[no_ps][35] = get_vector_from_array_int(c_t_35, 1);
  int c_d_35[] = {  6,   7,   8}; //   3
  psi_c_d[no_ps][35] = get_vector_from_array_int(c_d_35, 3);

  int c_p_36[] = {  8,  13,  14}; //   3
  psi_c_p[no_ps][36] = get_vector_from_array_int(c_p_36, 3);
  int c_f_36[] = {}; //   0
  psi_c_f[no_ps][36] = get_vector_from_array_int(c_f_36, 0);
  int c_t_36[] = {  0}; //   1
  psi_c_t[no_ps][36] = get_vector_from_array_int(c_t_36, 1);
  int c_d_36[] = {  9,  10,   8}; //   3
  psi_c_d[no_ps][36] = get_vector_from_array_int(c_d_36, 3);

  int c_p_37[] = {  8,  13,  15}; //   3
  psi_c_p[no_ps][37] = get_vector_from_array_int(c_p_37, 3);
  int c_f_37[] = {}; //   0
  psi_c_f[no_ps][37] = get_vector_from_array_int(c_f_37, 0);
  int c_t_37[] = {  0}; //   1
  psi_c_t[no_ps][37] = get_vector_from_array_int(c_t_37, 1);
  int c_d_37[] = {  9,  10,   8}; //   3
  psi_c_d[no_ps][37] = get_vector_from_array_int(c_d_37, 3);

  int c_p_38[] = { 12,  13,  14}; //   3
  psi_c_p[no_ps][38] = get_vector_from_array_int(c_p_38, 3);
  int c_f_38[] = {}; //   0
  psi_c_f[no_ps][38] = get_vector_from_array_int(c_f_38, 0);
  int c_t_38[] = {  0}; //   1
  psi_c_t[no_ps][38] = get_vector_from_array_int(c_t_38, 1);
  int c_d_38[] = {  9,  10,   8}; //   3
  psi_c_d[no_ps][38] = get_vector_from_array_int(c_d_38, 3);

  int c_p_39[] = { 12,  13,  15}; //   3
  psi_c_p[no_ps][39] = get_vector_from_array_int(c_p_39, 3);
  int c_f_39[] = {}; //   0
  psi_c_f[no_ps][39] = get_vector_from_array_int(c_f_39, 0);
  int c_t_39[] = {  0}; //   1
  psi_c_t[no_ps][39] = get_vector_from_array_int(c_t_39, 1);
  int c_d_39[] = {  9,  10,   8}; //   3
  psi_c_d[no_ps][39] = get_vector_from_array_int(c_d_39, 3);

  int c_p_40[] = {  0,  22,  23}; //   3
  psi_c_p[no_ps][40] = get_vector_from_array_int(c_p_40, 3);
  int c_f_40[] = {}; //   0
  psi_c_f[no_ps][40] = get_vector_from_array_int(c_f_40, 0);
  int c_t_40[] = {  1}; //   1
  psi_c_t[no_ps][40] = get_vector_from_array_int(c_t_40, 1);
  int c_d_40[] = { 14,   8,   3}; //   3
  psi_c_d[no_ps][40] = get_vector_from_array_int(c_d_40, 3);

  int c_p_41[] = {  0,  24,  23}; //   3
  psi_c_p[no_ps][41] = get_vector_from_array_int(c_p_41, 3);
  int c_f_41[] = {}; //   0
  psi_c_f[no_ps][41] = get_vector_from_array_int(c_f_41, 0);
  int c_t_41[] = {  1}; //   1
  psi_c_t[no_ps][41] = get_vector_from_array_int(c_t_41, 1);
  int c_d_41[] = { 14,   8,   3}; //   3
  psi_c_d[no_ps][41] = get_vector_from_array_int(c_d_41, 3);

  int c_p_42[] = {  4,  22,  23}; //   3
  psi_c_p[no_ps][42] = get_vector_from_array_int(c_p_42, 3);
  int c_f_42[] = {}; //   0
  psi_c_f[no_ps][42] = get_vector_from_array_int(c_f_42, 0);
  int c_t_42[] = {  1}; //   1
  psi_c_t[no_ps][42] = get_vector_from_array_int(c_t_42, 1);
  int c_d_42[] = { 14,   8,   3}; //   3
  psi_c_d[no_ps][42] = get_vector_from_array_int(c_d_42, 3);

  int c_p_43[] = {  4,  24,  23}; //   3
  psi_c_p[no_ps][43] = get_vector_from_array_int(c_p_43, 3);
  int c_f_43[] = {}; //   0
  psi_c_f[no_ps][43] = get_vector_from_array_int(c_f_43, 0);
  int c_t_43[] = {  1}; //   1
  psi_c_t[no_ps][43] = get_vector_from_array_int(c_t_43, 1);
  int c_d_43[] = { 14,   8,   3}; //   3
  psi_c_d[no_ps][43] = get_vector_from_array_int(c_d_43, 3);

  int c_p_44[] = {  8,  25,  26}; //   3
  psi_c_p[no_ps][44] = get_vector_from_array_int(c_p_44, 3);
  int c_f_44[] = {}; //   0
  psi_c_f[no_ps][44] = get_vector_from_array_int(c_f_44, 0);
  int c_t_44[] = {  2}; //   1
  psi_c_t[no_ps][44] = get_vector_from_array_int(c_t_44, 1);
  int c_d_44[] = { 12,   3,   8}; //   3
  psi_c_d[no_ps][44] = get_vector_from_array_int(c_d_44, 3);

  int c_p_45[] = {  8,  27,  26}; //   3
  psi_c_p[no_ps][45] = get_vector_from_array_int(c_p_45, 3);
  int c_f_45[] = {}; //   0
  psi_c_f[no_ps][45] = get_vector_from_array_int(c_f_45, 0);
  int c_t_45[] = {  2}; //   1
  psi_c_t[no_ps][45] = get_vector_from_array_int(c_t_45, 1);
  int c_d_45[] = { 12,   3,   8}; //   3
  psi_c_d[no_ps][45] = get_vector_from_array_int(c_d_45, 3);

  int c_p_46[] = { 12,  25,  26}; //   3
  psi_c_p[no_ps][46] = get_vector_from_array_int(c_p_46, 3);
  int c_f_46[] = {}; //   0
  psi_c_f[no_ps][46] = get_vector_from_array_int(c_f_46, 0);
  int c_t_46[] = {  2}; //   1
  psi_c_t[no_ps][46] = get_vector_from_array_int(c_t_46, 1);
  int c_d_46[] = { 12,   3,   8}; //   3
  psi_c_d[no_ps][46] = get_vector_from_array_int(c_d_46, 3);

  int c_p_47[] = { 12,  27,  26}; //   3
  psi_c_p[no_ps][47] = get_vector_from_array_int(c_p_47, 3);
  int c_f_47[] = {}; //   0
  psi_c_f[no_ps][47] = get_vector_from_array_int(c_f_47, 0);
  int c_t_47[] = {  2}; //   1
  psi_c_t[no_ps][47] = get_vector_from_array_int(c_t_47, 1);
  int c_d_47[] = { 12,   3,   8}; //   3
  psi_c_d[no_ps][47] = get_vector_from_array_int(c_d_47, 3);

  int c_p_48[] = {  0,  22}; //   2
  psi_c_p[no_ps][48] = get_vector_from_array_int(c_p_48, 2);
  int c_f_48[] = {  0}; //   1
  psi_c_f[no_ps][48] = get_vector_from_array_int(c_f_48, 1);
  int c_t_48[] = {  0,   3}; //   2
  psi_c_t[no_ps][48] = get_vector_from_array_int(c_t_48, 2);
  int c_d_48[] = {  8,   3}; //   2
  psi_c_d[no_ps][48] = get_vector_from_array_int(c_d_48, 2);

  int c_p_49[] = {  0,  24}; //   2
  psi_c_p[no_ps][49] = get_vector_from_array_int(c_p_49, 2);
  int c_f_49[] = {  0}; //   1
  psi_c_f[no_ps][49] = get_vector_from_array_int(c_f_49, 1);
  int c_t_49[] = {  0,   3}; //   2
  psi_c_t[no_ps][49] = get_vector_from_array_int(c_t_49, 2);
  int c_d_49[] = {  8,   3}; //   2
  psi_c_d[no_ps][49] = get_vector_from_array_int(c_d_49, 2);

  int c_p_50[] = {  4,  22}; //   2
  psi_c_p[no_ps][50] = get_vector_from_array_int(c_p_50, 2);
  int c_f_50[] = {  0}; //   1
  psi_c_f[no_ps][50] = get_vector_from_array_int(c_f_50, 1);
  int c_t_50[] = {  0,   3}; //   2
  psi_c_t[no_ps][50] = get_vector_from_array_int(c_t_50, 2);
  int c_d_50[] = {  8,   3}; //   2
  psi_c_d[no_ps][50] = get_vector_from_array_int(c_d_50, 2);

  int c_p_51[] = {  4,  24}; //   2
  psi_c_p[no_ps][51] = get_vector_from_array_int(c_p_51, 2);
  int c_f_51[] = {  0}; //   1
  psi_c_f[no_ps][51] = get_vector_from_array_int(c_f_51, 1);
  int c_t_51[] = {  0,   3}; //   2
  psi_c_t[no_ps][51] = get_vector_from_array_int(c_t_51, 2);
  int c_d_51[] = {  8,   3}; //   2
  psi_c_d[no_ps][51] = get_vector_from_array_int(c_d_51, 2);

  int c_p_52[] = {  8,  25}; //   2
  psi_c_p[no_ps][52] = get_vector_from_array_int(c_p_52, 2);
  int c_f_52[] = {  0}; //   1
  psi_c_f[no_ps][52] = get_vector_from_array_int(c_f_52, 1);
  int c_t_52[] = {  0,   4}; //   2
  psi_c_t[no_ps][52] = get_vector_from_array_int(c_t_52, 2);
  int c_d_52[] = {  3,   8}; //   2
  psi_c_d[no_ps][52] = get_vector_from_array_int(c_d_52, 2);

  int c_p_53[] = {  8,  27}; //   2
  psi_c_p[no_ps][53] = get_vector_from_array_int(c_p_53, 2);
  int c_f_53[] = {  0}; //   1
  psi_c_f[no_ps][53] = get_vector_from_array_int(c_f_53, 1);
  int c_t_53[] = {  0,   4}; //   2
  psi_c_t[no_ps][53] = get_vector_from_array_int(c_t_53, 2);
  int c_d_53[] = {  3,   8}; //   2
  psi_c_d[no_ps][53] = get_vector_from_array_int(c_d_53, 2);

  int c_p_54[] = { 12,  25}; //   2
  psi_c_p[no_ps][54] = get_vector_from_array_int(c_p_54, 2);
  int c_f_54[] = {  0}; //   1
  psi_c_f[no_ps][54] = get_vector_from_array_int(c_f_54, 1);
  int c_t_54[] = {  0,   4}; //   2
  psi_c_t[no_ps][54] = get_vector_from_array_int(c_t_54, 2);
  int c_d_54[] = {  3,   8}; //   2
  psi_c_d[no_ps][54] = get_vector_from_array_int(c_d_54, 2);

  int c_p_55[] = { 12,  27}; //   2
  psi_c_p[no_ps][55] = get_vector_from_array_int(c_p_55, 2);
  int c_f_55[] = {  0}; //   1
  psi_c_f[no_ps][55] = get_vector_from_array_int(c_f_55, 1);
  int c_t_55[] = {  0,   4}; //   2
  psi_c_t[no_ps][55] = get_vector_from_array_int(c_t_55, 2);
  int c_d_55[] = {  3,   8}; //   2
  psi_c_d[no_ps][55] = get_vector_from_array_int(c_d_55, 2);

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
