#include "../include/classes.cxx"
#include "../include/definitions.phasespace.set.cxx"
#include "../ppemxnmnex04/header/ppemxnmnex04.phasespace.h"
void ppemxnmnex04_ax_psp_240_gg_emmupvmvex(int no_ps, phasespace_set & psi){
  static Logger logger("ppemxnmnex04_ax_psp_240_gg_emmupvmvex");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;
  psi_v_smin[no_ps].resize(6);
  psi_needed_v_smin[no_ps].resize(6);
  int needed_v_smin_0[] = {   0,    1,    2,    6,    7,    8,    9,   10,   11,   12,   13,   14}; //  12
  psi_needed_v_smin[no_ps][  0] = get_vector_from_array_int(needed_v_smin_0, 12);
  int needed_v_smin_1[] = {   0,    1}; //   2
  psi_needed_v_smin[no_ps][  1] = get_vector_from_array_int(needed_v_smin_1, 2);
  int needed_v_smin_2[] = {   2}; //   1
  psi_needed_v_smin[no_ps][  2] = get_vector_from_array_int(needed_v_smin_2, 1);
  int needed_v_smin_3[] = {   3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14}; //  12
  psi_needed_v_smin[no_ps][  3] = get_vector_from_array_int(needed_v_smin_3, 12);
  int needed_v_smin_4[] = {   3,    4}; //   2
  psi_needed_v_smin[no_ps][  4] = get_vector_from_array_int(needed_v_smin_4, 2);
  int needed_v_smin_5[] = {   5}; //   1
  psi_needed_v_smin[no_ps][  5] = get_vector_from_array_int(needed_v_smin_5, 1);

  psi_v_smax[no_ps].resize(8);
  psi_needed_v_smax[no_ps].resize(8);
  int needed_v_smax_0[] = {   0,    1,    2,    6,    7,    8,    9,   10,   11}; //   9
  psi_needed_v_smax[no_ps][  0] = get_vector_from_array_int(needed_v_smax_0, 9);
  int needed_v_smax_1[] = {   0,    1}; //   2
  psi_needed_v_smax[no_ps][  1] = get_vector_from_array_int(needed_v_smax_1, 2);
  int needed_v_smax_2[] = {   2}; //   1
  psi_needed_v_smax[no_ps][  2] = get_vector_from_array_int(needed_v_smax_2, 1);
  int needed_v_smax_3[] = {   3,    4,    5,   12,   13,   14}; //   6
  psi_needed_v_smax[no_ps][  3] = get_vector_from_array_int(needed_v_smax_3, 6);
  int needed_v_smax_4[] = {   3,    4}; //   2
  psi_needed_v_smax[no_ps][  4] = get_vector_from_array_int(needed_v_smax_4, 2);
  int needed_v_smax_5[] = {   5}; //   1
  psi_needed_v_smax[no_ps][  5] = get_vector_from_array_int(needed_v_smax_5, 1);
  int needed_v_smax_6[] = {   6,    7,    8,    9,   10,   11}; //   6
  psi_needed_v_smax[no_ps][  6] = get_vector_from_array_int(needed_v_smax_6, 6);
  int needed_v_smax_7[] = {  12,   13,   14}; //   3
  psi_needed_v_smax[no_ps][  7] = get_vector_from_array_int(needed_v_smax_7, 3);

  psi_container_IS_startvalue[no_ps][0] = psi_container_IS_name.size();
  psi_g_p[no_ps].resize(8);
  psi_needed_g_p[no_ps].resize(8);
  int needed_g_p_0[] = {   0,    1,    2,    6,    7,    8,    9,   10,   11}; //   9
  psi_needed_g_p[no_ps][0] = get_vector_from_array_int(needed_g_p_0, 9);
  psi_container_IS_name.push_back("propagator_24_smin0_smax0");
  int needed_g_p_1[] = {   0,    1}; //   2
  psi_needed_g_p[no_ps][1] = get_vector_from_array_int(needed_g_p_1, 2);
  psi_container_IS_name.push_back("propagator_0_smin1_smax1");
  int needed_g_p_2[] = {   2}; //   1
  psi_needed_g_p[no_ps][2] = get_vector_from_array_int(needed_g_p_2, 1);
  psi_container_IS_name.push_back("propagator_0_smin2_smax2");
  int needed_g_p_3[] = {   3,    4,    5,   12,   13,   14}; //   6
  psi_needed_g_p[no_ps][3] = get_vector_from_array_int(needed_g_p_3, 6);
  psi_container_IS_name.push_back("propagator_24_smin3_smax3");
  int needed_g_p_4[] = {   3,    4}; //   2
  psi_needed_g_p[no_ps][4] = get_vector_from_array_int(needed_g_p_4, 2);
  psi_container_IS_name.push_back("propagator_0_smin4_smax4");
  int needed_g_p_5[] = {   5}; //   1
  psi_needed_g_p[no_ps][5] = get_vector_from_array_int(needed_g_p_5, 1);
  psi_container_IS_name.push_back("propagator_0_smin5_smax5");
  int needed_g_p_6[] = {   6,    7,    8,    9,   10,   11}; //   6
  psi_needed_g_p[no_ps][6] = get_vector_from_array_int(needed_g_p_6, 6);
  psi_container_IS_name.push_back("propagator_24_smin3_smax6");
  int needed_g_p_7[] = {  12,   13,   14}; //   3
  psi_needed_g_p[no_ps][7] = get_vector_from_array_int(needed_g_p_7, 3);
  psi_container_IS_name.push_back("propagator_24_smin0_smax7");

  psi_container_IS_startvalue[no_ps][1] = psi_container_IS_name.size();
  psi_g_f[no_ps].resize(0);
  psi_needed_g_f[no_ps].resize(0);

  psi_container_IS_startvalue[no_ps][2] = psi_container_IS_name.size();
  psi_g_t[no_ps].resize(6);
  psi_needed_g_t[no_ps].resize(6);
  int needed_g_t_0[] = {   9}; //   1
  psi_needed_g_t[no_ps][0] = get_vector_from_array_int(needed_g_t_0, 1);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_2__36_24");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_2__36_24");
  int needed_g_t_1[] = {  10}; //   1
  psi_needed_g_t[no_ps][1] = get_vector_from_array_int(needed_g_t_1, 1);
  psi_container_IS_name.push_back("t_of_tchannel_opt_6__1_2__36_24");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_6__1_2__36_24");
  int needed_g_t_2[] = {  11}; //   1
  psi_needed_g_t[no_ps][2] = get_vector_from_array_int(needed_g_t_2, 1);
  psi_container_IS_name.push_back("t_of_tchannel_opt_5__1_2__36_24");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_5__1_2__36_24");
  int needed_g_t_3[] = {  12}; //   1
  psi_needed_g_t[no_ps][3] = get_vector_from_array_int(needed_g_t_3, 1);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_2__24_36");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_2__24_36");
  int needed_g_t_4[] = {  13}; //   1
  psi_needed_g_t[no_ps][4] = get_vector_from_array_int(needed_g_t_4, 1);
  psi_container_IS_name.push_back("t_of_tchannel_opt_5__1_2__24_36");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_5__1_2__24_36");
  int needed_g_t_5[] = {  14}; //   1
  psi_needed_g_t[no_ps][5] = get_vector_from_array_int(needed_g_t_5, 1);
  psi_container_IS_name.push_back("t_of_tchannel_opt_6__1_2__24_36");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_6__1_2__24_36");

  psi_container_IS_startvalue[no_ps][3] = psi_container_IS_name.size();
  psi_g_d[no_ps].resize(11);
  psi_needed_g_d[no_ps].resize(11);
  int needed_g_d_0[] = {   0,    1}; //   2
  psi_needed_g_d[no_ps][0] = get_vector_from_array_int(needed_g_d_0, 2);
  psi_container_IS_name.push_back("costheta_of_decay_60__4_56");
  psi_container_IS_name.push_back("phi_of_decay_60__4_56");
  int needed_g_d_1[] = {   0,    1}; //   2
  psi_needed_g_d[no_ps][1] = get_vector_from_array_int(needed_g_d_1, 2);
  psi_container_IS_name.push_back("costheta_of_decay_56__32_24");
  psi_container_IS_name.push_back("phi_of_decay_56__32_24");
  int needed_g_d_2[] = {   0,    1,    2,    6,    7,    8,    9,   10,   11,   12,   13,   14}; //  12
  psi_needed_g_d[no_ps][2] = get_vector_from_array_int(needed_g_d_2, 12);
  psi_container_IS_name.push_back("costheta_of_decay_24__8_16");
  psi_container_IS_name.push_back("phi_of_decay_24__8_16");
  int needed_g_d_3[] = {   2}; //   1
  psi_needed_g_d[no_ps][3] = get_vector_from_array_int(needed_g_d_3, 1);
  psi_container_IS_name.push_back("costheta_of_decay_60__32_28");
  psi_container_IS_name.push_back("phi_of_decay_60__32_28");
  int needed_g_d_4[] = {   2}; //   1
  psi_needed_g_d[no_ps][4] = get_vector_from_array_int(needed_g_d_4, 1);
  psi_container_IS_name.push_back("costheta_of_decay_28__4_24");
  psi_container_IS_name.push_back("phi_of_decay_28__4_24");
  int needed_g_d_5[] = {   3,    4}; //   2
  psi_needed_g_d[no_ps][5] = get_vector_from_array_int(needed_g_d_5, 2);
  psi_container_IS_name.push_back("costheta_of_decay_60__8_52");
  psi_container_IS_name.push_back("phi_of_decay_60__8_52");
  int needed_g_d_6[] = {   3,    4}; //   2
  psi_needed_g_d[no_ps][6] = get_vector_from_array_int(needed_g_d_6, 2);
  psi_container_IS_name.push_back("costheta_of_decay_52__16_36");
  psi_container_IS_name.push_back("phi_of_decay_52__16_36");
  int needed_g_d_7[] = {   3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14}; //  12
  psi_needed_g_d[no_ps][7] = get_vector_from_array_int(needed_g_d_7, 12);
  psi_container_IS_name.push_back("costheta_of_decay_36__4_32");
  psi_container_IS_name.push_back("phi_of_decay_36__4_32");
  int needed_g_d_8[] = {   5}; //   1
  psi_needed_g_d[no_ps][8] = get_vector_from_array_int(needed_g_d_8, 1);
  psi_container_IS_name.push_back("costheta_of_decay_60__16_44");
  psi_container_IS_name.push_back("phi_of_decay_60__16_44");
  int needed_g_d_9[] = {   5}; //   1
  psi_needed_g_d[no_ps][9] = get_vector_from_array_int(needed_g_d_9, 1);
  psi_container_IS_name.push_back("costheta_of_decay_44__8_36");
  psi_container_IS_name.push_back("phi_of_decay_44__8_36");
  int needed_g_d_10[] = {   6,    7,    8}; //   3
  psi_needed_g_d[no_ps][10] = get_vector_from_array_int(needed_g_d_10, 3);
  psi_container_IS_name.push_back("costheta_of_decay_60__36_24");
  psi_container_IS_name.push_back("phi_of_decay_60__36_24");

  psi_c_p[no_ps].resize(15);
  psi_c_f[no_ps].resize(15);
  psi_c_t[no_ps].resize(15);
  psi_c_d[no_ps].resize(15);

  int c_p_0[] = {  0,   1}; //   2
  psi_c_p[no_ps][0] = get_vector_from_array_int(c_p_0, 2);
  int c_f_0[] = {}; //   0
  psi_c_f[no_ps][0] = get_vector_from_array_int(c_f_0, 0);
  int c_t_0[] = {}; //   0
  psi_c_t[no_ps][0] = get_vector_from_array_int(c_t_0, 0);
  int c_d_0[] = {  0,   1,   2}; //   3
  psi_c_d[no_ps][0] = get_vector_from_array_int(c_d_0, 3);

  int c_p_1[] = {  0,   1}; //   2
  psi_c_p[no_ps][1] = get_vector_from_array_int(c_p_1, 2);
  int c_f_1[] = {}; //   0
  psi_c_f[no_ps][1] = get_vector_from_array_int(c_f_1, 0);
  int c_t_1[] = {}; //   0
  psi_c_t[no_ps][1] = get_vector_from_array_int(c_t_1, 0);
  int c_d_1[] = {  0,   1,   2}; //   3
  psi_c_d[no_ps][1] = get_vector_from_array_int(c_d_1, 3);

  int c_p_2[] = {  0,   2}; //   2
  psi_c_p[no_ps][2] = get_vector_from_array_int(c_p_2, 2);
  int c_f_2[] = {}; //   0
  psi_c_f[no_ps][2] = get_vector_from_array_int(c_f_2, 0);
  int c_t_2[] = {}; //   0
  psi_c_t[no_ps][2] = get_vector_from_array_int(c_t_2, 0);
  int c_d_2[] = {  3,   4,   2}; //   3
  psi_c_d[no_ps][2] = get_vector_from_array_int(c_d_2, 3);

  int c_p_3[] = {  3,   4}; //   2
  psi_c_p[no_ps][3] = get_vector_from_array_int(c_p_3, 2);
  int c_f_3[] = {}; //   0
  psi_c_f[no_ps][3] = get_vector_from_array_int(c_f_3, 0);
  int c_t_3[] = {}; //   0
  psi_c_t[no_ps][3] = get_vector_from_array_int(c_t_3, 0);
  int c_d_3[] = {  5,   6,   7}; //   3
  psi_c_d[no_ps][3] = get_vector_from_array_int(c_d_3, 3);

  int c_p_4[] = {  3,   4}; //   2
  psi_c_p[no_ps][4] = get_vector_from_array_int(c_p_4, 2);
  int c_f_4[] = {}; //   0
  psi_c_f[no_ps][4] = get_vector_from_array_int(c_f_4, 0);
  int c_t_4[] = {}; //   0
  psi_c_t[no_ps][4] = get_vector_from_array_int(c_t_4, 0);
  int c_d_4[] = {  5,   6,   7}; //   3
  psi_c_d[no_ps][4] = get_vector_from_array_int(c_d_4, 3);

  int c_p_5[] = {  3,   5}; //   2
  psi_c_p[no_ps][5] = get_vector_from_array_int(c_p_5, 2);
  int c_f_5[] = {}; //   0
  psi_c_f[no_ps][5] = get_vector_from_array_int(c_f_5, 0);
  int c_t_5[] = {}; //   0
  psi_c_t[no_ps][5] = get_vector_from_array_int(c_t_5, 0);
  int c_d_5[] = {  8,   9,   7}; //   3
  psi_c_d[no_ps][5] = get_vector_from_array_int(c_d_5, 3);

  int c_p_6[] = {  0,   6}; //   2
  psi_c_p[no_ps][6] = get_vector_from_array_int(c_p_6, 2);
  int c_f_6[] = {}; //   0
  psi_c_f[no_ps][6] = get_vector_from_array_int(c_f_6, 0);
  int c_t_6[] = {}; //   0
  psi_c_t[no_ps][6] = get_vector_from_array_int(c_t_6, 0);
  int c_d_6[] = { 10,   7,   2}; //   3
  psi_c_d[no_ps][6] = get_vector_from_array_int(c_d_6, 3);

  int c_p_7[] = {  0,   6}; //   2
  psi_c_p[no_ps][7] = get_vector_from_array_int(c_p_7, 2);
  int c_f_7[] = {}; //   0
  psi_c_f[no_ps][7] = get_vector_from_array_int(c_f_7, 0);
  int c_t_7[] = {}; //   0
  psi_c_t[no_ps][7] = get_vector_from_array_int(c_t_7, 0);
  int c_d_7[] = { 10,   7,   2}; //   3
  psi_c_d[no_ps][7] = get_vector_from_array_int(c_d_7, 3);

  int c_p_8[] = {  0,   6}; //   2
  psi_c_p[no_ps][8] = get_vector_from_array_int(c_p_8, 2);
  int c_f_8[] = {}; //   0
  psi_c_f[no_ps][8] = get_vector_from_array_int(c_f_8, 0);
  int c_t_8[] = {}; //   0
  psi_c_t[no_ps][8] = get_vector_from_array_int(c_t_8, 0);
  int c_d_8[] = { 10,   7,   2}; //   3
  psi_c_d[no_ps][8] = get_vector_from_array_int(c_d_8, 3);

  int c_p_9[] = {  0,   6}; //   2
  psi_c_p[no_ps][9] = get_vector_from_array_int(c_p_9, 2);
  int c_f_9[] = {}; //   0
  psi_c_f[no_ps][9] = get_vector_from_array_int(c_f_9, 0);
  int c_t_9[] = {  0}; //   1
  psi_c_t[no_ps][9] = get_vector_from_array_int(c_t_9, 1);
  int c_d_9[] = {  7,   2}; //   2
  psi_c_d[no_ps][9] = get_vector_from_array_int(c_d_9, 2);

  int c_p_10[] = {  0,   6}; //   2
  psi_c_p[no_ps][10] = get_vector_from_array_int(c_p_10, 2);
  int c_f_10[] = {}; //   0
  psi_c_f[no_ps][10] = get_vector_from_array_int(c_f_10, 0);
  int c_t_10[] = {  1}; //   1
  psi_c_t[no_ps][10] = get_vector_from_array_int(c_t_10, 1);
  int c_d_10[] = {  7,   2}; //   2
  psi_c_d[no_ps][10] = get_vector_from_array_int(c_d_10, 2);

  int c_p_11[] = {  0,   6}; //   2
  psi_c_p[no_ps][11] = get_vector_from_array_int(c_p_11, 2);
  int c_f_11[] = {}; //   0
  psi_c_f[no_ps][11] = get_vector_from_array_int(c_f_11, 0);
  int c_t_11[] = {  2}; //   1
  psi_c_t[no_ps][11] = get_vector_from_array_int(c_t_11, 1);
  int c_d_11[] = {  7,   2}; //   2
  psi_c_d[no_ps][11] = get_vector_from_array_int(c_d_11, 2);

  int c_p_12[] = {  3,   7}; //   2
  psi_c_p[no_ps][12] = get_vector_from_array_int(c_p_12, 2);
  int c_f_12[] = {}; //   0
  psi_c_f[no_ps][12] = get_vector_from_array_int(c_f_12, 0);
  int c_t_12[] = {  3}; //   1
  psi_c_t[no_ps][12] = get_vector_from_array_int(c_t_12, 1);
  int c_d_12[] = {  2,   7}; //   2
  psi_c_d[no_ps][12] = get_vector_from_array_int(c_d_12, 2);

  int c_p_13[] = {  3,   7}; //   2
  psi_c_p[no_ps][13] = get_vector_from_array_int(c_p_13, 2);
  int c_f_13[] = {}; //   0
  psi_c_f[no_ps][13] = get_vector_from_array_int(c_f_13, 0);
  int c_t_13[] = {  4}; //   1
  psi_c_t[no_ps][13] = get_vector_from_array_int(c_t_13, 1);
  int c_d_13[] = {  2,   7}; //   2
  psi_c_d[no_ps][13] = get_vector_from_array_int(c_d_13, 2);

  int c_p_14[] = {  3,   7}; //   2
  psi_c_p[no_ps][14] = get_vector_from_array_int(c_p_14, 2);
  int c_f_14[] = {}; //   0
  psi_c_f[no_ps][14] = get_vector_from_array_int(c_f_14, 0);
  int c_t_14[] = {  5}; //   1
  psi_c_t[no_ps][14] = get_vector_from_array_int(c_t_14, 1);
  int c_d_14[] = {  2,   7}; //   2
  psi_c_d[no_ps][14] = get_vector_from_array_int(c_d_14, 2);

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
