#include "../include/classes.cxx"
#include "../include/definitions.phasespace.set.cxx"
#include "../ppemxnmnex04/header/ppemxnmnex04.phasespace.h"
void ppemxnmnex04_optimize_minv_doublereal(phasespace_set & psi){
  static Logger logger("ppemxnmnex04_optimize_minv_doublereal");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

#include "user/specify.optimize.phasespace.minv.doublereal.cxx"

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

int ppemxnmnex04_determination_MCchannels_doublereal(int no_ps, phasespace_set & psi){
  static Logger logger("ppemxnmnex04_determination_MCchannels_doublereal");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  int n_channel = 0;
  if      (psi_no_map[no_ps] ==  0){n_channel = 503;}
  else if (psi_no_map[no_ps] ==  2){n_channel = 79;}
  else if (psi_no_map[no_ps] ==  3){n_channel = 79;}
  else if (psi_no_map[no_ps] ==  4){n_channel = 87;}
  else if (psi_no_map[no_ps] ==  5){n_channel = 79;}
  else if (psi_no_map[no_ps] ==  6){n_channel = 79;}
  else if (psi_no_map[no_ps] ==  7){n_channel = 87;}
  else if (psi_no_map[no_ps] ==  8){n_channel = 79;}
  else if (psi_no_map[no_ps] ==  9){n_channel = 79;}
  else if (psi_no_map[no_ps] == 10){n_channel = 87;}
  else if (psi_no_map[no_ps] == 11){n_channel = 76;}
  else if (psi_no_map[no_ps] == 12){n_channel = 42;}
  else if (psi_no_map[no_ps] == 13){n_channel = 38;}
  else if (psi_no_map[no_ps] == 14){n_channel = 38;}
  else if (psi_no_map[no_ps] == 15){n_channel = 4;}
  else if (psi_no_map[no_ps] == 16){n_channel = 40;}
  else if (psi_no_map[no_ps] == 17){n_channel = 79;}
  else if (psi_no_map[no_ps] == 18){n_channel = 76;}
  else if (psi_no_map[no_ps] == 19){n_channel = 42;}
  else if (psi_no_map[no_ps] == 20){n_channel = 38;}
  else if (psi_no_map[no_ps] == 21){n_channel = 38;}
  else if (psi_no_map[no_ps] == 22){n_channel = 40;}
  else if (psi_no_map[no_ps] == 23){n_channel = 42;}
  else if (psi_no_map[no_ps] == 24){n_channel = 4;}
  else if (psi_no_map[no_ps] == 25){n_channel = 38;}
  else if (psi_no_map[no_ps] == 26){n_channel = 4;}
  else if (psi_no_map[no_ps] == 27){n_channel = 38;}
  else if (psi_no_map[no_ps] == 28){n_channel = 40;}
  else if (psi_no_map[no_ps] == 29){n_channel = 76;}
  else if (psi_no_map[no_ps] == 30){n_channel = 38;}
  else if (psi_no_map[no_ps] == 31){n_channel = 40;}
  else if (psi_no_map[no_ps] == 32){n_channel = 42;}
  else if (psi_no_map[no_ps] == 33){n_channel = 4;}
  else if (psi_no_map[no_ps] == 34){n_channel = 79;}
  else if (psi_no_map[no_ps] == 35){n_channel = 42;}
  else if (psi_no_map[no_ps] == 36){n_channel = 76;}
  else if (psi_no_map[no_ps] == 37){n_channel = 38;}
  else if (psi_no_map[no_ps] == 38){n_channel = 38;}
  else if (psi_no_map[no_ps] == 39){n_channel = 40;}
  else if (psi_no_map[no_ps] == 40){n_channel = 38;}
  else if (psi_no_map[no_ps] == 41){n_channel = 4;}
  else if (psi_no_map[no_ps] == 42){n_channel = 38;}
  else if (psi_no_map[no_ps] == 43){n_channel = 40;}
  else if (psi_no_map[no_ps] == 44){n_channel = 84;}
  else if (psi_no_map[no_ps] == 45){n_channel = 40;}
  else if (psi_no_map[no_ps] == 46){n_channel = 40;}
  else if (psi_no_map[no_ps] == 47){n_channel = 87;}
  else if (psi_no_map[no_ps] == 48){n_channel = 40;}
  else if (psi_no_map[no_ps] == 49){n_channel = 40;}
  else if (psi_no_map[no_ps] == 50){n_channel = 84;}
  else if (psi_no_map[no_ps] == 51){n_channel = 76;}
  else if (psi_no_map[no_ps] == 52){n_channel = 42;}
  else if (psi_no_map[no_ps] == 53){n_channel = 38;}
  else if (psi_no_map[no_ps] == 54){n_channel = 38;}
  else if (psi_no_map[no_ps] == 55){n_channel = 4;}
  else if (psi_no_map[no_ps] == 56){n_channel = 40;}
  else if (psi_no_map[no_ps] == 57){n_channel = 76;}
  else if (psi_no_map[no_ps] == 58){n_channel = 38;}
  else if (psi_no_map[no_ps] == 59){n_channel = 40;}
  else if (psi_no_map[no_ps] == 60){n_channel = 84;}
  return n_channel;

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

void ppemxnmnex04_ac_tau_psp_doublereal(int no_ps, vector<int> & tau_MC_map, phasespace_set & psi){
  static Logger logger("ppemxnmnex04_ac_tau_psp_doublereal");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  if      (psi.no_map[no_ps] == 0){}
  else if (psi.no_map[no_ps] ==  2){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  3){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  4){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  5){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  6){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  7){
    tau_MC_map.push_back(0);
    tau_MC_map.push_back(-5);
  }
  else if (psi.no_map[no_ps] ==  8){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  9){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 10){
    tau_MC_map.push_back(0);
    tau_MC_map.push_back(-5);
  }
  else if (psi.no_map[no_ps] == 11){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 12){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 13){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 14){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 15){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 16){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 17){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 18){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 19){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 20){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 21){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 22){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 23){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 24){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 25){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 26){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 27){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 28){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 29){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 30){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 31){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 32){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 33){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 34){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 35){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 36){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 37){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 38){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 39){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 40){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 41){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 42){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 43){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 44){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 45){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 46){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 47){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 48){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 49){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 50){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 51){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 52){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 53){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 54){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 55){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 56){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 57){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 58){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 59){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 60){
    tau_MC_map.push_back(0);
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

void ppemxnmnex04_ax_psp_doublereal(int no_ps, phasespace_set & psi){
  static Logger logger("ppemxnmnex04_ax_psp_doublereal");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;
  if (psi_no_map[no_ps] == 0){}
  else if (psi_no_map[no_ps] ==  2){ppemxnmnex04_ax_psp_240_gg_emmupvmvexddx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  3){ppemxnmnex04_ax_psp_240_gg_emmupvmvexuux(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  4){ppemxnmnex04_ax_psp_240_gg_emmupvmvexbbx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  5){ppemxnmnex04_ax_psp_240_gd_emmupvmvexgd(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  6){ppemxnmnex04_ax_psp_240_gu_emmupvmvexgu(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  7){ppemxnmnex04_ax_psp_240_gb_emmupvmvexgb(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  8){ppemxnmnex04_ax_psp_240_gdx_emmupvmvexgdx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  9){ppemxnmnex04_ax_psp_240_gux_emmupvmvexgux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 10){ppemxnmnex04_ax_psp_240_gbx_emmupvmvexgbx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 11){ppemxnmnex04_ax_psp_240_dd_emmupvmvexdd(no_ps, psi);}
  else if (psi_no_map[no_ps] == 12){ppemxnmnex04_ax_psp_240_du_emmupvmvexdu(no_ps, psi);}
  else if (psi_no_map[no_ps] == 13){ppemxnmnex04_ax_psp_240_ds_emmupvmvexds(no_ps, psi);}
  else if (psi_no_map[no_ps] == 14){ppemxnmnex04_ax_psp_240_dc_emmupvmvexdc(no_ps, psi);}
  else if (psi_no_map[no_ps] == 15){ppemxnmnex04_ax_psp_240_dc_emmupvmvexus(no_ps, psi);}
  else if (psi_no_map[no_ps] == 16){ppemxnmnex04_ax_psp_240_db_emmupvmvexdb(no_ps, psi);}
  else if (psi_no_map[no_ps] == 17){ppemxnmnex04_ax_psp_240_ddx_emmupvmvexgg(no_ps, psi);}
  else if (psi_no_map[no_ps] == 18){ppemxnmnex04_ax_psp_240_ddx_emmupvmvexddx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 19){ppemxnmnex04_ax_psp_240_ddx_emmupvmvexuux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 20){ppemxnmnex04_ax_psp_240_ddx_emmupvmvexssx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 21){ppemxnmnex04_ax_psp_240_ddx_emmupvmvexccx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 22){ppemxnmnex04_ax_psp_240_ddx_emmupvmvexbbx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 23){ppemxnmnex04_ax_psp_240_dux_emmupvmvexdux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 24){ppemxnmnex04_ax_psp_240_dux_emmupvmvexscx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 25){ppemxnmnex04_ax_psp_240_dsx_emmupvmvexdsx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 26){ppemxnmnex04_ax_psp_240_dsx_emmupvmvexucx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 27){ppemxnmnex04_ax_psp_240_dcx_emmupvmvexdcx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 28){ppemxnmnex04_ax_psp_240_dbx_emmupvmvexdbx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 29){ppemxnmnex04_ax_psp_240_uu_emmupvmvexuu(no_ps, psi);}
  else if (psi_no_map[no_ps] == 30){ppemxnmnex04_ax_psp_240_uc_emmupvmvexuc(no_ps, psi);}
  else if (psi_no_map[no_ps] == 31){ppemxnmnex04_ax_psp_240_ub_emmupvmvexub(no_ps, psi);}
  else if (psi_no_map[no_ps] == 32){ppemxnmnex04_ax_psp_240_udx_emmupvmvexudx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 33){ppemxnmnex04_ax_psp_240_udx_emmupvmvexcsx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 34){ppemxnmnex04_ax_psp_240_uux_emmupvmvexgg(no_ps, psi);}
  else if (psi_no_map[no_ps] == 35){ppemxnmnex04_ax_psp_240_uux_emmupvmvexddx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 36){ppemxnmnex04_ax_psp_240_uux_emmupvmvexuux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 37){ppemxnmnex04_ax_psp_240_uux_emmupvmvexssx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 38){ppemxnmnex04_ax_psp_240_uux_emmupvmvexccx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 39){ppemxnmnex04_ax_psp_240_uux_emmupvmvexbbx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 40){ppemxnmnex04_ax_psp_240_usx_emmupvmvexusx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 41){ppemxnmnex04_ax_psp_240_ucx_emmupvmvexdsx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 42){ppemxnmnex04_ax_psp_240_ucx_emmupvmvexucx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 43){ppemxnmnex04_ax_psp_240_ubx_emmupvmvexubx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 44){ppemxnmnex04_ax_psp_240_bb_emmupvmvexbb(no_ps, psi);}
  else if (psi_no_map[no_ps] == 45){ppemxnmnex04_ax_psp_240_bdx_emmupvmvexbdx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 46){ppemxnmnex04_ax_psp_240_bux_emmupvmvexbux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 47){ppemxnmnex04_ax_psp_240_bbx_emmupvmvexgg(no_ps, psi);}
  else if (psi_no_map[no_ps] == 48){ppemxnmnex04_ax_psp_240_bbx_emmupvmvexddx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 49){ppemxnmnex04_ax_psp_240_bbx_emmupvmvexuux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 50){ppemxnmnex04_ax_psp_240_bbx_emmupvmvexbbx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 51){ppemxnmnex04_ax_psp_240_dxdx_emmupvmvexdxdx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 52){ppemxnmnex04_ax_psp_240_dxux_emmupvmvexdxux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 53){ppemxnmnex04_ax_psp_240_dxsx_emmupvmvexdxsx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 54){ppemxnmnex04_ax_psp_240_dxcx_emmupvmvexdxcx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 55){ppemxnmnex04_ax_psp_240_dxcx_emmupvmvexuxsx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 56){ppemxnmnex04_ax_psp_240_dxbx_emmupvmvexdxbx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 57){ppemxnmnex04_ax_psp_240_uxux_emmupvmvexuxux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 58){ppemxnmnex04_ax_psp_240_uxcx_emmupvmvexuxcx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 59){ppemxnmnex04_ax_psp_240_uxbx_emmupvmvexuxbx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 60){ppemxnmnex04_ax_psp_240_bxbx_emmupvmvexbxbx(no_ps, psi);}

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
