#include "../include/classes.cxx"
#include "../include/definitions.phasespace.set.cxx"
#include "../ppexne02/header/ppexne02.phasespace.h"
void ppexne02_optimize_minv_doublereal(phasespace_set & psi){
  static Logger logger("ppexne02_optimize_minv_doublereal");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

#include "user/specify.optimize.phasespace.minv.doublereal.cxx"

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

int ppexne02_determination_MCchannels_doublereal(int no_ps, phasespace_set & psi){
  static Logger logger("ppexne02_determination_MCchannels_doublereal");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  int n_channel = 0;
  if      (psi_no_map[no_ps] ==   0){n_channel = 60;}
  else if (psi_no_map[no_ps] ==   1){n_channel = 8;}
  else if (psi_no_map[no_ps] ==   2){n_channel = 8;}
  else if (psi_no_map[no_ps] ==   3){n_channel = 8;}
  else if (psi_no_map[no_ps] ==   4){n_channel = 8;}
  else if (psi_no_map[no_ps] ==   5){n_channel = 8;}
  else if (psi_no_map[no_ps] ==   6){n_channel = 8;}
  else if (psi_no_map[no_ps] ==   7){n_channel = 8;}
  else if (psi_no_map[no_ps] ==   8){n_channel = 8;}
  else if (psi_no_map[no_ps] ==   9){n_channel = 8;}
  else if (psi_no_map[no_ps] ==  10){n_channel = 8;}
  else if (psi_no_map[no_ps] ==  11){n_channel = 8;}
  else if (psi_no_map[no_ps] ==  12){n_channel = 8;}
  else if (psi_no_map[no_ps] ==  13){n_channel = 8;}
  else if (psi_no_map[no_ps] ==  14){n_channel = 8;}
  else if (psi_no_map[no_ps] ==  15){n_channel = 8;}
  else if (psi_no_map[no_ps] ==  16){n_channel = 8;}
  else if (psi_no_map[no_ps] ==  17){n_channel = 8;}
  else if (psi_no_map[no_ps] ==  18){n_channel = 8;}
  else if (psi_no_map[no_ps] ==  19){n_channel = 4;}
  else if (psi_no_map[no_ps] ==  20){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  21){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  25){n_channel = 4;}
  else if (psi_no_map[no_ps] ==  26){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  27){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  31){n_channel = 4;}
  else if (psi_no_map[no_ps] ==  32){n_channel = 4;}
  else if (psi_no_map[no_ps] ==  33){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  34){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  35){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  36){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  37){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  38){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  43){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  44){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  49){n_channel = 4;}
  else if (psi_no_map[no_ps] ==  51){n_channel = 4;}
  else if (psi_no_map[no_ps] ==  52){n_channel = 4;}
  else if (psi_no_map[no_ps] ==  56){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  58){n_channel = 4;}
  else if (psi_no_map[no_ps] ==  59){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  61){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  62){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  63){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  64){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  65){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  66){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  69){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  71){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  72){n_channel = 4;}
  else if (psi_no_map[no_ps] ==  73){n_channel = 8;}
  else if (psi_no_map[no_ps] ==  74){n_channel = 4;}
  else if (psi_no_map[no_ps] ==  77){n_channel = 4;}
  else if (psi_no_map[no_ps] ==  78){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  79){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  80){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  83){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  84){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  86){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  87){n_channel = 4;}
  else if (psi_no_map[no_ps] ==  88){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  89){n_channel = 4;}
  else if (psi_no_map[no_ps] ==  90){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  91){n_channel = 4;}
  else if (psi_no_map[no_ps] ==  92){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  93){n_channel = 8;}
  else if (psi_no_map[no_ps] ==  94){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  95){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  97){n_channel = 4;}
  else if (psi_no_map[no_ps] ==  98){n_channel = 2;}
  else if (psi_no_map[no_ps] == 100){n_channel = 4;}
  else if (psi_no_map[no_ps] == 103){n_channel = 2;}
  else if (psi_no_map[no_ps] == 105){n_channel = 2;}
  else if (psi_no_map[no_ps] == 106){n_channel = 2;}
  else if (psi_no_map[no_ps] == 108){n_channel = 2;}
  else if (psi_no_map[no_ps] == 110){n_channel = 2;}
  else if (psi_no_map[no_ps] == 112){n_channel = 2;}
  else if (psi_no_map[no_ps] == 113){n_channel = 8;}
  else if (psi_no_map[no_ps] == 114){n_channel = 2;}
  else if (psi_no_map[no_ps] == 116){n_channel = 2;}
  else if (psi_no_map[no_ps] == 117){n_channel = 4;}
  else if (psi_no_map[no_ps] == 118){n_channel = 2;}
  else if (psi_no_map[no_ps] == 120){n_channel = 2;}
  else if (psi_no_map[no_ps] == 121){n_channel = 2;}
  else if (psi_no_map[no_ps] == 123){n_channel = 2;}
  else if (psi_no_map[no_ps] == 126){n_channel = 4;}
  else if (psi_no_map[no_ps] == 128){n_channel = 2;}
  else if (psi_no_map[no_ps] == 130){n_channel = 4;}
  else if (psi_no_map[no_ps] == 131){n_channel = 2;}
  else if (psi_no_map[no_ps] == 135){n_channel = 2;}
  else if (psi_no_map[no_ps] == 136){n_channel = 2;}
  else if (psi_no_map[no_ps] == 139){n_channel = 2;}
  else if (psi_no_map[no_ps] == 140){n_channel = 2;}
  else if (psi_no_map[no_ps] == 141){n_channel = 4;}
  else if (psi_no_map[no_ps] == 142){n_channel = 4;}
  else if (psi_no_map[no_ps] == 143){n_channel = 2;}
  else if (psi_no_map[no_ps] == 144){n_channel = 2;}
  else if (psi_no_map[no_ps] == 147){n_channel = 2;}
  else if (psi_no_map[no_ps] == 148){n_channel = 2;}
  else if (psi_no_map[no_ps] == 152){n_channel = 4;}
  else if (psi_no_map[no_ps] == 155){n_channel = 4;}
  else if (psi_no_map[no_ps] == 156){n_channel = 4;}
  else if (psi_no_map[no_ps] == 159){n_channel = 2;}
  else if (psi_no_map[no_ps] == 161){n_channel = 2;}
  else if (psi_no_map[no_ps] == 162){n_channel = 4;}
  else if (psi_no_map[no_ps] == 163){n_channel = 8;}
  else if (psi_no_map[no_ps] == 164){n_channel = 4;}
  else if (psi_no_map[no_ps] == 167){n_channel = 2;}
  else if (psi_no_map[no_ps] == 169){n_channel = 2;}
  else if (psi_no_map[no_ps] == 170){n_channel = 2;}
  else if (psi_no_map[no_ps] == 172){n_channel = 2;}
  else if (psi_no_map[no_ps] == 173){n_channel = 4;}
  else if (psi_no_map[no_ps] == 174){n_channel = 2;}
  else if (psi_no_map[no_ps] == 176){n_channel = 2;}
  else if (psi_no_map[no_ps] == 177){n_channel = 2;}
  else if (psi_no_map[no_ps] == 179){n_channel = 2;}
  else if (psi_no_map[no_ps] == 181){n_channel = 2;}
  else if (psi_no_map[no_ps] == 183){n_channel = 8;}
  else if (psi_no_map[no_ps] == 184){n_channel = 2;}
  else if (psi_no_map[no_ps] == 185){n_channel = 2;}
  else if (psi_no_map[no_ps] == 187){n_channel = 2;}
  else if (psi_no_map[no_ps] == 190){n_channel = 4;}
  else if (psi_no_map[no_ps] == 192){n_channel = 2;}
  else if (psi_no_map[no_ps] == 193){n_channel = 4;}
  else if (psi_no_map[no_ps] == 195){n_channel = 2;}
  else if (psi_no_map[no_ps] == 196){n_channel = 2;}
  else if (psi_no_map[no_ps] == 197){n_channel = 2;}
  else if (psi_no_map[no_ps] == 198){n_channel = 4;}
  else if (psi_no_map[no_ps] == 199){n_channel = 2;}
  else if (psi_no_map[no_ps] == 200){n_channel = 4;}
  else if (psi_no_map[no_ps] == 201){n_channel = 2;}
  else if (psi_no_map[no_ps] == 202){n_channel = 4;}
  else if (psi_no_map[no_ps] == 203){n_channel = 8;}
  else if (psi_no_map[no_ps] == 204){n_channel = 2;}
  else if (psi_no_map[no_ps] == 206){n_channel = 2;}
  else if (psi_no_map[no_ps] == 207){n_channel = 2;}
  else if (psi_no_map[no_ps] == 210){n_channel = 2;}
  else if (psi_no_map[no_ps] == 211){n_channel = 2;}
  else if (psi_no_map[no_ps] == 212){n_channel = 2;}
  else if (psi_no_map[no_ps] == 213){n_channel = 4;}
  else if (psi_no_map[no_ps] == 216){n_channel = 4;}
  else if (psi_no_map[no_ps] == 221){n_channel = 2;}
  else if (psi_no_map[no_ps] == 222){n_channel = 2;}
  else if (psi_no_map[no_ps] == 227){n_channel = 2;}
  else if (psi_no_map[no_ps] == 228){n_channel = 2;}
  else if (psi_no_map[no_ps] == 229){n_channel = 2;}
  else if (psi_no_map[no_ps] == 230){n_channel = 2;}
  else if (psi_no_map[no_ps] == 231){n_channel = 2;}
  else if (psi_no_map[no_ps] == 232){n_channel = 2;}
  else if (psi_no_map[no_ps] == 233){n_channel = 4;}
  else if (psi_no_map[no_ps] == 234){n_channel = 4;}
  else if (psi_no_map[no_ps] == 235){n_channel = 4;}
  else if (psi_no_map[no_ps] == 236){n_channel = 4;}
  else if (psi_no_map[no_ps] == 241){n_channel = 4;}
  else if (psi_no_map[no_ps] == 242){n_channel = 2;}
  else if (psi_no_map[no_ps] == 244){n_channel = 2;}
  else if (psi_no_map[no_ps] == 245){n_channel = 2;}
  else if (psi_no_map[no_ps] == 246){n_channel = 2;}
  else if (psi_no_map[no_ps] == 248){n_channel = 2;}
  else if (psi_no_map[no_ps] == 251){n_channel = 2;}
  else if (psi_no_map[no_ps] == 252){n_channel = 4;}
  else if (psi_no_map[no_ps] == 253){n_channel = 2;}
  else if (psi_no_map[no_ps] == 254){n_channel = 2;}
  else if (psi_no_map[no_ps] == 256){n_channel = 2;}
  else if (psi_no_map[no_ps] == 258){n_channel = 2;}
  else if (psi_no_map[no_ps] == 259){n_channel = 4;}
  else if (psi_no_map[no_ps] == 260){n_channel = 2;}
  else if (psi_no_map[no_ps] == 262){n_channel = 4;}
  else if (psi_no_map[no_ps] == 263){n_channel = 2;}
  else if (psi_no_map[no_ps] == 267){n_channel = 4;}
  else if (psi_no_map[no_ps] == 269){n_channel = 4;}
  else if (psi_no_map[no_ps] == 272){n_channel = 2;}
  else if (psi_no_map[no_ps] == 273){n_channel = 4;}
  else if (psi_no_map[no_ps] == 276){n_channel = 2;}
  else if (psi_no_map[no_ps] == 277){n_channel = 2;}
  else if (psi_no_map[no_ps] == 278){n_channel = 2;}
  else if (psi_no_map[no_ps] == 279){n_channel = 2;}
  else if (psi_no_map[no_ps] == 281){n_channel = 2;}
  else if (psi_no_map[no_ps] == 282){n_channel = 4;}
  else if (psi_no_map[no_ps] == 286){n_channel = 4;}
  else if (psi_no_map[no_ps] == 288){n_channel = 4;}
  return n_channel;

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

void ppexne02_ac_tau_psp_doublereal(int no_ps, vector<int> & tau_MC_map, phasespace_set & psi){
  static Logger logger("ppexne02_ac_tau_psp_doublereal");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  if      (psi.no_map[no_ps] == 0){}
  else if (psi.no_map[no_ps] ==   1){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==   2){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==   3){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==   4){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==   5){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==   6){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==   7){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==   8){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==   9){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  10){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  11){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  12){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  13){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  14){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  15){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  16){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  17){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  18){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  19){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  20){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  21){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  25){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  26){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  27){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  31){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  32){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  33){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  34){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  35){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  36){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  37){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  38){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  43){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  44){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  49){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  51){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  52){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  56){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  58){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  59){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  61){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  62){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  63){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  64){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  65){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  66){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  69){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  71){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  72){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  73){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  74){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  77){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  78){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  79){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  80){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  83){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  84){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  86){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  87){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  88){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  89){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  90){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  91){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  92){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  93){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  94){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  95){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  97){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  98){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 100){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 103){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 105){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 106){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 108){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 110){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 112){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 113){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 114){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 116){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 117){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 118){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 120){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 121){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 123){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 126){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 128){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 130){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 131){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 135){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 136){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 139){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 140){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 141){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 142){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 143){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 144){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 147){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 148){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 152){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 155){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 156){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 159){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 161){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 162){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 163){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 164){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 167){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 169){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 170){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 172){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 173){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 174){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 176){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 177){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 179){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 181){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 183){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 184){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 185){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 187){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 190){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 192){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 193){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 195){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 196){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 197){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 198){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 199){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 200){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 201){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 202){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 203){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 204){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 206){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 207){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 210){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 211){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 212){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 213){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 216){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 221){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 222){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 227){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 228){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 229){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 230){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 231){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 232){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 233){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 234){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 235){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 236){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 241){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 242){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 244){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 245){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 246){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 248){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 251){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 252){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 253){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 254){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 256){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 258){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 259){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 260){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 262){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 263){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 267){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 269){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 272){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 273){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 276){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 277){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 278){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 279){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 281){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 282){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 286){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 288){
    tau_MC_map.push_back(0);
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

void ppexne02_ax_psp_doublereal(int no_ps, phasespace_set & psi){
  static Logger logger("ppexne02_ax_psp_doublereal");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;
  if (psi_no_map[no_ps] == 0){}
  else if (psi_no_map[no_ps] ==   1){ppexne02_ax_psp_220_gg_epvedux(no_ps, psi);}
  else if (psi_no_map[no_ps] ==   2){ppexne02_ax_psp_220_gg_epvedcx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==   3){ppexne02_ax_psp_220_gg_epvesux(no_ps, psi);}
  else if (psi_no_map[no_ps] ==   4){ppexne02_ax_psp_220_gg_epvescx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==   5){ppexne02_ax_psp_220_gg_epvebux(no_ps, psi);}
  else if (psi_no_map[no_ps] ==   6){ppexne02_ax_psp_220_gg_epvebcx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==   7){ppexne02_ax_psp_220_gu_epvegd(no_ps, psi);}
  else if (psi_no_map[no_ps] ==   8){ppexne02_ax_psp_220_gu_epvegs(no_ps, psi);}
  else if (psi_no_map[no_ps] ==   9){ppexne02_ax_psp_220_gu_epvegb(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  10){ppexne02_ax_psp_220_gc_epvegd(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  11){ppexne02_ax_psp_220_gc_epvegs(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  12){ppexne02_ax_psp_220_gc_epvegb(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  13){ppexne02_ax_psp_220_gdx_epvegux(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  14){ppexne02_ax_psp_220_gdx_epvegcx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  15){ppexne02_ax_psp_220_gsx_epvegux(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  16){ppexne02_ax_psp_220_gsx_epvegcx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  17){ppexne02_ax_psp_220_gbx_epvegux(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  18){ppexne02_ax_psp_220_gbx_epvegcx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  19){ppexne02_ax_psp_220_du_epvedd(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  20){ppexne02_ax_psp_220_du_epveds(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  21){ppexne02_ax_psp_220_du_epvedb(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  25){ppexne02_ax_psp_220_dc_epvedd(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  26){ppexne02_ax_psp_220_dc_epveds(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  27){ppexne02_ax_psp_220_dc_epvedb(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  31){ppexne02_ax_psp_220_ddx_epvedux(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  32){ppexne02_ax_psp_220_ddx_epvedcx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  33){ppexne02_ax_psp_220_ddx_epvesux(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  34){ppexne02_ax_psp_220_ddx_epvescx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  35){ppexne02_ax_psp_220_ddx_epvebux(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  36){ppexne02_ax_psp_220_ddx_epvebcx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  37){ppexne02_ax_psp_220_dsx_epvedux(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  38){ppexne02_ax_psp_220_dsx_epvedcx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  43){ppexne02_ax_psp_220_dbx_epvedux(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  44){ppexne02_ax_psp_220_dbx_epvedcx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  49){ppexne02_ax_psp_220_uu_epvedu(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  51){ppexne02_ax_psp_220_uu_epveus(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  52){ppexne02_ax_psp_220_uu_epveub(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  56){ppexne02_ax_psp_220_us_epveds(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  58){ppexne02_ax_psp_220_us_epvess(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  59){ppexne02_ax_psp_220_us_epvesb(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  61){ppexne02_ax_psp_220_uc_epvedu(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  62){ppexne02_ax_psp_220_uc_epvedc(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  63){ppexne02_ax_psp_220_uc_epveus(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  64){ppexne02_ax_psp_220_uc_epveub(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  65){ppexne02_ax_psp_220_uc_epvesc(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  66){ppexne02_ax_psp_220_uc_epvecb(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  69){ppexne02_ax_psp_220_ub_epvedb(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  71){ppexne02_ax_psp_220_ub_epvesb(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  72){ppexne02_ax_psp_220_ub_epvebb(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  73){ppexne02_ax_psp_220_udx_epvegg(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  74){ppexne02_ax_psp_220_udx_epveddx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  77){ppexne02_ax_psp_220_udx_epveuux(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  78){ppexne02_ax_psp_220_udx_epveucx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  79){ppexne02_ax_psp_220_udx_epvesdx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  80){ppexne02_ax_psp_220_udx_epvessx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  83){ppexne02_ax_psp_220_udx_epveccx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  84){ppexne02_ax_psp_220_udx_epvebdx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  86){ppexne02_ax_psp_220_udx_epvebbx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  87){ppexne02_ax_psp_220_uux_epvedux(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  88){ppexne02_ax_psp_220_uux_epvedcx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  89){ppexne02_ax_psp_220_uux_epvesux(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  90){ppexne02_ax_psp_220_uux_epvescx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  91){ppexne02_ax_psp_220_uux_epvebux(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  92){ppexne02_ax_psp_220_uux_epvebcx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  93){ppexne02_ax_psp_220_usx_epvegg(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  94){ppexne02_ax_psp_220_usx_epveddx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  95){ppexne02_ax_psp_220_usx_epvedsx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  97){ppexne02_ax_psp_220_usx_epveuux(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  98){ppexne02_ax_psp_220_usx_epveucx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 100){ppexne02_ax_psp_220_usx_epvessx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 103){ppexne02_ax_psp_220_usx_epveccx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 105){ppexne02_ax_psp_220_usx_epvebsx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 106){ppexne02_ax_psp_220_usx_epvebbx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 108){ppexne02_ax_psp_220_ucx_epvedcx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 110){ppexne02_ax_psp_220_ucx_epvescx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 112){ppexne02_ax_psp_220_ucx_epvebcx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 113){ppexne02_ax_psp_220_ubx_epvegg(no_ps, psi);}
  else if (psi_no_map[no_ps] == 114){ppexne02_ax_psp_220_ubx_epveddx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 116){ppexne02_ax_psp_220_ubx_epvedbx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 117){ppexne02_ax_psp_220_ubx_epveuux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 118){ppexne02_ax_psp_220_ubx_epveucx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 120){ppexne02_ax_psp_220_ubx_epvessx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 121){ppexne02_ax_psp_220_ubx_epvesbx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 123){ppexne02_ax_psp_220_ubx_epveccx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 126){ppexne02_ax_psp_220_ubx_epvebbx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 128){ppexne02_ax_psp_220_sc_epveds(no_ps, psi);}
  else if (psi_no_map[no_ps] == 130){ppexne02_ax_psp_220_sc_epvess(no_ps, psi);}
  else if (psi_no_map[no_ps] == 131){ppexne02_ax_psp_220_sc_epvesb(no_ps, psi);}
  else if (psi_no_map[no_ps] == 135){ppexne02_ax_psp_220_sdx_epvesux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 136){ppexne02_ax_psp_220_sdx_epvescx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 139){ppexne02_ax_psp_220_ssx_epvedux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 140){ppexne02_ax_psp_220_ssx_epvedcx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 141){ppexne02_ax_psp_220_ssx_epvesux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 142){ppexne02_ax_psp_220_ssx_epvescx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 143){ppexne02_ax_psp_220_ssx_epvebux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 144){ppexne02_ax_psp_220_ssx_epvebcx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 147){ppexne02_ax_psp_220_sbx_epvesux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 148){ppexne02_ax_psp_220_sbx_epvescx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 152){ppexne02_ax_psp_220_cc_epvedc(no_ps, psi);}
  else if (psi_no_map[no_ps] == 155){ppexne02_ax_psp_220_cc_epvesc(no_ps, psi);}
  else if (psi_no_map[no_ps] == 156){ppexne02_ax_psp_220_cc_epvecb(no_ps, psi);}
  else if (psi_no_map[no_ps] == 159){ppexne02_ax_psp_220_cb_epvedb(no_ps, psi);}
  else if (psi_no_map[no_ps] == 161){ppexne02_ax_psp_220_cb_epvesb(no_ps, psi);}
  else if (psi_no_map[no_ps] == 162){ppexne02_ax_psp_220_cb_epvebb(no_ps, psi);}
  else if (psi_no_map[no_ps] == 163){ppexne02_ax_psp_220_cdx_epvegg(no_ps, psi);}
  else if (psi_no_map[no_ps] == 164){ppexne02_ax_psp_220_cdx_epveddx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 167){ppexne02_ax_psp_220_cdx_epveuux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 169){ppexne02_ax_psp_220_cdx_epvesdx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 170){ppexne02_ax_psp_220_cdx_epvessx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 172){ppexne02_ax_psp_220_cdx_epvecux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 173){ppexne02_ax_psp_220_cdx_epveccx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 174){ppexne02_ax_psp_220_cdx_epvebdx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 176){ppexne02_ax_psp_220_cdx_epvebbx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 177){ppexne02_ax_psp_220_cux_epvedux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 179){ppexne02_ax_psp_220_cux_epvesux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 181){ppexne02_ax_psp_220_cux_epvebux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 183){ppexne02_ax_psp_220_csx_epvegg(no_ps, psi);}
  else if (psi_no_map[no_ps] == 184){ppexne02_ax_psp_220_csx_epveddx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 185){ppexne02_ax_psp_220_csx_epvedsx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 187){ppexne02_ax_psp_220_csx_epveuux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 190){ppexne02_ax_psp_220_csx_epvessx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 192){ppexne02_ax_psp_220_csx_epvecux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 193){ppexne02_ax_psp_220_csx_epveccx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 195){ppexne02_ax_psp_220_csx_epvebsx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 196){ppexne02_ax_psp_220_csx_epvebbx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 197){ppexne02_ax_psp_220_ccx_epvedux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 198){ppexne02_ax_psp_220_ccx_epvedcx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 199){ppexne02_ax_psp_220_ccx_epvesux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 200){ppexne02_ax_psp_220_ccx_epvescx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 201){ppexne02_ax_psp_220_ccx_epvebux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 202){ppexne02_ax_psp_220_ccx_epvebcx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 203){ppexne02_ax_psp_220_cbx_epvegg(no_ps, psi);}
  else if (psi_no_map[no_ps] == 204){ppexne02_ax_psp_220_cbx_epveddx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 206){ppexne02_ax_psp_220_cbx_epvedbx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 207){ppexne02_ax_psp_220_cbx_epveuux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 210){ppexne02_ax_psp_220_cbx_epvessx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 211){ppexne02_ax_psp_220_cbx_epvesbx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 212){ppexne02_ax_psp_220_cbx_epvecux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 213){ppexne02_ax_psp_220_cbx_epveccx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 216){ppexne02_ax_psp_220_cbx_epvebbx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 221){ppexne02_ax_psp_220_bdx_epvebux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 222){ppexne02_ax_psp_220_bdx_epvebcx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 227){ppexne02_ax_psp_220_bsx_epvebux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 228){ppexne02_ax_psp_220_bsx_epvebcx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 229){ppexne02_ax_psp_220_bbx_epvedux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 230){ppexne02_ax_psp_220_bbx_epvedcx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 231){ppexne02_ax_psp_220_bbx_epvesux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 232){ppexne02_ax_psp_220_bbx_epvescx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 233){ppexne02_ax_psp_220_bbx_epvebux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 234){ppexne02_ax_psp_220_bbx_epvebcx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 235){ppexne02_ax_psp_220_dxdx_epvedxux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 236){ppexne02_ax_psp_220_dxdx_epvedxcx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 241){ppexne02_ax_psp_220_dxux_epveuxux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 242){ppexne02_ax_psp_220_dxux_epveuxcx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 244){ppexne02_ax_psp_220_dxsx_epvedxux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 245){ppexne02_ax_psp_220_dxsx_epvedxcx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 246){ppexne02_ax_psp_220_dxsx_epveuxsx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 248){ppexne02_ax_psp_220_dxsx_epvesxcx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 251){ppexne02_ax_psp_220_dxcx_epveuxcx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 252){ppexne02_ax_psp_220_dxcx_epvecxcx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 253){ppexne02_ax_psp_220_dxbx_epvedxux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 254){ppexne02_ax_psp_220_dxbx_epvedxcx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 256){ppexne02_ax_psp_220_dxbx_epveuxbx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 258){ppexne02_ax_psp_220_dxbx_epvecxbx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 259){ppexne02_ax_psp_220_uxsx_epveuxux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 260){ppexne02_ax_psp_220_uxsx_epveuxcx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 262){ppexne02_ax_psp_220_uxbx_epveuxux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 263){ppexne02_ax_psp_220_uxbx_epveuxcx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 267){ppexne02_ax_psp_220_sxsx_epveuxsx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 269){ppexne02_ax_psp_220_sxsx_epvesxcx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 272){ppexne02_ax_psp_220_sxcx_epveuxcx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 273){ppexne02_ax_psp_220_sxcx_epvecxcx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 276){ppexne02_ax_psp_220_sxbx_epveuxsx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 277){ppexne02_ax_psp_220_sxbx_epveuxbx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 278){ppexne02_ax_psp_220_sxbx_epvesxcx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 279){ppexne02_ax_psp_220_sxbx_epvecxbx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 281){ppexne02_ax_psp_220_cxbx_epveuxcx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 282){ppexne02_ax_psp_220_cxbx_epvecxcx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 286){ppexne02_ax_psp_220_bxbx_epveuxbx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 288){ppexne02_ax_psp_220_bxbx_epvecxbx(no_ps, psi);}

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
