#include "../include/classes.cxx"
#include "../include/definitions.phasespace.set.cxx"
#include "../ppnenex02/header/ppnenex02.phasespace.h"
void ppnenex02_optimize_minv_born(phasespace_set & psi){
  static Logger logger("ppnenex02_optimize_minv_born");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

#include "user/specify.optimize.phasespace.minv.born.cxx"

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

int ppnenex02_determination_MCchannels_born(int no_ps, phasespace_set & psi){
  static Logger logger("ppnenex02_determination_MCchannels_born");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  int n_channel = 0;
  if (psi_phasespace_order_alpha_s[no_ps] == 0 && psi_phasespace_order_alpha_e[no_ps] == 2 && psi_phasespace_order_interference[no_ps] == 0){
    if      (psi_no_map[no_ps] == 0){n_channel = 1;}
    else if (psi_no_map[no_ps] == 2){n_channel = 1;}
    else if (psi_no_map[no_ps] == 3){n_channel = 1;}
  }
  else if (psi_phasespace_order_alpha_s[no_ps] == 2 && psi_phasespace_order_alpha_e[no_ps] == 2 && psi_phasespace_order_interference[no_ps] == 0){
    if      (psi_no_map[no_ps] == 0){n_channel = 0;}
    else if (psi_no_map[no_ps] == 1){n_channel = 1;}
  }
  return n_channel;

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

void ppnenex02_ac_tau_psp_born(int no_ps, vector<int> & tau_MC_map, phasespace_set & psi){
  static Logger logger("ppnenex02_ac_tau_psp_born");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  if (psi.phasespace_order_alpha_s[no_ps] == 0 && psi.phasespace_order_alpha_e[no_ps] == 2 && psi.phasespace_order_interference[no_ps] == 0){
    if      (psi.no_map[no_ps] == 0){}
    else if (psi.no_map[no_ps] == 2){
      tau_MC_map.push_back(0);
      tau_MC_map.push_back(-23);
    }
    else if (psi.no_map[no_ps] == 3){
      tau_MC_map.push_back(0);
      tau_MC_map.push_back(-23);
    }
  }
  else if (psi.phasespace_order_alpha_s[no_ps] == 2 && psi.phasespace_order_alpha_e[no_ps] == 2 && psi.phasespace_order_interference[no_ps] == 0){
    if      (psi.no_map[no_ps] == 0){}
    else if (psi.no_map[no_ps] == 1){
      tau_MC_map.push_back(0);
      tau_MC_map.push_back(-23);
    }
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

void ppnenex02_ax_psp_born(int no_ps, phasespace_set & psi){
  static Logger logger("ppnenex02_ax_psp_born");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;
  if (psi_phasespace_order_alpha_s[no_ps] == 0 && psi_phasespace_order_alpha_e[no_ps] == 2 && psi_phasespace_order_interference[no_ps] == 0){
    if (psi_no_map[no_ps] == 0){}
    else if (psi_no_map[no_ps] == 2){ppnenex02_ax_psp_020_ddx_vevex(no_ps, psi);}
    else if (psi_no_map[no_ps] == 3){ppnenex02_ax_psp_020_uux_vevex(no_ps, psi);}
  }
  else if (psi_phasespace_order_alpha_s[no_ps] == 2 && psi_phasespace_order_alpha_e[no_ps] == 2 && psi_phasespace_order_interference[no_ps] == 0){
    if (psi_no_map[no_ps] == 0){}
    else if (psi_no_map[no_ps] == 1){ppnenex02_ax_psp_220_gg_vevex(no_ps, psi);}
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
