#include "../include/classes.cxx"
#include "../include/definitions.phasespace.set.cxx"
#include "../ppnenexa03/header/ppnenexa03.phasespace.h"
void ppnenexa03_ax_psp_230_gg_vevexauux(int no_ps, phasespace_set & psi){
  static Logger logger("ppnenexa03_ax_psp_230_gg_vevexauux");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;
  psi_v_smin[no_ps].resize(12);
  psi_needed_v_smin[no_ps].resize(12);
  int needed_v_smin_0[] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29}; //  30
  psi_needed_v_smin[no_ps][  0] = get_vector_from_array_int(needed_v_smin_0, 30);
  int needed_v_smin_1[] = {   0,    2,    7,   10,   15,   21,   24,   26}; //   8
  psi_needed_v_smin[no_ps][  1] = get_vector_from_array_int(needed_v_smin_1, 8);
  int needed_v_smin_2[] = {   1,    3,    6,   11,   14,   20,   25,   27}; //   8
  psi_needed_v_smin[no_ps][  2] = get_vector_from_array_int(needed_v_smin_2, 8);
  int needed_v_smin_3[] = {   2,    7,   15,    0,   21}; //   5
  psi_needed_v_smin[no_ps][  3] = get_vector_from_array_int(needed_v_smin_3, 5);
  int needed_v_smin_4[] = {   3,    6,   14,    1,   20}; //   5
  psi_needed_v_smin[no_ps][  4] = get_vector_from_array_int(needed_v_smin_4, 5);
  int needed_v_smin_5[] = {   4,    8,   10,   16,   23,   24,   26,   28}; //   8
  psi_needed_v_smin[no_ps][  5] = get_vector_from_array_int(needed_v_smin_5, 8);
  int needed_v_smin_6[] = {   4,    8,   16,   23,   28}; //   5
  psi_needed_v_smin[no_ps][  6] = get_vector_from_array_int(needed_v_smin_6, 5);
  int needed_v_smin_7[] = {   5,    9,   11,   17,   22,   25,   27,   29}; //   8
  psi_needed_v_smin[no_ps][  7] = get_vector_from_array_int(needed_v_smin_7, 8);
  int needed_v_smin_8[] = {   5,    9,   17,   22,   29}; //   5
  psi_needed_v_smin[no_ps][  8] = get_vector_from_array_int(needed_v_smin_8, 5);
  int needed_v_smin_9[] = {  12,   13,   18,   19}; //   4
  psi_needed_v_smin[no_ps][  9] = get_vector_from_array_int(needed_v_smin_9, 4);
  int needed_v_smin_10[] = {  12,   18}; //   2
  psi_needed_v_smin[no_ps][ 10] = get_vector_from_array_int(needed_v_smin_10, 2);
  int needed_v_smin_11[] = {  13,   19}; //   2
  psi_needed_v_smin[no_ps][ 11] = get_vector_from_array_int(needed_v_smin_11, 2);

  psi_v_smax[no_ps].resize(16);
  psi_needed_v_smax[no_ps].resize(16);
  int needed_v_smax_0[] = {   0,    1,    2,    3,    6,    7,   10,   11,   12,   13,   14,   15,   18,   19,   20,   21,   22,   23,   24,   25}; //  20
  psi_needed_v_smax[no_ps][  0] = get_vector_from_array_int(needed_v_smax_0, 20);
  int needed_v_smax_1[] = {   0,    2,    7,   10,   15,   21,   24}; //   7
  psi_needed_v_smax[no_ps][  1] = get_vector_from_array_int(needed_v_smax_1, 7);
  int needed_v_smax_2[] = {   1,    3,    6,   11,   14,   20,   25}; //   7
  psi_needed_v_smax[no_ps][  2] = get_vector_from_array_int(needed_v_smax_2, 7);
  int needed_v_smax_3[] = {   2,    5,    7,    9,   15,   17,    0,   13,   19,   21,   22,   29}; //  12
  psi_needed_v_smax[no_ps][  3] = get_vector_from_array_int(needed_v_smax_3, 12);
  int needed_v_smax_4[] = {   3,    4,    6,    8,   14,   16,    1,   12,   18,   20,   23,   28}; //  12
  psi_needed_v_smax[no_ps][  4] = get_vector_from_array_int(needed_v_smax_4, 12);
  int needed_v_smax_5[] = {   4,    8,   16,   26,   28}; //   5
  psi_needed_v_smax[no_ps][  5] = get_vector_from_array_int(needed_v_smax_5, 5);
  int needed_v_smax_6[] = {   4,    8,   16,   26,   28}; //   5
  psi_needed_v_smax[no_ps][  6] = get_vector_from_array_int(needed_v_smax_6, 5);
  int needed_v_smax_7[] = {   5,    9,   17,   27,   29}; //   5
  psi_needed_v_smax[no_ps][  7] = get_vector_from_array_int(needed_v_smax_7, 5);
  int needed_v_smax_8[] = {   5,    9,   17,   27,   29}; //   5
  psi_needed_v_smax[no_ps][  8] = get_vector_from_array_int(needed_v_smax_8, 5);
  int needed_v_smax_9[] = {  10,   24}; //   2
  psi_needed_v_smax[no_ps][  9] = get_vector_from_array_int(needed_v_smax_9, 2);
  int needed_v_smax_10[] = {  11,   25}; //   2
  psi_needed_v_smax[no_ps][ 10] = get_vector_from_array_int(needed_v_smax_10, 2);
  int needed_v_smax_11[] = {  22}; //   1
  psi_needed_v_smax[no_ps][ 11] = get_vector_from_array_int(needed_v_smax_11, 1);
  int needed_v_smax_12[] = {  23}; //   1
  psi_needed_v_smax[no_ps][ 12] = get_vector_from_array_int(needed_v_smax_12, 1);
  int needed_v_smax_13[] = {  26}; //   1
  psi_needed_v_smax[no_ps][ 13] = get_vector_from_array_int(needed_v_smax_13, 1);
  int needed_v_smax_14[] = {  27}; //   1
  psi_needed_v_smax[no_ps][ 14] = get_vector_from_array_int(needed_v_smax_14, 1);
  int needed_v_smax_15[] = {  12,   13,   18,   19}; //   4
  psi_needed_v_smax[no_ps][ 15] = get_vector_from_array_int(needed_v_smax_15, 4);

  psi_container_IS_startvalue[no_ps][0] = psi_container_IS_name.size();
  psi_g_p[no_ps].resize(17);
  psi_needed_g_p[no_ps].resize(17);
  int needed_g_p_0[] = {   0,    1,    2,    3,    6,    7,   10,   11,   12,   13,   14,   15,   18,   19,   20,   21,   22,   23,   24,   25}; //  20
  psi_needed_g_p[no_ps][0] = get_vector_from_array_int(needed_g_p_0, 20);
  psi_container_IS_name.push_back("propagator_23_smin0_smax0");
  int needed_g_p_1[] = {   0,    2,    7,   10,   15,   21,   24}; //   7
  psi_needed_g_p[no_ps][1] = get_vector_from_array_int(needed_g_p_1, 7);
  psi_container_IS_name.push_back("propagator_0_smin1_smax1");
  int needed_g_p_2[] = {   1,    3,    6,   11,   14,   20,   25}; //   7
  psi_needed_g_p[no_ps][2] = get_vector_from_array_int(needed_g_p_2, 7);
  psi_container_IS_name.push_back("propagator_0_smin2_smax2");
  int needed_g_p_3[] = {   2,    7,   15}; //   3
  psi_needed_g_p[no_ps][3] = get_vector_from_array_int(needed_g_p_3, 3);
  psi_container_IS_name.push_back("propagator_0_smin3_smax3");
  int needed_g_p_4[] = {   3,    6,   14}; //   3
  psi_needed_g_p[no_ps][4] = get_vector_from_array_int(needed_g_p_4, 3);
  psi_container_IS_name.push_back("propagator_0_smin4_smax4");
  int needed_g_p_5[] = {   4,    8,   16,   26,   28}; //   5
  psi_needed_g_p[no_ps][5] = get_vector_from_array_int(needed_g_p_5, 5);
  psi_container_IS_name.push_back("propagator_0_smin5_smax5");
  int needed_g_p_6[] = {   4,    8,   16,   26,   28}; //   5
  psi_needed_g_p[no_ps][6] = get_vector_from_array_int(needed_g_p_6, 5);
  psi_container_IS_name.push_back("propagator_23_smin0_smax6");
  int needed_g_p_7[] = {   4,    8,   16}; //   3
  psi_needed_g_p[no_ps][7] = get_vector_from_array_int(needed_g_p_7, 3);
  psi_container_IS_name.push_back("propagator_0_smin6_smax4");
  int needed_g_p_8[] = {   5,    9,   17,   27,   29}; //   5
  psi_needed_g_p[no_ps][8] = get_vector_from_array_int(needed_g_p_8, 5);
  psi_container_IS_name.push_back("propagator_0_smin7_smax7");
  int needed_g_p_9[] = {   5,    9,   17,   27,   29}; //   5
  psi_needed_g_p[no_ps][9] = get_vector_from_array_int(needed_g_p_9, 5);
  psi_container_IS_name.push_back("propagator_23_smin0_smax8");
  int needed_g_p_10[] = {   5,    9,   17}; //   3
  psi_needed_g_p[no_ps][10] = get_vector_from_array_int(needed_g_p_10, 3);
  psi_container_IS_name.push_back("propagator_0_smin8_smax3");
  int needed_g_p_11[] = {  10,   24}; //   2
  psi_needed_g_p[no_ps][11] = get_vector_from_array_int(needed_g_p_11, 2);
  psi_container_IS_name.push_back("propagator_0_smin5_smax9");
  int needed_g_p_12[] = {  11,   25}; //   2
  psi_needed_g_p[no_ps][12] = get_vector_from_array_int(needed_g_p_12, 2);
  psi_container_IS_name.push_back("propagator_0_smin7_smax10");
  int needed_g_p_13[] = {  22}; //   1
  psi_needed_g_p[no_ps][13] = get_vector_from_array_int(needed_g_p_13, 1);
  psi_container_IS_name.push_back("propagator_0_smin7_smax11");
  int needed_g_p_14[] = {  23}; //   1
  psi_needed_g_p[no_ps][14] = get_vector_from_array_int(needed_g_p_14, 1);
  psi_container_IS_name.push_back("propagator_0_smin5_smax12");
  int needed_g_p_15[] = {  26}; //   1
  psi_needed_g_p[no_ps][15] = get_vector_from_array_int(needed_g_p_15, 1);
  psi_container_IS_name.push_back("propagator_0_smin1_smax13");
  int needed_g_p_16[] = {  27}; //   1
  psi_needed_g_p[no_ps][16] = get_vector_from_array_int(needed_g_p_16, 1);
  psi_container_IS_name.push_back("propagator_0_smin2_smax14");

  psi_container_IS_startvalue[no_ps][1] = psi_container_IS_name.size();
  psi_g_f[no_ps].resize(7);
  psi_needed_g_f[no_ps].resize(7);
  int needed_g_f_0[] = {   0,   21}; //   2
  psi_needed_g_f[no_ps][0] = get_vector_from_array_int(needed_g_f_0, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin3_smax3");
  int needed_g_f_1[] = {   1,   20}; //   2
  psi_needed_g_f[no_ps][1] = get_vector_from_array_int(needed_g_f_1, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin4_smax4");
  int needed_g_f_2[] = {  12,   13,   18,   19}; //   4
  psi_needed_g_f[no_ps][2] = get_vector_from_array_int(needed_g_f_2, 4);
  psi_container_IS_name.push_back("timelikeinvariant_smin9_smax15");
  int needed_g_f_3[] = {  12,   18}; //   2
  psi_needed_g_f[no_ps][3] = get_vector_from_array_int(needed_g_f_3, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin10_smax4");
  int needed_g_f_4[] = {  13,   19}; //   2
  psi_needed_g_f[no_ps][4] = get_vector_from_array_int(needed_g_f_4, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin11_smax3");
  int needed_g_f_5[] = {  22,   29}; //   2
  psi_needed_g_f[no_ps][5] = get_vector_from_array_int(needed_g_f_5, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin8_smax3");
  int needed_g_f_6[] = {  23,   28}; //   2
  psi_needed_g_f[no_ps][6] = get_vector_from_array_int(needed_g_f_6, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin6_smax4");

  psi_container_IS_startvalue[no_ps][2] = psi_container_IS_name.size();
  psi_g_t[no_ps].resize(22);
  psi_needed_g_t[no_ps].resize(22);
  int needed_g_t_0[] = {   0,    2,    5,   22}; //   4
  psi_needed_g_t[no_ps][0] = get_vector_from_array_int(needed_g_t_0, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_1__32_92");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_1__32_92");
  int needed_g_t_1[] = {   0}; //   1
  psi_needed_g_t[no_ps][1] = get_vector_from_array_int(needed_g_t_1, 1);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__34_1__16_76");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__34_1__16_76");
  int needed_g_t_2[] = {   1,    3,    4,   23}; //   4
  psi_needed_g_t[no_ps][2] = get_vector_from_array_int(needed_g_t_2, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_1__64_60");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_1__64_60");
  int needed_g_t_3[] = {   1}; //   1
  psi_needed_g_t[no_ps][3] = get_vector_from_array_int(needed_g_t_3, 1);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__66_1__16_44");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__66_1__16_44");
  int needed_g_t_4[] = {  12,   14,   16,   18,   20,   28}; //   6
  psi_needed_g_t[no_ps][4] = get_vector_from_array_int(needed_g_t_4, 6);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_2__64_60");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_2__64_60");
  int needed_g_t_5[] = {  12,   18}; //   2
  psi_needed_g_t[no_ps][5] = get_vector_from_array_int(needed_g_t_5, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_65__32_28");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_65__32_28");
  int needed_g_t_6[] = {  12}; //   1
  psi_needed_g_t[no_ps][6] = get_vector_from_array_int(needed_g_t_6, 1);
  psi_container_IS_name.push_back("t_of_tchannel_0__34_65__16_12");
  psi_container_IS_name.push_back("phi_of_tchannel_0__34_65__16_12");
  int needed_g_t_7[] = {  13,   15,   17,   19,   21,   29}; //   6
  psi_needed_g_t[no_ps][7] = get_vector_from_array_int(needed_g_t_7, 6);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_2__32_92");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_2__32_92");
  int needed_g_t_8[] = {  13,   19}; //   2
  psi_needed_g_t[no_ps][8] = get_vector_from_array_int(needed_g_t_8, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_33__64_28");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_33__64_28");
  int needed_g_t_9[] = {  13}; //   1
  psi_needed_g_t[no_ps][9] = get_vector_from_array_int(needed_g_t_9, 1);
  psi_container_IS_name.push_back("t_of_tchannel_0__66_33__16_12");
  psi_container_IS_name.push_back("phi_of_tchannel_0__66_33__16_12");
  int needed_g_t_10[] = {  18}; //   1
  psi_needed_g_t[no_ps][10] = get_vector_from_array_int(needed_g_t_10, 1);
  psi_container_IS_name.push_back("t_of_tchannel_0__65_34__16_12");
  psi_container_IS_name.push_back("phi_of_tchannel_0__65_34__16_12");
  int needed_g_t_11[] = {  19}; //   1
  psi_needed_g_t[no_ps][11] = get_vector_from_array_int(needed_g_t_11, 1);
  psi_container_IS_name.push_back("t_of_tchannel_0__33_66__16_12");
  psi_container_IS_name.push_back("phi_of_tchannel_0__33_66__16_12");
  int needed_g_t_12[] = {  20}; //   1
  psi_needed_g_t[no_ps][12] = get_vector_from_array_int(needed_g_t_12, 1);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__65_2__16_44");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__65_2__16_44");
  int needed_g_t_13[] = {  21}; //   1
  psi_needed_g_t[no_ps][13] = get_vector_from_array_int(needed_g_t_13, 1);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__33_2__16_76");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__33_2__16_76");
  int needed_g_t_14[] = {  22}; //   1
  psi_needed_g_t[no_ps][14] = get_vector_from_array_int(needed_g_t_14, 1);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_34__80_12");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_34__80_12");
  int needed_g_t_15[] = {  23}; //   1
  psi_needed_g_t[no_ps][15] = get_vector_from_array_int(needed_g_t_15, 1);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_66__48_12");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_66__48_12");
  int needed_g_t_16[] = {  24}; //   1
  psi_needed_g_t[no_ps][16] = get_vector_from_array_int(needed_g_t_16, 1);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_2__48_76");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_2__48_76");
  int needed_g_t_17[] = {  25}; //   1
  psi_needed_g_t[no_ps][17] = get_vector_from_array_int(needed_g_t_17, 1);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_2__80_44");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_2__80_44");
  int needed_g_t_18[] = {  26}; //   1
  psi_needed_g_t[no_ps][18] = get_vector_from_array_int(needed_g_t_18, 1);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_1__48_76");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_1__48_76");
  int needed_g_t_19[] = {  27}; //   1
  psi_needed_g_t[no_ps][19] = get_vector_from_array_int(needed_g_t_19, 1);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_1__80_44");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_1__80_44");
  int needed_g_t_20[] = {  28}; //   1
  psi_needed_g_t[no_ps][20] = get_vector_from_array_int(needed_g_t_20, 1);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_65__48_12");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_65__48_12");
  int needed_g_t_21[] = {  29}; //   1
  psi_needed_g_t[no_ps][21] = get_vector_from_array_int(needed_g_t_21, 1);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_33__80_12");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_33__80_12");

  psi_container_IS_startvalue[no_ps][3] = psi_container_IS_name.size();
  psi_g_d[no_ps].resize(13);
  psi_needed_g_d[no_ps].resize(13);
  int needed_g_d_0[] = {   0,    2,    7,   10,   15,   21,   24,   26}; //   8
  psi_needed_g_d[no_ps][0] = get_vector_from_array_int(needed_g_d_0, 8);
  psi_container_IS_name.push_back("costheta_of_decay_76__64_12");
  psi_container_IS_name.push_back("phi_of_decay_76__64_12");
  int needed_g_d_1[] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29}; //  30
  psi_needed_g_d[no_ps][1] = get_vector_from_array_int(needed_g_d_1, 30);
  psi_container_IS_name.push_back("costheta_of_decay_12__4_8");
  psi_container_IS_name.push_back("phi_of_decay_12__4_8");
  int needed_g_d_2[] = {   1,    3,    6,   11,   14,   20,   25,   27}; //   8
  psi_needed_g_d[no_ps][2] = get_vector_from_array_int(needed_g_d_2, 8);
  psi_container_IS_name.push_back("costheta_of_decay_44__32_12");
  psi_container_IS_name.push_back("phi_of_decay_44__32_12");
  int needed_g_d_3[] = {   2,    7,   15}; //   3
  psi_needed_g_d[no_ps][3] = get_vector_from_array_int(needed_g_d_3, 3);
  psi_container_IS_name.push_back("costheta_of_decay_92__16_76");
  psi_container_IS_name.push_back("phi_of_decay_92__16_76");
  int needed_g_d_4[] = {   3,    6,   14}; //   3
  psi_needed_g_d[no_ps][4] = get_vector_from_array_int(needed_g_d_4, 3);
  psi_container_IS_name.push_back("costheta_of_decay_60__16_44");
  psi_container_IS_name.push_back("phi_of_decay_60__16_44");
  int needed_g_d_5[] = {   4,    8,   16}; //   3
  psi_needed_g_d[no_ps][5] = get_vector_from_array_int(needed_g_d_5, 3);
  psi_container_IS_name.push_back("costheta_of_decay_60__12_48");
  psi_container_IS_name.push_back("phi_of_decay_60__12_48");
  int needed_g_d_6[] = {   4,    8,   10,   16,   23,   24,   26,   28}; //   8
  psi_needed_g_d[no_ps][6] = get_vector_from_array_int(needed_g_d_6, 8);
  psi_container_IS_name.push_back("costheta_of_decay_48__16_32");
  psi_container_IS_name.push_back("phi_of_decay_48__16_32");
  int needed_g_d_7[] = {   5,    9,   17}; //   3
  psi_needed_g_d[no_ps][7] = get_vector_from_array_int(needed_g_d_7, 3);
  psi_container_IS_name.push_back("costheta_of_decay_92__12_80");
  psi_container_IS_name.push_back("phi_of_decay_92__12_80");
  int needed_g_d_8[] = {   5,    9,   11,   17,   22,   25,   27,   29}; //   8
  psi_needed_g_d[no_ps][8] = get_vector_from_array_int(needed_g_d_8, 8);
  psi_container_IS_name.push_back("costheta_of_decay_80__16_64");
  psi_container_IS_name.push_back("phi_of_decay_80__16_64");
  int needed_g_d_9[] = {   6,    8}; //   2
  psi_needed_g_d[no_ps][9] = get_vector_from_array_int(needed_g_d_9, 2);
  psi_container_IS_name.push_back("costheta_of_decay_124__64_60");
  psi_container_IS_name.push_back("phi_of_decay_124__64_60");
  int needed_g_d_10[] = {   7,    9}; //   2
  psi_needed_g_d[no_ps][10] = get_vector_from_array_int(needed_g_d_10, 2);
  psi_container_IS_name.push_back("costheta_of_decay_124__32_92");
  psi_container_IS_name.push_back("phi_of_decay_124__32_92");
  int needed_g_d_11[] = {  10}; //   1
  psi_needed_g_d[no_ps][11] = get_vector_from_array_int(needed_g_d_11, 1);
  psi_container_IS_name.push_back("costheta_of_decay_124__48_76");
  psi_container_IS_name.push_back("phi_of_decay_124__48_76");
  int needed_g_d_12[] = {  11}; //   1
  psi_needed_g_d[no_ps][12] = get_vector_from_array_int(needed_g_d_12, 1);
  psi_container_IS_name.push_back("costheta_of_decay_124__80_44");
  psi_container_IS_name.push_back("phi_of_decay_124__80_44");

  psi_c_p[no_ps].resize(30);
  psi_c_f[no_ps].resize(30);
  psi_c_t[no_ps].resize(30);
  psi_c_d[no_ps].resize(30);

  int c_p_0[] = {  0,   1}; //   2
  psi_c_p[no_ps][0] = get_vector_from_array_int(c_p_0, 2);
  int c_f_0[] = {  0}; //   1
  psi_c_f[no_ps][0] = get_vector_from_array_int(c_f_0, 1);
  int c_t_0[] = {  0,   1}; //   2
  psi_c_t[no_ps][0] = get_vector_from_array_int(c_t_0, 2);
  int c_d_0[] = {  0,   1}; //   2
  psi_c_d[no_ps][0] = get_vector_from_array_int(c_d_0, 2);

  int c_p_1[] = {  0,   2}; //   2
  psi_c_p[no_ps][1] = get_vector_from_array_int(c_p_1, 2);
  int c_f_1[] = {  1}; //   1
  psi_c_f[no_ps][1] = get_vector_from_array_int(c_f_1, 1);
  int c_t_1[] = {  2,   3}; //   2
  psi_c_t[no_ps][1] = get_vector_from_array_int(c_t_1, 2);
  int c_d_1[] = {  2,   1}; //   2
  psi_c_d[no_ps][1] = get_vector_from_array_int(c_d_1, 2);

  int c_p_2[] = {  0,   1,   3}; //   3
  psi_c_p[no_ps][2] = get_vector_from_array_int(c_p_2, 3);
  int c_f_2[] = {}; //   0
  psi_c_f[no_ps][2] = get_vector_from_array_int(c_f_2, 0);
  int c_t_2[] = {  0}; //   1
  psi_c_t[no_ps][2] = get_vector_from_array_int(c_t_2, 1);
  int c_d_2[] = {  3,   0,   1}; //   3
  psi_c_d[no_ps][2] = get_vector_from_array_int(c_d_2, 3);

  int c_p_3[] = {  0,   2,   4}; //   3
  psi_c_p[no_ps][3] = get_vector_from_array_int(c_p_3, 3);
  int c_f_3[] = {}; //   0
  psi_c_f[no_ps][3] = get_vector_from_array_int(c_f_3, 0);
  int c_t_3[] = {  2}; //   1
  psi_c_t[no_ps][3] = get_vector_from_array_int(c_t_3, 1);
  int c_d_3[] = {  4,   2,   1}; //   3
  psi_c_d[no_ps][3] = get_vector_from_array_int(c_d_3, 3);

  int c_p_4[] = {  5,   6,   7}; //   3
  psi_c_p[no_ps][4] = get_vector_from_array_int(c_p_4, 3);
  int c_f_4[] = {}; //   0
  psi_c_f[no_ps][4] = get_vector_from_array_int(c_f_4, 0);
  int c_t_4[] = {  2}; //   1
  psi_c_t[no_ps][4] = get_vector_from_array_int(c_t_4, 1);
  int c_d_4[] = {  5,   1,   6}; //   3
  psi_c_d[no_ps][4] = get_vector_from_array_int(c_d_4, 3);

  int c_p_5[] = {  8,   9,  10}; //   3
  psi_c_p[no_ps][5] = get_vector_from_array_int(c_p_5, 3);
  int c_f_5[] = {}; //   0
  psi_c_f[no_ps][5] = get_vector_from_array_int(c_f_5, 0);
  int c_t_5[] = {  0}; //   1
  psi_c_t[no_ps][5] = get_vector_from_array_int(c_t_5, 1);
  int c_d_5[] = {  7,   1,   8}; //   3
  psi_c_d[no_ps][5] = get_vector_from_array_int(c_d_5, 3);

  int c_p_6[] = {  0,   2,   4}; //   3
  psi_c_p[no_ps][6] = get_vector_from_array_int(c_p_6, 3);
  int c_f_6[] = {}; //   0
  psi_c_f[no_ps][6] = get_vector_from_array_int(c_f_6, 0);
  int c_t_6[] = {}; //   0
  psi_c_t[no_ps][6] = get_vector_from_array_int(c_t_6, 0);
  int c_d_6[] = {  9,   4,   2,   1}; //   4
  psi_c_d[no_ps][6] = get_vector_from_array_int(c_d_6, 4);

  int c_p_7[] = {  0,   1,   3}; //   3
  psi_c_p[no_ps][7] = get_vector_from_array_int(c_p_7, 3);
  int c_f_7[] = {}; //   0
  psi_c_f[no_ps][7] = get_vector_from_array_int(c_f_7, 0);
  int c_t_7[] = {}; //   0
  psi_c_t[no_ps][7] = get_vector_from_array_int(c_t_7, 0);
  int c_d_7[] = { 10,   3,   0,   1}; //   4
  psi_c_d[no_ps][7] = get_vector_from_array_int(c_d_7, 4);

  int c_p_8[] = {  5,   6,   7}; //   3
  psi_c_p[no_ps][8] = get_vector_from_array_int(c_p_8, 3);
  int c_f_8[] = {}; //   0
  psi_c_f[no_ps][8] = get_vector_from_array_int(c_f_8, 0);
  int c_t_8[] = {}; //   0
  psi_c_t[no_ps][8] = get_vector_from_array_int(c_t_8, 0);
  int c_d_8[] = {  9,   5,   1,   6}; //   4
  psi_c_d[no_ps][8] = get_vector_from_array_int(c_d_8, 4);

  int c_p_9[] = {  8,   9,  10}; //   3
  psi_c_p[no_ps][9] = get_vector_from_array_int(c_p_9, 3);
  int c_f_9[] = {}; //   0
  psi_c_f[no_ps][9] = get_vector_from_array_int(c_f_9, 0);
  int c_t_9[] = {}; //   0
  psi_c_t[no_ps][9] = get_vector_from_array_int(c_t_9, 0);
  int c_d_9[] = { 10,   7,   1,   8}; //   4
  psi_c_d[no_ps][9] = get_vector_from_array_int(c_d_9, 4);

  int c_p_10[] = {  0,   1,  11}; //   3
  psi_c_p[no_ps][10] = get_vector_from_array_int(c_p_10, 3);
  int c_f_10[] = {}; //   0
  psi_c_f[no_ps][10] = get_vector_from_array_int(c_f_10, 0);
  int c_t_10[] = {}; //   0
  psi_c_t[no_ps][10] = get_vector_from_array_int(c_t_10, 0);
  int c_d_10[] = { 11,   6,   0,   1}; //   4
  psi_c_d[no_ps][10] = get_vector_from_array_int(c_d_10, 4);

  int c_p_11[] = {  0,   2,  12}; //   3
  psi_c_p[no_ps][11] = get_vector_from_array_int(c_p_11, 3);
  int c_f_11[] = {}; //   0
  psi_c_f[no_ps][11] = get_vector_from_array_int(c_f_11, 0);
  int c_t_11[] = {}; //   0
  psi_c_t[no_ps][11] = get_vector_from_array_int(c_t_11, 0);
  int c_d_11[] = { 12,   8,   2,   1}; //   4
  psi_c_d[no_ps][11] = get_vector_from_array_int(c_d_11, 4);

  int c_p_12[] = {  0}; //   1
  psi_c_p[no_ps][12] = get_vector_from_array_int(c_p_12, 1);
  int c_f_12[] = {  2,   3}; //   2
  psi_c_f[no_ps][12] = get_vector_from_array_int(c_f_12, 2);
  int c_t_12[] = {  4,   5,   6}; //   3
  psi_c_t[no_ps][12] = get_vector_from_array_int(c_t_12, 3);
  int c_d_12[] = {  1}; //   1
  psi_c_d[no_ps][12] = get_vector_from_array_int(c_d_12, 1);

  int c_p_13[] = {  0}; //   1
  psi_c_p[no_ps][13] = get_vector_from_array_int(c_p_13, 1);
  int c_f_13[] = {  2,   4}; //   2
  psi_c_f[no_ps][13] = get_vector_from_array_int(c_f_13, 2);
  int c_t_13[] = {  7,   8,   9}; //   3
  psi_c_t[no_ps][13] = get_vector_from_array_int(c_t_13, 3);
  int c_d_13[] = {  1}; //   1
  psi_c_d[no_ps][13] = get_vector_from_array_int(c_d_13, 1);

  int c_p_14[] = {  0,   2,   4}; //   3
  psi_c_p[no_ps][14] = get_vector_from_array_int(c_p_14, 3);
  int c_f_14[] = {}; //   0
  psi_c_f[no_ps][14] = get_vector_from_array_int(c_f_14, 0);
  int c_t_14[] = {  4}; //   1
  psi_c_t[no_ps][14] = get_vector_from_array_int(c_t_14, 1);
  int c_d_14[] = {  4,   2,   1}; //   3
  psi_c_d[no_ps][14] = get_vector_from_array_int(c_d_14, 3);

  int c_p_15[] = {  0,   1,   3}; //   3
  psi_c_p[no_ps][15] = get_vector_from_array_int(c_p_15, 3);
  int c_f_15[] = {}; //   0
  psi_c_f[no_ps][15] = get_vector_from_array_int(c_f_15, 0);
  int c_t_15[] = {  7}; //   1
  psi_c_t[no_ps][15] = get_vector_from_array_int(c_t_15, 1);
  int c_d_15[] = {  3,   0,   1}; //   3
  psi_c_d[no_ps][15] = get_vector_from_array_int(c_d_15, 3);

  int c_p_16[] = {  5,   6,   7}; //   3
  psi_c_p[no_ps][16] = get_vector_from_array_int(c_p_16, 3);
  int c_f_16[] = {}; //   0
  psi_c_f[no_ps][16] = get_vector_from_array_int(c_f_16, 0);
  int c_t_16[] = {  4}; //   1
  psi_c_t[no_ps][16] = get_vector_from_array_int(c_t_16, 1);
  int c_d_16[] = {  5,   1,   6}; //   3
  psi_c_d[no_ps][16] = get_vector_from_array_int(c_d_16, 3);

  int c_p_17[] = {  8,   9,  10}; //   3
  psi_c_p[no_ps][17] = get_vector_from_array_int(c_p_17, 3);
  int c_f_17[] = {}; //   0
  psi_c_f[no_ps][17] = get_vector_from_array_int(c_f_17, 0);
  int c_t_17[] = {  7}; //   1
  psi_c_t[no_ps][17] = get_vector_from_array_int(c_t_17, 1);
  int c_d_17[] = {  7,   1,   8}; //   3
  psi_c_d[no_ps][17] = get_vector_from_array_int(c_d_17, 3);

  int c_p_18[] = {  0}; //   1
  psi_c_p[no_ps][18] = get_vector_from_array_int(c_p_18, 1);
  int c_f_18[] = {  2,   3}; //   2
  psi_c_f[no_ps][18] = get_vector_from_array_int(c_f_18, 2);
  int c_t_18[] = {  4,   5,  10}; //   3
  psi_c_t[no_ps][18] = get_vector_from_array_int(c_t_18, 3);
  int c_d_18[] = {  1}; //   1
  psi_c_d[no_ps][18] = get_vector_from_array_int(c_d_18, 1);

  int c_p_19[] = {  0}; //   1
  psi_c_p[no_ps][19] = get_vector_from_array_int(c_p_19, 1);
  int c_f_19[] = {  2,   4}; //   2
  psi_c_f[no_ps][19] = get_vector_from_array_int(c_f_19, 2);
  int c_t_19[] = {  7,   8,  11}; //   3
  psi_c_t[no_ps][19] = get_vector_from_array_int(c_t_19, 3);
  int c_d_19[] = {  1}; //   1
  psi_c_d[no_ps][19] = get_vector_from_array_int(c_d_19, 1);

  int c_p_20[] = {  0,   2}; //   2
  psi_c_p[no_ps][20] = get_vector_from_array_int(c_p_20, 2);
  int c_f_20[] = {  1}; //   1
  psi_c_f[no_ps][20] = get_vector_from_array_int(c_f_20, 1);
  int c_t_20[] = {  4,  12}; //   2
  psi_c_t[no_ps][20] = get_vector_from_array_int(c_t_20, 2);
  int c_d_20[] = {  2,   1}; //   2
  psi_c_d[no_ps][20] = get_vector_from_array_int(c_d_20, 2);

  int c_p_21[] = {  0,   1}; //   2
  psi_c_p[no_ps][21] = get_vector_from_array_int(c_p_21, 2);
  int c_f_21[] = {  0}; //   1
  psi_c_f[no_ps][21] = get_vector_from_array_int(c_f_21, 1);
  int c_t_21[] = {  7,  13}; //   2
  psi_c_t[no_ps][21] = get_vector_from_array_int(c_t_21, 2);
  int c_d_21[] = {  0,   1}; //   2
  psi_c_d[no_ps][21] = get_vector_from_array_int(c_d_21, 2);

  int c_p_22[] = {  0,  13}; //   2
  psi_c_p[no_ps][22] = get_vector_from_array_int(c_p_22, 2);
  int c_f_22[] = {  5}; //   1
  psi_c_f[no_ps][22] = get_vector_from_array_int(c_f_22, 1);
  int c_t_22[] = {  0,  14}; //   2
  psi_c_t[no_ps][22] = get_vector_from_array_int(c_t_22, 2);
  int c_d_22[] = {  8,   1}; //   2
  psi_c_d[no_ps][22] = get_vector_from_array_int(c_d_22, 2);

  int c_p_23[] = {  0,  14}; //   2
  psi_c_p[no_ps][23] = get_vector_from_array_int(c_p_23, 2);
  int c_f_23[] = {  6}; //   1
  psi_c_f[no_ps][23] = get_vector_from_array_int(c_f_23, 1);
  int c_t_23[] = {  2,  15}; //   2
  psi_c_t[no_ps][23] = get_vector_from_array_int(c_t_23, 2);
  int c_d_23[] = {  6,   1}; //   2
  psi_c_d[no_ps][23] = get_vector_from_array_int(c_d_23, 2);

  int c_p_24[] = {  0,   1,  11}; //   3
  psi_c_p[no_ps][24] = get_vector_from_array_int(c_p_24, 3);
  int c_f_24[] = {}; //   0
  psi_c_f[no_ps][24] = get_vector_from_array_int(c_f_24, 0);
  int c_t_24[] = { 16}; //   1
  psi_c_t[no_ps][24] = get_vector_from_array_int(c_t_24, 1);
  int c_d_24[] = {  6,   0,   1}; //   3
  psi_c_d[no_ps][24] = get_vector_from_array_int(c_d_24, 3);

  int c_p_25[] = {  0,   2,  12}; //   3
  psi_c_p[no_ps][25] = get_vector_from_array_int(c_p_25, 3);
  int c_f_25[] = {}; //   0
  psi_c_f[no_ps][25] = get_vector_from_array_int(c_f_25, 0);
  int c_t_25[] = { 17}; //   1
  psi_c_t[no_ps][25] = get_vector_from_array_int(c_t_25, 1);
  int c_d_25[] = {  8,   2,   1}; //   3
  psi_c_d[no_ps][25] = get_vector_from_array_int(c_d_25, 3);

  int c_p_26[] = {  5,   6,  15}; //   3
  psi_c_p[no_ps][26] = get_vector_from_array_int(c_p_26, 3);
  int c_f_26[] = {}; //   0
  psi_c_f[no_ps][26] = get_vector_from_array_int(c_f_26, 0);
  int c_t_26[] = { 18}; //   1
  psi_c_t[no_ps][26] = get_vector_from_array_int(c_t_26, 1);
  int c_d_26[] = {  0,   1,   6}; //   3
  psi_c_d[no_ps][26] = get_vector_from_array_int(c_d_26, 3);

  int c_p_27[] = {  8,   9,  16}; //   3
  psi_c_p[no_ps][27] = get_vector_from_array_int(c_p_27, 3);
  int c_f_27[] = {}; //   0
  psi_c_f[no_ps][27] = get_vector_from_array_int(c_f_27, 0);
  int c_t_27[] = { 19}; //   1
  psi_c_t[no_ps][27] = get_vector_from_array_int(c_t_27, 1);
  int c_d_27[] = {  2,   1,   8}; //   3
  psi_c_d[no_ps][27] = get_vector_from_array_int(c_d_27, 3);

  int c_p_28[] = {  5,   6}; //   2
  psi_c_p[no_ps][28] = get_vector_from_array_int(c_p_28, 2);
  int c_f_28[] = {  6}; //   1
  psi_c_f[no_ps][28] = get_vector_from_array_int(c_f_28, 1);
  int c_t_28[] = {  4,  20}; //   2
  psi_c_t[no_ps][28] = get_vector_from_array_int(c_t_28, 2);
  int c_d_28[] = {  1,   6}; //   2
  psi_c_d[no_ps][28] = get_vector_from_array_int(c_d_28, 2);

  int c_p_29[] = {  8,   9}; //   2
  psi_c_p[no_ps][29] = get_vector_from_array_int(c_p_29, 2);
  int c_f_29[] = {  5}; //   1
  psi_c_f[no_ps][29] = get_vector_from_array_int(c_f_29, 1);
  int c_t_29[] = {  7,  21}; //   2
  psi_c_t[no_ps][29] = get_vector_from_array_int(c_t_29, 2);
  int c_d_29[] = {  1,   8}; //   2
  psi_c_d[no_ps][29] = get_vector_from_array_int(c_d_29, 2);

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
