#include "../include/classes.cxx"
#include "../include/definitions.phasespace.set.cxx"
#include "../ppnenexa03/header/ppnenexa03.phasespace.h"
void ppnenexa03_ax_psp_230_uux_vevexagg(int no_ps, phasespace_set & psi){
  static Logger logger("ppnenexa03_ax_psp_230_uux_vevexagg");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;
  psi_v_smin[no_ps].resize(17);
  psi_needed_v_smin[no_ps].resize(17);
  int needed_v_smin_0[] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29}; //  30
  psi_needed_v_smin[no_ps][  0] = get_vector_from_array_int(needed_v_smin_0, 30);
  int needed_v_smin_1[] = {  24,   25,   26,   27,   28,   29,    4,    5,   18,   19}; //  10
  psi_needed_v_smin[no_ps][  1] = get_vector_from_array_int(needed_v_smin_1, 10);
  int needed_v_smin_2[] = {   0,    3,   20,   23}; //   4
  psi_needed_v_smin[no_ps][  2] = get_vector_from_array_int(needed_v_smin_2, 4);
  int needed_v_smin_3[] = {   0,    3,   20,   23}; //   4
  psi_needed_v_smin[no_ps][  3] = get_vector_from_array_int(needed_v_smin_3, 4);
  int needed_v_smin_4[] = {   1,    2,   21,   22}; //   4
  psi_needed_v_smin[no_ps][  4] = get_vector_from_array_int(needed_v_smin_4, 4);
  int needed_v_smin_5[] = {   1,    2,   21,   22}; //   4
  psi_needed_v_smin[no_ps][  5] = get_vector_from_array_int(needed_v_smin_5, 4);
  int needed_v_smin_6[] = {   4,    5,   18,   19,   24,   25,   28,   29}; //   8
  psi_needed_v_smin[no_ps][  6] = get_vector_from_array_int(needed_v_smin_6, 8);
  int needed_v_smin_7[] = {   6,    8,   15,   17,   27}; //   5
  psi_needed_v_smin[no_ps][  7] = get_vector_from_array_int(needed_v_smin_7, 5);
  int needed_v_smin_8[] = {   6,   15}; //   2
  psi_needed_v_smin[no_ps][  8] = get_vector_from_array_int(needed_v_smin_8, 2);
  int needed_v_smin_9[] = {   7,   10,   13,   16}; //   4
  psi_needed_v_smin[no_ps][  9] = get_vector_from_array_int(needed_v_smin_9, 4);
  int needed_v_smin_10[] = {   7,   13}; //   2
  psi_needed_v_smin[no_ps][ 10] = get_vector_from_array_int(needed_v_smin_10, 2);
  int needed_v_smin_11[] = {   8,   17}; //   2
  psi_needed_v_smin[no_ps][ 11] = get_vector_from_array_int(needed_v_smin_11, 2);
  int needed_v_smin_12[] = {   9,   11,   12,   14}; //   4
  psi_needed_v_smin[no_ps][ 12] = get_vector_from_array_int(needed_v_smin_12, 4);
  int needed_v_smin_13[] = {   9,   12}; //   2
  psi_needed_v_smin[no_ps][ 13] = get_vector_from_array_int(needed_v_smin_13, 2);
  int needed_v_smin_14[] = {  10,   16}; //   2
  psi_needed_v_smin[no_ps][ 14] = get_vector_from_array_int(needed_v_smin_14, 2);
  int needed_v_smin_15[] = {  11,   14}; //   2
  psi_needed_v_smin[no_ps][ 15] = get_vector_from_array_int(needed_v_smin_15, 2);
  int needed_v_smin_16[] = {  26}; //   1
  psi_needed_v_smin[no_ps][ 16] = get_vector_from_array_int(needed_v_smin_16, 1);

  psi_v_smax[no_ps].resize(14);
  psi_needed_v_smax[no_ps].resize(14);
  int needed_v_smax_0[] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   25,   27,   29}; //  27
  psi_needed_v_smax[no_ps][  0] = get_vector_from_array_int(needed_v_smax_0, 27);
  int needed_v_smax_1[] = {  24,   26,   28}; //   3
  psi_needed_v_smax[no_ps][  1] = get_vector_from_array_int(needed_v_smax_1, 3);
  int needed_v_smax_2[] = {  24,   26,   28}; //   3
  psi_needed_v_smax[no_ps][  2] = get_vector_from_array_int(needed_v_smax_2, 3);
  int needed_v_smax_3[] = {  25,   27,   29,    4,    5,   18,   19}; //   7
  psi_needed_v_smax[no_ps][  3] = get_vector_from_array_int(needed_v_smax_3, 7);
  int needed_v_smax_4[] = {   0,    3,   20,   23}; //   4
  psi_needed_v_smax[no_ps][  4] = get_vector_from_array_int(needed_v_smax_4, 4);
  int needed_v_smax_5[] = {   0,    3,    6,    7,   13,   15,   20,   23}; //   8
  psi_needed_v_smax[no_ps][  5] = get_vector_from_array_int(needed_v_smax_5, 8);
  int needed_v_smax_6[] = {   1,    2,   21,   22}; //   4
  psi_needed_v_smax[no_ps][  6] = get_vector_from_array_int(needed_v_smax_6, 4);
  int needed_v_smax_7[] = {   1,    2,    8,    9,   12,   17,   21,   22}; //   8
  psi_needed_v_smax[no_ps][  7] = get_vector_from_array_int(needed_v_smax_7, 8);
  int needed_v_smax_8[] = {   4,    5,   10,   11,   14,   16,   18,   19,   24,   25,   28,   29}; //  12
  psi_needed_v_smax[no_ps][  8] = get_vector_from_array_int(needed_v_smax_8, 12);
  int needed_v_smax_9[] = {   6,    8,   15,   17}; //   4
  psi_needed_v_smax[no_ps][  9] = get_vector_from_array_int(needed_v_smax_9, 4);
  int needed_v_smax_10[] = {   7,   10,   13,   16}; //   4
  psi_needed_v_smax[no_ps][ 10] = get_vector_from_array_int(needed_v_smax_10, 4);
  int needed_v_smax_11[] = {   9,   11,   12,   14}; //   4
  psi_needed_v_smax[no_ps][ 11] = get_vector_from_array_int(needed_v_smax_11, 4);
  int needed_v_smax_12[] = {  26}; //   1
  psi_needed_v_smax[no_ps][ 12] = get_vector_from_array_int(needed_v_smax_12, 1);
  int needed_v_smax_13[] = {  27}; //   1
  psi_needed_v_smax[no_ps][ 13] = get_vector_from_array_int(needed_v_smax_13, 1);

  psi_container_IS_startvalue[no_ps][0] = psi_container_IS_name.size();
  psi_g_p[no_ps].resize(4);
  psi_needed_g_p[no_ps].resize(4);
  int needed_g_p_0[] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   25,   27,   29}; //  27
  psi_needed_g_p[no_ps][0] = get_vector_from_array_int(needed_g_p_0, 27);
  psi_container_IS_name.push_back("propagator_23_smin0_smax0");
  int needed_g_p_1[] = {  24,   26,   28}; //   3
  psi_needed_g_p[no_ps][1] = get_vector_from_array_int(needed_g_p_1, 3);
  psi_container_IS_name.push_back("propagator_0_smin1_smax1");
  int needed_g_p_2[] = {  24,   26,   28}; //   3
  psi_needed_g_p[no_ps][2] = get_vector_from_array_int(needed_g_p_2, 3);
  psi_container_IS_name.push_back("propagator_23_smin0_smax2");
  int needed_g_p_3[] = {  25,   27,   29}; //   3
  psi_needed_g_p[no_ps][3] = get_vector_from_array_int(needed_g_p_3, 3);
  psi_container_IS_name.push_back("propagator_0_smin1_smax3");

  psi_container_IS_startvalue[no_ps][1] = psi_container_IS_name.size();
  psi_g_f[no_ps].resize(17);
  psi_needed_g_f[no_ps].resize(17);
  int needed_g_f_0[] = {   0,    3,   20,   23}; //   4
  psi_needed_g_f[no_ps][0] = get_vector_from_array_int(needed_g_f_0, 4);
  psi_container_IS_name.push_back("timelikeinvariant_smin2_smax4");
  int needed_g_f_1[] = {   0,    3,   20,   23}; //   4
  psi_needed_g_f[no_ps][1] = get_vector_from_array_int(needed_g_f_1, 4);
  psi_container_IS_name.push_back("timelikeinvariant_smin3_smax5");
  int needed_g_f_2[] = {   1,    2,   21,   22}; //   4
  psi_needed_g_f[no_ps][2] = get_vector_from_array_int(needed_g_f_2, 4);
  psi_container_IS_name.push_back("timelikeinvariant_smin4_smax6");
  int needed_g_f_3[] = {   1,    2,   21,   22}; //   4
  psi_needed_g_f[no_ps][3] = get_vector_from_array_int(needed_g_f_3, 4);
  psi_container_IS_name.push_back("timelikeinvariant_smin5_smax7");
  int needed_g_f_4[] = {   4,    5,   18,   19}; //   4
  psi_needed_g_f[no_ps][4] = get_vector_from_array_int(needed_g_f_4, 4);
  psi_container_IS_name.push_back("timelikeinvariant_smin1_smax3");
  int needed_g_f_5[] = {   4,    5,   18,   19,   24,   25,   28,   29}; //   8
  psi_needed_g_f[no_ps][5] = get_vector_from_array_int(needed_g_f_5, 8);
  psi_container_IS_name.push_back("timelikeinvariant_smin6_smax8");
  int needed_g_f_6[] = {   6,    8,   15,   17}; //   4
  psi_needed_g_f[no_ps][6] = get_vector_from_array_int(needed_g_f_6, 4);
  psi_container_IS_name.push_back("timelikeinvariant_smin7_smax9");
  int needed_g_f_7[] = {   6,   15}; //   2
  psi_needed_g_f[no_ps][7] = get_vector_from_array_int(needed_g_f_7, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin8_smax5");
  int needed_g_f_8[] = {   7,   10,   13,   16}; //   4
  psi_needed_g_f[no_ps][8] = get_vector_from_array_int(needed_g_f_8, 4);
  psi_container_IS_name.push_back("timelikeinvariant_smin9_smax10");
  int needed_g_f_9[] = {   7,   13}; //   2
  psi_needed_g_f[no_ps][9] = get_vector_from_array_int(needed_g_f_9, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin10_smax5");
  int needed_g_f_10[] = {   8,   17}; //   2
  psi_needed_g_f[no_ps][10] = get_vector_from_array_int(needed_g_f_10, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin11_smax7");
  int needed_g_f_11[] = {   9,   11,   12,   14}; //   4
  psi_needed_g_f[no_ps][11] = get_vector_from_array_int(needed_g_f_11, 4);
  psi_container_IS_name.push_back("timelikeinvariant_smin12_smax11");
  int needed_g_f_12[] = {   9,   12}; //   2
  psi_needed_g_f[no_ps][12] = get_vector_from_array_int(needed_g_f_12, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin13_smax7");
  int needed_g_f_13[] = {  10,   16}; //   2
  psi_needed_g_f[no_ps][13] = get_vector_from_array_int(needed_g_f_13, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin14_smax8");
  int needed_g_f_14[] = {  11,   14}; //   2
  psi_needed_g_f[no_ps][14] = get_vector_from_array_int(needed_g_f_14, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin15_smax8");
  int needed_g_f_15[] = {  26}; //   1
  psi_needed_g_f[no_ps][15] = get_vector_from_array_int(needed_g_f_15, 1);
  psi_container_IS_name.push_back("timelikeinvariant_smin16_smax12");
  int needed_g_f_16[] = {  27}; //   1
  psi_needed_g_f[no_ps][16] = get_vector_from_array_int(needed_g_f_16, 1);
  psi_container_IS_name.push_back("timelikeinvariant_smin7_smax13");

  psi_container_IS_startvalue[no_ps][2] = psi_container_IS_name.size();
  psi_g_t[no_ps].resize(48);
  psi_needed_g_t[no_ps].resize(48);
  int needed_g_t_0[] = {   0,    3}; //   2
  psi_needed_g_t[no_ps][0] = get_vector_from_array_int(needed_g_t_0, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_1__64_60");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_1__64_60");
  int needed_g_t_1[] = {   0,    3}; //   2
  psi_needed_g_t[no_ps][1] = get_vector_from_array_int(needed_g_t_1, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_66__12_48");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_66__12_48");
  int needed_g_t_2[] = {   0}; //   1
  psi_needed_g_t[no_ps][2] = get_vector_from_array_int(needed_g_t_2, 1);
  psi_container_IS_name.push_back("t_of_tchannel_0__66_13__32_16");
  psi_container_IS_name.push_back("phi_of_tchannel_0__66_13__32_16");
  int needed_g_t_3[] = {   1,    2}; //   2
  psi_needed_g_t[no_ps][3] = get_vector_from_array_int(needed_g_t_3, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_1__32_92");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_1__32_92");
  int needed_g_t_4[] = {   1,    2}; //   2
  psi_needed_g_t[no_ps][4] = get_vector_from_array_int(needed_g_t_4, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_34__12_80");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_34__12_80");
  int needed_g_t_5[] = {   1}; //   1
  psi_needed_g_t[no_ps][5] = get_vector_from_array_int(needed_g_t_5, 1);
  psi_container_IS_name.push_back("t_of_tchannel_0__34_13__64_16");
  psi_container_IS_name.push_back("phi_of_tchannel_0__34_13__64_16");
  int needed_g_t_6[] = {   2}; //   1
  psi_needed_g_t[no_ps][6] = get_vector_from_array_int(needed_g_t_6, 1);
  psi_container_IS_name.push_back("t_of_tchannel_0__34_13__16_64");
  psi_container_IS_name.push_back("phi_of_tchannel_0__34_13__16_64");
  int needed_g_t_7[] = {   3}; //   1
  psi_needed_g_t[no_ps][7] = get_vector_from_array_int(needed_g_t_7, 1);
  psi_container_IS_name.push_back("t_of_tchannel_0__66_13__16_32");
  psi_container_IS_name.push_back("phi_of_tchannel_0__66_13__16_32");
  int needed_g_t_8[] = {   4,    5,   24,   25}; //   4
  psi_needed_g_t[no_ps][8] = get_vector_from_array_int(needed_g_t_8, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_1__16_108");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_1__16_108");
  int needed_g_t_9[] = {   4,    5,   24}; //   3
  psi_needed_g_t[no_ps][9] = get_vector_from_array_int(needed_g_t_9, 3);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_18__12_96");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_18__12_96");
  int needed_g_t_10[] = {   4}; //   1
  psi_needed_g_t[no_ps][10] = get_vector_from_array_int(needed_g_t_10, 1);
  psi_container_IS_name.push_back("t_of_tchannel_0__18_13__64_32");
  psi_container_IS_name.push_back("phi_of_tchannel_0__18_13__64_32");
  int needed_g_t_11[] = {   5}; //   1
  psi_needed_g_t[no_ps][11] = get_vector_from_array_int(needed_g_t_11, 1);
  psi_container_IS_name.push_back("t_of_tchannel_0__18_13__32_64");
  psi_container_IS_name.push_back("phi_of_tchannel_0__18_13__32_64");
  int needed_g_t_12[] = {   6,    7,   13,   15,   20,   23}; //   6
  psi_needed_g_t[no_ps][12] = get_vector_from_array_int(needed_g_t_12, 6);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_2__64_60");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_2__64_60");
  int needed_g_t_13[] = {   6,   15}; //   2
  psi_needed_g_t[no_ps][13] = get_vector_from_array_int(needed_g_t_13, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_65__32_28");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_65__32_28");
  int needed_g_t_14[] = {   6}; //   1
  psi_needed_g_t[no_ps][14] = get_vector_from_array_int(needed_g_t_14, 1);
  psi_container_IS_name.push_back("t_of_tchannel_0__34_65__16_12");
  psi_container_IS_name.push_back("phi_of_tchannel_0__34_65__16_12");
  int needed_g_t_15[] = {   7,   13}; //   2
  psi_needed_g_t[no_ps][15] = get_vector_from_array_int(needed_g_t_15, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_65__16_44");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_65__16_44");
  int needed_g_t_16[] = {   7}; //   1
  psi_needed_g_t[no_ps][16] = get_vector_from_array_int(needed_g_t_16, 1);
  psi_container_IS_name.push_back("t_of_tchannel_0__18_65__32_12");
  psi_container_IS_name.push_back("phi_of_tchannel_0__18_65__32_12");
  int needed_g_t_17[] = {   8,    9,   12,   17,   21,   22}; //   6
  psi_needed_g_t[no_ps][17] = get_vector_from_array_int(needed_g_t_17, 6);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_2__32_92");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_2__32_92");
  int needed_g_t_18[] = {   8,   17}; //   2
  psi_needed_g_t[no_ps][18] = get_vector_from_array_int(needed_g_t_18, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_33__64_28");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_33__64_28");
  int needed_g_t_19[] = {   8}; //   1
  psi_needed_g_t[no_ps][19] = get_vector_from_array_int(needed_g_t_19, 1);
  psi_container_IS_name.push_back("t_of_tchannel_0__66_33__16_12");
  psi_container_IS_name.push_back("phi_of_tchannel_0__66_33__16_12");
  int needed_g_t_20[] = {   9,   12}; //   2
  psi_needed_g_t[no_ps][20] = get_vector_from_array_int(needed_g_t_20, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_33__16_76");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_33__16_76");
  int needed_g_t_21[] = {   9}; //   1
  psi_needed_g_t[no_ps][21] = get_vector_from_array_int(needed_g_t_21, 1);
  psi_container_IS_name.push_back("t_of_tchannel_0__18_33__64_12");
  psi_container_IS_name.push_back("phi_of_tchannel_0__18_33__64_12");
  int needed_g_t_22[] = {  10,   11,   14,   16,   18,   19,   28,   29}; //   8
  psi_needed_g_t[no_ps][22] = get_vector_from_array_int(needed_g_t_22, 8);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_2__16_108");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_2__16_108");
  int needed_g_t_23[] = {  10,   16}; //   2
  psi_needed_g_t[no_ps][23] = get_vector_from_array_int(needed_g_t_23, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_17__64_44");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_17__64_44");
  int needed_g_t_24[] = {  10}; //   1
  psi_needed_g_t[no_ps][24] = get_vector_from_array_int(needed_g_t_24, 1);
  psi_container_IS_name.push_back("t_of_tchannel_0__66_17__32_12");
  psi_container_IS_name.push_back("phi_of_tchannel_0__66_17__32_12");
  int needed_g_t_25[] = {  11,   14}; //   2
  psi_needed_g_t[no_ps][25] = get_vector_from_array_int(needed_g_t_25, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_17__32_76");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_17__32_76");
  int needed_g_t_26[] = {  11}; //   1
  psi_needed_g_t[no_ps][26] = get_vector_from_array_int(needed_g_t_26, 1);
  psi_container_IS_name.push_back("t_of_tchannel_0__34_17__64_12");
  psi_container_IS_name.push_back("phi_of_tchannel_0__34_17__64_12");
  int needed_g_t_27[] = {  12}; //   1
  psi_needed_g_t[no_ps][27] = get_vector_from_array_int(needed_g_t_27, 1);
  psi_container_IS_name.push_back("t_of_tchannel_0__33_18__64_12");
  psi_container_IS_name.push_back("phi_of_tchannel_0__33_18__64_12");
  int needed_g_t_28[] = {  13}; //   1
  psi_needed_g_t[no_ps][28] = get_vector_from_array_int(needed_g_t_28, 1);
  psi_container_IS_name.push_back("t_of_tchannel_0__65_18__32_12");
  psi_container_IS_name.push_back("phi_of_tchannel_0__65_18__32_12");
  int needed_g_t_29[] = {  14}; //   1
  psi_needed_g_t[no_ps][29] = get_vector_from_array_int(needed_g_t_29, 1);
  psi_container_IS_name.push_back("t_of_tchannel_0__17_34__64_12");
  psi_container_IS_name.push_back("phi_of_tchannel_0__17_34__64_12");
  int needed_g_t_30[] = {  15}; //   1
  psi_needed_g_t[no_ps][30] = get_vector_from_array_int(needed_g_t_30, 1);
  psi_container_IS_name.push_back("t_of_tchannel_0__65_34__16_12");
  psi_container_IS_name.push_back("phi_of_tchannel_0__65_34__16_12");
  int needed_g_t_31[] = {  16}; //   1
  psi_needed_g_t[no_ps][31] = get_vector_from_array_int(needed_g_t_31, 1);
  psi_container_IS_name.push_back("t_of_tchannel_0__17_66__32_12");
  psi_container_IS_name.push_back("phi_of_tchannel_0__17_66__32_12");
  int needed_g_t_32[] = {  17}; //   1
  psi_needed_g_t[no_ps][32] = get_vector_from_array_int(needed_g_t_32, 1);
  psi_container_IS_name.push_back("t_of_tchannel_0__33_66__16_12");
  psi_container_IS_name.push_back("phi_of_tchannel_0__33_66__16_12");
  int needed_g_t_33[] = {  18,   19,   29}; //   3
  psi_needed_g_t[no_ps][33] = get_vector_from_array_int(needed_g_t_33, 3);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_17__12_96");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_17__12_96");
  int needed_g_t_34[] = {  18}; //   1
  psi_needed_g_t[no_ps][34] = get_vector_from_array_int(needed_g_t_34, 1);
  psi_container_IS_name.push_back("t_of_tchannel_0__17_14__32_64");
  psi_container_IS_name.push_back("phi_of_tchannel_0__17_14__32_64");
  int needed_g_t_35[] = {  19}; //   1
  psi_needed_g_t[no_ps][35] = get_vector_from_array_int(needed_g_t_35, 1);
  psi_container_IS_name.push_back("t_of_tchannel_0__17_14__64_32");
  psi_container_IS_name.push_back("phi_of_tchannel_0__17_14__64_32");
  int needed_g_t_36[] = {  20,   23}; //   2
  psi_needed_g_t[no_ps][36] = get_vector_from_array_int(needed_g_t_36, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_65__12_48");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_65__12_48");
  int needed_g_t_37[] = {  20}; //   1
  psi_needed_g_t[no_ps][37] = get_vector_from_array_int(needed_g_t_37, 1);
  psi_container_IS_name.push_back("t_of_tchannel_0__65_14__16_32");
  psi_container_IS_name.push_back("phi_of_tchannel_0__65_14__16_32");
  int needed_g_t_38[] = {  21,   22}; //   2
  psi_needed_g_t[no_ps][38] = get_vector_from_array_int(needed_g_t_38, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_33__12_80");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_33__12_80");
  int needed_g_t_39[] = {  21}; //   1
  psi_needed_g_t[no_ps][39] = get_vector_from_array_int(needed_g_t_39, 1);
  psi_container_IS_name.push_back("t_of_tchannel_0__33_14__16_64");
  psi_container_IS_name.push_back("phi_of_tchannel_0__33_14__16_64");
  int needed_g_t_40[] = {  22}; //   1
  psi_needed_g_t[no_ps][40] = get_vector_from_array_int(needed_g_t_40, 1);
  psi_container_IS_name.push_back("t_of_tchannel_0__33_14__64_16");
  psi_container_IS_name.push_back("phi_of_tchannel_0__33_14__64_16");
  int needed_g_t_41[] = {  23}; //   1
  psi_needed_g_t[no_ps][41] = get_vector_from_array_int(needed_g_t_41, 1);
  psi_container_IS_name.push_back("t_of_tchannel_0__65_14__32_16");
  psi_container_IS_name.push_back("phi_of_tchannel_0__65_14__32_16");
  int needed_g_t_42[] = {  25}; //   1
  psi_needed_g_t[no_ps][42] = get_vector_from_array_int(needed_g_t_42, 1);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_18__96_12");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_18__96_12");
  int needed_g_t_43[] = {  26}; //   1
  psi_needed_g_t[no_ps][43] = get_vector_from_array_int(needed_g_t_43, 1);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_2__12_112");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_2__12_112");
  int needed_g_t_44[] = {  26}; //   1
  psi_needed_g_t[no_ps][44] = get_vector_from_array_int(needed_g_t_44, 1);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_13__96_16");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_13__96_16");
  int needed_g_t_45[] = {  27}; //   1
  psi_needed_g_t[no_ps][45] = get_vector_from_array_int(needed_g_t_45, 1);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_2__96_28");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_2__96_28");
  int needed_g_t_46[] = {  27}; //   1
  psi_needed_g_t[no_ps][46] = get_vector_from_array_int(needed_g_t_46, 1);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_97__12_16");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_97__12_16");
  int needed_g_t_47[] = {  28}; //   1
  psi_needed_g_t[no_ps][47] = get_vector_from_array_int(needed_g_t_47, 1);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_17__96_12");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_17__96_12");

  psi_container_IS_startvalue[no_ps][3] = psi_container_IS_name.size();
  psi_g_d[no_ps].resize(2);
  psi_needed_g_d[no_ps].resize(2);
  int needed_g_d_0[] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29}; //  30
  psi_needed_g_d[no_ps][0] = get_vector_from_array_int(needed_g_d_0, 30);
  psi_container_IS_name.push_back("costheta_of_decay_12__4_8");
  psi_container_IS_name.push_back("phi_of_decay_12__4_8");
  int needed_g_d_1[] = {  24,   25,   26,   27,   28,   29}; //   6
  psi_needed_g_d[no_ps][1] = get_vector_from_array_int(needed_g_d_1, 6);
  psi_container_IS_name.push_back("costheta_of_decay_96__32_64");
  psi_container_IS_name.push_back("phi_of_decay_96__32_64");

  psi_c_p[no_ps].resize(30);
  psi_c_f[no_ps].resize(30);
  psi_c_t[no_ps].resize(30);
  psi_c_d[no_ps].resize(30);

  int c_p_0[] = {  0}; //   1
  psi_c_p[no_ps][0] = get_vector_from_array_int(c_p_0, 1);
  int c_f_0[] = {  0,   1}; //   2
  psi_c_f[no_ps][0] = get_vector_from_array_int(c_f_0, 2);
  int c_t_0[] = {  0,   1,   2}; //   3
  psi_c_t[no_ps][0] = get_vector_from_array_int(c_t_0, 3);
  int c_d_0[] = {  0}; //   1
  psi_c_d[no_ps][0] = get_vector_from_array_int(c_d_0, 1);

  int c_p_1[] = {  0}; //   1
  psi_c_p[no_ps][1] = get_vector_from_array_int(c_p_1, 1);
  int c_f_1[] = {  2,   3}; //   2
  psi_c_f[no_ps][1] = get_vector_from_array_int(c_f_1, 2);
  int c_t_1[] = {  3,   4,   5}; //   3
  psi_c_t[no_ps][1] = get_vector_from_array_int(c_t_1, 3);
  int c_d_1[] = {  0}; //   1
  psi_c_d[no_ps][1] = get_vector_from_array_int(c_d_1, 1);

  int c_p_2[] = {  0}; //   1
  psi_c_p[no_ps][2] = get_vector_from_array_int(c_p_2, 1);
  int c_f_2[] = {  2,   3}; //   2
  psi_c_f[no_ps][2] = get_vector_from_array_int(c_f_2, 2);
  int c_t_2[] = {  3,   4,   6}; //   3
  psi_c_t[no_ps][2] = get_vector_from_array_int(c_t_2, 3);
  int c_d_2[] = {  0}; //   1
  psi_c_d[no_ps][2] = get_vector_from_array_int(c_d_2, 1);

  int c_p_3[] = {  0}; //   1
  psi_c_p[no_ps][3] = get_vector_from_array_int(c_p_3, 1);
  int c_f_3[] = {  0,   1}; //   2
  psi_c_f[no_ps][3] = get_vector_from_array_int(c_f_3, 2);
  int c_t_3[] = {  0,   1,   7}; //   3
  psi_c_t[no_ps][3] = get_vector_from_array_int(c_t_3, 3);
  int c_d_3[] = {  0}; //   1
  psi_c_d[no_ps][3] = get_vector_from_array_int(c_d_3, 1);

  int c_p_4[] = {  0}; //   1
  psi_c_p[no_ps][4] = get_vector_from_array_int(c_p_4, 1);
  int c_f_4[] = {  4,   5}; //   2
  psi_c_f[no_ps][4] = get_vector_from_array_int(c_f_4, 2);
  int c_t_4[] = {  8,   9,  10}; //   3
  psi_c_t[no_ps][4] = get_vector_from_array_int(c_t_4, 3);
  int c_d_4[] = {  0}; //   1
  psi_c_d[no_ps][4] = get_vector_from_array_int(c_d_4, 1);

  int c_p_5[] = {  0}; //   1
  psi_c_p[no_ps][5] = get_vector_from_array_int(c_p_5, 1);
  int c_f_5[] = {  4,   5}; //   2
  psi_c_f[no_ps][5] = get_vector_from_array_int(c_f_5, 2);
  int c_t_5[] = {  8,   9,  11}; //   3
  psi_c_t[no_ps][5] = get_vector_from_array_int(c_t_5, 3);
  int c_d_5[] = {  0}; //   1
  psi_c_d[no_ps][5] = get_vector_from_array_int(c_d_5, 1);

  int c_p_6[] = {  0}; //   1
  psi_c_p[no_ps][6] = get_vector_from_array_int(c_p_6, 1);
  int c_f_6[] = {  6,   7}; //   2
  psi_c_f[no_ps][6] = get_vector_from_array_int(c_f_6, 2);
  int c_t_6[] = { 12,  13,  14}; //   3
  psi_c_t[no_ps][6] = get_vector_from_array_int(c_t_6, 3);
  int c_d_6[] = {  0}; //   1
  psi_c_d[no_ps][6] = get_vector_from_array_int(c_d_6, 1);

  int c_p_7[] = {  0}; //   1
  psi_c_p[no_ps][7] = get_vector_from_array_int(c_p_7, 1);
  int c_f_7[] = {  8,   9}; //   2
  psi_c_f[no_ps][7] = get_vector_from_array_int(c_f_7, 2);
  int c_t_7[] = { 12,  15,  16}; //   3
  psi_c_t[no_ps][7] = get_vector_from_array_int(c_t_7, 3);
  int c_d_7[] = {  0}; //   1
  psi_c_d[no_ps][7] = get_vector_from_array_int(c_d_7, 1);

  int c_p_8[] = {  0}; //   1
  psi_c_p[no_ps][8] = get_vector_from_array_int(c_p_8, 1);
  int c_f_8[] = {  6,  10}; //   2
  psi_c_f[no_ps][8] = get_vector_from_array_int(c_f_8, 2);
  int c_t_8[] = { 17,  18,  19}; //   3
  psi_c_t[no_ps][8] = get_vector_from_array_int(c_t_8, 3);
  int c_d_8[] = {  0}; //   1
  psi_c_d[no_ps][8] = get_vector_from_array_int(c_d_8, 1);

  int c_p_9[] = {  0}; //   1
  psi_c_p[no_ps][9] = get_vector_from_array_int(c_p_9, 1);
  int c_f_9[] = { 11,  12}; //   2
  psi_c_f[no_ps][9] = get_vector_from_array_int(c_f_9, 2);
  int c_t_9[] = { 17,  20,  21}; //   3
  psi_c_t[no_ps][9] = get_vector_from_array_int(c_t_9, 3);
  int c_d_9[] = {  0}; //   1
  psi_c_d[no_ps][9] = get_vector_from_array_int(c_d_9, 1);

  int c_p_10[] = {  0}; //   1
  psi_c_p[no_ps][10] = get_vector_from_array_int(c_p_10, 1);
  int c_f_10[] = {  8,  13}; //   2
  psi_c_f[no_ps][10] = get_vector_from_array_int(c_f_10, 2);
  int c_t_10[] = { 22,  23,  24}; //   3
  psi_c_t[no_ps][10] = get_vector_from_array_int(c_t_10, 3);
  int c_d_10[] = {  0}; //   1
  psi_c_d[no_ps][10] = get_vector_from_array_int(c_d_10, 1);

  int c_p_11[] = {  0}; //   1
  psi_c_p[no_ps][11] = get_vector_from_array_int(c_p_11, 1);
  int c_f_11[] = { 11,  14}; //   2
  psi_c_f[no_ps][11] = get_vector_from_array_int(c_f_11, 2);
  int c_t_11[] = { 22,  25,  26}; //   3
  psi_c_t[no_ps][11] = get_vector_from_array_int(c_t_11, 3);
  int c_d_11[] = {  0}; //   1
  psi_c_d[no_ps][11] = get_vector_from_array_int(c_d_11, 1);

  int c_p_12[] = {  0}; //   1
  psi_c_p[no_ps][12] = get_vector_from_array_int(c_p_12, 1);
  int c_f_12[] = { 11,  12}; //   2
  psi_c_f[no_ps][12] = get_vector_from_array_int(c_f_12, 2);
  int c_t_12[] = { 17,  20,  27}; //   3
  psi_c_t[no_ps][12] = get_vector_from_array_int(c_t_12, 3);
  int c_d_12[] = {  0}; //   1
  psi_c_d[no_ps][12] = get_vector_from_array_int(c_d_12, 1);

  int c_p_13[] = {  0}; //   1
  psi_c_p[no_ps][13] = get_vector_from_array_int(c_p_13, 1);
  int c_f_13[] = {  8,   9}; //   2
  psi_c_f[no_ps][13] = get_vector_from_array_int(c_f_13, 2);
  int c_t_13[] = { 12,  15,  28}; //   3
  psi_c_t[no_ps][13] = get_vector_from_array_int(c_t_13, 3);
  int c_d_13[] = {  0}; //   1
  psi_c_d[no_ps][13] = get_vector_from_array_int(c_d_13, 1);

  int c_p_14[] = {  0}; //   1
  psi_c_p[no_ps][14] = get_vector_from_array_int(c_p_14, 1);
  int c_f_14[] = { 11,  14}; //   2
  psi_c_f[no_ps][14] = get_vector_from_array_int(c_f_14, 2);
  int c_t_14[] = { 22,  25,  29}; //   3
  psi_c_t[no_ps][14] = get_vector_from_array_int(c_t_14, 3);
  int c_d_14[] = {  0}; //   1
  psi_c_d[no_ps][14] = get_vector_from_array_int(c_d_14, 1);

  int c_p_15[] = {  0}; //   1
  psi_c_p[no_ps][15] = get_vector_from_array_int(c_p_15, 1);
  int c_f_15[] = {  6,   7}; //   2
  psi_c_f[no_ps][15] = get_vector_from_array_int(c_f_15, 2);
  int c_t_15[] = { 12,  13,  30}; //   3
  psi_c_t[no_ps][15] = get_vector_from_array_int(c_t_15, 3);
  int c_d_15[] = {  0}; //   1
  psi_c_d[no_ps][15] = get_vector_from_array_int(c_d_15, 1);

  int c_p_16[] = {  0}; //   1
  psi_c_p[no_ps][16] = get_vector_from_array_int(c_p_16, 1);
  int c_f_16[] = {  8,  13}; //   2
  psi_c_f[no_ps][16] = get_vector_from_array_int(c_f_16, 2);
  int c_t_16[] = { 22,  23,  31}; //   3
  psi_c_t[no_ps][16] = get_vector_from_array_int(c_t_16, 3);
  int c_d_16[] = {  0}; //   1
  psi_c_d[no_ps][16] = get_vector_from_array_int(c_d_16, 1);

  int c_p_17[] = {  0}; //   1
  psi_c_p[no_ps][17] = get_vector_from_array_int(c_p_17, 1);
  int c_f_17[] = {  6,  10}; //   2
  psi_c_f[no_ps][17] = get_vector_from_array_int(c_f_17, 2);
  int c_t_17[] = { 17,  18,  32}; //   3
  psi_c_t[no_ps][17] = get_vector_from_array_int(c_t_17, 3);
  int c_d_17[] = {  0}; //   1
  psi_c_d[no_ps][17] = get_vector_from_array_int(c_d_17, 1);

  int c_p_18[] = {  0}; //   1
  psi_c_p[no_ps][18] = get_vector_from_array_int(c_p_18, 1);
  int c_f_18[] = {  4,   5}; //   2
  psi_c_f[no_ps][18] = get_vector_from_array_int(c_f_18, 2);
  int c_t_18[] = { 22,  33,  34}; //   3
  psi_c_t[no_ps][18] = get_vector_from_array_int(c_t_18, 3);
  int c_d_18[] = {  0}; //   1
  psi_c_d[no_ps][18] = get_vector_from_array_int(c_d_18, 1);

  int c_p_19[] = {  0}; //   1
  psi_c_p[no_ps][19] = get_vector_from_array_int(c_p_19, 1);
  int c_f_19[] = {  4,   5}; //   2
  psi_c_f[no_ps][19] = get_vector_from_array_int(c_f_19, 2);
  int c_t_19[] = { 22,  33,  35}; //   3
  psi_c_t[no_ps][19] = get_vector_from_array_int(c_t_19, 3);
  int c_d_19[] = {  0}; //   1
  psi_c_d[no_ps][19] = get_vector_from_array_int(c_d_19, 1);

  int c_p_20[] = {  0}; //   1
  psi_c_p[no_ps][20] = get_vector_from_array_int(c_p_20, 1);
  int c_f_20[] = {  0,   1}; //   2
  psi_c_f[no_ps][20] = get_vector_from_array_int(c_f_20, 2);
  int c_t_20[] = { 12,  36,  37}; //   3
  psi_c_t[no_ps][20] = get_vector_from_array_int(c_t_20, 3);
  int c_d_20[] = {  0}; //   1
  psi_c_d[no_ps][20] = get_vector_from_array_int(c_d_20, 1);

  int c_p_21[] = {  0}; //   1
  psi_c_p[no_ps][21] = get_vector_from_array_int(c_p_21, 1);
  int c_f_21[] = {  2,   3}; //   2
  psi_c_f[no_ps][21] = get_vector_from_array_int(c_f_21, 2);
  int c_t_21[] = { 17,  38,  39}; //   3
  psi_c_t[no_ps][21] = get_vector_from_array_int(c_t_21, 3);
  int c_d_21[] = {  0}; //   1
  psi_c_d[no_ps][21] = get_vector_from_array_int(c_d_21, 1);

  int c_p_22[] = {  0}; //   1
  psi_c_p[no_ps][22] = get_vector_from_array_int(c_p_22, 1);
  int c_f_22[] = {  2,   3}; //   2
  psi_c_f[no_ps][22] = get_vector_from_array_int(c_f_22, 2);
  int c_t_22[] = { 17,  38,  40}; //   3
  psi_c_t[no_ps][22] = get_vector_from_array_int(c_t_22, 3);
  int c_d_22[] = {  0}; //   1
  psi_c_d[no_ps][22] = get_vector_from_array_int(c_d_22, 1);

  int c_p_23[] = {  0}; //   1
  psi_c_p[no_ps][23] = get_vector_from_array_int(c_p_23, 1);
  int c_f_23[] = {  0,   1}; //   2
  psi_c_f[no_ps][23] = get_vector_from_array_int(c_f_23, 2);
  int c_t_23[] = { 12,  36,  41}; //   3
  psi_c_t[no_ps][23] = get_vector_from_array_int(c_t_23, 3);
  int c_d_23[] = {  0}; //   1
  psi_c_d[no_ps][23] = get_vector_from_array_int(c_d_23, 1);

  int c_p_24[] = {  1,   2}; //   2
  psi_c_p[no_ps][24] = get_vector_from_array_int(c_p_24, 2);
  int c_f_24[] = {  5}; //   1
  psi_c_f[no_ps][24] = get_vector_from_array_int(c_f_24, 1);
  int c_t_24[] = {  8,   9}; //   2
  psi_c_t[no_ps][24] = get_vector_from_array_int(c_t_24, 2);
  int c_d_24[] = {  0,   1}; //   2
  psi_c_d[no_ps][24] = get_vector_from_array_int(c_d_24, 2);

  int c_p_25[] = {  0,   3}; //   2
  psi_c_p[no_ps][25] = get_vector_from_array_int(c_p_25, 2);
  int c_f_25[] = {  5}; //   1
  psi_c_f[no_ps][25] = get_vector_from_array_int(c_f_25, 1);
  int c_t_25[] = {  8,  42}; //   2
  psi_c_t[no_ps][25] = get_vector_from_array_int(c_t_25, 2);
  int c_d_25[] = {  1,   0}; //   2
  psi_c_d[no_ps][25] = get_vector_from_array_int(c_d_25, 2);

  int c_p_26[] = {  1,   2}; //   2
  psi_c_p[no_ps][26] = get_vector_from_array_int(c_p_26, 2);
  int c_f_26[] = { 15}; //   1
  psi_c_f[no_ps][26] = get_vector_from_array_int(c_f_26, 1);
  int c_t_26[] = { 43,  44}; //   2
  psi_c_t[no_ps][26] = get_vector_from_array_int(c_t_26, 2);
  int c_d_26[] = {  0,   1}; //   2
  psi_c_d[no_ps][26] = get_vector_from_array_int(c_d_26, 2);

  int c_p_27[] = {  0,   3}; //   2
  psi_c_p[no_ps][27] = get_vector_from_array_int(c_p_27, 2);
  int c_f_27[] = { 16}; //   1
  psi_c_f[no_ps][27] = get_vector_from_array_int(c_f_27, 1);
  int c_t_27[] = { 45,  46}; //   2
  psi_c_t[no_ps][27] = get_vector_from_array_int(c_t_27, 2);
  int c_d_27[] = {  1,   0}; //   2
  psi_c_d[no_ps][27] = get_vector_from_array_int(c_d_27, 2);

  int c_p_28[] = {  1,   2}; //   2
  psi_c_p[no_ps][28] = get_vector_from_array_int(c_p_28, 2);
  int c_f_28[] = {  5}; //   1
  psi_c_f[no_ps][28] = get_vector_from_array_int(c_f_28, 1);
  int c_t_28[] = { 22,  47}; //   2
  psi_c_t[no_ps][28] = get_vector_from_array_int(c_t_28, 2);
  int c_d_28[] = {  0,   1}; //   2
  psi_c_d[no_ps][28] = get_vector_from_array_int(c_d_28, 2);

  int c_p_29[] = {  0,   3}; //   2
  psi_c_p[no_ps][29] = get_vector_from_array_int(c_p_29, 2);
  int c_f_29[] = {  5}; //   1
  psi_c_f[no_ps][29] = get_vector_from_array_int(c_f_29, 1);
  int c_t_29[] = { 22,  33}; //   2
  psi_c_t[no_ps][29] = get_vector_from_array_int(c_t_29, 2);
  int c_d_29[] = {  1,   0}; //   2
  psi_c_d[no_ps][29] = get_vector_from_array_int(c_d_29, 2);

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
