#include "../include/classes.cxx"
#include "../include/definitions.phasespace.set.cxx"
#include "../ppwx01/header/ppwx01.phasespace.h"
void ppwx01_optimize_minv_real(phasespace_set & psi){
  static Logger logger("ppwx01_optimize_minv_real");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

#include "user/specify.optimize.phasespace.minv.real.cxx"

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

int ppwx01_determination_MCchannels_real(int no_ps, phasespace_set & psi){
  static Logger logger("ppwx01_determination_MCchannels_real");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  int n_channel = 0;
  if      (psi_no_map[no_ps] ==  0){n_channel = 12;}
  else if (psi_no_map[no_ps] ==  1){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  2){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  3){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  4){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  5){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  6){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  7){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  8){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  9){n_channel = 2;}
  else if (psi_no_map[no_ps] == 10){n_channel = 2;}
  else if (psi_no_map[no_ps] == 11){n_channel = 2;}
  else if (psi_no_map[no_ps] == 12){n_channel = 2;}
  else if (psi_no_map[no_ps] == 13){n_channel = 2;}
  else if (psi_no_map[no_ps] == 14){n_channel = 2;}
  else if (psi_no_map[no_ps] == 15){n_channel = 2;}
  else if (psi_no_map[no_ps] == 16){n_channel = 2;}
  else if (psi_no_map[no_ps] == 17){n_channel = 2;}
  else if (psi_no_map[no_ps] == 18){n_channel = 2;}
  return n_channel;

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

void ppwx01_ac_tau_psp_real(int no_ps, vector<int> & tau_MC_map, phasespace_set & psi){
  static Logger logger("ppwx01_ac_tau_psp_real");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  if      (psi.no_map[no_ps] == 0){}
  else if (psi.no_map[no_ps] ==  1){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  2){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  3){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  4){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  5){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  6){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  7){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  8){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  9){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 10){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 11){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 12){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 13){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 14){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 15){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 16){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 17){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 18){
    tau_MC_map.push_back(0);
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

void ppwx01_ax_psp_real(int no_ps, phasespace_set & psi){
  static Logger logger("ppwx01_ax_psp_real");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;
  if (psi_no_map[no_ps] == 0){}
  else if (psi_no_map[no_ps] ==  1){ppwx01_ax_psp_110_gu_wpd(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  2){ppwx01_ax_psp_110_gu_wps(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  3){ppwx01_ax_psp_110_gu_wpb(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  4){ppwx01_ax_psp_110_gc_wpd(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  5){ppwx01_ax_psp_110_gc_wps(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  6){ppwx01_ax_psp_110_gc_wpb(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  7){ppwx01_ax_psp_110_gdx_wpux(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  8){ppwx01_ax_psp_110_gdx_wpcx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  9){ppwx01_ax_psp_110_gsx_wpux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 10){ppwx01_ax_psp_110_gsx_wpcx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 11){ppwx01_ax_psp_110_gbx_wpux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 12){ppwx01_ax_psp_110_gbx_wpcx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 13){ppwx01_ax_psp_110_udx_wpg(no_ps, psi);}
  else if (psi_no_map[no_ps] == 14){ppwx01_ax_psp_110_usx_wpg(no_ps, psi);}
  else if (psi_no_map[no_ps] == 15){ppwx01_ax_psp_110_ubx_wpg(no_ps, psi);}
  else if (psi_no_map[no_ps] == 16){ppwx01_ax_psp_110_cdx_wpg(no_ps, psi);}
  else if (psi_no_map[no_ps] == 17){ppwx01_ax_psp_110_csx_wpg(no_ps, psi);}
  else if (psi_no_map[no_ps] == 18){ppwx01_ax_psp_110_cbx_wpg(no_ps, psi);}

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
