#include "../include/classes.cxx"
#include "../include/definitions.phasespace.set.cxx"
#include "../ppwxw02/header/ppwxw02.phasespace.h"
void ppwxw02_ax_psp_220_bbx_wpwmbbx(int no_ps, phasespace_set & psi){
  static Logger logger("ppwxw02_ax_psp_220_bbx_wpwmbbx");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;
  psi_v_smin[no_ps].resize(11);
  psi_needed_v_smin[no_ps].resize(11);
  int needed_v_smin_0[] = {   2,    3,    4,    6,    7,    8,   11,   12,   13,   14,   15,   16,   23,   24,   25,   26,   27,   28,   30,   31,   32,   33,   34,   35}; //  24
  psi_needed_v_smin[no_ps][  0] = get_vector_from_array_int(needed_v_smin_0, 24);
  int needed_v_smin_1[] = {   5,   20,   29,   30,   31,   32,   33,   34,   35}; //   9
  psi_needed_v_smin[no_ps][  1] = get_vector_from_array_int(needed_v_smin_1, 9);
  int needed_v_smin_2[] = {   6,    7,    8,   14,   15,   16,    2,    3,    4}; //   9
  psi_needed_v_smin[no_ps][  2] = get_vector_from_array_int(needed_v_smin_2, 9);
  int needed_v_smin_3[] = {   9,   17,   18,   19,    0}; //   5
  psi_needed_v_smin[no_ps][  3] = get_vector_from_array_int(needed_v_smin_3, 5);
  int needed_v_smin_4[] = {   9,   17}; //   2
  psi_needed_v_smin[no_ps][  4] = get_vector_from_array_int(needed_v_smin_4, 2);
  int needed_v_smin_5[] = {  10,   18,   21,   22,    1}; //   5
  psi_needed_v_smin[no_ps][  5] = get_vector_from_array_int(needed_v_smin_5, 5);
  int needed_v_smin_6[] = {  10,   22,    1,   21}; //   4
  psi_needed_v_smin[no_ps][  6] = get_vector_from_array_int(needed_v_smin_6, 4);
  int needed_v_smin_7[] = {  11,   12,   13,   23,   24,   25,   26,   27,   28}; //   9
  psi_needed_v_smin[no_ps][  7] = get_vector_from_array_int(needed_v_smin_7, 9);
  int needed_v_smin_8[] = {   0,   19}; //   2
  psi_needed_v_smin[no_ps][  8] = get_vector_from_array_int(needed_v_smin_8, 2);
  int needed_v_smin_9[] = {   5}; //   1
  psi_needed_v_smin[no_ps][  9] = get_vector_from_array_int(needed_v_smin_9, 1);
  int needed_v_smin_10[] = {  20,   29}; //   2
  psi_needed_v_smin[no_ps][ 10] = get_vector_from_array_int(needed_v_smin_10, 2);

  psi_v_smax[no_ps].resize(11);
  psi_needed_v_smax[no_ps].resize(11);
  int needed_v_smax_0[] = {   2,    3,    4,    6,    7,    8,   11,   12,   13,   14,   15,   16,   23,   24,   25,   26,   27,   28,   33,   34,   35}; //  21
  psi_needed_v_smax[no_ps][  0] = get_vector_from_array_int(needed_v_smax_0, 21);
  int needed_v_smax_1[] = {   5,   20,   29,   30,   31,   32}; //   6
  psi_needed_v_smax[no_ps][  1] = get_vector_from_array_int(needed_v_smax_1, 6);
  int needed_v_smax_2[] = {   6,    7,    8,    9,   14,   15,   16,   17,    2,    3,    4}; //  11
  psi_needed_v_smax[no_ps][  2] = get_vector_from_array_int(needed_v_smax_2, 11);
  int needed_v_smax_3[] = {   9,   17,   19,    0}; //   4
  psi_needed_v_smax[no_ps][  3] = get_vector_from_array_int(needed_v_smax_3, 4);
  int needed_v_smax_4[] = {  10,   18,   21,   22,    1}; //   5
  psi_needed_v_smax[no_ps][  4] = get_vector_from_array_int(needed_v_smax_4, 5);
  int needed_v_smax_5[] = {  10,   11,   12,   13,   22,   23,   24,   25,    1,   21,   26,   27,   28}; //  13
  psi_needed_v_smax[no_ps][  5] = get_vector_from_array_int(needed_v_smax_5, 13);
  int needed_v_smax_6[] = {  18}; //   1
  psi_needed_v_smax[no_ps][  6] = get_vector_from_array_int(needed_v_smax_6, 1);
  int needed_v_smax_7[] = {  30,   31,   32}; //   3
  psi_needed_v_smax[no_ps][  7] = get_vector_from_array_int(needed_v_smax_7, 3);
  int needed_v_smax_8[] = {  33,   34,   35}; //   3
  psi_needed_v_smax[no_ps][  8] = get_vector_from_array_int(needed_v_smax_8, 3);
  int needed_v_smax_9[] = {   0,   19,   20,   29}; //   4
  psi_needed_v_smax[no_ps][  9] = get_vector_from_array_int(needed_v_smax_9, 4);
  int needed_v_smax_10[] = {   5}; //   1
  psi_needed_v_smax[no_ps][ 10] = get_vector_from_array_int(needed_v_smax_10, 1);

  psi_container_IS_startvalue[no_ps][0] = psi_container_IS_name.size();
  psi_g_p[no_ps].resize(15);
  psi_needed_g_p[no_ps].resize(15);
  int needed_g_p_0[] = {   2,    6,   11,   14,   23,   26,   33}; //   7
  psi_needed_g_p[no_ps][0] = get_vector_from_array_int(needed_g_p_0, 7);
  psi_container_IS_name.push_back("propagator_0_smin0_smax0");
  int needed_g_p_1[] = {   3,    7,   12,   15,   24,   27,   34}; //   7
  psi_needed_g_p[no_ps][1] = get_vector_from_array_int(needed_g_p_1, 7);
  psi_container_IS_name.push_back("propagator_23_smin0_smax0");
  int needed_g_p_2[] = {   4,    8,   13,   16,   25,   28,   35}; //   7
  psi_needed_g_p[no_ps][2] = get_vector_from_array_int(needed_g_p_2, 7);
  psi_container_IS_name.push_back("propagator_25_smin0_smax0");
  int needed_g_p_3[] = {   5,   20,   29,   30,   31,   32}; //   6
  psi_needed_g_p[no_ps][3] = get_vector_from_array_int(needed_g_p_3, 6);
  psi_container_IS_name.push_back("propagator_0_smin1_smax1");
  int needed_g_p_4[] = {   6,    7,    8,   14,   15,   16}; //   6
  psi_needed_g_p[no_ps][4] = get_vector_from_array_int(needed_g_p_4, 6);
  psi_container_IS_name.push_back("propagator_5_smin2_smax2");
  int needed_g_p_5[] = {   9,   17,   19}; //   3
  psi_needed_g_p[no_ps][5] = get_vector_from_array_int(needed_g_p_5, 3);
  psi_container_IS_name.push_back("propagator_6_smin3_smax3");
  int needed_g_p_6[] = {   9,   17}; //   2
  psi_needed_g_p[no_ps][6] = get_vector_from_array_int(needed_g_p_6, 2);
  psi_container_IS_name.push_back("propagator_5_smin4_smax2");
  int needed_g_p_7[] = {  10,   18,   21,   22}; //   4
  psi_needed_g_p[no_ps][7] = get_vector_from_array_int(needed_g_p_7, 4);
  psi_container_IS_name.push_back("propagator_6_smin5_smax4");
  int needed_g_p_8[] = {  10,   22}; //   2
  psi_needed_g_p[no_ps][8] = get_vector_from_array_int(needed_g_p_8, 2);
  psi_container_IS_name.push_back("propagator_5_smin6_smax5");
  int needed_g_p_9[] = {  11,   12,   13,   23,   24,   25}; //   6
  psi_needed_g_p[no_ps][9] = get_vector_from_array_int(needed_g_p_9, 6);
  psi_container_IS_name.push_back("propagator_5_smin7_smax5");
  int needed_g_p_10[] = {  18}; //   1
  psi_needed_g_p[no_ps][10] = get_vector_from_array_int(needed_g_p_10, 1);
  psi_container_IS_name.push_back("propagator_6_smin3_smax6");
  int needed_g_p_11[] = {  30}; //   1
  psi_needed_g_p[no_ps][11] = get_vector_from_array_int(needed_g_p_11, 1);
  psi_container_IS_name.push_back("propagator_0_smin0_smax7");
  int needed_g_p_12[] = {  31}; //   1
  psi_needed_g_p[no_ps][12] = get_vector_from_array_int(needed_g_p_12, 1);
  psi_container_IS_name.push_back("propagator_23_smin0_smax7");
  int needed_g_p_13[] = {  32}; //   1
  psi_needed_g_p[no_ps][13] = get_vector_from_array_int(needed_g_p_13, 1);
  psi_container_IS_name.push_back("propagator_25_smin0_smax7");
  int needed_g_p_14[] = {  33,   34,   35}; //   3
  psi_needed_g_p[no_ps][14] = get_vector_from_array_int(needed_g_p_14, 3);
  psi_container_IS_name.push_back("propagator_0_smin1_smax8");

  psi_container_IS_startvalue[no_ps][1] = psi_container_IS_name.size();
  psi_g_f[no_ps].resize(8);
  psi_needed_g_f[no_ps].resize(8);
  int needed_g_f_0[] = {   0}; //   1
  psi_needed_g_f[no_ps][0] = get_vector_from_array_int(needed_g_f_0, 1);
  psi_container_IS_name.push_back("timelikeinvariant_smin3_smax3");
  int needed_g_f_1[] = {   0,   19}; //   2
  psi_needed_g_f[no_ps][1] = get_vector_from_array_int(needed_g_f_1, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin8_smax9");
  int needed_g_f_2[] = {   1}; //   1
  psi_needed_g_f[no_ps][2] = get_vector_from_array_int(needed_g_f_2, 1);
  psi_container_IS_name.push_back("timelikeinvariant_smin5_smax4");
  int needed_g_f_3[] = {   1,   21}; //   2
  psi_needed_g_f[no_ps][3] = get_vector_from_array_int(needed_g_f_3, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin6_smax5");
  int needed_g_f_4[] = {   2,    3,    4}; //   3
  psi_needed_g_f[no_ps][4] = get_vector_from_array_int(needed_g_f_4, 3);
  psi_container_IS_name.push_back("timelikeinvariant_smin2_smax2");
  int needed_g_f_5[] = {   5}; //   1
  psi_needed_g_f[no_ps][5] = get_vector_from_array_int(needed_g_f_5, 1);
  psi_container_IS_name.push_back("timelikeinvariant_smin9_smax10");
  int needed_g_f_6[] = {  20,   29}; //   2
  psi_needed_g_f[no_ps][6] = get_vector_from_array_int(needed_g_f_6, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin10_smax9");
  int needed_g_f_7[] = {  26,   27,   28}; //   3
  psi_needed_g_f[no_ps][7] = get_vector_from_array_int(needed_g_f_7, 3);
  psi_container_IS_name.push_back("timelikeinvariant_smin7_smax5");

  psi_container_IS_startvalue[no_ps][2] = psi_container_IS_name.size();
  psi_g_t[no_ps].resize(15);
  psi_needed_g_t[no_ps].resize(15);
  int needed_g_t_0[] = {   0,   19,   20,   29}; //   4
  psi_needed_g_t[no_ps][0] = get_vector_from_array_int(needed_g_t_0, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_6__1_2__8_52");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_6__1_2__8_52");
  int needed_g_t_1[] = {   0,   19}; //   2
  psi_needed_g_t[no_ps][1] = get_vector_from_array_int(needed_g_t_1, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_9__32_20");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_9__32_20");
  int needed_g_t_2[] = {   0}; //   1
  psi_needed_g_t[no_ps][2] = get_vector_from_array_int(needed_g_t_2, 1);
  psi_container_IS_name.push_back("t_of_tchannel_5__9_34__4_16");
  psi_container_IS_name.push_back("phi_of_tchannel_5__9_34__4_16");
  int needed_g_t_3[] = {   1,   21,   22,   23,   24,   25,   26,   27,   28}; //   9
  psi_needed_g_t[no_ps][3] = get_vector_from_array_int(needed_g_t_3, 9);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_2__16_44");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_2__16_44");
  int needed_g_t_4[] = {   1,   21}; //   2
  psi_needed_g_t[no_ps][4] = get_vector_from_array_int(needed_g_t_4, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_6__2_17__4_40");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_6__2_17__4_40");
  int needed_g_t_5[] = {   1}; //   1
  psi_needed_g_t[no_ps][5] = get_vector_from_array_int(needed_g_t_5, 1);
  psi_container_IS_name.push_back("t_of_tchannel_5__17_6__32_8");
  psi_container_IS_name.push_back("phi_of_tchannel_5__17_6__32_8");
  int needed_g_t_6[] = {   2,    3,    4,    6,    7,    8,    9}; //   7
  psi_needed_g_t[no_ps][6] = get_vector_from_array_int(needed_g_t_6, 7);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_1__32_28");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_1__32_28");
  int needed_g_t_7[] = {   2,    3,    4}; //   3
  psi_needed_g_t[no_ps][7] = get_vector_from_array_int(needed_g_t_7, 3);
  psi_container_IS_name.push_back("t_of_tchannel_opt_5__1_34__12_16");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_5__1_34__12_16");
  int needed_g_t_8[] = {   5}; //   1
  psi_needed_g_t[no_ps][8] = get_vector_from_array_int(needed_g_t_8, 1);
  psi_container_IS_name.push_back("t_of_tchannel_opt_6__2_1__4_56");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_6__2_1__4_56");
  int needed_g_t_9[] = {   5}; //   1
  psi_needed_g_t[no_ps][9] = get_vector_from_array_int(needed_g_t_9, 1);
  psi_container_IS_name.push_back("t_of_tchannel_opt_5__1_6__48_8");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_5__1_6__48_8");
  int needed_g_t_10[] = {  20}; //   1
  psi_needed_g_t[no_ps][10] = get_vector_from_array_int(needed_g_t_10, 1);
  psi_container_IS_name.push_back("t_of_tchannel_opt_6__2_9__4_48");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_6__2_9__4_48");
  int needed_g_t_11[] = {  26,   27,   28}; //   3
  psi_needed_g_t[no_ps][11] = get_vector_from_array_int(needed_g_t_11, 3);
  psi_container_IS_name.push_back("t_of_tchannel_opt_5__2_17__12_32");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_5__2_17__12_32");
  int needed_g_t_12[] = {  29}; //   1
  psi_needed_g_t[no_ps][12] = get_vector_from_array_int(needed_g_t_12, 1);
  psi_container_IS_name.push_back("t_of_tchannel_opt_5__2_9__48_4");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_5__2_9__48_4");
  int needed_g_t_13[] = {  30,   31,   32}; //   3
  psi_needed_g_t[no_ps][13] = get_vector_from_array_int(needed_g_t_13, 3);
  psi_container_IS_name.push_back("t_of_tchannel_opt_5__1_2__12_48");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_5__1_2__12_48");
  int needed_g_t_14[] = {  33,   34,   35}; //   3
  psi_needed_g_t[no_ps][14] = get_vector_from_array_int(needed_g_t_14, 3);
  psi_container_IS_name.push_back("t_of_tchannel_opt_5__1_2__48_12");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_5__1_2__48_12");

  psi_container_IS_startvalue[no_ps][3] = psi_container_IS_name.size();
  psi_g_d[no_ps].resize(11);
  psi_needed_g_d[no_ps].resize(11);
  int needed_g_d_0[] = {   2,    3,    4,    6,    7,    8,   11,   12,   13,   14,   15,   16,   23,   24,   25,   26,   27,   28,   30,   31,   32,   33,   34,   35}; //  24
  psi_needed_g_d[no_ps][0] = get_vector_from_array_int(needed_g_d_0, 24);
  psi_container_IS_name.push_back("costheta_of_decay_12__4_8");
  psi_container_IS_name.push_back("phi_of_decay_12__4_8");
  int needed_g_d_1[] = {   5,   20,   29,   30,   31,   32,   33,   34,   35}; //   9
  psi_needed_g_d[no_ps][1] = get_vector_from_array_int(needed_g_d_1, 9);
  psi_container_IS_name.push_back("costheta_of_decay_48__16_32");
  psi_container_IS_name.push_back("phi_of_decay_48__16_32");
  int needed_g_d_2[] = {   6,    7,    8,   14,   15,   16}; //   6
  psi_needed_g_d[no_ps][2] = get_vector_from_array_int(needed_g_d_2, 6);
  psi_container_IS_name.push_back("costheta_of_decay_28__16_12");
  psi_container_IS_name.push_back("phi_of_decay_28__16_12");
  int needed_g_d_3[] = {   9,   17}; //   2
  psi_needed_g_d[no_ps][3] = get_vector_from_array_int(needed_g_d_3, 2);
  psi_container_IS_name.push_back("costheta_of_decay_28__8_20");
  psi_container_IS_name.push_back("phi_of_decay_28__8_20");
  int needed_g_d_4[] = {   9,   17,   18,   19}; //   4
  psi_needed_g_d[no_ps][4] = get_vector_from_array_int(needed_g_d_4, 4);
  psi_container_IS_name.push_back("costheta_of_decay_20__4_16");
  psi_container_IS_name.push_back("phi_of_decay_20__4_16");
  int needed_g_d_5[] = {  10,   11,   12,   13}; //   4
  psi_needed_g_d[no_ps][5] = get_vector_from_array_int(needed_g_d_5, 4);
  psi_container_IS_name.push_back("costheta_of_decay_60__16_44");
  psi_container_IS_name.push_back("phi_of_decay_60__16_44");
  int needed_g_d_6[] = {  10,   22}; //   2
  psi_needed_g_d[no_ps][6] = get_vector_from_array_int(needed_g_d_6, 2);
  psi_container_IS_name.push_back("costheta_of_decay_44__4_40");
  psi_container_IS_name.push_back("phi_of_decay_44__4_40");
  int needed_g_d_7[] = {  10,   18,   21,   22}; //   4
  psi_needed_g_d[no_ps][7] = get_vector_from_array_int(needed_g_d_7, 4);
  psi_container_IS_name.push_back("costheta_of_decay_40__8_32");
  psi_container_IS_name.push_back("phi_of_decay_40__8_32");
  int needed_g_d_8[] = {  11,   12,   13,   23,   24,   25}; //   6
  psi_needed_g_d[no_ps][8] = get_vector_from_array_int(needed_g_d_8, 6);
  psi_container_IS_name.push_back("costheta_of_decay_44__32_12");
  psi_container_IS_name.push_back("phi_of_decay_44__32_12");
  int needed_g_d_9[] = {  14,   15,   16,   17}; //   4
  psi_needed_g_d[no_ps][9] = get_vector_from_array_int(needed_g_d_9, 4);
  psi_container_IS_name.push_back("costheta_of_decay_60__32_28");
  psi_container_IS_name.push_back("phi_of_decay_60__32_28");
  int needed_g_d_10[] = {  18}; //   1
  psi_needed_g_d[no_ps][10] = get_vector_from_array_int(needed_g_d_10, 1);
  psi_container_IS_name.push_back("costheta_of_decay_60__20_40");
  psi_container_IS_name.push_back("phi_of_decay_60__20_40");

  psi_c_p[no_ps].resize(36);
  psi_c_f[no_ps].resize(36);
  psi_c_t[no_ps].resize(36);
  psi_c_d[no_ps].resize(36);

  int c_p_0[] = {}; //   0
  psi_c_p[no_ps][0] = get_vector_from_array_int(c_p_0, 0);
  int c_f_0[] = {  0,   1}; //   2
  psi_c_f[no_ps][0] = get_vector_from_array_int(c_f_0, 2);
  int c_t_0[] = {  0,   1,   2}; //   3
  psi_c_t[no_ps][0] = get_vector_from_array_int(c_t_0, 3);
  int c_d_0[] = {}; //   0
  psi_c_d[no_ps][0] = get_vector_from_array_int(c_d_0, 0);

  int c_p_1[] = {}; //   0
  psi_c_p[no_ps][1] = get_vector_from_array_int(c_p_1, 0);
  int c_f_1[] = {  2,   3}; //   2
  psi_c_f[no_ps][1] = get_vector_from_array_int(c_f_1, 2);
  int c_t_1[] = {  3,   4,   5}; //   3
  psi_c_t[no_ps][1] = get_vector_from_array_int(c_t_1, 3);
  int c_d_1[] = {}; //   0
  psi_c_d[no_ps][1] = get_vector_from_array_int(c_d_1, 0);

  int c_p_2[] = {  0}; //   1
  psi_c_p[no_ps][2] = get_vector_from_array_int(c_p_2, 1);
  int c_f_2[] = {  4}; //   1
  psi_c_f[no_ps][2] = get_vector_from_array_int(c_f_2, 1);
  int c_t_2[] = {  6,   7}; //   2
  psi_c_t[no_ps][2] = get_vector_from_array_int(c_t_2, 2);
  int c_d_2[] = {  0}; //   1
  psi_c_d[no_ps][2] = get_vector_from_array_int(c_d_2, 1);

  int c_p_3[] = {  1}; //   1
  psi_c_p[no_ps][3] = get_vector_from_array_int(c_p_3, 1);
  int c_f_3[] = {  4}; //   1
  psi_c_f[no_ps][3] = get_vector_from_array_int(c_f_3, 1);
  int c_t_3[] = {  6,   7}; //   2
  psi_c_t[no_ps][3] = get_vector_from_array_int(c_t_3, 2);
  int c_d_3[] = {  0}; //   1
  psi_c_d[no_ps][3] = get_vector_from_array_int(c_d_3, 1);

  int c_p_4[] = {  2}; //   1
  psi_c_p[no_ps][4] = get_vector_from_array_int(c_p_4, 1);
  int c_f_4[] = {  4}; //   1
  psi_c_f[no_ps][4] = get_vector_from_array_int(c_f_4, 1);
  int c_t_4[] = {  6,   7}; //   2
  psi_c_t[no_ps][4] = get_vector_from_array_int(c_t_4, 2);
  int c_d_4[] = {  0}; //   1
  psi_c_d[no_ps][4] = get_vector_from_array_int(c_d_4, 1);

  int c_p_5[] = {  3}; //   1
  psi_c_p[no_ps][5] = get_vector_from_array_int(c_p_5, 1);
  int c_f_5[] = {  5}; //   1
  psi_c_f[no_ps][5] = get_vector_from_array_int(c_f_5, 1);
  int c_t_5[] = {  8,   9}; //   2
  psi_c_t[no_ps][5] = get_vector_from_array_int(c_t_5, 2);
  int c_d_5[] = {  1}; //   1
  psi_c_d[no_ps][5] = get_vector_from_array_int(c_d_5, 1);

  int c_p_6[] = {  0,   4}; //   2
  psi_c_p[no_ps][6] = get_vector_from_array_int(c_p_6, 2);
  int c_f_6[] = {}; //   0
  psi_c_f[no_ps][6] = get_vector_from_array_int(c_f_6, 0);
  int c_t_6[] = {  6}; //   1
  psi_c_t[no_ps][6] = get_vector_from_array_int(c_t_6, 1);
  int c_d_6[] = {  2,   0}; //   2
  psi_c_d[no_ps][6] = get_vector_from_array_int(c_d_6, 2);

  int c_p_7[] = {  1,   4}; //   2
  psi_c_p[no_ps][7] = get_vector_from_array_int(c_p_7, 2);
  int c_f_7[] = {}; //   0
  psi_c_f[no_ps][7] = get_vector_from_array_int(c_f_7, 0);
  int c_t_7[] = {  6}; //   1
  psi_c_t[no_ps][7] = get_vector_from_array_int(c_t_7, 1);
  int c_d_7[] = {  2,   0}; //   2
  psi_c_d[no_ps][7] = get_vector_from_array_int(c_d_7, 2);

  int c_p_8[] = {  2,   4}; //   2
  psi_c_p[no_ps][8] = get_vector_from_array_int(c_p_8, 2);
  int c_f_8[] = {}; //   0
  psi_c_f[no_ps][8] = get_vector_from_array_int(c_f_8, 0);
  int c_t_8[] = {  6}; //   1
  psi_c_t[no_ps][8] = get_vector_from_array_int(c_t_8, 1);
  int c_d_8[] = {  2,   0}; //   2
  psi_c_d[no_ps][8] = get_vector_from_array_int(c_d_8, 2);

  int c_p_9[] = {  5,   6}; //   2
  psi_c_p[no_ps][9] = get_vector_from_array_int(c_p_9, 2);
  int c_f_9[] = {}; //   0
  psi_c_f[no_ps][9] = get_vector_from_array_int(c_f_9, 0);
  int c_t_9[] = {  6}; //   1
  psi_c_t[no_ps][9] = get_vector_from_array_int(c_t_9, 1);
  int c_d_9[] = {  3,   4}; //   2
  psi_c_d[no_ps][9] = get_vector_from_array_int(c_d_9, 2);

  int c_p_10[] = {  7,   8}; //   2
  psi_c_p[no_ps][10] = get_vector_from_array_int(c_p_10, 2);
  int c_f_10[] = {}; //   0
  psi_c_f[no_ps][10] = get_vector_from_array_int(c_f_10, 0);
  int c_t_10[] = {}; //   0
  psi_c_t[no_ps][10] = get_vector_from_array_int(c_t_10, 0);
  int c_d_10[] = {  5,   6,   7}; //   3
  psi_c_d[no_ps][10] = get_vector_from_array_int(c_d_10, 3);

  int c_p_11[] = {  0,   9}; //   2
  psi_c_p[no_ps][11] = get_vector_from_array_int(c_p_11, 2);
  int c_f_11[] = {}; //   0
  psi_c_f[no_ps][11] = get_vector_from_array_int(c_f_11, 0);
  int c_t_11[] = {}; //   0
  psi_c_t[no_ps][11] = get_vector_from_array_int(c_t_11, 0);
  int c_d_11[] = {  5,   8,   0}; //   3
  psi_c_d[no_ps][11] = get_vector_from_array_int(c_d_11, 3);

  int c_p_12[] = {  1,   9}; //   2
  psi_c_p[no_ps][12] = get_vector_from_array_int(c_p_12, 2);
  int c_f_12[] = {}; //   0
  psi_c_f[no_ps][12] = get_vector_from_array_int(c_f_12, 0);
  int c_t_12[] = {}; //   0
  psi_c_t[no_ps][12] = get_vector_from_array_int(c_t_12, 0);
  int c_d_12[] = {  5,   8,   0}; //   3
  psi_c_d[no_ps][12] = get_vector_from_array_int(c_d_12, 3);

  int c_p_13[] = {  2,   9}; //   2
  psi_c_p[no_ps][13] = get_vector_from_array_int(c_p_13, 2);
  int c_f_13[] = {}; //   0
  psi_c_f[no_ps][13] = get_vector_from_array_int(c_f_13, 0);
  int c_t_13[] = {}; //   0
  psi_c_t[no_ps][13] = get_vector_from_array_int(c_t_13, 0);
  int c_d_13[] = {  5,   8,   0}; //   3
  psi_c_d[no_ps][13] = get_vector_from_array_int(c_d_13, 3);

  int c_p_14[] = {  0,   4}; //   2
  psi_c_p[no_ps][14] = get_vector_from_array_int(c_p_14, 2);
  int c_f_14[] = {}; //   0
  psi_c_f[no_ps][14] = get_vector_from_array_int(c_f_14, 0);
  int c_t_14[] = {}; //   0
  psi_c_t[no_ps][14] = get_vector_from_array_int(c_t_14, 0);
  int c_d_14[] = {  9,   2,   0}; //   3
  psi_c_d[no_ps][14] = get_vector_from_array_int(c_d_14, 3);

  int c_p_15[] = {  1,   4}; //   2
  psi_c_p[no_ps][15] = get_vector_from_array_int(c_p_15, 2);
  int c_f_15[] = {}; //   0
  psi_c_f[no_ps][15] = get_vector_from_array_int(c_f_15, 0);
  int c_t_15[] = {}; //   0
  psi_c_t[no_ps][15] = get_vector_from_array_int(c_t_15, 0);
  int c_d_15[] = {  9,   2,   0}; //   3
  psi_c_d[no_ps][15] = get_vector_from_array_int(c_d_15, 3);

  int c_p_16[] = {  2,   4}; //   2
  psi_c_p[no_ps][16] = get_vector_from_array_int(c_p_16, 2);
  int c_f_16[] = {}; //   0
  psi_c_f[no_ps][16] = get_vector_from_array_int(c_f_16, 0);
  int c_t_16[] = {}; //   0
  psi_c_t[no_ps][16] = get_vector_from_array_int(c_t_16, 0);
  int c_d_16[] = {  9,   2,   0}; //   3
  psi_c_d[no_ps][16] = get_vector_from_array_int(c_d_16, 3);

  int c_p_17[] = {  5,   6}; //   2
  psi_c_p[no_ps][17] = get_vector_from_array_int(c_p_17, 2);
  int c_f_17[] = {}; //   0
  psi_c_f[no_ps][17] = get_vector_from_array_int(c_f_17, 0);
  int c_t_17[] = {}; //   0
  psi_c_t[no_ps][17] = get_vector_from_array_int(c_t_17, 0);
  int c_d_17[] = {  9,   3,   4}; //   3
  psi_c_d[no_ps][17] = get_vector_from_array_int(c_d_17, 3);

  int c_p_18[] = {  7,  10}; //   2
  psi_c_p[no_ps][18] = get_vector_from_array_int(c_p_18, 2);
  int c_f_18[] = {}; //   0
  psi_c_f[no_ps][18] = get_vector_from_array_int(c_f_18, 0);
  int c_t_18[] = {}; //   0
  psi_c_t[no_ps][18] = get_vector_from_array_int(c_t_18, 0);
  int c_d_18[] = { 10,   4,   7}; //   3
  psi_c_d[no_ps][18] = get_vector_from_array_int(c_d_18, 3);

  int c_p_19[] = {  5}; //   1
  psi_c_p[no_ps][19] = get_vector_from_array_int(c_p_19, 1);
  int c_f_19[] = {  1}; //   1
  psi_c_f[no_ps][19] = get_vector_from_array_int(c_f_19, 1);
  int c_t_19[] = {  0,   1}; //   2
  psi_c_t[no_ps][19] = get_vector_from_array_int(c_t_19, 2);
  int c_d_19[] = {  4}; //   1
  psi_c_d[no_ps][19] = get_vector_from_array_int(c_d_19, 1);

  int c_p_20[] = {  3}; //   1
  psi_c_p[no_ps][20] = get_vector_from_array_int(c_p_20, 1);
  int c_f_20[] = {  6}; //   1
  psi_c_f[no_ps][20] = get_vector_from_array_int(c_f_20, 1);
  int c_t_20[] = {  0,  10}; //   2
  psi_c_t[no_ps][20] = get_vector_from_array_int(c_t_20, 2);
  int c_d_20[] = {  1}; //   1
  psi_c_d[no_ps][20] = get_vector_from_array_int(c_d_20, 1);

  int c_p_21[] = {  7}; //   1
  psi_c_p[no_ps][21] = get_vector_from_array_int(c_p_21, 1);
  int c_f_21[] = {  3}; //   1
  psi_c_f[no_ps][21] = get_vector_from_array_int(c_f_21, 1);
  int c_t_21[] = {  3,   4}; //   2
  psi_c_t[no_ps][21] = get_vector_from_array_int(c_t_21, 2);
  int c_d_21[] = {  7}; //   1
  psi_c_d[no_ps][21] = get_vector_from_array_int(c_d_21, 1);

  int c_p_22[] = {  7,   8}; //   2
  psi_c_p[no_ps][22] = get_vector_from_array_int(c_p_22, 2);
  int c_f_22[] = {}; //   0
  psi_c_f[no_ps][22] = get_vector_from_array_int(c_f_22, 0);
  int c_t_22[] = {  3}; //   1
  psi_c_t[no_ps][22] = get_vector_from_array_int(c_t_22, 1);
  int c_d_22[] = {  6,   7}; //   2
  psi_c_d[no_ps][22] = get_vector_from_array_int(c_d_22, 2);

  int c_p_23[] = {  0,   9}; //   2
  psi_c_p[no_ps][23] = get_vector_from_array_int(c_p_23, 2);
  int c_f_23[] = {}; //   0
  psi_c_f[no_ps][23] = get_vector_from_array_int(c_f_23, 0);
  int c_t_23[] = {  3}; //   1
  psi_c_t[no_ps][23] = get_vector_from_array_int(c_t_23, 1);
  int c_d_23[] = {  8,   0}; //   2
  psi_c_d[no_ps][23] = get_vector_from_array_int(c_d_23, 2);

  int c_p_24[] = {  1,   9}; //   2
  psi_c_p[no_ps][24] = get_vector_from_array_int(c_p_24, 2);
  int c_f_24[] = {}; //   0
  psi_c_f[no_ps][24] = get_vector_from_array_int(c_f_24, 0);
  int c_t_24[] = {  3}; //   1
  psi_c_t[no_ps][24] = get_vector_from_array_int(c_t_24, 1);
  int c_d_24[] = {  8,   0}; //   2
  psi_c_d[no_ps][24] = get_vector_from_array_int(c_d_24, 2);

  int c_p_25[] = {  2,   9}; //   2
  psi_c_p[no_ps][25] = get_vector_from_array_int(c_p_25, 2);
  int c_f_25[] = {}; //   0
  psi_c_f[no_ps][25] = get_vector_from_array_int(c_f_25, 0);
  int c_t_25[] = {  3}; //   1
  psi_c_t[no_ps][25] = get_vector_from_array_int(c_t_25, 1);
  int c_d_25[] = {  8,   0}; //   2
  psi_c_d[no_ps][25] = get_vector_from_array_int(c_d_25, 2);

  int c_p_26[] = {  0}; //   1
  psi_c_p[no_ps][26] = get_vector_from_array_int(c_p_26, 1);
  int c_f_26[] = {  7}; //   1
  psi_c_f[no_ps][26] = get_vector_from_array_int(c_f_26, 1);
  int c_t_26[] = {  3,  11}; //   2
  psi_c_t[no_ps][26] = get_vector_from_array_int(c_t_26, 2);
  int c_d_26[] = {  0}; //   1
  psi_c_d[no_ps][26] = get_vector_from_array_int(c_d_26, 1);

  int c_p_27[] = {  1}; //   1
  psi_c_p[no_ps][27] = get_vector_from_array_int(c_p_27, 1);
  int c_f_27[] = {  7}; //   1
  psi_c_f[no_ps][27] = get_vector_from_array_int(c_f_27, 1);
  int c_t_27[] = {  3,  11}; //   2
  psi_c_t[no_ps][27] = get_vector_from_array_int(c_t_27, 2);
  int c_d_27[] = {  0}; //   1
  psi_c_d[no_ps][27] = get_vector_from_array_int(c_d_27, 1);

  int c_p_28[] = {  2}; //   1
  psi_c_p[no_ps][28] = get_vector_from_array_int(c_p_28, 1);
  int c_f_28[] = {  7}; //   1
  psi_c_f[no_ps][28] = get_vector_from_array_int(c_f_28, 1);
  int c_t_28[] = {  3,  11}; //   2
  psi_c_t[no_ps][28] = get_vector_from_array_int(c_t_28, 2);
  int c_d_28[] = {  0}; //   1
  psi_c_d[no_ps][28] = get_vector_from_array_int(c_d_28, 1);

  int c_p_29[] = {  3}; //   1
  psi_c_p[no_ps][29] = get_vector_from_array_int(c_p_29, 1);
  int c_f_29[] = {  6}; //   1
  psi_c_f[no_ps][29] = get_vector_from_array_int(c_f_29, 1);
  int c_t_29[] = {  0,  12}; //   2
  psi_c_t[no_ps][29] = get_vector_from_array_int(c_t_29, 2);
  int c_d_29[] = {  1}; //   1
  psi_c_d[no_ps][29] = get_vector_from_array_int(c_d_29, 1);

  int c_p_30[] = {  3,  11}; //   2
  psi_c_p[no_ps][30] = get_vector_from_array_int(c_p_30, 2);
  int c_f_30[] = {}; //   0
  psi_c_f[no_ps][30] = get_vector_from_array_int(c_f_30, 0);
  int c_t_30[] = { 13}; //   1
  psi_c_t[no_ps][30] = get_vector_from_array_int(c_t_30, 1);
  int c_d_30[] = {  0,   1}; //   2
  psi_c_d[no_ps][30] = get_vector_from_array_int(c_d_30, 2);

  int c_p_31[] = {  3,  12}; //   2
  psi_c_p[no_ps][31] = get_vector_from_array_int(c_p_31, 2);
  int c_f_31[] = {}; //   0
  psi_c_f[no_ps][31] = get_vector_from_array_int(c_f_31, 0);
  int c_t_31[] = { 13}; //   1
  psi_c_t[no_ps][31] = get_vector_from_array_int(c_t_31, 1);
  int c_d_31[] = {  0,   1}; //   2
  psi_c_d[no_ps][31] = get_vector_from_array_int(c_d_31, 2);

  int c_p_32[] = {  3,  13}; //   2
  psi_c_p[no_ps][32] = get_vector_from_array_int(c_p_32, 2);
  int c_f_32[] = {}; //   0
  psi_c_f[no_ps][32] = get_vector_from_array_int(c_f_32, 0);
  int c_t_32[] = { 13}; //   1
  psi_c_t[no_ps][32] = get_vector_from_array_int(c_t_32, 1);
  int c_d_32[] = {  0,   1}; //   2
  psi_c_d[no_ps][32] = get_vector_from_array_int(c_d_32, 2);

  int c_p_33[] = {  0,  14}; //   2
  psi_c_p[no_ps][33] = get_vector_from_array_int(c_p_33, 2);
  int c_f_33[] = {}; //   0
  psi_c_f[no_ps][33] = get_vector_from_array_int(c_f_33, 0);
  int c_t_33[] = { 14}; //   1
  psi_c_t[no_ps][33] = get_vector_from_array_int(c_t_33, 1);
  int c_d_33[] = {  1,   0}; //   2
  psi_c_d[no_ps][33] = get_vector_from_array_int(c_d_33, 2);

  int c_p_34[] = {  1,  14}; //   2
  psi_c_p[no_ps][34] = get_vector_from_array_int(c_p_34, 2);
  int c_f_34[] = {}; //   0
  psi_c_f[no_ps][34] = get_vector_from_array_int(c_f_34, 0);
  int c_t_34[] = { 14}; //   1
  psi_c_t[no_ps][34] = get_vector_from_array_int(c_t_34, 1);
  int c_d_34[] = {  1,   0}; //   2
  psi_c_d[no_ps][34] = get_vector_from_array_int(c_d_34, 2);

  int c_p_35[] = {  2,  14}; //   2
  psi_c_p[no_ps][35] = get_vector_from_array_int(c_p_35, 2);
  int c_f_35[] = {}; //   0
  psi_c_f[no_ps][35] = get_vector_from_array_int(c_f_35, 0);
  int c_t_35[] = { 14}; //   1
  psi_c_t[no_ps][35] = get_vector_from_array_int(c_t_35, 1);
  int c_d_35[] = {  1,   0}; //   2
  psi_c_d[no_ps][35] = get_vector_from_array_int(c_d_35, 2);

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
