#include "../include/classes.cxx"
#include "../include/definitions.phasespace.set.cxx"
#include "../ppz01/header/ppz01.phasespace.h"
void ppz01_optimize_minv_real(phasespace_set & psi){
  static Logger logger("ppz01_optimize_minv_real");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

#include "user/specify.optimize.phasespace.minv.real.cxx"

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

int ppz01_determination_MCchannels_real(int no_ps, phasespace_set & psi){
  static Logger logger("ppz01_determination_MCchannels_real");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  int n_channel = 0;
  if      (psi_no_map[no_ps] == 0){n_channel = 3;}
  else if (psi_no_map[no_ps] == 2){n_channel = 2;}
  else if (psi_no_map[no_ps] == 3){n_channel = 2;}
  else if (psi_no_map[no_ps] == 4){n_channel = 2;}
  else if (psi_no_map[no_ps] == 5){n_channel = 2;}
  else if (psi_no_map[no_ps] == 6){n_channel = 2;}
  else if (psi_no_map[no_ps] == 7){n_channel = 2;}
  return n_channel;

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

void ppz01_ac_tau_psp_real(int no_ps, vector<int> & tau_MC_map, phasespace_set & psi){
  static Logger logger("ppz01_ac_tau_psp_real");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  if      (psi.no_map[no_ps] == 0){}
  else if (psi.no_map[no_ps] == 2){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 3){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 4){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 5){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 6){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 7){
    tau_MC_map.push_back(0);
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

void ppz01_ax_psp_real(int no_ps, phasespace_set & psi){
  static Logger logger("ppz01_ax_psp_real");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;
  if (psi_no_map[no_ps] == 0){}
  else if (psi_no_map[no_ps] == 2){ppz01_ax_psp_110_gd_zd(no_ps, psi);}
  else if (psi_no_map[no_ps] == 3){ppz01_ax_psp_110_gu_zu(no_ps, psi);}
  else if (psi_no_map[no_ps] == 4){ppz01_ax_psp_110_gdx_zdx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 5){ppz01_ax_psp_110_gux_zux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 6){ppz01_ax_psp_110_ddx_zg(no_ps, psi);}
  else if (psi_no_map[no_ps] == 7){ppz01_ax_psp_110_uux_zg(no_ps, psi);}

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
