#ifndef MODEL_SET_H
#define MODEL_SET_H

#include <string>
#include <vector>
#include "logger.h"

using namespace std;

class model_set{
private:

public:
//
// constructors
//
  model_set();

  model_set(vector<string> & file_input, int N_f, int N_f_active, double scale_ren, int present_type_perturbative_order, vector<string> & collection_type_perturbative_order, vector<string> & contribution_LHAPDFname, vector<int> & contribution_LHAPDFsubset, int switch_alpha_CMS, int switch_costheta_real);

  void get_simple_userinput_from_readin(vector<string> & user_variable, vector<string> & user_value, vector<string> & readin);
  void initialization_LHAPDF(string & this_lhapdfname, int this_lhapdfsubset);

//
// access elements
//

  double M_W;
  double M_Z;
  double M_H;
  double M_t;
  double M_b;
  double M_c;
  double M_s;
  double M_u;
  double M_d;
  double M_e;
  double M_mu;
  double M_tau;
  double M_ve;
  double M_vm;
  double M_vt;

  double M2_W;
  double M2_Z;
  double M2_H;
  double M2_t;
  double M2_b;
  double M2_c;
  double M2_s;
  double M2_u;
  double M2_d;
  double M2_e;
  double M2_mu;
  double M2_tau;
  double M2_ve;
  double M2_vm;
  double M2_vt;

  double Gamma_W;
  double Gamma_Z;
  double Gamma_H;
  double Gamma_t;
  double Gamma_b;
  double Gamma_c;

  double map_Gamma_W;
  double map_Gamma_Z;
  double map_Gamma_H;
  double map_Gamma_t;
  double map_Gamma_b;
  double map_Gamma_c;
  
  double reg_Gamma_W;
  double reg_Gamma_Z;
  double reg_Gamma_H;
  double reg_Gamma_t;
  double reg_Gamma_b;
  double reg_Gamma_c;

  double_complex cM_W;
  double_complex cM_Z;
  double_complex cM_H;
  double_complex cM_t;
  double_complex cM_b;
  double_complex cM_c;

  double_complex cM2_W;
  double_complex cM2_Z;
  double_complex cM2_H;
  double_complex cM2_t;
  double_complex cM2_b;
  double_complex cM2_c;

  double G_F;

  double Gamma_Wlv;
  double Gamma_Wud;
  double Gamma_Zll;
  double Gamma_Zvv;
  double Gamma_Zdd;
  double Gamma_Zuu;
  double Gamma_tWb;

  double BR_Wlv;
  double BR_Wud;
  double BR_Zll;
  double BR_Zvv;
  double BR_Zdd;
  double BR_Zuu;
  double BR_tWb;

  double alpha_s;
  double g_s;

  double alpha_e;
  double e;

  double cos_w;
  double cos2_w;
  double sin2_w;
  double sin_w;

  double_complex ccos_w;
  double_complex ccos2_w;
  double_complex csin2_w;
  double_complex csin_w;

  string CKM_matrix;
  double theta_c;
  vector<vector<double_complex> > V_ckm;
  double V_du;
  double V_dc;
  double V_dt;
  double V_su;
  double V_sc;
  double V_st;
  double V_bu;
  double V_bc;
  double V_bt;

  vector<double> e_pow;
  vector<double> M;
  vector<double> M2;
  vector<double> Gamma;
  vector<double_complex> cM;
  vector<double_complex> cM2;
  vector<double> map_Gamma;
  vector<double> reg_Gamma;


  double Q_u;
  double Q_d;
  double Q_v;
  double Q_l;
  double Iw_u;
  double Iw_d;
  double Iw_n;
  double Iw_l;


  double Cplus_Zuu;
  double Cplus_Zdd;
  double Cminus_Zuu;
  double Cminus_Zdd;
  double Cplus_Znn;
  double Cplus_Zee;
  double Cminus_Znn;
  double Cminus_Zee;
  double C_ZWminusWplus;

  double Cplus_Auu;
  double Cplus_Add;
  double Cminus_Auu;
  double Cminus_Add;
  double Cplus_Ann;
  double Cplus_Aee;
  double Cminus_Ann;
  double Cminus_Aee;
  double C_AWminusWplus;

  //  double Cplus_W; == 0 in SM
  double Cminus_W;

  double_complex cCplus_Zuu;
  double_complex cCplus_Zdd;
  double_complex cCminus_Zuu;
  double_complex cCminus_Zdd;
  double_complex cCplus_Znn;
  double_complex cCplus_Zee;
  double_complex cCminus_Znn;
  double_complex cCminus_Zee;
  double_complex cC_ZWminusWplus;

  double_complex cCplus_Auu;
  double_complex cCplus_Add;
  double_complex cCminus_Auu;
  double_complex cCminus_Add;
  double_complex cCplus_Ann;
  double_complex cCplus_Aee;
  double_complex cCminus_Ann;
  double_complex cCminus_Aee;
  double_complex cC_AWminusWplus;

  double_complex cCminus_W;

};

#endif
