#include "../include/classes.cxx"
#include "../qTsubtraction/header/radish.h"

////////////////////
//  constructors  //
////////////////////
runresumption_set::runresumption_set(){
  size_proc_generic = 0;
  size_proceeding.resize(6);
}
runresumption_set::runresumption_set(observable_set & _osi, phasespace_set & _psi, observable_set & _save_osi, phasespace_set & _save_psi){
  size_proc_generic = 0;
  size_proceeding.resize(6);

  osi = &_osi;
  psi = &_psi;

  resumption_osi = &_save_osi;
  resumption_psi = &_save_psi;

  (*resumption_psi).random_manager.proceeding_save();
}

void runresumption_set::perform_proceeding_step(){
  *resumption_osi = *osi;
  *resumption_psi = *psi;
  (*resumption_psi).random_manager.proceeding_save();
}
void runresumption_set::perform_proceeding_in(){
  (*osi).perform_proceeding_in(*psi);
}
void runresumption_set::perform_proceeding_out(){
  // Should depend on value of switch_proceeding when used !!!
  (*resumption_osi).perform_proceeding_out(*resumption_psi);
  //  (*osi).perform_proceeding_out(*psi);
}
void runresumption_set::perform_proceeding_check(){
  (*osi).perform_proceeding_check(*psi);
}

void runresumption_set::perform_iteration_step(){
  Logger logger("runresumption_set::perform_iteration_step");
  logger << LOG_DEBUG << "started" << endl;

  if (osi->switch_output_proceeding == 2){perform_proceeding_out();}
  osi->calculate_intermediate_result(*psi);
  osi->perform_integration_step_complete(*psi);
  if (osi->switch_output_distribution){
    osi->output_distribution_complete(*psi);
#ifdef RADISH
    if (osi->switch_radish) {
      print_all_histos(psi->i_gen);
    }
#endif    
  }

  if (osi->csi->type_contribution == "RVA"){
    logger << LOG_INFO << "Information about killed phase-space points at " << psi->i_acc << " events:" << endl;
    for (int i_q = 0; i_q < osi->n_qTcut; i_q++){
      logger << LOG_INFO << "counter_killed_qTcut[" << setw(3) << i_q << "] = " << setw(8) << osi->counter_killed_qTcut[i_q] << "   counter_acc_qTcut[" << setw(3) << i_q << "] = " << setw(8) << osi->counter_acc_qTcut[i_q] << "   ratio = " << double(osi->counter_killed_qTcut[i_q]) / double(osi->counter_acc_qTcut[i_q]) << endl;
    }
  }

  psi->step_MCweight_optimization();
  psi->random_manager.do_optimization_step(psi->i_acc);
  psi->result_MCweight_optimization();
  psi->step_tau_weight_optimization();
  psi->step_x1x2_weight_optimization();
  if (osi->csi->type_contribution == "CA" || 
      osi->csi->type_contribution == "RCA" || 
      osi->csi->type_contribution == "L2CA"){
    psi->step_z1z2_weight_optimization();
    // for CT, CT2 this is handled differently.
  }
  output_weight_optimization(*psi, *osi, size_proc_generic, size_proceeding);
  if (osi->switch_output_proceeding){perform_proceeding_step();}
  if (osi->switch_output_proceeding == 1){perform_proceeding_out();}

  /*
  if ((*osi).switch_output_proceeding == 2){perform_proceeding_out();}
  (*osi).calculate_intermediate_result(*psi);
  (*osi).perform_integration_step_complete(*psi);
  if ((*osi).switch_output_distribution){(*osi).output_distribution_complete(*psi);}
  (*psi).step_MCweight_optimization();
  (*psi).random_manager.do_optimization_step((*psi).i_acc);
  (*psi).result_MCweight_optimization();
  (*psi).step_tau_weight_optimization();
  (*psi).step_x1x2_weight_optimization();
  output_weight_optimization(*psi, *osi, size_proc_generic, size_proceeding);
  if ((*osi).switch_output_proceeding){perform_proceeding_step();}
  if ((*osi).switch_output_proceeding == 1){perform_proceeding_out();}
  */

  logger << LOG_DEBUG << "finished" << endl;
}
