#include "../include/classes.cxx"
//#include "../include/definitions.cxx"
#include "../include/definitions.observable.set.cxx"
#include "../include/definitions.phasespace.set.cxx"

// different type_corrections could maybe be merged !!!

void calculate_ME2_RA_QCD(observable_set & oset){
  static Logger logger("calculate_ME2_QCD_RA");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  logger << LOG_DEBUG_VERBOSE << "osi_cut_ps.size() = " << osi_cut_ps.size() << endl;
  if (osi_cut_ps[0] > -1){
    static int n_momentum = 5 * (osi_n_particle + 2);
    double *P;
    P = new double[n_momentum];
    for (int i = 1; i < osi_p_parton[0].size(); i++){
      logger << LOG_DEBUG_VERBOSE << "i = " << i << endl;
      P[5 * (i - 1)]     = osi_p_parton[0][i].x0();
      P[5 * (i - 1) + 1] = osi_p_parton[0][i].x1();
      P[5 * (i - 1) + 2] = osi_p_parton[0][i].x2();
      P[5 * (i - 1) + 3] = osi_p_parton[0][i].x3();
      P[5 * (i - 1) + 4] = osi_p_parton[0][i].m();
    }
    //    logger << LOG_DEBUG << "osi_type_contribution = " << osi_type_contribution << "   model = " << osi_user_string_value[osi_user_string_map["model"]] << endl;

    if ((osi_type_contribution == "RA" ||
	 osi_type_contribution == "RRA") && osi_user_string_value[osi_user_string_map["model"]] != "Bornloop"){
      //      logger << LOG_DEBUG << "RA/RRA" << endl;
      ol_evaluate_tree(osi_RA_dipole[0].process_id, P, &osi_value_ME2term[0]);

      if (!(osi_check_vanishing_ME2_end)){
	static double b_ME2;
	static int n_cc = (osi_n_particle + 2) * (osi_n_particle + 1) / 2;
	static double ewcc;
	static double *M2cc;
	M2cc = new double[n_cc];
	osi_flag_vanishing_ME2 = 0;
	ol_evaluate_cc(1, P, &b_ME2, M2cc, &ewcc);
	logger << LOG_DEBUG_VERBOSE << "b_ME2 = " << b_ME2 << endl;
	for (int i_c = 0; i_c < n_cc; i_c++){
	  logger << LOG_DEBUG_VERBOSE << "M2cc[" << setw(2) << i_c << "] = " << M2cc[i_c] << endl;
	  if (abs(M2cc[i_c]) > 1.e12 * abs(b_ME2)){
	    logger << LOG_DEBUG << "b_ME2 = 0. due to numerical cancellations!" << endl;
	    osi_flag_vanishing_ME2 = 1;
	    break;
	  }
	}
	delete [] M2cc;
      }
    }
    else if (osi_type_contribution == "L2RA" || 
	       osi_user_string_value[osi_user_string_map["model"]] == "Bornloop"){
      logger << LOG_DEBUG << "L2RA" << endl;
      double *M2L2;
      M2L2 = new double[5];
      static double one = 1;
      static double acc;
      static char * renscale = stch("renscale");
      static char * fact_uv = stch("fact_uv");
      static char * fact_ir = stch("fact_ir");
      ol_setparameter_double(renscale, osi_var_mu_ren);
      ol_setparameter_double(fact_uv, one);
      ol_setparameter_double(fact_ir, one);
      logger << LOG_DEBUG_VERBOSE << "before l_evaluate_loop2" << endl;
      logger << LOG_DEBUG << "osi_RA_dipole[0].process_id = " << osi_RA_dipole[0].process_id << endl;
      ol_evaluate_loop2(osi_RA_dipole[0].process_id, P, M2L2, &acc);
      logger << LOG_DEBUG_VERBOSE << "after l_evaluate_loop2" << endl;
      //      ME2 = M2L2[0];
      //  VA_b_ME2 = M2L2[0];
      osi_value_ME2term[0] = M2L2[0];
      logger << LOG_DEBUG << "M2L2[0] = " << M2L2[0] << endl;
      
      osi_flag_vanishing_ME2 = 0;
      if (osi_value_ME2term[0] == 0.){
	osi_flag_vanishing_ME2 = 1;
	logger << LOG_DEBUG << "b_ME2 = 0. due to numerical cancellations!" << endl;
      }
      
      delete [] M2L2;
    }
    else {
      logger << LOG_FATAL << "Should not happen!" << endl;
    }
    delete [] P;
  }
  else {osi_value_ME2term[0] = 0.;}

  for (int i_a = 1; i_a < osi_n_ps; i_a++){
    if (osi_cut_ps[i_a] >= 0){
      if (osi_RA_dipole[i_a].massive() == 0){      
	if      (osi_RA_dipole[i_a].type_dipole() == 1){osi_value_ME2term[i_a] = oset.calculate_dipole_QCD_A_ij_k(i_a);}
	else if (osi_RA_dipole[i_a].type_dipole() == 2){osi_value_ME2term[i_a] = oset.calculate_dipole_QCD_A_ij_a(i_a);}
	else if (osi_RA_dipole[i_a].type_dipole() == 3){osi_value_ME2term[i_a] = oset.calculate_dipole_QCD_A_ai_k(i_a);}
	else if (osi_RA_dipole[i_a].type_dipole() == 5){osi_value_ME2term[i_a] = oset.calculate_dipole_QCD_A_ai_b(i_a);}
	else {cout << "Should not happen!" << endl;}
      }
      else {
	if      (osi_RA_dipole[i_a].type_dipole() == 1){osi_value_ME2term[i_a] = oset.calculate_dipole_QCD_A_ij_k_massive(i_a);}
	else if (osi_RA_dipole[i_a].type_dipole() == 2){osi_value_ME2term[i_a] = oset.calculate_dipole_QCD_A_ij_a_massive(i_a);}
	else if (osi_RA_dipole[i_a].type_dipole() == 3){osi_value_ME2term[i_a] = oset.calculate_dipole_QCD_A_ai_k(i_a);}
	else if (osi_RA_dipole[i_a].type_dipole() == 5){osi_value_ME2term[i_a] = oset.calculate_dipole_QCD_A_ai_b(i_a);}
      }
    }
    else {osi_value_ME2term[i_a] = 0.;}
  }
  osi_RA_ME2 = osi_value_ME2term;
  /*
  for (int i_a = 0; i_a < osi_n_ps; i_a++){
    logger << LOG_DEBUG << "osi_cut_ps[" << setw(2) << i_a << "] = " << setw(3) << osi_cut_ps[i_a] << "   osi_RA_ME2[" << setw(2) << i_a << "] = " << setw(23) << setw(15) << osi_RA_ME2[i_a] << endl;
  }
  */

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

void calculate_ME2check_RA_QCD(phasespace_set & psi, observable_set & oset){
  static Logger logger("calculate_ME2check_QCD_RA");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  if (osi_p_parton[0][0].x0() != 0.){
    ofstream out_comparison;
    out_comparison.open(osi_filename_comparison.c_str(), ofstream::out | ofstream::app);  
    for (int i_p = 0; i_p < osi_p_parton[0].size(); i_p++){psi_xbp_all[0][intpow(2, i_p - 1)] = osi_p_parton[0][i_p];}
    for (int i_p = 0; i_p < osi_p_parton[0].size(); i_p++){logger << LOG_DEBUG_VERBOSE << "osi_p_parton[0][" << i_p << "] = " << osi_p_parton[0][i_p] << endl;}
    psi.determine_dipole_phasespace_RA(osi_RA_dipole);
    for (int i_a = 1; i_a < osi_n_ps; i_a++){
      for (int i_p = 0; i_p < osi_p_parton[i_a].size(); i_p++){
 	osi_p_parton[i_a][i_p] = psi_xbp_all[i_a][intpow(2, i_p - 1)];
      }
    }
    for (int i_a = 0; i_a < osi_n_ps; i_a++){osi_cut_ps[i_a] = 0;}
    calculate_ME2_RA_QCD(oset);
    //    OLP_PrintParameter(stch(osi_filename_olparameters.c_str()));

    oset.output_testpoint_RA(out_comparison);

    out_comparison << "Corresponding phase-space points:" << endl << endl;
    for (int i_a = 0; i_a < osi_n_ps; i_a++){
      out_comparison << setw(12) << osi_RA_dipole[i_a].name() << endl << endl;
      vector<vector<int> > xdx_pa = osi_RA_dipole[i_a].dx_pa();
      oset.output_momenta_phasespace(out_comparison, i_a);
    }
    out_comparison.close();
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}




