#include "../include/classes.cxx"
#include "../include/definitions.observable.set.cxx"
#include "../include/definitions.phasespace.set.cxx"

void calculate_ME2_VT_QCD(observable_set & oset){
  static Logger logger("calculate_ME2_VT_QCD");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  static double one = 1;
  static int n_momentum = 5 * (osi_n_particle + 2);
  double *P;
  P = new double[n_momentum];
  for (int i = 1; i < osi_p_parton[0].size(); i++){
    P[5 * (i - 1)]     = osi_p_parton[0][i].x0();
    P[5 * (i - 1) + 1] = osi_p_parton[0][i].x1();
    P[5 * (i - 1) + 2] = osi_p_parton[0][i].x2();
    P[5 * (i - 1) + 3] = osi_p_parton[0][i].x3();
    P[5 * (i - 1) + 4] = osi_p_parton[0][i].m();
  }

  if ((osi_type_contribution == "VT" || osi_type_contribution == "NLL_LO" || osi_type_contribution == "NLL_NLO" || osi_type_contribution == "NNLL_LO" || osi_type_contribution == "NNLL_NLO" || osi_type_contribution == "CT2") && osi_user_string_value[osi_user_string_map["model"]] != "Bornloop"){

  static double acc;
  static double M2L0;
  double *M2L1;
  double *IRL1;
  M2L1 = new double[3];
  IRL1 = new double[3];
  double *M2L2;
  double *IRL2;
  M2L2 = new double[5];
  IRL2 = new double[5];
  
  static char * OL_mu_ren = stch("muren");
  static char * OL_mu_reg = stch("mureg");
  static char * pole_uv = stch("pole_uv");
  static char * pole_ir1 = stch("pole_ir1");
  static char * pole_ir2 = stch("pole_ir2");
  ol_setparameter_double(pole_uv, osi_VA_DeltaUV);
  ol_setparameter_double(pole_ir1, osi_VA_DeltaIR1);
  ol_setparameter_double(pole_ir2, osi_VA_DeltaIR2);
  
  double mu_Q = (osi_p_parton[0][1] + osi_p_parton[0][2]).m();
  ol_setparameter_double(OL_mu_ren, mu_Q);
  ol_setparameter_double(OL_mu_reg, mu_Q);
  static char * fact_uv = stch("fact_uv");
  static char * fact_ir = stch("fact_ir");
  ol_setparameter_double(fact_uv, one);
  ol_setparameter_double(fact_ir, one);
  
  ol_evaluate_full(1, P, &osi_VA_b_ME2, M2L1, IRL1, M2L2, IRL2, &acc);
  osi_VA_V_ME2 = M2L1[0];
  
  ol_evaluate_ct(1, P, &M2L0, &osi_VA_X_ME2);
  
  if (osi_QT_finalstate_massive_coloured && (osi_type_contribution == "VT" || osi_type_contribution == "NLL_LO" || osi_type_contribution == "NLL_NLO" || osi_type_contribution == "NNLL_LO" || osi_type_contribution == "NNLL_NLO" || osi_type_contribution == "CT2")){// maybe also needed for CT2 ???
    /*
    if ((oset.name_process[0] == 'g' && oset.name_process[1] == 'g') || (oset.name_process[0] != 'g' && oset.name_process[1] != 'g')){
//    if (oset.name_process[0] == 'g' && oset.name_process[1] == 'g'){
//      logger << LOG_FATAL << "VT or CT2 term for gg channel is not implemented yet !!!" << endl;
//
//      exit(1);
//    }
//    if (oset.name_process[0] != 'g' && oset.name_process[1] != 'g'){
//      logger << LOG_FATAL << "VT or CT2 term for qqx channel is not implemented yet !!!" << endl;

      logger << LOG_FATAL << "VT or CT2 term for gg and qqx channel is not implemented yet !!!" << endl;
      //void ol_tree_colbasis_dim(int id, int* ncolb, int* colelemsz, int* nheltot); 

      int ncolb = 0;
      int colelemsz = 0;
      int nheltot = 0;

      ol_tree_colbasis_dim(1, &ncolb, &colelemsz, &nheltot); 

      cout << "ncolb = " << ncolb << endl;
      cout << "colelemsz = " << colelemsz << endl;
      cout << "nheltot = " << nheltot << endl;

      //      int basis[ncolb][colelemsz];
      //      int needed[ncolb][ncolb];

      int *basis;
      int *needed;
      basis = new int[ncolb*colelemsz];
      needed = new int[ncolb*ncolb];
      int cpp_basis[ncolb][colelemsz];
      int cpp_needed[ncolb][ncolb];
      // int basis[ncolb][colelemsz];
      // needed[ncolb][ncolb];
      ol_tree_colbasis(1, basis, needed);

 
      cout << endl;
      for (int i_c = 0; i_c < ncolb; i_c++){
	for (int i_i = 0; i_i < colelemsz; i_i++){
	  cpp_basis[i_c][i_i] = basis[i_c * colelemsz + i_i];
	  cout << "basis[" << i_c << "][" << i_i << "] = " << setw(5) << cpp_basis[i_c][i_i] << setw(5) << basis[i_c * colelemsz + i_i] << endl;
	}
	cout << endl;
      }

      // qqx -> ttx
      // 3 1 0 2 4 -> T^{i1}_31 * T^{i1}_24
      // 3 4 0 2 1 -> T^{i1}_34 * T^{i1}_21

      // gg -> ttx
      // 1 2 3 4 0 -> [T^{1}T^{2}]_34
      // 2 1 3 4 0 -> [T^{2}T^{1}]_34

      for (int i_c = 0; i_c < ncolb; i_c++){
	for (int j_c = 0; j_c < ncolb; j_c++){
	  cpp_needed[i_c][j_c] = needed[i_c * ncolb + j_c];
	  cout << "needed[" << i_c << "][" << j_c << "] = " << setw(5) << needed[i_c * ncolb + j_c] << setw(5) << cpp_needed[i_c][j_c] << endl;
	}
      }

      double *amp;
      amp = new double[nheltot*2*ncolb];
      double_complex cpp_amp[nheltot][ncolb];

      double cpp_amp2[nheltot][ncolb];

      // double amp[nheltot][2*ncolb];
      int nhel = 0;

      cout << "nheltot = " << nheltot << endl;

      ol_evaluate_tree_colvect(1, P, amp, &nhel); 

      cout << "nhel = " << nhel << endl;

      double amp2_col0 = 0.;
      for (int i_h = 0; i_h < nheltot; i_h++){
	for (int i_c = 0; i_c < ncolb; i_c++){
	  //	  cpp_amp[i_h][i_c] = double_complex(amp[2 * (i_h * ncolb + i_c)], amp[2 * (i_h * ncolb + i_c) + 1]);
	  //	  cout << "amp[" << i_h << "][" << i_c << "] = " << setprecision(15) << setw(23) << amp[2 * (i_h * ncolb + i_c)] << " + " << setprecision(15) << setw(23) << amp[2 * (i_h * ncolb + i_c) + 1] << "i   " << setprecision(15) << setw(23) << cpp_amp[i_h][i_c] << endl;
	  cpp_amp[i_h][i_c] = double_complex(amp[2 * i_h + 2 * i_c * nheltot], amp[2 * i_h + 2 * i_c * nheltot + 1]);
	  cpp_amp2[i_h][i_c] = pow(abs(cpp_amp[i_h][i_c]), 2);
	  cout << "amp[" << i_h << "][" << i_c << "] = " << setprecision(15) << setw(23) << amp[2 * i_h + 2 * i_c * nheltot] << " + " << setprecision(15) << setw(23) << amp[2 * i_h + 2 * i_c * nheltot + 1] << "i   " << setprecision(15) << setw(23) << cpp_amp[i_h][i_c] << endl;
	}
	  amp2_col0 += cpp_amp2[i_h][0];
      }
      cout << "amp2_col0 = " << amp2_col0 << endl;

      double b_ME2 = 0.;
      ol_evaluate_tree(1, P, &b_ME2);

      cout << "amp2_col0 / b_ME2 = " << amp2_col0 / b_ME2 << endl;

      
      for (int i_h = 0; i_h < nheltot*2*ncolb; i_h++){
	cout << "amp[" << i_h << "] = " << setprecision(15) << setw(23) << amp[i_h] << endl;
      }
      
      // for comparison
      static int n_cc = (osi_n_particle + 2) * (osi_n_particle + 1) / 2;
      static double ewcc;
      static double *M2cc;
      M2cc = new double[n_cc];
      ol_evaluate_cc(1, P, &osi_ME2, M2cc, &ewcc);

      cout << "amp2_col0 / M2cc[0] = " << amp2_col0 / M2cc[0] << endl;

      for (int i_c = 0; i_c < osi_QT_correlationoperator.size(); i_c++){
	logger << LOG_INFO << "QT_ME2_cf[" << i_c << "] = " << osi_QT_ME2_cf[i_c] << "   charge_factor = " << osi_QT_correlationoperator[i_c].charge_factor << "   no_BLHA_entry = " << osi_QT_correlationoperator[i_c].no_BLHA_entry << endl;
      } 

      for (int i_c = 0; i_c < n_cc; i_c++){
	logger << LOG_INFO << "M2cc[" << i_c << "] = " << M2cc[i_c] << endl;
      }

      delete [] M2cc;




      exit(1);
    }
*/
      // different distinction needed: the partonic process is always gg or qqx !!!
      // e.g. check pdf contributions and determine from this if the channels 0->gg, 1->qqx, 2->gq, 3->rest are active !!!
      //    if ((oset.name_process[0] == 'g' && oset.name_process[1] != 'g') || (oset.name_process[0] == 'g' && oset.name_process[1] != 'g')){
      static int n_cc = (osi_n_particle + 2) * (osi_n_particle + 1) / 2;
      static double ewcc;
      static double *M2cc;
      M2cc = new double[n_cc];
      ol_evaluate_cc(1, P, &osi_ME2, M2cc, &ewcc);
      for (int i_c = 0; i_c < osi_QT_correlationoperator.size(); i_c++){
	//      if (osi_QT_correlationoperator[i_c].type_combination == 1 || osi_QT_correlationoperator[i_c].type_combination == 4){osi_QT_ME2_cf[i_c] = osi_QT_correlationoperator[i_c].charge_factor;}
	if (osi_QT_correlationoperator[i_c].type_combination == 1){osi_QT_ME2_cf[i_c] = osi_QT_correlationoperator[i_c].charge_factor;}
	else {osi_QT_ME2_cf[i_c] = M2cc[osi_QT_correlationoperator[i_c].no_BLHA_entry] / osi_ME2;} 
	logger << LOG_DEBUG_VERBOSE << "QT_ME2_cf[" << i_c << "] = " << osi_QT_ME2_cf[i_c] << "   charge_factor = " << osi_QT_correlationoperator[i_c].charge_factor << "   no_BLHA_entry = " << osi_QT_correlationoperator[i_c].no_BLHA_entry << endl;
      }
      delete [] M2cc;
      //    }
  }
  delete [] M2L2;
  delete [] IRL2;
  delete [] M2L1;
  delete [] IRL1;

  }
  else if (osi_type_contribution == "L2VT" || 
	   osi_user_string_value[osi_user_string_map["model"]] == "Bornloop"){
    // trivial workaround to compare CS and QT at NLO without the virtual amplitude.
    calculate_ME2_ioperator_VA_QCD(oset);
    osi_VA_X_ME2 = 0.;
    osi_VA_V_ME2 = -osi_VA_I_ME2;
    //    osi_VA_V_ME2 = 0.;
    osi_VA_I_ME2 = 0.;
  }

  /*
  osi_QT_H1_delta = (osi_VA_V_ME2 + osi_VA_X_ME2) / osi_VA_b_ME2;
  osi_QT_H1_delta /= 2;

  osi_QT_H1_delta /= (osi_alpha_S * inv2pi);
  
  if (oset.switch_polenorm == 1){
    if(oset.name_process[0] == 'g'){
      osi_QT_H1_delta -= 1.0/6*C_A*M_PI*M_PI;
    }
    else {
      osi_QT_H1_delta -= 1.0/6*C_F*M_PI*M_PI;
    }
  }
*/
  //  osi_VA_V_ME2 = 2 Re < M0 | M1 >  etc.
  osi_QT_H1_delta = (osi_VA_V_ME2 + osi_VA_X_ME2) / osi_VA_b_ME2 / (osi_alpha_S / pi);
  //  (alpha_S / pi) normalization of H1
  if (oset.switch_polenorm == 1){
    if (oset.name_process[0] == 'g'){osi_QT_H1_delta -= pi2_6 * C_A;}
    else {osi_QT_H1_delta -= pi2_6 * C_F;}
  }

  if (osi_QT_finalstate_massive_coloured){
    double Ft1 = 0.;
    double v34 = sqrt(1. - pow(2 * osi_msi.M2_t / (2 * (osi_p_parton[0][3] * osi_p_parton[0][4])), 2));
    double frac_v34 = (1. + v34) / (1. - v34);
    double log_v34 = log(frac_v34);
    double y34 = osi_p_parton[0][3].rapidity() - osi_p_parton[0][4].rapidity();
    double dilogpT2m2 = gsl_sf_dilog(-osi_p_parton[0][3].pT2() / osi_msi.M2_t);
    double logmT2m2 = log(osi_p_parton[0][3].ET2() / osi_msi.M2_t);
    double L34 = log_v34 * logmT2m2
      - 2 * gsl_sf_dilog(2 * v34 / (1. + v34))
      - .25 * pow(log_v34, 2)
      + 2 * (gsl_sf_dilog(1. - exp(y34) / sqrt(frac_v34)) + gsl_sf_dilog(1. - exp(-y34) / sqrt(frac_v34)) + .5 * pow(y34, 2));
    for (int i_c = 0; i_c < osi_QT_correlationoperator.size(); i_c++){
      if (osi_QT_correlationoperator[i_c].type_combination == 1){
	Ft1 += (logmT2m2 + dilogpT2m2) * osi_QT_ME2_cf[i_c];
      }
      else if (osi_QT_correlationoperator[i_c].type_combination == 2){
	Ft1 += (2 * dilogpT2m2 + (1. / v34) * L34) * osi_QT_ME2_cf[i_c];
      }
    }
    osi_QT_H1_delta += .5 * Ft1;
    //  H1 -> H1 - It1  (It1 = 2 Re < M0 | It1 | M0 >) 
  }

  /*
  delete [] M2L2;
  delete [] IRL2;
  delete [] M2L1;
  delete [] IRL1;
  */
  delete [] P;

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

void calculate_ME2check_VT_QCD(observable_set & oset){
  static Logger logger("calculate_ME2check_VT_QCD");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  osi_VA_delta_flag = 1;
  string sDelta;

  osi_VA_b_ME2 = 0.;
  osi_VA_V_ME2 = 0.;
  osi_VA_X_ME2 = 0.;
  osi_VA_I_ME2 = 0.;

  osi_QT_A0 = 0.;
  osi_QT_A1 = 0.;
  osi_QT_A2 = 0.;
  osi_QT_H1_delta = 0.;
  osi_QT_H2_delta = 0.;

  logger << LOG_DEBUG_VERBOSE << "number of scales = " << osi_n_scales_CV << endl;
  for (int i_s = 0; i_s < osi_n_scales_CV; i_s++){osi_VA_X_ME2_CV[i_s] = 0.;}

  if (osi_p_parton[0][0].x0() != 0.){
    ofstream out_comparison;
    out_comparison.open(osi_filename_comparison.c_str(), ofstream::out | ofstream::app);  
    osi_VA_DeltaUV = 0.;
    osi_VA_DeltaIR1 = 0.;
    osi_VA_DeltaIR2 = 0.;
    static char * OL_mu_ren = stch("muren");
    static char * OL_mu_reg = stch("mureg");
    static char * pole_uv = stch("pole_uv");
    static char * pole_ir1 = stch("pole_ir1");
    static char * pole_ir2 = stch("pole_ir2");
    ol_setparameter_double(OL_mu_ren, osi_var_mu_ren);
    ol_setparameter_double(OL_mu_reg, osi_var_mu_ren);
    ol_setparameter_double(pole_uv, osi_VA_DeltaUV);
    ol_setparameter_double(pole_ir1, osi_VA_DeltaIR1);
    ol_setparameter_double(pole_ir2, osi_VA_DeltaIR2);
    calculate_ME2_VT_QCD(oset);
    out_comparison << "Absolute results: " << endl << endl;
    oset.output_testpoint_VA_result(out_comparison);
    out_comparison << endl;
    out_comparison << "Particle momenta: " << endl << endl;
    output_momenta(out_comparison, oset);
    out_comparison.close();
  }
  //  OLP_PrintParameter(stch(osi_filename_olparameters.c_str()));
 
  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

void calculate_ME2_VT2_QCD(observable_set & oset, call_generic & generic){
  static Logger logger("calculate_ME2_VT2_QCD");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  static double acc;
  static int n_momentum = 5 * (osi_n_particle + 2);
  static double *P;
  P = new double[n_momentum];
  for (int i = 1; i < osi_p_parton[0].size(); i++){
    P[5 * (i - 1)]     = osi_p_parton[0][i].x0();
    P[5 * (i - 1) + 1] = osi_p_parton[0][i].x1();
    P[5 * (i - 1) + 2] = osi_p_parton[0][i].x2();
    P[5 * (i - 1) + 3] = osi_p_parton[0][i].x3();
    P[5 * (i - 1) + 4] = osi_p_parton[0][i].m();
  }

  double *M2L1;
  double *IRL1;
  M2L1 = new double[3];
  IRL1 = new double[3];
  double *M2L2;
  double *IRL2;
  M2L2 = new double[5];
  IRL2 = new double[5];

  double mu_Q = (osi_p_parton[0][1] + osi_p_parton[0][2]).m();
  static double one = 1;

  static char * OL_mu_ren = stch("muren");
  static char * OL_mu_reg = stch("mureg");
    //  static char * renscale = stch("renscale");
  static char * pole_uv = stch("pole_uv");
  static char * pole_ir1 = stch("pole_ir1");
  static char * pole_ir2 = stch("pole_ir2");
  //  ol_setparameter_double(renscale, osi_var_mu_ren);
  ///  ol_setparameter_double(OL_mu_ren, osi_var_mu_ren);
  ///  ol_setparameter_double(OL_mu_reg, osi_var_mu_ren);
  ol_setparameter_double(pole_uv, osi_VA_DeltaUV);
  ol_setparameter_double(pole_ir1, osi_VA_DeltaIR1);
  ol_setparameter_double(pole_ir2, osi_VA_DeltaIR2);
  
  int polenorm_0=0;
  static char * polenorm = stch("polenorm");
  ol_setparameter_int(polenorm, polenorm_0);
  
  //  ol_setparameter_double(stch("renscale"), mu_Q);
  ol_setparameter_double(OL_mu_ren, mu_Q);
  ol_setparameter_double(OL_mu_reg, mu_Q);
  static char * fact_uv = stch("fact_uv");
  static char * fact_ir = stch("fact_ir");
  ol_setparameter_double(fact_uv, one);
  ol_setparameter_double(fact_ir, one);
  //  ol_setparameter_double(stch("fact_uv"), one);
  //  ol_setparameter_double(stch("fact_ir"), one);
  
  //  ol_evaluate_loop2(1, P, M2L2, &acc);
  ol_evaluate_full(1, P, &osi_VA_b_ME2, M2L1, IRL1, M2L2, IRL2, &acc);

  // previous version !!! check if correct !!!
  //  osi_VA_V_ME2 = M2L1[0];

  static double M2L0;
  ol_evaluate_ct(1, P, &M2L0, &osi_VA_X_ME2);
  osi_VA_V_ME2 = M2L1[0]+osi_VA_X_ME2;
  
  generic.calculate_H2(oset);
  
  //  logger << LOG_DEBUG_VERBOSE << "ratios = " << osi_QT_A0 / osi_VA_b_ME2 << ", " << osi_QT_A1 / M2L1[0] << endl;
  logger << LOG_DEBUG_VERBOSE << "ratios = " << osi_QT_A0 / osi_VA_b_ME2 << ", " << osi_QT_A1 / osi_VA_V_ME2 << endl;
  
  delete [] M2L1;
  delete [] IRL1;
  delete [] M2L2;
  delete [] IRL2;
  delete [] P;

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

void calculate_ME2check_VT2_QCD(observable_set & oset, call_generic & generic){
  static Logger logger("calculate_ME2check_VT2_QCD");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  osi_VA_delta_flag = 1;
  string sDelta;

  osi_VA_b_ME2 = 0.;
  osi_VA_V_ME2 = 0.;
  osi_VA_X_ME2 = 0.;
  osi_VA_I_ME2 = 0.;

  osi_QT_A0 = 0.;
  osi_QT_A1 = 0.;
  osi_QT_A2 = 0.;
  osi_QT_H1_delta = 0.;
  osi_QT_H2_delta = 0.;
  for (int i_s = 0; i_s < osi_n_scales_CV; i_s++){osi_VA_X_ME2_CV[i_s] = 0.;}

  if (osi_p_parton[0][0].x0() != 0.){
    ofstream out_comparison;
    out_comparison.open(osi_filename_comparison.c_str(), ofstream::out | ofstream::app);  
    osi_VA_DeltaUV = 0.;
    osi_VA_DeltaIR1 = 0.;
    osi_VA_DeltaIR2 = 0.;
    static char * OL_mu_ren = stch("muren");
    static char * OL_mu_reg = stch("mureg");
    static char * pole_uv = stch("pole_uv");
    static char * pole_ir1 = stch("pole_ir1");
    static char * pole_ir2 = stch("pole_ir2");
    ol_setparameter_double(OL_mu_ren, osi_var_mu_ren);
    ol_setparameter_double(OL_mu_reg, osi_var_mu_ren);
    ol_setparameter_double(pole_uv, osi_VA_DeltaUV);
    ol_setparameter_double(pole_ir1, osi_VA_DeltaIR1);
    ol_setparameter_double(pole_ir2, osi_VA_DeltaIR2);
    calculate_ME2_VT2_QCD(oset, generic);
    out_comparison << "Absolute results: " << endl << endl;
    oset.output_testpoint_VA_result(out_comparison);
    out_comparison << endl;
    out_comparison << "Particle momenta: " << endl << endl;
    output_momenta(out_comparison, oset);
    out_comparison.close();
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
