      subroutine reader_input(workdir)
      implicit none
      include 'types.f'

      include 'ewinput.f'
      include 'nflav.f'

      include 'constants.f'
      include 'nf.f'
      include 'debug.f'
      include 'couple.f'
      include 'kpart.f'
      include 'maxwt.f'
      include 'masses.f'
      include 'kprocess.f'
      include 'scale.f'
      include 'facscale.f'
      include 'zerowidth.f'
      include 'gridinfo.f'
      include 'verbose.f'
      include 'limits.f'
      include 'lhapdf.f'
      include 'pdlabel.f'
      include 'qcdcouple.f'
      include 'nlooprun.f'
      include 'vanillafiles.f'
      include 'breit.f'
      include 'energy.f'
      include 'nproc.f'
      include 'iterat.f'
      include 'mcfmparameters.f'
      include 'hdecaymode.f'

      character*72 workdir
      character*90 line
      character*15 part
      logical:: spira,dryrun,makecuts,creategrid,writerefs
      integer:: nmin,nmax,ii
      integer:: ih1,ih2,idum,origij
      integer:: NPTYPE,NGROUP,NSET
      real(dp):: rtsmin,factor
      real(dp):: mbbmin,mbbmax,Mwmin,Mwmax
      real(dp):: Rcut
      logical:: technicalincluded
      real(dp):: ran2,ran2nr,randummy
      real(dp):: alphas

      common/writerefs/writerefs
      common/spira/spira
      common/nmin/nmin
      common/nmax/nmax
      common/rtsmin/rtsmin

      common/density/ih1,ih2
      common/ranno/idum

      common/pdflib/NPTYPE,NGROUP,NSET

      common/Rcut/Rcut
      common/makecuts/makecuts
      common/origij/origij

      save /ranno/

c~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
      real(dp) m_min, m_max

!     set MCFM parameters
      nevtrequested=-1
      nproc=0
      if (born_proc=='DY') nproc=1
      if (born_proc=='H')  nproc=2
      if (born_proc=='Wp') nproc=3
      if (born_proc=='Wm') nproc=4
      if (born_proc=='DYMY') nproc=5

      hdecaymode = hdecay_mode

      part='lo'
      sqrts=born_sqrts
      ih1=born_ih1
      ih2=born_ih2
      hmass=born_hmass
      scale=born_scale
      facscale=born_facscale
      zerowidth=.false.

      itmx1=born_itmx1
      itmx2=born_itmx2
      ncall1=born_ncall1
      ncall2=born_ncall2

      origij=born_origij

! ew parameters
      ewscheme=born_ewscheme
      GF_inp=born_GF_GeVm2
      aemmz_inp=born_aemmz
      xw_inp=born_sinwsq
      wmass_inp=born_MW
      zmass_inp=born_MZ
      wwidth=born_Wwidth
      zwidth=born_Zwidth
      hwidth=born_Hwidth
      nflav=born_nf
      mt=born_mt
      mb=born_mb
      mc=born_mc
      ms=born_ms
      m_min=born_m_min
      m_max=born_m_max


      if (nflav .ne. nf) then
            write(*,*) "Inconsistent number of flavour in the MCFM matrix element ", nf, "and in running coupling and PDFs ", nflav
            stop
      endif

      ! invariant mass window
      wsqmin=m_min**2
      wsqmax=m_max**2

c=======================================================================
c--- set-up the random number generator with a negative seed
      idum=-abs(origij)
      randummy=ran2()


      return
      end

